/**
 * <copyright>
 * 
 * Copyright (c) 2013 itemis and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis - Initial API and implementation
 * 
 * </copyright>
 */

package org.safe.examples.editor.pages;

import org.eclipse.jface.viewers.ILabelProvider;
import org.eclipse.sphinx.emf.editors.forms.layouts.LayoutFactory;
import org.eclipse.sphinx.emf.editors.forms.pages.GenericContentsTreePage;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.forms.IManagedForm;
import org.safe.examples.editor.SAFEFormEditor;
import org.safe.examples.editor.internal.messages.Messages;
import org.safe.examples.editor.sections.SAFEContentsTreeSection;

public class SAFEContentsTreePage extends GenericContentsTreePage{
	
	public SAFEContentsTreePage(SAFEFormEditor formEditor) {
		this(formEditor, Messages.SAFEContentsTreePage_title);
	}

	public SAFEContentsTreePage(SAFEFormEditor formEditor, String title) {
		super(formEditor, title);
	}

	@Override
	protected void doCreateFormContent(final IManagedForm managedForm) {
		// Create single columned page layout
		Composite body = managedForm.getForm().getBody();
		body.setLayout(LayoutFactory.createFormBodyGridLayout(false, 1));

		// Create model contents tree section
		SAFEContentsTreeSection acts = new SAFEContentsTreeSection(this, pageInput);
		acts.createContent(managedForm, body);
		addSection(acts);
		contentsTreeSection = acts;
	}

	@Override
	public ILabelProvider getLabelProvider() {
		return new AppearanceExampleColumnLabelProvider((SAFEFormEditor) getEditor());
	}
}
