/**
 * <copyright>
 * 
 * Copyright (c) 2013 itemis and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.ide.ui.wizards.pages;

import org.eclipse.sphinx.emf.workspace.ui.wizards.groups.BasicMetaModelVersionGroup;
import org.eclipse.sphinx.emf.workspace.ui.wizards.pages.NewModelProjectCreationPage;
import org.eclipse.swt.widgets.Composite;
import org.safe.common.metamodel.SAFEReleaseDescriptor;
import org.safe.ide.preferences.ISAFEWorkspacePreferenceConstants;
import org.safe.ide.preferences.ISAFEWorkspacePreferences;
import org.safe.ide.ui.messages.WorkspaceUIMessages;

public class NewSAFEProjectCreationPage extends NewModelProjectCreationPage<SAFEReleaseDescriptor> {

	/**
	 * Creates a new project creation wizard page.
	 * 
	 * @param pageName
	 *            the name of this page
	 */
	public NewSAFEProjectCreationPage(String pageName) {
		super(pageName, SAFEReleaseDescriptor.INSTANCE, ISAFEWorkspacePreferences.SAFE_RELEASE,
				ISAFEWorkspacePreferenceConstants.SAFE_PREFERENCE_PAGE_ID);
	}

	/*
	 * @see
	 * org.eclipse.sphinx.emf.workspace.ui.wizards.pages.NewModelProjectCreationPage#createMetaModelVersionGroup(org
	 * .eclipse.swt.widgets.Composite, org.eclipse.sphinx.platform.preferences.IProjectWorkspacePreference,
	 * org.eclipse.sphinx.emf.metamodel.IMetaModelDescriptor)
	 */
	@Override
	public void createMetaModelVersionGroup(Composite parent) {
		metaModelVersionGroup = new BasicMetaModelVersionGroup<SAFEReleaseDescriptor>("MetaModelVersionGroup", baseMetaModelDescriptor, //$NON-NLS-1$
				metaModelVersionPreference, metaModelVersionPreferencePageId);
		metaModelVersionGroup.setMetaModelVersionLabel(WorkspaceUIMessages.label_metaModelRelease);
		metaModelVersionGroup.createContent(parent, 3, false);

	}

}
