/**
 * <copyright>
 * 
 * Copyright (c) 2013 itemis and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.ide.internal.syncing;

import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IResourceChangeEvent;
import org.eclipse.sphinx.emf.model.ModelDescriptorRegistry;
import org.eclipse.sphinx.emf.workspace.syncing.IModelSyncRequest;
import org.eclipse.sphinx.platform.resources.syncing.AbstractResourceSynchronizerDelegate;
import org.safe.common.metamodel.SAFEReleaseDescriptor;
import org.safe.ide.util.SAFEPlatformUtil;

public class SAFEModelSynchronizerDelegate extends
	AbstractResourceSynchronizerDelegate<IModelSyncRequest> {

    @Override
    public void handleProjectDescriptionChanged(int eventType, IProject project) {
	if (eventType == IResourceChangeEvent.POST_CHANGE) {
	    if (SAFEPlatformUtil.hasSAFENature(project)
		    && ModelDescriptorRegistry.INSTANCE.getModels(project,
			    SAFEReleaseDescriptor.INSTANCE).isEmpty()) {
		// TODO Enhance IModelSyncRequest such that handling of
		// individual models in projects becomes possible
		syncRequest.addProjectToLoad(project);
	    }
	    if (!SAFEPlatformUtil.hasSAFENature(project)
		    && !ModelDescriptorRegistry.INSTANCE.getModels(project,
			    SAFEReleaseDescriptor.INSTANCE).isEmpty()) {
		// TODO Enhance IModelSyncRequest such that handling of
		// individual models in projects becomes possible
		syncRequest.addProjectToUnload(project);
	    }
	}
    }
}
