/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.edit.providers;


import java.util.Collection;
import java.util.List;
import java.util.MissingResourceException;

import org.eclipse.emf.common.command.Command;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.command.AddCommand;
import org.eclipse.emf.edit.command.CommandParameter;
import org.eclipse.emf.edit.command.RemoveCommand;

import org.eclipse.emf.edit.domain.EditingDomain;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

import org.eclipse.sphinx.emf.edit.CustomCommandRegistry;
import org.eclipse.sphinx.emf.edit.ExtendedItemProviderAdapter;
import org.eclipse.sphinx.emf.edit.ResourceLocatorRegistry;

import org.safe.metamodel.safe10.DiagnosticCoverageTypeEnum;
import org.safe.metamodel.safe10.QuantifiedDiagnosticCoverageProperty;
import org.safe.metamodel.safe10.Safe10Package;

import org.safe.metamodel.safe10.edit.Activator;

/**
 * This is the item provider adapter for a {@link org.safe.metamodel.safe10.QuantifiedDiagnosticCoverageProperty} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class QuantifiedDiagnosticCoveragePropertyItemProvider
  extends ExtendedItemProviderAdapter
  implements
    IEditingDomainItemProvider,
    IStructuredItemContentProvider,
    ITreeItemContentProvider,
    IItemLabelProvider,
    IItemPropertySource
{
  /**
   * This constructs an instance from a factory and a notifier.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public QuantifiedDiagnosticCoveragePropertyItemProvider(AdapterFactory adapterFactory)
  {
    super(adapterFactory);
  }

  /**
   * This returns the property descriptors for the adapted class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object)
  {
    if (itemPropertyDescriptors == null)
    {
      super.getPropertyDescriptors(object);

      addFaultTypePropertyDescriptor(object);
      addDcValuePropertyDescriptor(object);
      addContextPropertyDescriptor(object);
    }
    return itemPropertyDescriptors;
  }

  /**
   * This adds a property descriptor for the Fault Type feature.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected void addFaultTypePropertyDescriptor(Object object)
  {
    itemPropertyDescriptors.add
      (createItemPropertyDescriptor
        (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
         getResourceLocator(),
         getString("_UI_QuantifiedDiagnosticCoverageProperty_faultType_feature"),
         getString("_UI_PropertyDescriptor_description", "_UI_QuantifiedDiagnosticCoverageProperty_faultType_feature", "_UI_QuantifiedDiagnosticCoverageProperty_type"),
         Safe10Package.eINSTANCE.getQuantifiedDiagnosticCoverageProperty_FaultType(),
         true,
         false,
         false,
         ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
         null,
         null));
  }

  /**
   * This adds a property descriptor for the Dc Value feature.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected void addDcValuePropertyDescriptor(Object object)
  {
    itemPropertyDescriptors.add
      (createItemPropertyDescriptor
        (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
         getResourceLocator(),
         getString("_UI_QuantifiedDiagnosticCoverageProperty_dcValue_feature"),
         getString("_UI_PropertyDescriptor_description", "_UI_QuantifiedDiagnosticCoverageProperty_dcValue_feature", "_UI_QuantifiedDiagnosticCoverageProperty_type"),
         Safe10Package.eINSTANCE.getQuantifiedDiagnosticCoverageProperty_DcValue(),
         true,
         false,
         false,
         ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
         null,
         null));
  }

  /**
   * This adds a property descriptor for the Context feature.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected void addContextPropertyDescriptor(Object object)
  {
    itemPropertyDescriptors.add
      (createItemPropertyDescriptor
        (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
         getResourceLocator(),
         getString("_UI_QuantifiedDiagnosticCoverageProperty_context_feature"),
         getString("_UI_PropertyDescriptor_description", "_UI_QuantifiedDiagnosticCoverageProperty_context_feature", "_UI_QuantifiedDiagnosticCoverageProperty_type"),
         Safe10Package.eINSTANCE.getQuantifiedDiagnosticCoverageProperty_Context(),
         true,
         false,
         false,
         ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
         null,
         null));
  }

  /**
   * This returns QuantifiedDiagnosticCoverageProperty.gif.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object getImage(Object object)
  {
    if(object != null){
      String nsURI = ((EObject) object).eClass().getEPackage().getNsURI();
      ResourceLocator resourceLocator = ResourceLocatorRegistry.INSTANCE
            .getResourceLocator(nsURI);
        if (resourceLocator != null) {
          try {
            Object image = resourceLocator.getImage("full/obj16/QuantifiedDiagnosticCoverageProperty"); 
            if (image != null) {
              return overlayImage(object, image);
            }
          }catch(MissingResourceException ex){
            // Fail silent
          }
        }
      return overlayImage(object, getResourceLocator().getImage("full/obj16/QuantifiedDiagnosticCoverageProperty"));
    }
    return null;
  }

  /**
   * This returns the label text for the adapted class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String getText(Object object)
  {
    DiagnosticCoverageTypeEnum labelValue = ((QuantifiedDiagnosticCoverageProperty)object).getFaultType();
    String label = labelValue == null ? null : labelValue.toString();
    String typeLabel = getString("_UI_QuantifiedDiagnosticCoverageProperty_type"); 
      return label == null || label.length() == 0 ? typeLabel : label;
  }

  /**
   * This handles model notifications by calling {@link #updateChildren} to update any cached
   * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void notifyChanged(Notification notification)
  {
    updateChildren(notification);

    switch (notification.getFeatureID(QuantifiedDiagnosticCoverageProperty.class))
    {
      case Safe10Package.QUANTIFIED_DIAGNOSTIC_COVERAGE_PROPERTY__FAULT_TYPE:
      case Safe10Package.QUANTIFIED_DIAGNOSTIC_COVERAGE_PROPERTY__DC_VALUE:
      case Safe10Package.QUANTIFIED_DIAGNOSTIC_COVERAGE_PROPERTY__CONTEXT:
        fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
        return;
    }
    super.notifyChanged(notification);
  }

  /**
   * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
   * that can be created under this object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object)
  {
    super.collectNewChildDescriptors(newChildDescriptors, object);
  }

  /**
   * Return the resource locator for this item provider's resources.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public ResourceLocator getResourceLocator()
  {
    return Activator.INSTANCE;
  }

   
  @Override
   protected Command createAddCommand(EditingDomain domain, EObject owner, EStructuralFeature feature, Collection<?> collection, int index) {
    Command addCommand = CustomCommandRegistry.INSTANCE.createCustomCommand(domain, new CommandParameter(owner, feature, collection, index),
        AddCommand.class);
    if (addCommand != null) {
      return addCommand  ;
    }
    return super.createAddCommand(domain, owner, feature, collection, index);
  }
  
  @Override
  protected Command createRemoveCommand(EditingDomain domain, EObject owner, EStructuralFeature feature, Collection<?> collection) {
    Command removeCommand = CustomCommandRegistry.INSTANCE.createCustomCommand(domain, new CommandParameter(owner, feature, collection),
        RemoveCommand.class);
    if (removeCommand != null) {
      return removeCommand;
    }
    return super.createRemoveCommand(domain, owner, feature, collection);
  }
}
