/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.edit.providers;


import java.util.Collection;
import java.util.List;
import java.util.MissingResourceException;

import org.eclipse.emf.common.command.Command;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.command.AddCommand;
import org.eclipse.emf.edit.command.CommandParameter;
import org.eclipse.emf.edit.command.RemoveCommand;

import org.eclipse.emf.edit.domain.EditingDomain;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

import org.eclipse.sphinx.emf.edit.CustomCommandRegistry;
import org.eclipse.sphinx.emf.edit.ExtendedItemProviderAdapter;
import org.eclipse.sphinx.emf.edit.ResourceLocatorRegistry;

import org.safe.metamodel.safe10.Safe10Factory;
import org.safe.metamodel.safe10.Safe10Package;
import org.safe.metamodel.safe10.SafeElementType;
import org.safe.metamodel.safe10.SafetyCase;

import org.safe.metamodel.safe10.edit.Activator;

/**
 * This is the item provider adapter for a {@link org.safe.metamodel.safe10.SafetyCase} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class SafetyCaseItemProvider
  extends ExtendedItemProviderAdapter
  implements
    IEditingDomainItemProvider,
    IStructuredItemContentProvider,
    ITreeItemContentProvider,
    IItemLabelProvider,
    IItemPropertySource
{
  /**
   * This constructs an instance from a factory and a notifier.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SafetyCaseItemProvider(AdapterFactory adapterFactory)
  {
    super(adapterFactory);
  }

  /**
   * This returns the property descriptors for the adapted class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object)
  {
    if (itemPropertyDescriptors == null)
    {
      super.getPropertyDescriptors(object);

      addElementTypePropertyDescriptor(object);
    }
    return itemPropertyDescriptors;
  }

  /**
   * This adds a property descriptor for the Element Type feature.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected void addElementTypePropertyDescriptor(Object object)
  {
    itemPropertyDescriptors.add
      (createItemPropertyDescriptor
        (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
         getResourceLocator(),
         getString("_UI_SafetyCase_elementType_feature"),
         getString("_UI_PropertyDescriptor_description", "_UI_SafetyCase_elementType_feature", "_UI_SafetyCase_type"),
         Safe10Package.eINSTANCE.getSafetyCase_ElementType(),
         true,
         false,
         false,
         ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
         null,
         null));
  }

  /**
   * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
   * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
   * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object)
  {
    if (childrenFeatures == null)
    {
      super.getChildrenFeatures(object);
      childrenFeatures.add(Safe10Package.eINSTANCE.getSafetyCase_Assumption());
      childrenFeatures.add(Safe10Package.eINSTANCE.getSafetyCase_Context());
      childrenFeatures.add(Safe10Package.eINSTANCE.getSafetyCase_Goal());
      childrenFeatures.add(Safe10Package.eINSTANCE.getSafetyCase_Justification());
      childrenFeatures.add(Safe10Package.eINSTANCE.getSafetyCase_Solution());
      childrenFeatures.add(Safe10Package.eINSTANCE.getSafetyCase_Strategy());
    }
    return childrenFeatures;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EStructuralFeature getChildFeature(Object object, Object child)
  {
    // Check the type of the specified child object and return the proper feature to use for
    // adding (see {@link AddCommand}) it as a child.

    return super.getChildFeature(object, child);
  }

  /**
   * This returns SafetyCase.gif.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object getImage(Object object)
  {
    if(object != null){
      String nsURI = ((EObject) object).eClass().getEPackage().getNsURI();
      ResourceLocator resourceLocator = ResourceLocatorRegistry.INSTANCE
            .getResourceLocator(nsURI);
        if (resourceLocator != null) {
          try {
            Object image = resourceLocator.getImage("full/obj16/SafetyCase"); 
            if (image != null) {
              return overlayImage(object, image);
            }
          }catch(MissingResourceException ex){
            // Fail silent
          }
        }
      return overlayImage(object, getResourceLocator().getImage("full/obj16/SafetyCase"));
    }
    return null;
  }

  /**
   * This returns the label text for the adapted class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String getText(Object object)
  {
    SafeElementType labelValue = ((SafetyCase)object).getElementType();
    String label = labelValue == null ? null : labelValue.toString();
    String typeLabel = getString("_UI_SafetyCase_type"); 
      return label == null || label.length() == 0 ? typeLabel : label;
  }

  /**
   * This handles model notifications by calling {@link #updateChildren} to update any cached
   * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void notifyChanged(Notification notification)
  {
    updateChildren(notification);

    switch (notification.getFeatureID(SafetyCase.class))
    {
      case Safe10Package.SAFETY_CASE__ELEMENT_TYPE:
        fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
        return;
      case Safe10Package.SAFETY_CASE__ASSUMPTION:
      case Safe10Package.SAFETY_CASE__CONTEXT:
      case Safe10Package.SAFETY_CASE__GOAL:
      case Safe10Package.SAFETY_CASE__JUSTIFICATION:
      case Safe10Package.SAFETY_CASE__SOLUTION:
      case Safe10Package.SAFETY_CASE__STRATEGY:
        fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
        return;
    }
    super.notifyChanged(notification);
  }

  /**
   * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
   * that can be created under this object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object)
  {
    super.collectNewChildDescriptors(newChildDescriptors, object);

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSafetyCase_Assumption(),
         Safe10Factory.eINSTANCE.createAssumption()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSafetyCase_Context(),
         Safe10Factory.eINSTANCE.createContext()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSafetyCase_Goal(),
         Safe10Factory.eINSTANCE.createGoal()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSafetyCase_Justification(),
         Safe10Factory.eINSTANCE.createJustification()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSafetyCase_Solution(),
         Safe10Factory.eINSTANCE.createSolution()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSafetyCase_Solution(),
         Safe10Factory.eINSTANCE.createAnalysisReport()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSafetyCase_Solution(),
         Safe10Factory.eINSTANCE.createDesignSpecification()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSafetyCase_Solution(),
         Safe10Factory.eINSTANCE.createTestProtocol()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSafetyCase_Solution(),
         Safe10Factory.eINSTANCE.createFieldTestProtocol()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSafetyCase_Solution(),
         Safe10Factory.eINSTANCE.createFMEAReport()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSafetyCase_Solution(),
         Safe10Factory.eINSTANCE.createUnitTestProtocol()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSafetyCase_Strategy(),
         Safe10Factory.eINSTANCE.createStrategy()));
  }

  /**
   * Return the resource locator for this item provider's resources.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public ResourceLocator getResourceLocator()
  {
    return Activator.INSTANCE;
  }

   
  @Override
   protected Command createAddCommand(EditingDomain domain, EObject owner, EStructuralFeature feature, Collection<?> collection, int index) {
    Command addCommand = CustomCommandRegistry.INSTANCE.createCustomCommand(domain, new CommandParameter(owner, feature, collection, index),
        AddCommand.class);
    if (addCommand != null) {
      return addCommand  ;
    }
    return super.createAddCommand(domain, owner, feature, collection, index);
  }
  
  @Override
  protected Command createRemoveCommand(EditingDomain domain, EObject owner, EStructuralFeature feature, Collection<?> collection) {
    Command removeCommand = CustomCommandRegistry.INSTANCE.createCustomCommand(domain, new CommandParameter(owner, feature, collection),
        RemoveCommand.class);
    if (removeCommand != null) {
      return removeCommand;
    }
    return super.createRemoveCommand(domain, owner, feature, collection);
  }
}
