/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.edit.providers;


import java.util.Collection;
import java.util.List;
import java.util.MissingResourceException;

import org.eclipse.emf.common.command.Command;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.command.AddCommand;
import org.eclipse.emf.edit.command.CommandParameter;
import org.eclipse.emf.edit.command.RemoveCommand;

import org.eclipse.emf.edit.domain.EditingDomain;

import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ViewerNotification;

import org.eclipse.sphinx.emf.edit.CustomCommandRegistry;
import org.eclipse.sphinx.emf.edit.ResourceLocatorRegistry;

import org.safe.metamodel.safe10.Safe10Factory;
import org.safe.metamodel.safe10.Safe10Package;
import org.safe.metamodel.safe10.Satisfy;

/**
 * This is the item provider adapter for a {@link org.safe.metamodel.safe10.Satisfy} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class SatisfyItemProvider
  extends RequirementsReleationshipItemProvider
  implements
    IEditingDomainItemProvider,
    IStructuredItemContentProvider,
    ITreeItemContentProvider,
    IItemLabelProvider,
    IItemPropertySource
{
  /**
   * This constructs an instance from a factory and a notifier.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SatisfyItemProvider(AdapterFactory adapterFactory)
  {
    super(adapterFactory);
  }

  /**
   * This returns the property descriptors for the adapted class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object)
  {
    if (itemPropertyDescriptors == null)
    {
      super.getPropertyDescriptors(object);

    }
    return itemPropertyDescriptors;
  }

  /**
   * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
   * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
   * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object)
  {
    if (childrenFeatures == null)
    {
      super.getChildrenFeatures(object);
      childrenFeatures.add(Safe10Package.eINSTANCE.getSatisfy_SatisfiedElement());
      childrenFeatures.add(Safe10Package.eINSTANCE.getSatisfy_SatisfyingTargets());
    }
    return childrenFeatures;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EStructuralFeature getChildFeature(Object object, Object child)
  {
    // Check the type of the specified child object and return the proper feature to use for
    // adding (see {@link AddCommand}) it as a child.

    return super.getChildFeature(object, child);
  }

  /**
   * This returns Satisfy.gif.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object getImage(Object object)
  {
    if(object != null){
      String nsURI = ((EObject) object).eClass().getEPackage().getNsURI();
      ResourceLocator resourceLocator = ResourceLocatorRegistry.INSTANCE
            .getResourceLocator(nsURI);
        if (resourceLocator != null) {
          try {
            Object image = resourceLocator.getImage("full/obj16/Satisfy"); 
            if (image != null) {
              return overlayImage(object, image);
            }
          }catch(MissingResourceException ex){
            // Fail silent
          }
        }
      return overlayImage(object, getResourceLocator().getImage("full/obj16/Satisfy"));
    }
    return null;
  }

  /**
   * This returns the label text for the adapted class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String getText(Object object)
  {
    return getString("_UI_Satisfy_type");
  }

  /**
   * This handles model notifications by calling {@link #updateChildren} to update any cached
   * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void notifyChanged(Notification notification)
  {
    updateChildren(notification);

    switch (notification.getFeatureID(Satisfy.class))
    {
      case Safe10Package.SATISFY__SATISFIED_ELEMENT:
      case Safe10Package.SATISFY__SATISFYING_TARGETS:
        fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
        return;
    }
    super.notifyChanged(notification);
  }

  /**
   * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
   * that can be created under this object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object)
  {
    super.collectNewChildDescriptors(newChildDescriptors, object);

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSatisfy_SatisfiedElement(),
         Safe10Factory.eINSTANCE.createFunctionalSafetyRequirement()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSatisfy_SatisfiedElement(),
         Safe10Factory.eINSTANCE.createHardwareSafetyRequirement()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSatisfy_SatisfiedElement(),
         Safe10Factory.eINSTANCE.createSafetyConcept()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSatisfy_SatisfiedElement(),
         Safe10Factory.eINSTANCE.createSoftwareSafetyRequirement()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSatisfy_SatisfiedElement(),
         Safe10Factory.eINSTANCE.createTechnicalSafetyRequirement()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSatisfy_SatisfiedElement(),
         Safe10Factory.eINSTANCE.createWarningAndDegradation()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSatisfy_SatisfiedElement(),
         Safe10Factory.eINSTANCE.createAssumption()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSatisfy_SatisfiedElement(),
         Safe10Factory.eINSTANCE.createContext()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSatisfy_SatisfiedElement(),
         Safe10Factory.eINSTANCE.createControlFlowMonitor()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSatisfy_SatisfiedElement(),
         Safe10Factory.eINSTANCE.createAlivenessMonitor()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSatisfy_SatisfiedElement(),
         Safe10Factory.eINSTANCE.createAutosarAlivenessMonitor()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSatisfy_SatisfiedElement(),
         Safe10Factory.eINSTANCE.createActuatorMonitor()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSatisfy_SatisfiedElement(),
         Safe10Factory.eINSTANCE.createAutosarActuatorMonitor()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSatisfy_SatisfiedElement(),
         Safe10Factory.eINSTANCE.createCRC()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSatisfy_SatisfiedElement(),
         Safe10Factory.eINSTANCE.createAutosarCRC()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSatisfy_SatisfiedElement(),
         Safe10Factory.eINSTANCE.createComponentPrototypeCRC()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSatisfy_SatisfiedElement(),
         Safe10Factory.eINSTANCE.createInterfaceCRC()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSatisfy_SatisfiedElement(),
         Safe10Factory.eINSTANCE.createComparison()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSatisfy_SatisfiedElement(),
         Safe10Factory.eINSTANCE.createAutosarComparison()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSatisfy_SatisfiedElement(),
         Safe10Factory.eINSTANCE.createChromosomeComparison()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSatisfy_SatisfiedElement(),
         Safe10Factory.eINSTANCE.createContextRangeCheck()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSatisfy_SatisfiedElement(),
         Safe10Factory.eINSTANCE.createAutosarContextRangeCheck()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSatisfy_SatisfiedElement(),
         Safe10Factory.eINSTANCE.createCpuSelfTest()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSatisfy_SatisfiedElement(),
         Safe10Factory.eINSTANCE.createChromosomeCpuSelfTest()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSatisfy_SatisfiedElement(),
         Safe10Factory.eINSTANCE.createFilter()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSatisfy_SatisfiedElement(),
         Safe10Factory.eINSTANCE.createGradientCheck()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSatisfy_SatisfiedElement(),
         Safe10Factory.eINSTANCE.createAutosarGradientCheck()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSatisfy_SatisfiedElement(),
         Safe10Factory.eINSTANCE.createHealthMonitor()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSatisfy_SatisfiedElement(),
         Safe10Factory.eINSTANCE.createChromosomeHealthMonitor()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSatisfy_SatisfiedElement(),
         Safe10Factory.eINSTANCE.createChromosomeApplicationHealthMonitor()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSatisfy_SatisfiedElement(),
         Safe10Factory.eINSTANCE.createCHROMOSOMEHealthMonitorNotification()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSatisfy_SatisfiedElement(),
         Safe10Factory.eINSTANCE.createChromosomeNodeHealthMonitor()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSatisfy_SatisfiedElement(),
         Safe10Factory.eINSTANCE.createHeartbeatReceiver()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSatisfy_SatisfiedElement(),
         Safe10Factory.eINSTANCE.createChromosomeHeartbeatReceiver()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSatisfy_SatisfiedElement(),
         Safe10Factory.eINSTANCE.createHeartbeatSender()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSatisfy_SatisfiedElement(),
         Safe10Factory.eINSTANCE.createChromosomeHeartbeatSender()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSatisfy_SatisfiedElement(),
         Safe10Factory.eINSTANCE.createHeartbeat()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSatisfy_SatisfiedElement(),
         Safe10Factory.eINSTANCE.createMemorySelfTest()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSatisfy_SatisfiedElement(),
         Safe10Factory.eINSTANCE.createChromosomeMemoryTest()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSatisfy_SatisfiedElement(),
         Safe10Factory.eINSTANCE.createVoter()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSatisfy_SatisfiedElement(),
         Safe10Factory.eINSTANCE.createChromosomeVoter()));

    newChildDescriptors.add
      (createChildParameter
        (Safe10Package.eINSTANCE.getSatisfy_SatisfyingTargets(),
         Safe10Factory.eINSTANCE.createAllocationTargets()));
  }

   
  @Override
   protected Command createAddCommand(EditingDomain domain, EObject owner, EStructuralFeature feature, Collection<?> collection, int index) {
    Command addCommand = CustomCommandRegistry.INSTANCE.createCustomCommand(domain, new CommandParameter(owner, feature, collection, index),
        AddCommand.class);
    if (addCommand != null) {
      return addCommand  ;
    }
    return super.createAddCommand(domain, owner, feature, collection, index);
  }
  
  @Override
  protected Command createRemoveCommand(EditingDomain domain, EObject owner, EStructuralFeature feature, Collection<?> collection) {
    Command removeCommand = CustomCommandRegistry.INSTANCE.createCustomCommand(domain, new CommandParameter(owner, feature, collection),
        RemoveCommand.class);
    if (removeCommand != null) {
      return removeCommand;
    }
    return super.createRemoveCommand(domain, owner, feature, collection);
  }
}
