/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Actor</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * The Actor class is an abstract class which provides the structure that is needed for the contributions of different actors to the operational situation and the hazard. 
 * 
 * <i><u>Note:</u></i>
 * The risk assessment of hazardous events focuses on the harm to each person potentially at risk  including the driver or the passengers of the vehicle causing the hazardous event, and other persons potentially at risk such as cyclists, pedestrians or occupants of other vehicles. 
 * <i><u>
 * </u></i><i><u>Reference: </u></i>
 * ISO26262-3-7.4.3.2
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Hazards.Actor</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.Actor#getInformal <em>Informal</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.Actor#getFormal <em>Formal</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getActor()
 * @model annotation="MetaData guid='{6BD046FA-A800-46db-83FA-138E3CF484CC}' id='-1412318172' EA\040name='Actor'"
 *        extendedMetaData="name='ACTOR' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='ACTORS'"
 * @generated
 */
public interface Actor extends Identifiable
{
  /**
   * Returns the value of the '<em><b>Informal</b></em>' attribute.
   * The default value is <code>""</code>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * Provides the possibility to capture the informal description of the contribution of a particular actor
   * <!-- end-model-doc -->
   * @return the value of the '<em>Informal</em>' attribute.
   * @see #isSetInformal()
   * @see #unsetInformal()
   * @see #setInformal(String)
   * @see org.safe.metamodel.safe10.Safe10Package#getActor_Informal()
   * @model default="" unsettable="true" dataType="org.safe.metamodel.safe10.String"
   *        annotation="MetaData guid='{D1D90C66-E6C7-491b-9630-959E5EEC02B3}' id='1128861426' EA\040name='informal'"
   *        extendedMetaData="name='INFORMAL' kind='attribute'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='INFORMALS' xmlAttribute='true' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  String getInformal();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.Actor#getInformal <em>Informal</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Informal</em>' attribute.
   * @see #isSetInformal()
   * @see #Informal()
   * @see #getInformal()
   * @generated
   */
  void setInformal(String value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.Actor#getInformal <em>Informal</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetInformal()
   * @see #getInformal()
   * @see #setInformal(String)
   * @generated
   */
  void unsetInformal();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.Actor#getInformal <em>Informal</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Informal</em>' attribute is set.
   * @see #Informal()
   * @see #getInformal()
   * @see #setInformal(String)
   * @generated
   */
  boolean isSetInformal();

  /**
   * Returns the value of the '<em><b>Formal</b></em>' attribute.
   * The default value is <code>""</code>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * Provides the possibility to capture the formal description of the contribution of a particular actor
   * <!-- end-model-doc -->
   * @return the value of the '<em>Formal</em>' attribute.
   * @see #isSetFormal()
   * @see #unsetFormal()
   * @see #setFormal(String)
   * @see org.safe.metamodel.safe10.Safe10Package#getActor_Formal()
   * @model default="" unsettable="true" dataType="org.safe.metamodel.safe10.String" required="true"
   *        annotation="MetaData guid='{D1DB2CFF-10E0-467c-8944-1389B7422F03}' id='-135894443' EA\040name='formal'"
   *        extendedMetaData="name='FORMAL' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='FORMALS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  String getFormal();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.Actor#getFormal <em>Formal</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Formal</em>' attribute.
   * @see #isSetFormal()
   * @see #Formal()
   * @see #getFormal()
   * @generated
   */
  void setFormal(String value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.Actor#getFormal <em>Formal</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetFormal()
   * @see #getFormal()
   * @see #setFormal(String)
   * @generated
   */
  void unsetFormal();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.Actor#getFormal <em>Formal</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Formal</em>' attribute is set.
   * @see #Formal()
   * @see #getFormal()
   * @see #setFormal(String)
   * @generated
   */
  boolean isSetFormal();

} // Actor
