/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Aliveness Monitor</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * The aliveness monitor contains the set of mapped checkpoint definitions to executable entities. The set of checkpoints contained in the mechanism defines the scope of a specific mechanism instance.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.SoftwareSafetyRequirements.AlivenessMonitor.AlivenessMonitor</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.AlivenessMonitor#getCheckpoints <em>Checkpoints</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getAlivenessMonitor()
 * @model annotation="MetaData guid='{77B7C8E7-73ED-4d7a-B327-A34FD93C0D77}' id='232' EA\040name='AlivenessMonitor'"
 *        extendedMetaData="name='ALIVENESS-MONITOR' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='ALIVENESS-MONITORS'"
 * @generated
 */
public interface AlivenessMonitor extends SoftwareSafetyRequirement
{
  /**
   * Returns the value of the '<em><b>Checkpoints</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.CheckPoint}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * The set of checkpoints used to monitor aliveness of a runnable component.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Checkpoints</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getAlivenessMonitor_Checkpoints()
   * @model containment="true" required="true"
   *        annotation="MetaData guid='{D86589CE-B88E-4386-AB23-46CEFCB3759F}' id='155' EA\040name=''"
   *        extendedMetaData="name='CHECKPOINTS' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='CHECKPOINTSS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<CheckPoint> getCheckpoints();

} // AlivenessMonitor
