/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import autosar40.bswmodule.bswinterfaces.BswModuleEntry;

import autosar40.ecuresource.HwElement;

import autosar40.swcomponent.composition.SwComponentPrototype;

import org.eatop.eel.eastadl21.AnalysisFunctionPrototype;
import org.eatop.eel.eastadl21.DesignFunctionPrototype;
import org.eatop.eel.eastadl21.HardwareComponentPrototype;
import org.eatop.eel.eastadl21.VehicleFeature;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Allocation Targets</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Elements to which AllocatableElements can be allocated.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.AllocationTargets</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.AllocationTargets#getSatisfyingSWComponent <em>Satisfying SW Component</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.AllocationTargets#getSatisfyingAnalysisFunction <em>Satisfying Analysis Function</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.AllocationTargets#getSatisfyingHWComponent <em>Satisfying HW Component</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.AllocationTargets#getSatisfyingBSWModule <em>Satisfying BSW Module</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.AllocationTargets#getSatisfyingHWElement <em>Satisfying HW Element</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.AllocationTargets#getSatisfyingFeature <em>Satisfying Feature</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.AllocationTargets#getSatisfyingDesignFunction <em>Satisfying Design Function</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getAllocationTargets()
 * @model annotation="MetaData guid='{DFDD482C-4281-4a26-8E50-997ADC88EEC9}' id='-288632561' EA\040name='AllocationTargets'"
 *        extendedMetaData="name='ALLOCATION-TARGETS' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='ALLOCATION-TARGETSS'"
 * @generated
 */
public interface AllocationTargets extends Identifiable
{
  /**
   * Returns the value of the '<em><b>Satisfying SW Component</b></em>' reference list.
   * The list contents are of type {@link autosar40.swcomponent.composition.SwComponentPrototype}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Satisfying SW Component</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Satisfying SW Component</em>' reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getAllocationTargets_SatisfyingSWComponent()
   * @model annotation="MetaData guid='{30F6690E-604E-4734-8B51-1751186278A4}' id='-1137156403' EA\040name=''"
   *        extendedMetaData="name='SATISFYING-SW-COMPONENT-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SATISFYING-SW-COMPONENT-REFS' xmlAttribute='false' featureWrapperElement='true' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  EList<SwComponentPrototype> getSatisfyingSWComponent();

  /**
   * Returns the value of the '<em><b>Satisfying Analysis Function</b></em>' reference list.
   * The list contents are of type {@link org.eatop.eel.eastadl21.AnalysisFunctionPrototype}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Satisfying Analysis Function</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Satisfying Analysis Function</em>' reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getAllocationTargets_SatisfyingAnalysisFunction()
   * @model annotation="MetaData guid='{25B9DA63-A7CF-473b-899C-425C18377A68}' id='-982996559' EA\040name=''"
   *        extendedMetaData="name='SATISFYING-ANALYSIS-FUNCTION-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SATISFYING-ANALYSIS-FUNCTION-REFS' xmlAttribute='false' featureWrapperElement='true' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  EList<AnalysisFunctionPrototype> getSatisfyingAnalysisFunction();

  /**
   * Returns the value of the '<em><b>Satisfying HW Component</b></em>' reference list.
   * The list contents are of type {@link org.eatop.eel.eastadl21.HardwareComponentPrototype}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Satisfying HW Component</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Satisfying HW Component</em>' reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getAllocationTargets_SatisfyingHWComponent()
   * @model annotation="MetaData guid='{255F10F9-FEA9-4461-8FEC-5E10AD95C024}' id='-852538553' EA\040name=''"
   *        extendedMetaData="name='SATISFYING-HW-COMPONENT-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SATISFYING-HW-COMPONENT-REFS' xmlAttribute='false' featureWrapperElement='true' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  EList<HardwareComponentPrototype> getSatisfyingHWComponent();

  /**
   * Returns the value of the '<em><b>Satisfying BSW Module</b></em>' reference list.
   * The list contents are of type {@link autosar40.bswmodule.bswinterfaces.BswModuleEntry}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Satisfying BSW Module</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Satisfying BSW Module</em>' reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getAllocationTargets_SatisfyingBSWModule()
   * @model annotation="MetaData guid='{118AF619-C3CC-4fda-B98A-7B247FF66322}' id='760535050' EA\040name=''"
   *        extendedMetaData="name='SATISFYING-BSW-MODULE-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SATISFYING-BSW-MODULE-REFS' xmlAttribute='false' featureWrapperElement='true' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  EList<BswModuleEntry> getSatisfyingBSWModule();

  /**
   * Returns the value of the '<em><b>Satisfying HW Element</b></em>' reference list.
   * The list contents are of type {@link autosar40.ecuresource.HwElement}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Satisfying HW Element</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Satisfying HW Element</em>' reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getAllocationTargets_SatisfyingHWElement()
   * @model annotation="MetaData guid='{46A80C1E-D960-412c-9C92-0B6C08111A54}' id='1035076988' EA\040name=''"
   *        extendedMetaData="name='SATISFYING-HW-ELEMENT-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SATISFYING-HW-ELEMENT-REFS' xmlAttribute='false' featureWrapperElement='true' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  EList<HwElement> getSatisfyingHWElement();

  /**
   * Returns the value of the '<em><b>Satisfying Feature</b></em>' reference list.
   * The list contents are of type {@link org.eatop.eel.eastadl21.VehicleFeature}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Satisfying Feature</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Satisfying Feature</em>' reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getAllocationTargets_SatisfyingFeature()
   * @model annotation="MetaData guid='{C687FD2F-3628-4dea-8D8D-781B4F9478C6}' id='1410567792' EA\040name=''"
   *        extendedMetaData="name='SATISFYING-FEATURE-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SATISFYING-FEATURE-REFS' xmlAttribute='false' featureWrapperElement='true' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  EList<VehicleFeature> getSatisfyingFeature();

  /**
   * Returns the value of the '<em><b>Satisfying Design Function</b></em>' reference list.
   * The list contents are of type {@link org.eatop.eel.eastadl21.DesignFunctionPrototype}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Satisfying Design Function</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Satisfying Design Function</em>' reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getAllocationTargets_SatisfyingDesignFunction()
   * @model annotation="MetaData guid='{2F6A8AE4-9CE4-4523-B28A-DDF714DD0058}' id='1931139614' EA\040name=''"
   *        extendedMetaData="name='SATISFYING-DESIGN-FUNCTION-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SATISFYING-DESIGN-FUNCTION-REFS' xmlAttribute='false' featureWrapperElement='true' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  EList<DesignFunctionPrototype> getSatisfyingDesignFunction();

} // AllocationTargets
