/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Autosar Comparison Param</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * AUTOSAR specific comparison parameters. Allows to reference AUTOSAR elements used in the comparison.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.SoftwareSafetyRequirements.Comparison.AutosarComparisonParam</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.AutosarComparisonParam#getTarget <em>Target</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getAutosarComparisonParam()
 * @model annotation="MetaData guid='{8FF8523B-2B78-4150-BE0B-0968C84614A0}' id='237' EA\040name='AutosarComparisonParam'"
 *        extendedMetaData="name='AUTOSAR-COMPARISON-PARAM' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='AUTOSAR-COMPARISON-PARAMS'"
 * @generated
 */
public interface AutosarComparisonParam extends ComparisonParameter
{
  /**
   * Returns the value of the '<em><b>Target</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * The target variable data prototype of an AUTOSAR software component which provides a value for the comparison operation.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Target</em>' containment reference.
   * @see #setTarget(AutosarVariableDataPrototypeInstanceRef)
   * @see org.safe.metamodel.safe10.Safe10Package#getAutosarComparisonParam_Target()
   * @model containment="true" required="true"
   *        annotation="MetaData guid='{902B0B9A-8C89-4eeb-9B29-F954FFF2F228}' id='1387194336' EA\040name=''"
   *        extendedMetaData="name='TARGET' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='TARGETS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  AutosarVariableDataPrototypeInstanceRef getTarget();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.AutosarComparisonParam#getTarget <em>Target</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Target</em>' containment reference.
   * @see #getTarget()
   * @generated
   */
  void setTarget(AutosarVariableDataPrototypeInstanceRef value);

} // AutosarComparisonParam
