/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import autosar40.swcomponent.composition.SwComponentPrototype;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Autosar Component In Composition Instance Ref</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * A reference to an AUTOSAR software component within a software component composition instance which finds itself in another model / file.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.CommonStructure.AUTOSARInstanceRefs.AutosarComponentInCompositionInstanceRef</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.AutosarComponentInCompositionInstanceRef#getTargetComponent <em>Target Component</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getAutosarComponentInCompositionInstanceRef()
 * @model annotation="MetaData guid='{9AFC4081-5844-4276-916B-64130B3CBC6C}' id='1883423642' EA\040name='AutosarComponentInCompositionInstanceRef'"
 *        extendedMetaData="name='AUTOSAR-COMPONENT-IN-COMPOSITION-INSTANCE-REF' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='AUTOSAR-COMPONENT-IN-COMPOSITION-INSTANCE-REFS'"
 * @generated
 */
public interface AutosarComponentInCompositionInstanceRef extends AutosarAbstractComponentInstanceRef
{
  /**
   * Returns the value of the '<em><b>Target Component</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Target Component</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Target Component</em>' reference.
   * @see #setTargetComponent(SwComponentPrototype)
   * @see org.safe.metamodel.safe10.Safe10Package#getAutosarComponentInCompositionInstanceRef_TargetComponent()
   * @model required="true"
   *        annotation="MetaData guid='{2B024A7D-0650-426a-9BDB-8220A7725334}' id='1944021250' EA\040name=''"
   *        extendedMetaData="name='TARGET-COMPONENT-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='TARGET-COMPONENT-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  SwComponentPrototype getTargetComponent();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.AutosarComponentInCompositionInstanceRef#getTargetComponent <em>Target Component</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Target Component</em>' reference.
   * @see #getTargetComponent()
   * @generated
   */
  void setTargetComponent(SwComponentPrototype value);

} // AutosarComponentInCompositionInstanceRef
