/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import autosar40.commonstructure.modedeclaration.ModeDeclaration;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Autosar Context</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * AUTOSAR specific meta class for defining the context used by the range check SSR.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.SoftwareSafetyRequirements.ContextRangeCheck.AutosarContext</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.AutosarContext#getContext <em>Context</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.AutosarContext#getModeDeclaration <em>Mode Declaration</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getAutosarContext()
 * @model annotation="MetaData guid='{CCCF3421-76BB-49ce-AE47-99971376AA9B}' id='245' EA\040name='AutosarContext'"
 *        extendedMetaData="name='AUTOSAR-CONTEXT' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='AUTOSAR-CONTEXTS'"
 * @generated
 */
public interface AutosarContext extends RangeCheckContext
{
  /**
   * Returns the value of the '<em><b>Context</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * The instance of a mode group declaration whose modes are used to define a value range context
   * <!-- end-model-doc -->
   * @return the value of the '<em>Context</em>' containment reference.
   * @see #setContext(AutosarModeInPortFromComponentInCompositionInstanceRef)
   * @see org.safe.metamodel.safe10.Safe10Package#getAutosarContext_Context()
   * @model containment="true" required="true"
   *        annotation="MetaData guid='{3B713031-7006-4937-BC84-1F47E8769E29}' id='-1465329729' EA\040name=''"
   *        extendedMetaData="name='CONTEXT' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='CONTEXTS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  AutosarModeInPortFromComponentInCompositionInstanceRef getContext();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.AutosarContext#getContext <em>Context</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Context</em>' containment reference.
   * @see #getContext()
   * @generated
   */
  void setContext(AutosarModeInPortFromComponentInCompositionInstanceRef value);

  /**
   * Returns the value of the '<em><b>Mode Declaration</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Mode Declaration</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Mode Declaration</em>' reference.
   * @see #setModeDeclaration(ModeDeclaration)
   * @see org.safe.metamodel.safe10.Safe10Package#getAutosarContext_ModeDeclaration()
   * @model required="true"
   *        annotation="MetaData guid='{679CEB40-E361-4b2e-BD2A-6456B4C44CEA}' id='-610587656' EA\040name=''"
   *        extendedMetaData="name='MODE-DECLARATION-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='MODE-DECLARATION-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  ModeDeclaration getModeDeclaration();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.AutosarContext#getModeDeclaration <em>Mode Declaration</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Mode Declaration</em>' reference.
   * @see #getModeDeclaration()
   * @generated
   */
  void setModeDeclaration(ModeDeclaration value);

} // AutosarContext
