/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Autosar Context Range Check</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * AUTOSAR specific meta class defining the context range check SSR.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.SoftwareSafetyRequirements.ContextRangeCheck.AutosarContextRangeCheck</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.AutosarContextRangeCheck#getChecked <em>Checked</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getAutosarContextRangeCheck()
 * @model annotation="MetaData guid='{7CFE7146-FD7E-4ac4-9CBA-DB5C74B668AB}' id='247' EA\040name='AutosarContextRangeCheck'"
 *        extendedMetaData="name='AUTOSAR-CONTEXT-RANGE-CHECK' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='AUTOSAR-CONTEXT-RANGE-CHECKS'"
 * @generated
 */
public interface AutosarContextRangeCheck extends ContextRangeCheck
{
  /**
   * Returns the value of the '<em><b>Checked</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * The variable data prototype of an AUTOSAR software component whose range is monitored
   * <!-- end-model-doc -->
   * @return the value of the '<em>Checked</em>' containment reference.
   * @see #setChecked(AutosarVariableDataPrototypeInstanceRef)
   * @see org.safe.metamodel.safe10.Safe10Package#getAutosarContextRangeCheck_Checked()
   * @model containment="true" required="true"
   *        annotation="MetaData guid='{6C3548B7-5806-473c-80EA-DA314F1E41F9}' id='1158808161' EA\040name=''"
   *        extendedMetaData="name='CHECKED' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='CHECKEDS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  AutosarVariableDataPrototypeInstanceRef getChecked();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.AutosarContextRangeCheck#getChecked <em>Checked</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Checked</em>' containment reference.
   * @see #getChecked()
   * @generated
   */
  void setChecked(AutosarVariableDataPrototypeInstanceRef value);

} // AutosarContextRangeCheck
