/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Autosar Gradient Check</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * AUTOSAR specific meta class for defining the gradient check SSR.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.SoftwareSafetyRequirements.GradientCheck.AutosarGradientCheck</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.AutosarGradientCheck#getObserved <em>Observed</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getAutosarGradientCheck()
 * @model annotation="MetaData guid='{27512B81-936B-4a24-9F87-A4D31CE40877}' id='260' EA\040name='AutosarGradientCheck'"
 *        extendedMetaData="name='AUTOSAR-GRADIENT-CHECK' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='AUTOSAR-GRADIENT-CHECKS'"
 * @generated
 */
public interface AutosarGradientCheck extends GradientCheck
{
  /**
   * Returns the value of the '<em><b>Observed</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * The AUTOSAR variable data prototype instance to be monitored by the gradient check
   * <!-- end-model-doc -->
   * @return the value of the '<em>Observed</em>' containment reference.
   * @see #setObserved(AutosarVariableDataPrototypeInstanceRef)
   * @see org.safe.metamodel.safe10.Safe10Package#getAutosarGradientCheck_Observed()
   * @model containment="true" required="true"
   *        annotation="MetaData guid='{A7EA15CE-5B15-42b7-9665-89ABCD79AF55}' id='1405591557' EA\040name=''"
   *        extendedMetaData="name='OBSERVED' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='OBSERVEDS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  AutosarVariableDataPrototypeInstanceRef getObserved();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.AutosarGradientCheck#getObserved <em>Observed</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Observed</em>' containment reference.
   * @see #getObserved()
   * @generated
   */
  void setObserved(AutosarVariableDataPrototypeInstanceRef value);

} // AutosarGradientCheck
