/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import autosar40.ecuresource.HwElement;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Autosar Hardware Safety Extension</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * This class represent the Safety Extension point for referenced element of Hardware Element as part of a component (respectively AUTOSAR HW Element Type) to allow the capture of hardware failure and summary failure quantified contribution to HWComponent.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.CommonStructure.SafetyExtensions.ImplementationSafetyExtension.AutosarHardwareSafetyExtension</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.AutosarHardwareSafetyExtension#getHardwarePartSafetyAnalysis <em>Hardware Part Safety Analysis</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.AutosarHardwareSafetyExtension#getScope <em>Scope</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.AutosarHardwareSafetyExtension#getRamdomHardwarePartFailure <em>Ramdom Hardware Part Failure</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getAutosarHardwareSafetyExtension()
 * @model annotation="MetaData guid='{C187A87F-3ADA-4439-B225-567BA7533EE9}' id='-101655698' EA\040name='AutosarHardwareSafetyExtension'"
 *        extendedMetaData="name='AUTOSAR-HARDWARE-SAFETY-EXTENSION' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='AUTOSAR-HARDWARE-SAFETY-EXTENSIONS'"
 * @generated
 */
public interface AutosarHardwareSafetyExtension extends AutosarSafetyExtension
{
  /**
   * Returns the value of the '<em><b>Hardware Part Safety Analysis</b></em>' reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.HWPartFailureAnalysis}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Hardware Part Safety Analysis</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Hardware Part Safety Analysis</em>' reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getAutosarHardwareSafetyExtension_HardwarePartSafetyAnalysis()
   * @model annotation="MetaData guid='{B7F73D01-7694-455f-B1C4-48456058DB1F}' id='-491465961' EA\040name=''"
   *        extendedMetaData="name='HARDWARE-PART-SAFETY-ANALYSIS-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HARDWARE-PART-SAFETY-ANALYSIS-REFS' xmlAttribute='false' featureWrapperElement='true' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  EList<HWPartFailureAnalysis> getHardwarePartSafetyAnalysis();

  /**
   * Returns the value of the '<em><b>Scope</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Scope</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Scope</em>' reference.
   * @see #setScope(HwElement)
   * @see org.safe.metamodel.safe10.Safe10Package#getAutosarHardwareSafetyExtension_Scope()
   * @model required="true"
   *        annotation="MetaData guid='{D1FA7598-DC89-401b-8F18-A13C34EA16FA}' id='1026299236' EA\040name=''"
   *        extendedMetaData="name='SCOPE-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SCOPE-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  HwElement getScope();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.AutosarHardwareSafetyExtension#getScope <em>Scope</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Scope</em>' reference.
   * @see #getScope()
   * @generated
   */
  void setScope(HwElement value);

  /**
   * Returns the value of the '<em><b>Ramdom Hardware Part Failure</b></em>' reference.
   * It is bidirectional and its opposite is '{@link org.safe.metamodel.safe10.HWPartFailure#getNameWasNotSet_3 <em>Name Was Not Set 3</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Ramdom Hardware Part Failure</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Ramdom Hardware Part Failure</em>' reference.
   * @see #setRamdomHardwarePartFailure(HWPartFailure)
   * @see org.safe.metamodel.safe10.Safe10Package#getAutosarHardwareSafetyExtension_RamdomHardwarePartFailure()
   * @see org.safe.metamodel.safe10.HWPartFailure#getNameWasNotSet_3
   * @model opposite="NameWasNotSet_3"
   *        extendedMetaData="name='RAMDOM-HARDWARE-PART-FAILURE-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='RAMDOM-HARDWARE-PART-FAILURE-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  HWPartFailure getRamdomHardwarePartFailure();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.AutosarHardwareSafetyExtension#getRamdomHardwarePartFailure <em>Ramdom Hardware Part Failure</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Ramdom Hardware Part Failure</em>' reference.
   * @see #getRamdomHardwarePartFailure()
   * @generated
   */
  void setRamdomHardwarePartFailure(HWPartFailure value);

} // AutosarHardwareSafetyExtension
