/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import autosar40.swcomponent.components.SwComponentType;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Autosar Vfb Safety Extension</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * This meta-class defines the element used for specifications of SAFE extensions at VFB level on AUTOSAR. This means elements which relate to a composition directly, not yet in a given system context.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.CommonStructure.SafetyExtensions.ImplementationSafetyExtension.AutosarVfbSafetyExtension</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.AutosarVfbSafetyExtension#getScope <em>Scope</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getAutosarVfbSafetyExtension()
 * @model annotation="MetaData guid='{42361252-6919-4049-8BC5-554D5B4C347D}' id='207' EA\040name='AutosarVfbSafetyExtension'"
 *        extendedMetaData="name='AUTOSAR-VFB-SAFETY-EXTENSION' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='AUTOSAR-VFB-SAFETY-EXTENSIONS'"
 * @generated
 */
public interface AutosarVfbSafetyExtension extends AutosarSafetyExtension
{
  /**
   * Returns the value of the '<em><b>Scope</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Scope</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Scope</em>' reference.
   * @see #setScope(SwComponentType)
   * @see org.safe.metamodel.safe10.Safe10Package#getAutosarVfbSafetyExtension_Scope()
   * @model required="true"
   *        annotation="MetaData guid='{FB4592A2-BA8E-417f-9E44-0AA6AE7E3572}' id='860291526' EA\040name=''"
   *        extendedMetaData="name='SCOPE-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SCOPE-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  SwComponentType getScope();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.AutosarVfbSafetyExtension#getScope <em>Scope</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Scope</em>' reference.
   * @see #getScope()
   * @generated
   */
  void setScope(SwComponentType value);

} // AutosarVfbSafetyExtension
