/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Check Point</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * A checkpoint provides the attributes necessary for checking if a given executable unity is being triggered correctly by the system.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.SoftwareSafetyRequirements.AlivenessMonitor.CheckPoint</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.CheckPoint#getLowerTolerance <em>Lower Tolerance</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.CheckPoint#getMaxReport <em>Max Report</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.CheckPoint#getUpperTolerance <em>Upper Tolerance</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.CheckPoint#getPeriod <em>Period</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getCheckPoint()
 * @model annotation="MetaData guid='{4D5290A2-3233-45c3-887E-B6550FC91EE4}' id='226' EA\040name='CheckPoint'"
 *        extendedMetaData="name='CHECK-POINT' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='CHECK-POINTS'"
 * @generated
 */
public interface CheckPoint extends Identifiable
{
  /**
   * Returns the value of the '<em><b>Lower Tolerance</b></em>' attribute.
   * The default value is <code>"0.0"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Lower Tolerance</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Lower Tolerance</em>' attribute.
   * @see #isSetLowerTolerance()
   * @see #unsetLowerTolerance()
   * @see #setLowerTolerance(Double)
   * @see org.safe.metamodel.safe10.Safe10Package#getCheckPoint_LowerTolerance()
   * @model default="0.0" unsettable="true" dataType="org.safe.metamodel.safe10.Float" required="true"
   *        annotation="MetaData guid='{E53A0EBF-7EE0-4c8d-94F9-CEAAD1CE8E61}' id='24' EA\040name='lowerTolerance'"
   *        extendedMetaData="name='LOWER-TOLERANCE' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='LOWER-TOLERANCES' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Double getLowerTolerance();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.CheckPoint#getLowerTolerance <em>Lower Tolerance</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Lower Tolerance</em>' attribute.
   * @see #isSetLowerTolerance()
   * @see #LowerTolerance()
   * @see #getLowerTolerance()
   * @generated
   */
  void setLowerTolerance(Double value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.CheckPoint#getLowerTolerance <em>Lower Tolerance</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetLowerTolerance()
   * @see #getLowerTolerance()
   * @see #setLowerTolerance(Double)
   * @generated
   */
  void unsetLowerTolerance();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.CheckPoint#getLowerTolerance <em>Lower Tolerance</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Lower Tolerance</em>' attribute is set.
   * @see #LowerTolerance()
   * @see #getLowerTolerance()
   * @see #setLowerTolerance(Double)
   * @generated
   */
  boolean isSetLowerTolerance();

  /**
   * Returns the value of the '<em><b>Max Report</b></em>' attribute.
   * The default value is <code>"0"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Max Report</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Max Report</em>' attribute.
   * @see #isSetMaxReport()
   * @see #unsetMaxReport()
   * @see #setMaxReport(Integer)
   * @see org.safe.metamodel.safe10.Safe10Package#getCheckPoint_MaxReport()
   * @model default="0" unsettable="true" dataType="org.safe.metamodel.safe10.Integer" required="true"
   *        annotation="MetaData guid='{C28B421C-5F4F-4d35-83F4-8696314E5056}' id='25' EA\040name='maxReport'"
   *        extendedMetaData="name='MAX-REPORT' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='MAX-REPORTS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Integer getMaxReport();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.CheckPoint#getMaxReport <em>Max Report</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Max Report</em>' attribute.
   * @see #isSetMaxReport()
   * @see #MaxReport()
   * @see #getMaxReport()
   * @generated
   */
  void setMaxReport(Integer value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.CheckPoint#getMaxReport <em>Max Report</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetMaxReport()
   * @see #getMaxReport()
   * @see #setMaxReport(Integer)
   * @generated
   */
  void unsetMaxReport();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.CheckPoint#getMaxReport <em>Max Report</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Max Report</em>' attribute is set.
   * @see #MaxReport()
   * @see #getMaxReport()
   * @see #setMaxReport(Integer)
   * @generated
   */
  boolean isSetMaxReport();

  /**
   * Returns the value of the '<em><b>Upper Tolerance</b></em>' attribute.
   * The default value is <code>"0.0"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Upper Tolerance</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Upper Tolerance</em>' attribute.
   * @see #isSetUpperTolerance()
   * @see #unsetUpperTolerance()
   * @see #setUpperTolerance(Double)
   * @see org.safe.metamodel.safe10.Safe10Package#getCheckPoint_UpperTolerance()
   * @model default="0.0" unsettable="true" dataType="org.safe.metamodel.safe10.Float" required="true"
   *        annotation="MetaData guid='{EB49A80B-E319-446e-99E0-74DF466761CA}' id='26' EA\040name='upperTolerance'"
   *        extendedMetaData="name='UPPER-TOLERANCE' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='UPPER-TOLERANCES' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Double getUpperTolerance();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.CheckPoint#getUpperTolerance <em>Upper Tolerance</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Upper Tolerance</em>' attribute.
   * @see #isSetUpperTolerance()
   * @see #UpperTolerance()
   * @see #getUpperTolerance()
   * @generated
   */
  void setUpperTolerance(Double value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.CheckPoint#getUpperTolerance <em>Upper Tolerance</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetUpperTolerance()
   * @see #getUpperTolerance()
   * @see #setUpperTolerance(Double)
   * @generated
   */
  void unsetUpperTolerance();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.CheckPoint#getUpperTolerance <em>Upper Tolerance</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Upper Tolerance</em>' attribute is set.
   * @see #UpperTolerance()
   * @see #getUpperTolerance()
   * @see #setUpperTolerance(Double)
   * @generated
   */
  boolean isSetUpperTolerance();

  /**
   * Returns the value of the '<em><b>Period</b></em>' attribute.
   * The default value is <code>"0"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Period</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Period</em>' attribute.
   * @see #isSetPeriod()
   * @see #unsetPeriod()
   * @see #setPeriod(Integer)
   * @see org.safe.metamodel.safe10.Safe10Package#getCheckPoint_Period()
   * @model default="0" unsettable="true" dataType="org.safe.metamodel.safe10.Integer" required="true"
   *        annotation="MetaData guid='{C2892868-3685-4344-9C11-877E65A36695}' id='1354892504' EA\040name='period'"
   *        extendedMetaData="name='PERIOD' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='PERIODS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Integer getPeriod();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.CheckPoint#getPeriod <em>Period</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Period</em>' attribute.
   * @see #isSetPeriod()
   * @see #Period()
   * @see #getPeriod()
   * @generated
   */
  void setPeriod(Integer value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.CheckPoint#getPeriod <em>Period</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetPeriod()
   * @see #getPeriod()
   * @see #setPeriod(Integer)
   * @generated
   */
  void unsetPeriod();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.CheckPoint#getPeriod <em>Period</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Period</em>' attribute is set.
   * @see #Period()
   * @see #getPeriod()
   * @see #setPeriod(Integer)
   * @generated
   */
  boolean isSetPeriod();

} // CheckPoint
