/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Chromosome Component Mode Condition</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * A CHROMOSOME specific condition referencing a Mode of a certain CHROMOSOME  component instance. The condition is fired when the component is monitored by the Health Monitor and enters mode specified by triggeredBy relation.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.SoftwareSafetyRequirements.HealthMonitor.ChromosomeComponentModeCondition</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.ChromosomeComponentModeCondition#getTriggeredBy <em>Triggered By</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getChromosomeComponentModeCondition()
 * @model annotation="MetaData guid='{1EF75B1F-2F89-4d03-835F-C0830F77FA5A}' id='-1754484081' EA\040name='ChromosomeComponentModeCondition'"
 *        extendedMetaData="name='CHROMOSOME-COMPONENT-MODE-CONDITION' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='CHROMOSOME-COMPONENT-MODE-CONDITIONS'"
 * @generated
 */
public interface ChromosomeComponentModeCondition extends HealthMonitorErrorCondition
{
  /**
   * Returns the value of the '<em><b>Triggered By</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Triggered By</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Triggered By</em>' reference.
   * @see #setTriggeredBy(ComponentModeInstanceRef)
   * @see org.safe.metamodel.safe10.Safe10Package#getChromosomeComponentModeCondition_TriggeredBy()
   * @model required="true"
   *        annotation="MetaData guid='{78CF3D7F-7475-4096-96ED-4A653278557B}' id='1985966298' EA\040name=''"
   *        extendedMetaData="name='TRIGGERED-BY-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='TRIGGERED-BY-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  ComponentModeInstanceRef getTriggeredBy();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.ChromosomeComponentModeCondition#getTriggeredBy <em>Triggered By</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Triggered By</em>' reference.
   * @see #getTriggeredBy()
   * @generated
   */
  void setTriggeredBy(ComponentModeInstanceRef value);

} // ChromosomeComponentModeCondition
