/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Context Parameter</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Provides the valid range parameters for a given context.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.SoftwareSafetyRequirements.ContextRangeCheck.ContextParameter</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.ContextParameter#getValue <em>Value</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getContextParameter()
 * @model annotation="MetaData guid='{49F648B8-51B2-466c-A8B3-2F27A0884101}' id='242' EA\040name='ContextParameter'"
 *        extendedMetaData="name='CONTEXT-PARAMETER' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='CONTEXT-PARAMETERS'"
 * @generated
 */
public interface ContextParameter extends Identifiable
{
  /**
   * Returns the value of the '<em><b>Value</b></em>' attribute.
   * The default value is <code>"0.0"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Value</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Value</em>' attribute.
   * @see #isSetValue()
   * @see #unsetValue()
   * @see #setValue(Double)
   * @see org.safe.metamodel.safe10.Safe10Package#getContextParameter_Value()
   * @model default="0.0" unsettable="true" dataType="org.safe.metamodel.safe10.Float" required="true"
   *        annotation="MetaData guid='{7D424D0B-CF84-463a-9877-5210FAC11788}' id='34' EA\040name='value'"
   *        extendedMetaData="name='VALUE' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='VALUES' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Double getValue();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.ContextParameter#getValue <em>Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Value</em>' attribute.
   * @see #isSetValue()
   * @see #Value()
   * @see #getValue()
   * @generated
   */
  void setValue(Double value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.ContextParameter#getValue <em>Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetValue()
   * @see #getValue()
   * @see #setValue(Double)
   * @generated
   */
  void unsetValue();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.ContextParameter#getValue <em>Value</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Value</em>' attribute is set.
   * @see #Value()
   * @see #getValue()
   * @see #setValue(Double)
   * @generated
   */
  boolean isSetValue();

} // ContextParameter
