/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Context Range Check</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * This meta-class defines a range check SSR whose range is defined based on the current system/component context (e.g. AUTOSAR mode).
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.SoftwareSafetyRequirements.ContextRangeCheck.ContextRangeCheck</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.ContextRangeCheck#getDefault <em>Default</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.ContextRangeCheck#getAdditional <em>Additional</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getContextRangeCheck()
 * @model annotation="MetaData guid='{05428801-D6BE-4ab3-A154-7867A566B50F}' id='238' EA\040name='ContextRangeCheck'"
 *        extendedMetaData="name='CONTEXT-RANGE-CHECK' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='CONTEXT-RANGE-CHECKS'"
 * @generated
 */
public interface ContextRangeCheck extends SoftwareSafetyRequirement
{
  /**
   * Returns the value of the '<em><b>Default</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * The default context required for a context range check.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Default</em>' containment reference.
   * @see #setDefault(RangeCheckContext)
   * @see org.safe.metamodel.safe10.Safe10Package#getContextRangeCheck_Default()
   * @model containment="true" required="true"
   *        annotation="MetaData guid='{3A007088-F40B-44a8-8E31-70E6280DAB3A}' id='142' EA\040name=''"
   *        extendedMetaData="name='DEFAULT' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='DEFAULTS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  RangeCheckContext getDefault();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.ContextRangeCheck#getDefault <em>Default</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Default</em>' containment reference.
   * @see #getDefault()
   * @generated
   */
  void setDefault(RangeCheckContext value);

  /**
   * Returns the value of the '<em><b>Additional</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.RangeCheckContext}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * The additional context specifications for a context range check.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Additional</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getContextRangeCheck_Additional()
   * @model containment="true"
   *        annotation="MetaData guid='{52740858-C2F4-4f83-A1EF-A426434B2EDA}' id='1710609379' EA\040name=''"
   *        extendedMetaData="name='ADDITIONAL' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='ADDITIONALS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<RangeCheckContext> getAdditional();

} // ContextRangeCheck
