/**
 */
package org.safe.metamodel.safe10;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Control Flow Policy</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * <!-- begin-model-doc -->
 * null
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.SoftwareSafetyRequirements.ControlFlowMonitor.ControlFlowPolicy</b></em> 
 * <!-- end-model-doc -->
 * @see org.safe.metamodel.safe10.Safe10Package#getControlFlowPolicy()
 * @model annotation="MetaData guid='{8C57239A-4222-4f1d-82C5-885A3272CBAF}' id='-1689230556' EA\040name='ControlFlowPolicy'"
 *        annotation="Stereotype Stereotype='enumeration'"
 *        extendedMetaData="name='CONTROL-FLOW-POLICY'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='CONTROL-FLOW-POLICYS'"
 * @generated
 */
public enum ControlFlowPolicy implements Enumerator
{
  /**
   * The '<em><b>Read before write</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #READ_BEFORE_WRITE_VALUE
   * @generated
   * @ordered
   */
  READ_BEFORE_WRITE(0, "read_before_write", "READ_BEFORE_WRITE"),

  /**
   * The '<em><b>Write before read</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #WRITE_BEFORE_READ_VALUE
   * @generated
   * @ordered
   */
  WRITE_BEFORE_READ(1, "write_before_read", "WRITE_BEFORE_READ"),

  /**
   * The '<em><b>Sequence</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #SEQUENCE_VALUE
   * @generated
   * @ordered
   */
  SEQUENCE(2, "sequence", "SEQUENCE"),

  /**
   * The '<em><b>Read write block</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #READ_WRITE_BLOCK_VALUE
   * @generated
   * @ordered
   */
  READ_WRITE_BLOCK(3, "read_write_block", "READ_WRITE_BLOCK");

  /**
   * The '<em><b>Read before write</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of '<em><b>Read before write</b></em>' literal object isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @see #READ_BEFORE_WRITE
   * @model name="read_before_write" literal="READ_BEFORE_WRITE"
   * @generated
   * @ordered
   */
  public static final int READ_BEFORE_WRITE_VALUE = 0;

  /**
   * The '<em><b>Write before read</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of '<em><b>Write before read</b></em>' literal object isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @see #WRITE_BEFORE_READ
   * @model name="write_before_read" literal="WRITE_BEFORE_READ"
   * @generated
   * @ordered
   */
  public static final int WRITE_BEFORE_READ_VALUE = 1;

  /**
   * The '<em><b>Sequence</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of '<em><b>Sequence</b></em>' literal object isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @see #SEQUENCE
   * @model name="sequence" literal="SEQUENCE"
   * @generated
   * @ordered
   */
  public static final int SEQUENCE_VALUE = 2;

  /**
   * The '<em><b>Read write block</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of '<em><b>Read write block</b></em>' literal object isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @see #READ_WRITE_BLOCK
   * @model name="read_write_block" literal="READ_WRITE_BLOCK"
   * @generated
   * @ordered
   */
  public static final int READ_WRITE_BLOCK_VALUE = 3;

  /**
   * An array of all the '<em><b>Control Flow Policy</b></em>' enumerators.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private static final ControlFlowPolicy[] VALUES_ARRAY =
    new ControlFlowPolicy[]
    {
      READ_BEFORE_WRITE,
      WRITE_BEFORE_READ,
      SEQUENCE,
      READ_WRITE_BLOCK,
    };

  /**
   * A public read-only list of all the '<em><b>Control Flow Policy</b></em>' enumerators.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final List<ControlFlowPolicy> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

  /**
   * Returns the '<em><b>Control Flow Policy</b></em>' literal with the specified literal value.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static ControlFlowPolicy get(String literal)
  {
    for (int i = 0; i < VALUES_ARRAY.length; ++i)
    {
      ControlFlowPolicy result = VALUES_ARRAY[i];
      if (result.toString().equals(literal))
      {
        return result;
      }
    }
    return null;
  }

  /**
   * Returns the '<em><b>Control Flow Policy</b></em>' literal with the specified name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static ControlFlowPolicy getByName(String name)
  {
    for (int i = 0; i < VALUES_ARRAY.length; ++i)
    {
      ControlFlowPolicy result = VALUES_ARRAY[i];
      if (result.getName().equals(name))
      {
        return result;
      }
    }
    return null;
  }

  /**
   * Returns the '<em><b>Control Flow Policy</b></em>' literal with the specified integer value.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static ControlFlowPolicy get(int value)
  {
    switch (value)
    {
      case READ_BEFORE_WRITE_VALUE: return READ_BEFORE_WRITE;
      case WRITE_BEFORE_READ_VALUE: return WRITE_BEFORE_READ;
      case SEQUENCE_VALUE: return SEQUENCE;
      case READ_WRITE_BLOCK_VALUE: return READ_WRITE_BLOCK;
    }
    return null;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private final int value;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private final String name;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private final String literal;

  /**
   * Only this class can construct instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private ControlFlowPolicy(int value, String name, String literal)
  {
    this.value = value;
    this.name = name;
    this.literal = literal;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public int getValue()
  {
    return value;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getName()
  {
    return name;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getLiteral()
  {
    return literal;
  }

  /**
   * Returns the literal value of the enumerator, which is its string representation.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    return literal;
  }
  
} //ControlFlowPolicy
