/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Controllability Reference</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * The class ControllabilityReference is introduced to provide the possibility to capture diagrams. These diagrams are based on road tests and enable a determination of the controllability parameter of the hazardous event.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Hazards.ControllabilityReference</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.ControllabilityReference#getTableOfValues <em>Table Of Values</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.ControllabilityReference#getFunction <em>Function</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getControllabilityReference()
 * @model annotation="MetaData guid='{F9B3E6C3-775A-447c-87A2-431526F0E23F}' id='-105606735' EA\040name='ControllabilityReference'"
 *        extendedMetaData="name='CONTROLLABILITY-REFERENCE' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='CONTROLLABILITY-REFERENCES'"
 * @generated
 */
public interface ControllabilityReference extends Identifiable
{
  /**
   * Returns the value of the '<em><b>Table Of Values</b></em>' attribute.
   * The default value is <code>""</code>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * Provides the possibility to capture the diagrams in form of tables of values.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Table Of Values</em>' attribute.
   * @see #isSetTableOfValues()
   * @see #unsetTableOfValues()
   * @see #setTableOfValues(String)
   * @see org.safe.metamodel.safe10.Safe10Package#getControllabilityReference_TableOfValues()
   * @model default="" unsettable="true" dataType="org.safe.metamodel.safe10.String"
   *        annotation="MetaData guid='{FFA4C02C-9B0B-48de-9F43-83E0D77FF2D3}' id='-721587385' EA\040name='tableOfValues'"
   *        extendedMetaData="name='TABLE-OF-VALUES' kind='attribute'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='TABLE-OF-VALUESS' xmlAttribute='true' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  String getTableOfValues();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.ControllabilityReference#getTableOfValues <em>Table Of Values</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Table Of Values</em>' attribute.
   * @see #isSetTableOfValues()
   * @see #TableOfValues()
   * @see #getTableOfValues()
   * @generated
   */
  void setTableOfValues(String value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.ControllabilityReference#getTableOfValues <em>Table Of Values</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetTableOfValues()
   * @see #getTableOfValues()
   * @see #setTableOfValues(String)
   * @generated
   */
  void unsetTableOfValues();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.ControllabilityReference#getTableOfValues <em>Table Of Values</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Table Of Values</em>' attribute is set.
   * @see #TableOfValues()
   * @see #getTableOfValues()
   * @see #setTableOfValues(String)
   * @generated
   */
  boolean isSetTableOfValues();

  /**
   * Returns the value of the '<em><b>Function</b></em>' attribute.
   * The default value is <code>""</code>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * Provides the possibility to capture the diagram in form of functions.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Function</em>' attribute.
   * @see #isSetFunction()
   * @see #unsetFunction()
   * @see #setFunction(String)
   * @see org.safe.metamodel.safe10.Safe10Package#getControllabilityReference_Function()
   * @model default="" unsettable="true" dataType="org.safe.metamodel.safe10.String" required="true"
   *        annotation="MetaData guid='{33BB7727-BD24-410d-8EFB-A79515358B38}' id='-689790434' EA\040name='function'"
   *        extendedMetaData="name='FUNCTION' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='FUNCTIONS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  String getFunction();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.ControllabilityReference#getFunction <em>Function</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Function</em>' attribute.
   * @see #isSetFunction()
   * @see #Function()
   * @see #getFunction()
   * @generated
   */
  void setFunction(String value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.ControllabilityReference#getFunction <em>Function</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetFunction()
   * @see #getFunction()
   * @see #setFunction(String)
   * @generated
   */
  void unsetFunction();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.ControllabilityReference#getFunction <em>Function</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Function</em>' attribute is set.
   * @see #Function()
   * @see #getFunction()
   * @see #setFunction(String)
   * @generated
   */
  boolean isSetFunction();

} // ControllabilityReference
