/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Cpu Self Test</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * This meta-class element defines a CPU self-test SSR. The entity implementing such an SSR is executed periodically according to its configuration, and may trigger error handlers in case of error detection.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.SoftwareSafetyRequirements.CpuSelfTest.CpuSelfTest</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.CpuSelfTest#getConfig <em>Config</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getCpuSelfTest()
 * @model annotation="MetaData guid='{863A3105-4EC2-451b-9F55-142B478385EB}' id='114477809' EA\040name='CpuSelfTest'"
 *        extendedMetaData="name='CPU-SELF-TEST' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='CPU-SELF-TESTS'"
 * @generated
 */
public interface CpuSelfTest extends SoftwareSafetyRequirement
{
  /**
   * Returns the value of the '<em><b>Config</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * Configures the CpuSelfTest SSR with execution configuration and definition of a specific test to be executed.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Config</em>' containment reference.
   * @see #setConfig(CpuSelfTestConfig)
   * @see org.safe.metamodel.safe10.Safe10Package#getCpuSelfTest_Config()
   * @model containment="true" required="true"
   *        annotation="MetaData guid='{3DE64BFB-55E7-42af-8355-2C10E69F4D49}' id='1046924095' EA\040name=''"
   *        extendedMetaData="name='CONFIG' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='CONFIGS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  CpuSelfTestConfig getConfig();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.CpuSelfTest#getConfig <em>Config</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Config</em>' containment reference.
   * @see #getConfig()
   * @generated
   */
  void setConfig(CpuSelfTestConfig value);

} // CpuSelfTest
