/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Cpu Self Test Config</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Configuration meta class to configure CPU test SSR.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.SoftwareSafetyRequirements.CpuSelfTest.CpuSelfTestConfig</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.CpuSelfTestConfig#getExecutionPeriodMs <em>Execution Period Ms</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.CpuSelfTestConfig#getExecuteInSegments <em>Execute In Segments</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.CpuSelfTestConfig#getNumSegments <em>Num Segments</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.CpuSelfTestConfig#getAlgorithms <em>Algorithms</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getCpuSelfTestConfig()
 * @model annotation="MetaData guid='{44543DCC-1643-4bbb-A288-91D6F28252B7}' id='24779656' EA\040name='CpuSelfTestConfig'"
 *        extendedMetaData="name='CPU-SELF-TEST-CONFIG' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='CPU-SELF-TEST-CONFIGS'"
 * @generated
 */
public interface CpuSelfTestConfig extends Identifiable
{
  /**
   * Returns the value of the '<em><b>Execution Period Ms</b></em>' attribute.
   * The default value is <code>"0"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Execution Period Ms</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Execution Period Ms</em>' attribute.
   * @see #isSetExecutionPeriodMs()
   * @see #unsetExecutionPeriodMs()
   * @see #setExecutionPeriodMs(Integer)
   * @see org.safe.metamodel.safe10.Safe10Package#getCpuSelfTestConfig_ExecutionPeriodMs()
   * @model default="0" unsettable="true" dataType="org.safe.metamodel.safe10.Integer" required="true"
   *        annotation="MetaData guid='{A137FC5D-1E87-4ccb-BFAA-241C8850E84B}' id='-2139674526' EA\040name='executionPeriodMs'"
   *        extendedMetaData="name='EXECUTION-PERIOD-MS' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='EXECUTION-PERIOD-MSS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Integer getExecutionPeriodMs();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.CpuSelfTestConfig#getExecutionPeriodMs <em>Execution Period Ms</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Execution Period Ms</em>' attribute.
   * @see #isSetExecutionPeriodMs()
   * @see #ExecutionPeriodMs()
   * @see #getExecutionPeriodMs()
   * @generated
   */
  void setExecutionPeriodMs(Integer value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.CpuSelfTestConfig#getExecutionPeriodMs <em>Execution Period Ms</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetExecutionPeriodMs()
   * @see #getExecutionPeriodMs()
   * @see #setExecutionPeriodMs(Integer)
   * @generated
   */
  void unsetExecutionPeriodMs();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.CpuSelfTestConfig#getExecutionPeriodMs <em>Execution Period Ms</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Execution Period Ms</em>' attribute is set.
   * @see #ExecutionPeriodMs()
   * @see #getExecutionPeriodMs()
   * @see #setExecutionPeriodMs(Integer)
   * @generated
   */
  boolean isSetExecutionPeriodMs();

  /**
   * Returns the value of the '<em><b>Execute In Segments</b></em>' attribute.
   * The default value is <code>"false"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Execute In Segments</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Execute In Segments</em>' attribute.
   * @see #isSetExecuteInSegments()
   * @see #unsetExecuteInSegments()
   * @see #setExecuteInSegments(Boolean)
   * @see org.safe.metamodel.safe10.Safe10Package#getCpuSelfTestConfig_ExecuteInSegments()
   * @model default="false" unsettable="true" dataType="org.safe.metamodel.safe10.Boolean" required="true"
   *        annotation="MetaData guid='{1282E6AF-8B6B-45f7-9F8F-358A7A04DDA7}' id='1371153723' EA\040name='executeInSegments'"
   *        extendedMetaData="name='EXECUTE-IN-SEGMENTS' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='EXECUTE-IN-SEGMENTSS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Boolean getExecuteInSegments();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.CpuSelfTestConfig#getExecuteInSegments <em>Execute In Segments</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Execute In Segments</em>' attribute.
   * @see #isSetExecuteInSegments()
   * @see #ExecuteInSegments()
   * @see #getExecuteInSegments()
   * @generated
   */
  void setExecuteInSegments(Boolean value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.CpuSelfTestConfig#getExecuteInSegments <em>Execute In Segments</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetExecuteInSegments()
   * @see #getExecuteInSegments()
   * @see #setExecuteInSegments(Boolean)
   * @generated
   */
  void unsetExecuteInSegments();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.CpuSelfTestConfig#getExecuteInSegments <em>Execute In Segments</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Execute In Segments</em>' attribute is set.
   * @see #ExecuteInSegments()
   * @see #getExecuteInSegments()
   * @see #setExecuteInSegments(Boolean)
   * @generated
   */
  boolean isSetExecuteInSegments();

  /**
   * Returns the value of the '<em><b>Num Segments</b></em>' attribute.
   * The default value is <code>"0"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Num Segments</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Num Segments</em>' attribute.
   * @see #isSetNumSegments()
   * @see #unsetNumSegments()
   * @see #setNumSegments(Integer)
   * @see org.safe.metamodel.safe10.Safe10Package#getCpuSelfTestConfig_NumSegments()
   * @model default="0" unsettable="true" dataType="org.safe.metamodel.safe10.Integer" required="true"
   *        annotation="MetaData guid='{AF713AE2-5C5C-46d3-A925-4F715E789216}' id='48991584' EA\040name='numSegments'"
   *        extendedMetaData="name='NUM-SEGMENTS' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='NUM-SEGMENTSS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Integer getNumSegments();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.CpuSelfTestConfig#getNumSegments <em>Num Segments</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Num Segments</em>' attribute.
   * @see #isSetNumSegments()
   * @see #NumSegments()
   * @see #getNumSegments()
   * @generated
   */
  void setNumSegments(Integer value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.CpuSelfTestConfig#getNumSegments <em>Num Segments</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetNumSegments()
   * @see #getNumSegments()
   * @see #setNumSegments(Integer)
   * @generated
   */
  void unsetNumSegments();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.CpuSelfTestConfig#getNumSegments <em>Num Segments</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Num Segments</em>' attribute is set.
   * @see #NumSegments()
   * @see #getNumSegments()
   * @see #setNumSegments(Integer)
   * @generated
   */
  boolean isSetNumSegments();

  /**
   * Returns the value of the '<em><b>Algorithms</b></em>' attribute.
   * The default value is <code>"LIMITEDNUMBEROFWALKINGPATTERNS"</code>.
   * The literals are from the enumeration {@link org.safe.metamodel.safe10.CpuTestAlgorithmEnum}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Algorithms</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Algorithms</em>' attribute.
   * @see org.safe.metamodel.safe10.CpuTestAlgorithmEnum
   * @see #isSetAlgorithms()
   * @see #unsetAlgorithms()
   * @see #setAlgorithms(CpuTestAlgorithmEnum)
   * @see org.safe.metamodel.safe10.Safe10Package#getCpuSelfTestConfig_Algorithms()
   * @model default="LIMITEDNUMBEROFWALKINGPATTERNS" unsettable="true" required="true"
   *        annotation="MetaData guid='{72E60788-C667-4a01-9303-D9AA66E68C2B}' id='955411091' EA\040name='algorithms'"
   *        extendedMetaData="name='ALGORITHMS' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='ALGORITHMSS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  CpuTestAlgorithmEnum getAlgorithms();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.CpuSelfTestConfig#getAlgorithms <em>Algorithms</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Algorithms</em>' attribute.
   * @see org.safe.metamodel.safe10.CpuTestAlgorithmEnum
   * @see #isSetAlgorithms()
   * @see #Algorithms()
   * @see #getAlgorithms()
   * @generated
   */
  void setAlgorithms(CpuTestAlgorithmEnum value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.CpuSelfTestConfig#getAlgorithms <em>Algorithms</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetAlgorithms()
   * @see #getAlgorithms()
   * @see #setAlgorithms(CpuTestAlgorithmEnum)
   * @generated
   */
  void unsetAlgorithms();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.CpuSelfTestConfig#getAlgorithms <em>Algorithms</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Algorithms</em>' attribute is set.
   * @see #Algorithms()
   * @see #getAlgorithms()
   * @see #setAlgorithms(CpuTestAlgorithmEnum)
   * @generated
   */
  boolean isSetAlgorithms();

} // CpuSelfTestConfig
