/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>EMP Analysis</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Error model prototype specified for a concrete analysis function instance.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.ErrorModel.ErrorModelType.EMPAnalysis</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.EMPAnalysis#getTarget <em>Target</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getEMPAnalysis()
 * @model annotation="MetaData guid='{220DBC78-05FF-499b-B8AA-11606460A6FA}' id='-496658781' EA\040name='EMPAnalysis'"
 *        extendedMetaData="name='EMP-ANALYSIS' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='EMP-ANALYSISS'"
 * @generated
 */
public interface EMPAnalysis extends ErrorModelPrototype
{
  /**
   * Returns the value of the '<em><b>Target</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * A nominal function instance as target of the related error model prototype.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Target</em>' containment reference.
   * @see #setTarget(ErrorModelPrototype_analysisFunctionTarget)
   * @see org.safe.metamodel.safe10.Safe10Package#getEMPAnalysis_Target()
   * @model containment="true"
   *        annotation="MetaData guid='{81C30AF8-C712-40e3-BEA1-F8BD72469BF6}' id='-1739246572' EA\040name=''"
   *        annotation="TaggedValues xml.name='TARGET-IREF' xml.namePlural='TARGET-IREFS' xml.roleElement='true' xml.typeElement='false' xml.typeWrapperElement='false'"
   *        extendedMetaData="name='TARGET-IREF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='TARGET-IREFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  ErrorModelPrototype_analysisFunctionTarget getTarget();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.EMPAnalysis#getTarget <em>Target</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Target</em>' containment reference.
   * @see #getTarget()
   * @generated
   */
  void setTarget(ErrorModelPrototype_analysisFunctionTarget value);

} // EMPAnalysis
