/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import autosar40.system.fibex.fibexcore.coretopology.EcuInstance;

import autosar40.system.swmapping.EcuPartition;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>EM Type Application Environment</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * The EMTypeApplicationEnvironment allows describing the error model for the runtime environment of application software on AUTOSAR implementation level. The application environment can be virtual, meaning that the modeled error model is an assumption of the environment the application software is running on. In a real system, EMTypeApplicationEnvironment is associated with a concrete ECUInstance in the system and (optional) with a ECU partition within this ECU. In this case, the error model represents the description of the unintended behavior originated by this runtime environment.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.ErrorModel.ErrorModelType.EMTypeApplicationEnvironment</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.EMTypeApplicationEnvironment#getTargetPartition <em>Target Partition</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.EMTypeApplicationEnvironment#getTargetECU <em>Target ECU</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getEMTypeApplicationEnvironment()
 * @model annotation="MetaData guid='{C4FFF5A9-A4FD-4668-A09F-74C0D935F8C5}' id='-1263266984' EA\040name='EMTypeApplicationEnvironment'"
 *        extendedMetaData="name='EM-TYPE-APPLICATION-ENVIRONMENT' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='EM-TYPE-APPLICATION-ENVIRONMENTS'"
 * @generated
 */
public interface EMTypeApplicationEnvironment extends ErrorModelType
{
  /**
   * Returns the value of the '<em><b>Target Partition</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * The target ECU partition
   * <!-- end-model-doc -->
   * @return the value of the '<em>Target Partition</em>' reference.
   * @see #setTargetPartition(EcuPartition)
   * @see org.safe.metamodel.safe10.Safe10Package#getEMTypeApplicationEnvironment_TargetPartition()
   * @model annotation="MetaData guid='{7C36CA9B-F6CE-4eba-BB33-40CB72C709B4}' id='-1036304888' EA\040name=''"
   *        extendedMetaData="name='TARGET-PARTITION-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='TARGET-PARTITION-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  EcuPartition getTargetPartition();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.EMTypeApplicationEnvironment#getTargetPartition <em>Target Partition</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Target Partition</em>' reference.
   * @see #getTargetPartition()
   * @generated
   */
  void setTargetPartition(EcuPartition value);

  /**
   * Returns the value of the '<em><b>Target ECU</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * The target ECU.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Target ECU</em>' reference.
   * @see #setTargetECU(EcuInstance)
   * @see org.safe.metamodel.safe10.Safe10Package#getEMTypeApplicationEnvironment_TargetECU()
   * @model annotation="MetaData guid='{78607C96-A8D2-4146-A733-D8627D09724D}' id='791767427' EA\040name=''"
   *        extendedMetaData="name='TARGET-ECU-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='TARGET-ECU-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  EcuInstance getTargetECU();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.EMTypeApplicationEnvironment#getTargetECU <em>Target ECU</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Target ECU</em>' reference.
   * @see #getTargetECU()
   * @generated
   */
  void setTargetECU(EcuInstance value);

} // EMTypeApplicationEnvironment
