/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Error Behavior Mapping</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * The class ErrorBehaviorMapping allows to map an error behavior to a concrete instance of an ErrorModelType within the ErrorModel. For each instance reference referred by the association named "errorModel", the following rule must be considered:
 * - The ErrorModelType of the first context element in the instanceRef of type ErrorModelInstanceRef must match with the attribute "rootErrorModelType" of the ErrorModel, where this ErrorBehaviorMapping is contained
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.ErrorModel.Mapping.ErrorBehaviorMapping</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.ErrorBehaviorMapping#getErrorModel <em>Error Model</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.ErrorBehaviorMapping#getErrorBehavior <em>Error Behavior</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getErrorBehaviorMapping()
 * @model annotation="MetaData guid='{ED97B2C2-F07E-4a8e-9845-E07A752CCD1D}' id='-832434220' EA\040name='ErrorBehaviorMapping'"
 *        extendedMetaData="name='ERROR-BEHAVIOR-MAPPING' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='ERROR-BEHAVIOR-MAPPINGS'"
 * @generated
 */
public interface ErrorBehaviorMapping extends Identifiable
{
  /**
   * Returns the value of the '<em><b>Error Model</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.ErrorModelInstanceRef}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * The error model instances, for which this error behavior shall be applied.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Error Model</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getErrorBehaviorMapping_ErrorModel()
   * @model containment="true"
   *        annotation="MetaData guid='{4234DA9F-F924-4ad8-BA8C-B860183EF324}' id='810734629' EA\040name=''"
   *        extendedMetaData="name='ERROR-MODEL' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='ERROR-MODELS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<ErrorModelInstanceRef> getErrorModel();

  /**
   * Returns the value of the '<em><b>Error Behavior</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * The target error behavior.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Error Behavior</em>' reference.
   * @see #setErrorBehavior(AbstractErrorBehavior)
   * @see org.safe.metamodel.safe10.Safe10Package#getErrorBehaviorMapping_ErrorBehavior()
   * @model required="true"
   *        annotation="MetaData guid='{BE24C3FA-B549-4f3a-8852-3260129C2E6B}' id='-662385957' EA\040name=''"
   *        extendedMetaData="name='ERROR-BEHAVIOR-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='ERROR-BEHAVIOR-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  AbstractErrorBehavior getErrorBehavior();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.ErrorBehaviorMapping#getErrorBehavior <em>Error Behavior</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Error Behavior</em>' reference.
   * @see #getErrorBehavior()
   * @generated
   */
  void setErrorBehavior(AbstractErrorBehavior value);

} // ErrorBehaviorMapping
