/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Error Model Prototype</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * The ErrorModelPrototype is used to define hierarchical error models allowing additional detail or structure to the error model of a particular target. A hierarchal structure can also be defined when several ErrorModels are integrated to a larger ErrorModel representing a system integrated from several targets. 
 * 
 * There are diffent  subtypes of ErrorModelPrototype specified, allowing to add additional information describe the context of the ErrorModelProtoype.
 * 
 * Semantics:
 * An ErrorModelPrototype represents an occurrence of the ErrorModelType that types it.
 * 
 * Extension:
 * (See ADLFunctionPrototype)
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.ErrorModel.ErrorModelType.ErrorModelPrototype</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.ErrorModelPrototype#getType <em>Type</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getErrorModelPrototype()
 * @model annotation="MetaData guid='{3F949A13-7BAD-4939-84C0-290C71CEBBC4}' id='-762025878' EA\040name='ErrorModelPrototype'"
 *        extendedMetaData="name='ERROR-MODEL-PROTOTYPE' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='ERROR-MODEL-PROTOTYPES'"
 * @generated
 */
public interface ErrorModelPrototype extends Identifiable
{
  /**
   * Returns the value of the '<em><b>Type</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * The ErrorModelType that types the ErrorModelPrototype.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Type</em>' reference.
   * @see #setType(ErrorModelType)
   * @see org.safe.metamodel.safe10.Safe10Package#getErrorModelPrototype_Type()
   * @model required="true"
   *        annotation="MetaData guid='{247678FE-F43F-43d3-8225-406E00452B62}' id='-1736563620' EA\040name=''"
   *        annotation="Stereotype Stereotype='isOfType'"
   *        extendedMetaData="name='TYPE-TREF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='TYPE-TREFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  ErrorModelType getType();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.ErrorModelPrototype#getType <em>Type</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Type</em>' reference.
   * @see #getType()
   * @generated
   */
  void setType(ErrorModelType value);

} // ErrorModelPrototype
