/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Failure Rate</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * This super class provides generic information required by all the concrete distributions gaussian, gumbel, frechet, exponential and uniform.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.ErrorModel.ErrorModelType.QuantitativeErrorModel.FailureRate</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.FailureRate#getLambda <em>Lambda</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.FailureRate#getRationalScalingFactor <em>Rational Scaling Factor</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.FailureRate#getScalingFactor <em>Scaling Factor</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.FailureRate#getSource <em>Source</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.FailureRate#getMalfunction <em>Malfunction</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getFailureRate()
 * @model abstract="true"
 *        annotation="MetaData guid='{F3394E3B-6001-47c1-A3F0-75263150AC90}' id='13177945' EA\040name='FailureRate'"
 *        extendedMetaData="name='FAILURE-RATE' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='FAILURE-RATES'"
 * @generated
 */
public interface FailureRate extends EObject
{
  /**
   * Returns the value of the '<em><b>Lambda</b></em>' attribute.
   * The default value is <code>"0.0"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Lambda</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Lambda</em>' attribute.
   * @see #isSetLambda()
   * @see #unsetLambda()
   * @see #setLambda(Double)
   * @see org.safe.metamodel.safe10.Safe10Package#getFailureRate_Lambda()
   * @model default="0.0" unsettable="true" dataType="org.safe.metamodel.safe10.Float" required="true"
   *        annotation="MetaData guid='{A7E3FA64-17A3-48b1-8EFC-9E79B213D319}' id='1392966723' EA\040name='lambda'"
   *        extendedMetaData="name='LAMBDA' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='LAMBDAS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Double getLambda();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.FailureRate#getLambda <em>Lambda</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Lambda</em>' attribute.
   * @see #isSetLambda()
   * @see #Lambda()
   * @see #getLambda()
   * @generated
   */
  void setLambda(Double value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.FailureRate#getLambda <em>Lambda</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetLambda()
   * @see #getLambda()
   * @see #setLambda(Double)
   * @generated
   */
  void unsetLambda();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.FailureRate#getLambda <em>Lambda</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Lambda</em>' attribute is set.
   * @see #Lambda()
   * @see #getLambda()
   * @see #setLambda(Double)
   * @generated
   */
  boolean isSetLambda();

  /**
   * Returns the value of the '<em><b>Rational Scaling Factor</b></em>' attribute.
   * The default value is <code>""</code>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * The rationaleScalingFactor shall provide a rationale, if a scaling factor different to 1.0 is applied.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Rational Scaling Factor</em>' attribute.
   * @see #isSetRationalScalingFactor()
   * @see #unsetRationalScalingFactor()
   * @see #setRationalScalingFactor(String)
   * @see org.safe.metamodel.safe10.Safe10Package#getFailureRate_RationalScalingFactor()
   * @model default="" unsettable="true" dataType="org.safe.metamodel.safe10.String"
   *        annotation="MetaData guid='{C58759D2-CBDE-4272-822B-78B9840BF15A}' id='1233210567' EA\040name='rationalScalingFactor'"
   *        extendedMetaData="name='RATIONAL-SCALING-FACTOR' kind='attribute'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='RATIONAL-SCALING-FACTORS' xmlAttribute='true' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  String getRationalScalingFactor();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.FailureRate#getRationalScalingFactor <em>Rational Scaling Factor</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Rational Scaling Factor</em>' attribute.
   * @see #isSetRationalScalingFactor()
   * @see #RationalScalingFactor()
   * @see #getRationalScalingFactor()
   * @generated
   */
  void setRationalScalingFactor(String value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.FailureRate#getRationalScalingFactor <em>Rational Scaling Factor</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetRationalScalingFactor()
   * @see #getRationalScalingFactor()
   * @see #setRationalScalingFactor(String)
   * @generated
   */
  void unsetRationalScalingFactor();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.FailureRate#getRationalScalingFactor <em>Rational Scaling Factor</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Rational Scaling Factor</em>' attribute is set.
   * @see #RationalScalingFactor()
   * @see #getRationalScalingFactor()
   * @see #setRationalScalingFactor(String)
   * @generated
   */
  boolean isSetRationalScalingFactor();

  /**
   * Returns the value of the '<em><b>Scaling Factor</b></em>' attribute.
   * The default value is <code>"0.0"</code>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * The scalingFactor allows potential scaling between different sources of failure rates as described in ISO Part 5 Annex F.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Scaling Factor</em>' attribute.
   * @see #isSetScalingFactor()
   * @see #unsetScalingFactor()
   * @see #setScalingFactor(Double)
   * @see org.safe.metamodel.safe10.Safe10Package#getFailureRate_ScalingFactor()
   * @model default="0.0" unsettable="true" dataType="org.safe.metamodel.safe10.Float"
   *        annotation="MetaData guid='{1B8BE52B-FBCA-4367-A761-B0AEC31E2EF6}' id='-959943725' EA\040name='scalingFactor'"
   *        extendedMetaData="name='SCALING-FACTOR' kind='attribute'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SCALING-FACTORS' xmlAttribute='true' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Double getScalingFactor();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.FailureRate#getScalingFactor <em>Scaling Factor</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Scaling Factor</em>' attribute.
   * @see #isSetScalingFactor()
   * @see #ScalingFactor()
   * @see #getScalingFactor()
   * @generated
   */
  void setScalingFactor(Double value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.FailureRate#getScalingFactor <em>Scaling Factor</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetScalingFactor()
   * @see #getScalingFactor()
   * @see #setScalingFactor(Double)
   * @generated
   */
  void unsetScalingFactor();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.FailureRate#getScalingFactor <em>Scaling Factor</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Scaling Factor</em>' attribute is set.
   * @see #ScalingFactor()
   * @see #getScalingFactor()
   * @see #setScalingFactor(Double)
   * @generated
   */
  boolean isSetScalingFactor();

  /**
   * Returns the value of the '<em><b>Source</b></em>' attribute.
   * The default value is <code>""</code>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * FIT rate source shall documented according to possible source as described in ISO 26262 Part 5 8.4.3.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Source</em>' attribute.
   * @see #isSetSource()
   * @see #unsetSource()
   * @see #setSource(String)
   * @see org.safe.metamodel.safe10.Safe10Package#getFailureRate_Source()
   * @model default="" unsettable="true" dataType="org.safe.metamodel.safe10.String"
   *        annotation="MetaData guid='{B2C01E43-4030-4b70-B63F-661918C436F7}' id='1400590750' EA\040name='source'"
   *        extendedMetaData="name='SOURCE' kind='attribute'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SOURCES' xmlAttribute='true' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  String getSource();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.FailureRate#getSource <em>Source</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Source</em>' attribute.
   * @see #isSetSource()
   * @see #Source()
   * @see #getSource()
   * @generated
   */
  void setSource(String value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.FailureRate#getSource <em>Source</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetSource()
   * @see #getSource()
   * @see #setSource(String)
   * @generated
   */
  void unsetSource();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.FailureRate#getSource <em>Source</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Source</em>' attribute is set.
   * @see #Source()
   * @see #getSource()
   * @see #setSource(String)
   * @generated
   */
  boolean isSetSource();

  /**
   * Returns the value of the '<em><b>Malfunction</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * The malfunction to which the failure rate shall be associated with.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Malfunction</em>' reference.
   * @see #setMalfunction(MalfunctionPrototype)
   * @see org.safe.metamodel.safe10.Safe10Package#getFailureRate_Malfunction()
   * @model required="true"
   *        annotation="MetaData guid='{CE650A35-2761-40dc-882E-B29C73AC8F9D}' id='1256779744' EA\040name=''"
   *        extendedMetaData="name='MALFUNCTION-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='MALFUNCTION-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  MalfunctionPrototype getMalfunction();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.FailureRate#getMalfunction <em>Malfunction</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Malfunction</em>' reference.
   * @see #getMalfunction()
   * @generated
   */
  void setMalfunction(MalfunctionPrototype value);

} // FailureRate
