/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Filter</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * The Filter meta element represents a error handling specification which defines how an erroneous value provided to it can be corrected. The mechanism can be referred by detection software safety requirements.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.SoftwareSafetyRequirements.Filter.Filter</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.Filter#getValue <em>Value</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.Filter#getCurrent <em>Current</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.Filter#getPrevious <em>Previous</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getFilter()
 * @model annotation="MetaData guid='{84AA4198-B4DB-4378-AE59-8DCDE7CBC119}' id='-1499550223' EA\040name='Filter'"
 *        extendedMetaData="name='FILTER' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='FILTERS'"
 * @generated
 */
public interface Filter extends SoftwareSafetyRequirement
{
  /**
   * Returns the value of the '<em><b>Value</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * The formula defining how the value of the filter shall be computed
   * <!-- end-model-doc -->
   * @return the value of the '<em>Value</em>' containment reference.
   * @see #setValue(FilterExpression)
   * @see org.safe.metamodel.safe10.Safe10Package#getFilter_Value()
   * @model containment="true" required="true"
   *        annotation="MetaData guid='{4C3DA287-B085-430c-BE11-DD7C682D0CC0}' id='1171933673' EA\040name=''"
   *        extendedMetaData="name='VALUE' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='VALUES' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  FilterExpression getValue();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.Filter#getValue <em>Value</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Value</em>' containment reference.
   * @see #getValue()
   * @generated
   */
  void setValue(FilterExpression value);

  /**
   * Returns the value of the '<em><b>Current</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * The current value provided as input to the filter
   * <!-- end-model-doc -->
   * @return the value of the '<em>Current</em>' containment reference.
   * @see #setCurrent(FilterParameter)
   * @see org.safe.metamodel.safe10.Safe10Package#getFilter_Current()
   * @model containment="true" required="true"
   *        annotation="MetaData guid='{DFCA3A1C-3734-4e64-A347-D625FC4FE993}' id='-1219612027' EA\040name=''"
   *        extendedMetaData="name='CURRENT' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='CURRENTS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  FilterParameter getCurrent();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.Filter#getCurrent <em>Current</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Current</em>' containment reference.
   * @see #getCurrent()
   * @generated
   */
  void setCurrent(FilterParameter value);

  /**
   * Returns the value of the '<em><b>Previous</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.FilterParameter}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * The previous value(s) of the filter which shall be taken into account while computing a new filtered value
   * <!-- end-model-doc -->
   * @return the value of the '<em>Previous</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getFilter_Previous()
   * @model containment="true"
   *        annotation="MetaData guid='{3C8F096F-2FA0-4167-A66A-79F05966F58F}' id='1113743202' EA\040name=''"
   *        extendedMetaData="name='PREVIOUS' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='PREVIOUSS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<FilterParameter> getPrevious();

} // Filter
