/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Filter Parameter</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * A FilterParameter meta element defines the possible values which can be referred within a Filter. These are used to calculate and correct erroneous values provided to a filter realization.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.SoftwareSafetyRequirements.Filter.FilterParameter</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.FilterParameter#getIdentifier <em>Identifier</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getFilterParameter()
 * @model annotation="MetaData guid='{A5FFAAD7-C551-4298-BE11-443A90D01885}' id='-1223965121' EA\040name='FilterParameter'"
 *        extendedMetaData="name='FILTER-PARAMETER' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='FILTER-PARAMETERS'"
 * @generated
 */
public interface FilterParameter extends Identifiable
{
  /**
   * Returns the value of the '<em><b>Identifier</b></em>' attribute.
   * The default value is <code>""</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Identifier</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Identifier</em>' attribute.
   * @see #isSetIdentifier()
   * @see #unsetIdentifier()
   * @see #setIdentifier(String)
   * @see org.safe.metamodel.safe10.Safe10Package#getFilterParameter_Identifier()
   * @model default="" unsettable="true" dataType="org.safe.metamodel.safe10.String" required="true"
   *        annotation="MetaData guid='{FBFADFC6-084F-4739-8119-34A14B764002}' id='-1501812995' EA\040name='identifier'"
   *        extendedMetaData="name='IDENTIFIER' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='IDENTIFIERS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  String getIdentifier();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.FilterParameter#getIdentifier <em>Identifier</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Identifier</em>' attribute.
   * @see #isSetIdentifier()
   * @see #Identifier()
   * @see #getIdentifier()
   * @generated
   */
  void setIdentifier(String value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.FilterParameter#getIdentifier <em>Identifier</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetIdentifier()
   * @see #getIdentifier()
   * @see #setIdentifier(String)
   * @generated
   */
  void unsetIdentifier();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.FilterParameter#getIdentifier <em>Identifier</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Identifier</em>' attribute is set.
   * @see #Identifier()
   * @see #getIdentifier()
   * @see #setIdentifier(String)
   * @generated
   */
  boolean isSetIdentifier();

} // FilterParameter
