/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eatop.eel.eastadl21.AnalysisFunctionType;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Functional Safety Extension</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * The FunctionalSafetyExtension is used as interface to the AnalysisLevel defined in EAST-ADL. This extension specifies the add-on needed to model the functional safety concept defined in the ISO 26262 part 3 chapter 8. 
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.CommonStructure.SafetyExtensions.FunctionalSafetyExtension.FunctionalSafetyExtension</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.FunctionalSafetyExtension#getScope <em>Scope</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.FunctionalSafetyExtension#getRequirement <em>Requirement</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getFunctionalSafetyExtension()
 * @model annotation="MetaData guid='{90B08BD2-9E11-4026-B855-83A1C6DF4772}' id='637603198' EA\040name='FunctionalSafetyExtension'"
 *        extendedMetaData="name='FUNCTIONAL-SAFETY-EXTENSION' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='FUNCTIONAL-SAFETY-EXTENSIONS'"
 * @generated
 */
public interface FunctionalSafetyExtension extends SingleLevelSafetyExtension
{
  /**
   * Returns the value of the '<em><b>Scope</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Scope</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Scope</em>' reference.
   * @see #setScope(AnalysisFunctionType)
   * @see org.safe.metamodel.safe10.Safe10Package#getFunctionalSafetyExtension_Scope()
   * @model required="true"
   *        annotation="MetaData guid='{E0286F66-9F04-4dc2-A436-0DA2EC08AE44}' id='-1474601204' EA\040name=''"
   *        extendedMetaData="name='SCOPE-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SCOPE-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  AnalysisFunctionType getScope();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.FunctionalSafetyExtension#getScope <em>Scope</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Scope</em>' reference.
   * @see #getScope()
   * @generated
   */
  void setScope(AnalysisFunctionType value);

  /**
   * Returns the value of the '<em><b>Requirement</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.FunctionalSafetyRequirement}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Requirement</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Requirement</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getFunctionalSafetyExtension_Requirement()
   * @model containment="true"
   *        annotation="MetaData guid='{B892A279-F8CB-4a52-9872-7EA1932EAC4F}' id='1087436228' EA\040name=''"
   *        extendedMetaData="name='REQUIREMENT' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='REQUIREMENTS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<FunctionalSafetyRequirement> getRequirement();

} // FunctionalSafetyExtension
