/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>HW Component Quantified FM From Part</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * This class describes the quantified failure rate of a failure mode of a HWComponent based on the contribution of each HWPartFailureMode of the related HWPart as AUTOSAR HW Element (calculated with the formula and stored in the attribute lambdaFailureMode).
 * 
 * The attribute SafetyComponentClassName is used to identify the HWComponent Class name  for further calculation of all failure mode to the same HWComponent.
 * 
 * A quantified HW ComponentFailureMode must identify the related HWFailureMode of the HWComponent.
 * 
 * During modeling a design rule must be ensured that AutosarHWElementType  used as BaseHwElement for the instanceRef relation is the same as the root hierarchy on the HwElement creation
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Hardware.FailurePart.HWComponentQuantifiedFMFromPart</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.HWComponentQuantifiedFMFromPart#getLambdaFailureMode <em>Lambda Failure Mode</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HWComponentQuantifiedFMFromPart#getFailureLogic <em>Failure Logic</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HWComponentQuantifiedFMFromPart#getHwCQFMlambdaFailureModeValue <em>Hw CQF Mlambda Failure Mode Value</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getHWComponentQuantifiedFMFromPart()
 * @model annotation="MetaData guid='{726B19DF-2C80-416c-B58E-DF85CEA7F3AA}' id='456355323' EA\040name='HWComponentQuantifiedFMFromPart'"
 *        extendedMetaData="name='HW-COMPONENT-QUANTIFIED-FM-FROM-PART' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HW-COMPONENT-QUANTIFIED-FM-FROM-PARTS'"
 * @generated
 */
public interface HWComponentQuantifiedFMFromPart extends Identifiable, Referrable
{
  /**
   * Returns the value of the '<em><b>Lambda Failure Mode</b></em>' attribute.
   * The default value is <code>"0.0"</code>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * This attribute contains the quantified failure rate for the corresponding failure mode of the hardware component.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Lambda Failure Mode</em>' attribute.
   * @see #isSetLambdaFailureMode()
   * @see #unsetLambdaFailureMode()
   * @see #setLambdaFailureMode(Double)
   * @see org.safe.metamodel.safe10.Safe10Package#getHWComponentQuantifiedFMFromPart_LambdaFailureMode()
   * @model default="0.0" unsettable="true" dataType="org.safe.metamodel.safe10.Float" required="true"
   *        annotation="MetaData guid='{C0259858-5320-4e3f-A944-45DBDFAC0828}' id='-728115424' EA\040name='lambdaFailureMode'"
   *        extendedMetaData="name='LAMBDA-FAILURE-MODE' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='LAMBDA-FAILURE-MODES' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Double getLambdaFailureMode();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HWComponentQuantifiedFMFromPart#getLambdaFailureMode <em>Lambda Failure Mode</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Lambda Failure Mode</em>' attribute.
   * @see #isSetLambdaFailureMode()
   * @see #LambdaFailureMode()
   * @see #getLambdaFailureMode()
   * @generated
   */
  void setLambdaFailureMode(Double value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.HWComponentQuantifiedFMFromPart#getLambdaFailureMode <em>Lambda Failure Mode</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetLambdaFailureMode()
   * @see #getLambdaFailureMode()
   * @see #setLambdaFailureMode(Double)
   * @generated
   */
  void unsetLambdaFailureMode();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.HWComponentQuantifiedFMFromPart#getLambdaFailureMode <em>Lambda Failure Mode</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Lambda Failure Mode</em>' attribute is set.
   * @see #LambdaFailureMode()
   * @see #getLambdaFailureMode()
   * @see #setLambdaFailureMode(Double)
   * @generated
   */
  boolean isSetLambdaFailureMode();

  /**
   * Returns the value of the '<em><b>Failure Logic</b></em>' attribute.
   * The default value is <code>""</code>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * Define the specification of HWPartFailureMode contribution to HWFailureMode of the above abstraction layer (Block)on an external formalism or the path to the file containing the external specification.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Failure Logic</em>' attribute.
   * @see #isSetFailureLogic()
   * @see #unsetFailureLogic()
   * @see #setFailureLogic(String)
   * @see org.safe.metamodel.safe10.Safe10Package#getHWComponentQuantifiedFMFromPart_FailureLogic()
   * @model default="" unsettable="true" dataType="org.safe.metamodel.safe10.String"
   *        annotation="MetaData guid='{A6FF1AD6-7C6C-46ce-B709-7AC2F1AB8D64}' id='1384351606' EA\040name='failureLogic'"
   *        extendedMetaData="name='FAILURE-LOGIC' kind='attribute'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='FAILURE-LOGICS' xmlAttribute='true' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  String getFailureLogic();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HWComponentQuantifiedFMFromPart#getFailureLogic <em>Failure Logic</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Failure Logic</em>' attribute.
   * @see #isSetFailureLogic()
   * @see #FailureLogic()
   * @see #getFailureLogic()
   * @generated
   */
  void setFailureLogic(String value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.HWComponentQuantifiedFMFromPart#getFailureLogic <em>Failure Logic</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetFailureLogic()
   * @see #getFailureLogic()
   * @see #setFailureLogic(String)
   * @generated
   */
  void unsetFailureLogic();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.HWComponentQuantifiedFMFromPart#getFailureLogic <em>Failure Logic</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Failure Logic</em>' attribute is set.
   * @see #FailureLogic()
   * @see #getFailureLogic()
   * @see #setFailureLogic(String)
   * @generated
   */
  boolean isSetFailureLogic();

  /**
   * Returns the value of the '<em><b>Hw CQF Mlambda Failure Mode Value</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Hw CQF Mlambda Failure Mode Value</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Hw CQF Mlambda Failure Mode Value</em>' containment reference.
   * @see #setHwCQFMlambdaFailureModeValue(HWLambdaPartFormula)
   * @see org.safe.metamodel.safe10.Safe10Package#getHWComponentQuantifiedFMFromPart_HwCQFMlambdaFailureModeValue()
   * @model containment="true" required="true"
   *        annotation="MetaData guid='{64AF4971-5CEE-4991-9DF0-4E265FB60A7E}' id='405641111' EA\040name=''"
   *        extendedMetaData="name='HW-CQF-MLAMBDA-FAILURE-MODE-VALUE' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HW-CQF-MLAMBDA-FAILURE-MODE-VALUES' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  HWLambdaPartFormula getHwCQFMlambdaFailureModeValue();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HWComponentQuantifiedFMFromPart#getHwCQFMlambdaFailureModeValue <em>Hw CQF Mlambda Failure Mode Value</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Hw CQF Mlambda Failure Mode Value</em>' containment reference.
   * @see #getHwCQFMlambdaFailureModeValue()
   * @generated
   */
  void setHwCQFMlambdaFailureModeValue(HWLambdaPartFormula value);

} // HWComponentQuantifiedFMFromPart
