/**
 */
package org.safe.metamodel.safe10;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>HWLF Target Failure Rate Class Enum</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * <!-- begin-model-doc -->
 * ISO 26262 Part 5 9.4.3.11 -Table 9 (Targets of failure rate class and coverage of hardware part regarding dual-point faults)
 * 
 * DM: Dedicated measures
 * LDC: Diagnostic coverage with respect to latent faults
 * 
 * Additionally, OUT-OF-SCOPE was added.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Hardware.ProbabilisticMethods.HWLFTargetFailureRateClassEnum</b></em> 
 * <!-- end-model-doc -->
 * @see org.safe.metamodel.safe10.Safe10Package#getHWLFTargetFailureRateClassEnum()
 * @model annotation="MetaData guid='{E076A852-DE80-46fb-B158-65DEB60BE814}' id='2110114747' EA\040name='HWLFTargetFailureRateClassEnum'"
 *        annotation="Stereotype Stereotype='enumeration'"
 *        extendedMetaData="name='HWLF-TARGET-FAILURE-RATE-CLASS-ENUM'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HWLF-TARGET-FAILURE-RATE-CLASS-ENUMS'"
 * @generated
 */
public enum HWLFTargetFailureRateClassEnum implements Enumerator
{
  /**
   * The '<em><b>Out Of Scope</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #OUT_OF_SCOPE_VALUE
   * @generated
   * @ordered
   */
  OUT_OF_SCOPE(0, "OutOfScope", "OUTOFSCOPE"),

  /**
   * The '<em><b>ASIL Dand LDC GTEQ 99pct</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #ASIL_DAND_LDC_GTEQ_99PCT_VALUE
   * @generated
   * @ordered
   */
  ASIL_DAND_LDC_GTEQ_99PCT(1, "ASIL_D_and_LDC_GTEQ_99pct", "ASIL_D_AND_LDC_GTEQ_99PCT"),

  /**
   * The '<em><b>ASIL Dand LDC GTEQ 90pct</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #ASIL_DAND_LDC_GTEQ_90PCT_VALUE
   * @generated
   * @ordered
   */
  ASIL_DAND_LDC_GTEQ_90PCT(2, "ASIL_D_and_LDC_GTEQ_90pct", "ASIL_D_AND_LDC_GTEQ_90PCT"),

  /**
   * The '<em><b>ASIL Dand LDC LT 90pct</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #ASIL_DAND_LDC_LT_90PCT_VALUE
   * @generated
   * @ordered
   */
  ASIL_DAND_LDC_LT_90PCT(3, "ASIL_D_and_LDC_LT_90pct", "ASIL_D_AND_LDC_LT_90PCT"),

  /**
   * The '<em><b>ASIL Cand LDC GTEQ 99pct</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #ASIL_CAND_LDC_GTEQ_99PCT_VALUE
   * @generated
   * @ordered
   */
  ASIL_CAND_LDC_GTEQ_99PCT(4, "ASIL_C_and_LDC_GTEQ_99pct", "ASIL_C_AND_LDC_GTEQ_99PCT"),

  /**
   * The '<em><b>ASIL Cand LDC GTEQ 90pct</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #ASIL_CAND_LDC_GTEQ_90PCT_VALUE
   * @generated
   * @ordered
   */
  ASIL_CAND_LDC_GTEQ_90PCT(5, "ASIL_C_and_LDC_GTEQ_90pct", "ASIL_C_AND_LDC_GTEQ_90PCT"),

  /**
   * The '<em><b>ASIL Cand LDC GTEQ 80pct</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #ASIL_CAND_LDC_GTEQ_80PCT_VALUE
   * @generated
   * @ordered
   */
  ASIL_CAND_LDC_GTEQ_80PCT(6, "ASIL_C_and_LDC_GTEQ_80pct", "ASIL_C_AND_LDC_GTEQ_80PCT"),

  /**
   * The '<em><b>ASIL Cand LDC GT 80pct</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #ASIL_CAND_LDC_GT_80PCT_VALUE
   * @generated
   * @ordered
   */
  ASIL_CAND_LDC_GT_80PCT(7, "ASIL_C_and_LDC_GT_80pct", "ASIL_C_AND_LDC_GT_80PCT");

  /**
   * The '<em><b>Out Of Scope</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of '<em><b>Out Of Scope</b></em>' literal object isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @see #OUT_OF_SCOPE
   * @model name="OutOfScope" literal="OUTOFSCOPE"
   * @generated
   * @ordered
   */
  public static final int OUT_OF_SCOPE_VALUE = 0;

  /**
   * The '<em><b>ASIL Dand LDC GTEQ 99pct</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of '<em><b>ASIL Dand LDC GTEQ 99pct</b></em>' literal object isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @see #ASIL_DAND_LDC_GTEQ_99PCT
   * @model name="ASIL_D_and_LDC_GTEQ_99pct" literal="ASIL_D_AND_LDC_GTEQ_99PCT"
   * @generated
   * @ordered
   */
  public static final int ASIL_DAND_LDC_GTEQ_99PCT_VALUE = 1;

  /**
   * The '<em><b>ASIL Dand LDC GTEQ 90pct</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of '<em><b>ASIL Dand LDC GTEQ 90pct</b></em>' literal object isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @see #ASIL_DAND_LDC_GTEQ_90PCT
   * @model name="ASIL_D_and_LDC_GTEQ_90pct" literal="ASIL_D_AND_LDC_GTEQ_90PCT"
   * @generated
   * @ordered
   */
  public static final int ASIL_DAND_LDC_GTEQ_90PCT_VALUE = 2;

  /**
   * The '<em><b>ASIL Dand LDC LT 90pct</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of '<em><b>ASIL Dand LDC LT 90pct</b></em>' literal object isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @see #ASIL_DAND_LDC_LT_90PCT
   * @model name="ASIL_D_and_LDC_LT_90pct" literal="ASIL_D_AND_LDC_LT_90PCT"
   * @generated
   * @ordered
   */
  public static final int ASIL_DAND_LDC_LT_90PCT_VALUE = 3;

  /**
   * The '<em><b>ASIL Cand LDC GTEQ 99pct</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of '<em><b>ASIL Cand LDC GTEQ 99pct</b></em>' literal object isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @see #ASIL_CAND_LDC_GTEQ_99PCT
   * @model name="ASIL_C_and_LDC_GTEQ_99pct" literal="ASIL_C_AND_LDC_GTEQ_99PCT"
   * @generated
   * @ordered
   */
  public static final int ASIL_CAND_LDC_GTEQ_99PCT_VALUE = 4;

  /**
   * The '<em><b>ASIL Cand LDC GTEQ 90pct</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of '<em><b>ASIL Cand LDC GTEQ 90pct</b></em>' literal object isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @see #ASIL_CAND_LDC_GTEQ_90PCT
   * @model name="ASIL_C_and_LDC_GTEQ_90pct" literal="ASIL_C_AND_LDC_GTEQ_90PCT"
   * @generated
   * @ordered
   */
  public static final int ASIL_CAND_LDC_GTEQ_90PCT_VALUE = 5;

  /**
   * The '<em><b>ASIL Cand LDC GTEQ 80pct</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of '<em><b>ASIL Cand LDC GTEQ 80pct</b></em>' literal object isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @see #ASIL_CAND_LDC_GTEQ_80PCT
   * @model name="ASIL_C_and_LDC_GTEQ_80pct" literal="ASIL_C_AND_LDC_GTEQ_80PCT"
   * @generated
   * @ordered
   */
  public static final int ASIL_CAND_LDC_GTEQ_80PCT_VALUE = 6;

  /**
   * The '<em><b>ASIL Cand LDC GT 80pct</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of '<em><b>ASIL Cand LDC GT 80pct</b></em>' literal object isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @see #ASIL_CAND_LDC_GT_80PCT
   * @model name="ASIL_C_and_LDC_GT_80pct" literal="ASIL_C_AND_LDC_GT_80PCT"
   * @generated
   * @ordered
   */
  public static final int ASIL_CAND_LDC_GT_80PCT_VALUE = 7;

  /**
   * An array of all the '<em><b>HWLF Target Failure Rate Class Enum</b></em>' enumerators.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private static final HWLFTargetFailureRateClassEnum[] VALUES_ARRAY =
    new HWLFTargetFailureRateClassEnum[]
    {
      OUT_OF_SCOPE,
      ASIL_DAND_LDC_GTEQ_99PCT,
      ASIL_DAND_LDC_GTEQ_90PCT,
      ASIL_DAND_LDC_LT_90PCT,
      ASIL_CAND_LDC_GTEQ_99PCT,
      ASIL_CAND_LDC_GTEQ_90PCT,
      ASIL_CAND_LDC_GTEQ_80PCT,
      ASIL_CAND_LDC_GT_80PCT,
    };

  /**
   * A public read-only list of all the '<em><b>HWLF Target Failure Rate Class Enum</b></em>' enumerators.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final List<HWLFTargetFailureRateClassEnum> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

  /**
   * Returns the '<em><b>HWLF Target Failure Rate Class Enum</b></em>' literal with the specified literal value.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static HWLFTargetFailureRateClassEnum get(String literal)
  {
    for (int i = 0; i < VALUES_ARRAY.length; ++i)
    {
      HWLFTargetFailureRateClassEnum result = VALUES_ARRAY[i];
      if (result.toString().equals(literal))
      {
        return result;
      }
    }
    return null;
  }

  /**
   * Returns the '<em><b>HWLF Target Failure Rate Class Enum</b></em>' literal with the specified name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static HWLFTargetFailureRateClassEnum getByName(String name)
  {
    for (int i = 0; i < VALUES_ARRAY.length; ++i)
    {
      HWLFTargetFailureRateClassEnum result = VALUES_ARRAY[i];
      if (result.getName().equals(name))
      {
        return result;
      }
    }
    return null;
  }

  /**
   * Returns the '<em><b>HWLF Target Failure Rate Class Enum</b></em>' literal with the specified integer value.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static HWLFTargetFailureRateClassEnum get(int value)
  {
    switch (value)
    {
      case OUT_OF_SCOPE_VALUE: return OUT_OF_SCOPE;
      case ASIL_DAND_LDC_GTEQ_99PCT_VALUE: return ASIL_DAND_LDC_GTEQ_99PCT;
      case ASIL_DAND_LDC_GTEQ_90PCT_VALUE: return ASIL_DAND_LDC_GTEQ_90PCT;
      case ASIL_DAND_LDC_LT_90PCT_VALUE: return ASIL_DAND_LDC_LT_90PCT;
      case ASIL_CAND_LDC_GTEQ_99PCT_VALUE: return ASIL_CAND_LDC_GTEQ_99PCT;
      case ASIL_CAND_LDC_GTEQ_90PCT_VALUE: return ASIL_CAND_LDC_GTEQ_90PCT;
      case ASIL_CAND_LDC_GTEQ_80PCT_VALUE: return ASIL_CAND_LDC_GTEQ_80PCT;
      case ASIL_CAND_LDC_GT_80PCT_VALUE: return ASIL_CAND_LDC_GT_80PCT;
    }
    return null;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private final int value;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private final String name;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private final String literal;

  /**
   * Only this class can construct instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private HWLFTargetFailureRateClassEnum(int value, String name, String literal)
  {
    this.value = value;
    this.name = name;
    this.literal = literal;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public int getValue()
  {
    return value;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getName()
  {
    return name;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getLiteral()
  {
    return literal;
  }

  /**
   * Returns the literal value of the enumerator, which is its string representation.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    return literal;
  }
  
} //HWLFTargetFailureRateClassEnum
