/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>HWPMHF</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * This class describes the Probabilistic Metric for random Hardware Failures (PMHF) as in ISO Part 5 Clause 9.4.2.
 * 
 * A simplified alculation is included in the class HWPMHFFormula.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Hardware.ProbabilisticMethods.HWPMHF</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.HWPMHF#getCalculatedValue <em>Calculated Value</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HWPMHF#getRationaleDedicatedMeasures <em>Rationale Dedicated Measures</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HWPMHF#getExposureTime <em>Exposure Time</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HWPMHF#getRationaleExposureTime <em>Rationale Exposure Time</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HWPMHF#getHwPMHFCalculatedValue <em>Hw PMHF Calculated Value</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getHWPMHF()
 * @model annotation="MetaData guid='{F5507EF8-B579-4626-B169-2832A4914A0A}' id='-1322629448' EA\040name='HWPMHF'"
 *        extendedMetaData="name='HWPMHF' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HWPMHFS'"
 * @generated
 */
public interface HWPMHF extends Identifiable
{
  /**
   * Returns the value of the '<em><b>Calculated Value</b></em>' attribute.
   * The default value is <code>"0.0"</code>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * The calculatedValue is the result of the calculation of the PMHF (in FIT).
   * <!-- end-model-doc -->
   * @return the value of the '<em>Calculated Value</em>' attribute.
   * @see #isSetCalculatedValue()
   * @see #unsetCalculatedValue()
   * @see #setCalculatedValue(Double)
   * @see org.safe.metamodel.safe10.Safe10Package#getHWPMHF_CalculatedValue()
   * @model default="0.0" unsettable="true" dataType="org.safe.metamodel.safe10.Float" required="true"
   *        annotation="MetaData guid='{62631271-8F83-4624-9591-F582D270FC4F}' id='905428569' EA\040name='calculatedValue'"
   *        extendedMetaData="name='CALCULATED-VALUE' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='CALCULATED-VALUES' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Double getCalculatedValue();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HWPMHF#getCalculatedValue <em>Calculated Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Calculated Value</em>' attribute.
   * @see #isSetCalculatedValue()
   * @see #CalculatedValue()
   * @see #getCalculatedValue()
   * @generated
   */
  void setCalculatedValue(Double value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.HWPMHF#getCalculatedValue <em>Calculated Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetCalculatedValue()
   * @see #getCalculatedValue()
   * @see #setCalculatedValue(Double)
   * @generated
   */
  void unsetCalculatedValue();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.HWPMHF#getCalculatedValue <em>Calculated Value</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Calculated Value</em>' attribute is set.
   * @see #CalculatedValue()
   * @see #getCalculatedValue()
   * @see #setCalculatedValue(Double)
   * @generated
   */
  boolean isSetCalculatedValue();

  /**
   * Returns the value of the '<em><b>Rationale Dedicated Measures</b></em>' attribute.
   * The default value is <code>""</code>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * The attribute rationaleDedicatedMeasures shall allow to define a rationale for applied dedicated measures in the design.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Rationale Dedicated Measures</em>' attribute.
   * @see #isSetRationaleDedicatedMeasures()
   * @see #unsetRationaleDedicatedMeasures()
   * @see #setRationaleDedicatedMeasures(String)
   * @see org.safe.metamodel.safe10.Safe10Package#getHWPMHF_RationaleDedicatedMeasures()
   * @model default="" unsettable="true" dataType="org.safe.metamodel.safe10.String" required="true"
   *        annotation="MetaData guid='{E539AAD5-252D-4335-95F9-4C0FADAE8B15}' id='1926893615' EA\040name='rationaleDedicatedMeasures'"
   *        extendedMetaData="name='RATIONALE-DEDICATED-MEASURES' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='RATIONALE-DEDICATED-MEASURESS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  String getRationaleDedicatedMeasures();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HWPMHF#getRationaleDedicatedMeasures <em>Rationale Dedicated Measures</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Rationale Dedicated Measures</em>' attribute.
   * @see #isSetRationaleDedicatedMeasures()
   * @see #RationaleDedicatedMeasures()
   * @see #getRationaleDedicatedMeasures()
   * @generated
   */
  void setRationaleDedicatedMeasures(String value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.HWPMHF#getRationaleDedicatedMeasures <em>Rationale Dedicated Measures</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetRationaleDedicatedMeasures()
   * @see #getRationaleDedicatedMeasures()
   * @see #setRationaleDedicatedMeasures(String)
   * @generated
   */
  void unsetRationaleDedicatedMeasures();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.HWPMHF#getRationaleDedicatedMeasures <em>Rationale Dedicated Measures</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Rationale Dedicated Measures</em>' attribute is set.
   * @see #RationaleDedicatedMeasures()
   * @see #getRationaleDedicatedMeasures()
   * @see #setRationaleDedicatedMeasures(String)
   * @generated
   */
  boolean isSetRationaleDedicatedMeasures();

  /**
   * Returns the value of the '<em><b>Exposure Time</b></em>' attribute.
   * The default value is <code>"0.0"</code>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * The exposure time is the duration of exposure, shall be expressed in h.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Exposure Time</em>' attribute.
   * @see #isSetExposureTime()
   * @see #unsetExposureTime()
   * @see #setExposureTime(Double)
   * @see org.safe.metamodel.safe10.Safe10Package#getHWPMHF_ExposureTime()
   * @model default="0.0" unsettable="true" dataType="org.safe.metamodel.safe10.Float" required="true"
   *        annotation="MetaData guid='{7AF37B91-804F-4c84-ADEE-41492CD1AF9A}' id='-1429181530' EA\040name='exposureTime'"
   *        extendedMetaData="name='EXPOSURE-TIME' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='EXPOSURE-TIMES' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Double getExposureTime();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HWPMHF#getExposureTime <em>Exposure Time</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Exposure Time</em>' attribute.
   * @see #isSetExposureTime()
   * @see #ExposureTime()
   * @see #getExposureTime()
   * @generated
   */
  void setExposureTime(Double value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.HWPMHF#getExposureTime <em>Exposure Time</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetExposureTime()
   * @see #getExposureTime()
   * @see #setExposureTime(Double)
   * @generated
   */
  void unsetExposureTime();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.HWPMHF#getExposureTime <em>Exposure Time</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Exposure Time</em>' attribute is set.
   * @see #ExposureTime()
   * @see #getExposureTime()
   * @see #setExposureTime(Double)
   * @generated
   */
  boolean isSetExposureTime();

  /**
   * Returns the value of the '<em><b>Rationale Exposure Time</b></em>' attribute.
   * The default value is <code>""</code>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * The attribute rationaleExposureTime is for Documentation of rationale for Exposure Time.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Rationale Exposure Time</em>' attribute.
   * @see #isSetRationaleExposureTime()
   * @see #unsetRationaleExposureTime()
   * @see #setRationaleExposureTime(String)
   * @see org.safe.metamodel.safe10.Safe10Package#getHWPMHF_RationaleExposureTime()
   * @model default="" unsettable="true" dataType="org.safe.metamodel.safe10.String" required="true"
   *        annotation="MetaData guid='{3AAE42FE-CC99-4273-9D5A-793FAF4A9322}' id='2074022468' EA\040name='rationaleExposureTime'"
   *        extendedMetaData="name='RATIONALE-EXPOSURE-TIME' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='RATIONALE-EXPOSURE-TIMES' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  String getRationaleExposureTime();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HWPMHF#getRationaleExposureTime <em>Rationale Exposure Time</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Rationale Exposure Time</em>' attribute.
   * @see #isSetRationaleExposureTime()
   * @see #RationaleExposureTime()
   * @see #getRationaleExposureTime()
   * @generated
   */
  void setRationaleExposureTime(String value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.HWPMHF#getRationaleExposureTime <em>Rationale Exposure Time</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetRationaleExposureTime()
   * @see #getRationaleExposureTime()
   * @see #setRationaleExposureTime(String)
   * @generated
   */
  void unsetRationaleExposureTime();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.HWPMHF#getRationaleExposureTime <em>Rationale Exposure Time</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Rationale Exposure Time</em>' attribute is set.
   * @see #RationaleExposureTime()
   * @see #getRationaleExposureTime()
   * @see #setRationaleExposureTime(String)
   * @generated
   */
  boolean isSetRationaleExposureTime();

  /**
   * Returns the value of the '<em><b>Hw PMHF Calculated Value</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Hw PMHF Calculated Value</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Hw PMHF Calculated Value</em>' containment reference.
   * @see #setHwPMHFCalculatedValue(HWPMHFFormula)
   * @see org.safe.metamodel.safe10.Safe10Package#getHWPMHF_HwPMHFCalculatedValue()
   * @model containment="true" required="true"
   *        annotation="MetaData guid='{9242DB34-6508-4b70-99B5-9EB8AD1DAA35}' id='1110729735' EA\040name=''"
   *        extendedMetaData="name='HW-PMHF-CALCULATED-VALUE' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HW-PMHF-CALCULATED-VALUES' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  HWPMHFFormula getHwPMHFCalculatedValue();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HWPMHF#getHwPMHFCalculatedValue <em>Hw PMHF Calculated Value</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Hw PMHF Calculated Value</em>' containment reference.
   * @see #getHwPMHFCalculatedValue()
   * @generated
   */
  void setHwPMHFCalculatedValue(HWPMHFFormula value);

} // HWPMHF
