/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>HW Part Failure</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * This class describes the failure data extension for all HWPart elements, including part failure rate and part failure mode.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Hardware.FailurePart.HWPartFailure</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.HWPartFailure#getNameWasNotSet_3 <em>Name Was Not Set 3</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HWPartFailure#getHwPartFailureMode <em>Hw Part Failure Mode</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HWPartFailure#getHwPartFailureRate <em>Hw Part Failure Rate</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getHWPartFailure()
 * @model annotation="MetaData guid='{0AEB08CF-B1E5-45d4-BC94-281F8E6A39BE}' id='-1697592469' EA\040name='HWPartFailure'"
 *        extendedMetaData="name='HW-PART-FAILURE' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HW-PART-FAILURES'"
 * @generated
 */
public interface HWPartFailure extends Identifiable
{
  /**
   * Returns the value of the '<em><b>Name Was Not Set 3</b></em>' reference.
   * It is bidirectional and its opposite is '{@link org.safe.metamodel.safe10.AutosarHardwareSafetyExtension#getRamdomHardwarePartFailure <em>Ramdom Hardware Part Failure</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Name Was Not Set 3</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Name Was Not Set 3</em>' reference.
   * @see #setNameWasNotSet_3(AutosarHardwareSafetyExtension)
   * @see org.safe.metamodel.safe10.Safe10Package#getHWPartFailure_NameWasNotSet_3()
   * @see org.safe.metamodel.safe10.AutosarHardwareSafetyExtension#getRamdomHardwarePartFailure
   * @model opposite="ramdomHardwarePartFailure"
   *        annotation="MetaData guid='{BD4D6686-7DD8-4a72-A20A-7BD0381B3E39}' id='-327469539' EA\040name=''"
   *        extendedMetaData="name='NAME-WAS-NOT-SET-3-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='NAME-WAS-NOT-SET-3-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  AutosarHardwareSafetyExtension getNameWasNotSet_3();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HWPartFailure#getNameWasNotSet_3 <em>Name Was Not Set 3</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Name Was Not Set 3</em>' reference.
   * @see #getNameWasNotSet_3()
   * @generated
   */
  void setNameWasNotSet_3(AutosarHardwareSafetyExtension value);

  /**
   * Returns the value of the '<em><b>Hw Part Failure Mode</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.HWPartFailureMode}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Hw Part Failure Mode</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Hw Part Failure Mode</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getHWPartFailure_HwPartFailureMode()
   * @model containment="true"
   *        annotation="MetaData guid='{D7C1FBA7-00D0-43ce-A3FF-D70872E1404C}' id='302887607' EA\040name=''"
   *        extendedMetaData="name='HW-PART-FAILURE-MODE' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HW-PART-FAILURE-MODES' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<HWPartFailureMode> getHwPartFailureMode();

  /**
   * Returns the value of the '<em><b>Hw Part Failure Rate</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Hw Part Failure Rate</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Hw Part Failure Rate</em>' containment reference.
   * @see #setHwPartFailureRate(HWPartFailureRate)
   * @see org.safe.metamodel.safe10.Safe10Package#getHWPartFailure_HwPartFailureRate()
   * @model containment="true" required="true"
   *        annotation="MetaData guid='{E20101F2-231F-4f30-85C4-BBAEC1D992D3}' id='-917555274' EA\040name=''"
   *        extendedMetaData="name='HW-PART-FAILURE-RATE' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HW-PART-FAILURE-RATES' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  HWPartFailureRate getHwPartFailureRate();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HWPartFailure#getHwPartFailureRate <em>Hw Part Failure Rate</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Hw Part Failure Rate</em>' containment reference.
   * @see #getHwPartFailureRate()
   * @generated
   */
  void setHwPartFailureRate(HWPartFailureRate value);

} // HWPartFailure
