/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>HW Quantitative Failure Analysis</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * This class represent the container for all quantified failure analysis required by the ISO 26262 Part 5 for a dedicated SafetyGoal. This class allows to cluster all meta class  for the HWArchitecturalMetrics described in the ISO Part 5 Clause 8 (Single-Point-Fault Metric, Latent-Fault Metric) and probabilistic value for violation of safety goal (PMH) or Failure Class Method described in the ISO Part 5 Clause 9.
 * 
 * Each HWFailureAnalysis belongs to exactly one SafetyGoal. The ASIL-TargetValue (e.g. ASIL-D) is derived from the SafetyGoal.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Hardware.HWQuantitativeMeasure.HWQuantitativeFailureAnalysis</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.HWQuantitativeFailureAnalysis#getHwArchitecturalMetrics <em>Hw Architectural Metrics</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HWQuantitativeFailureAnalysis#getHwProbalisticValue <em>Hw Probalistic Value</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HWQuantitativeFailureAnalysis#getNameWasNotSet_5 <em>Name Was Not Set 5</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getHWQuantitativeFailureAnalysis()
 * @model annotation="MetaData guid='{27C9F4D1-6DF3-4010-98F5-532862230C97}' id='-329506175' EA\040name='HWQuantitativeFailureAnalysis'"
 *        extendedMetaData="name='HW-QUANTITATIVE-FAILURE-ANALYSIS' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HW-QUANTITATIVE-FAILURE-ANALYSISS'"
 * @generated
 */
public interface HWQuantitativeFailureAnalysis extends Identifiable
{
  /**
   * Returns the value of the '<em><b>Hw Architectural Metrics</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Hw Architectural Metrics</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Hw Architectural Metrics</em>' containment reference.
   * @see #setHwArchitecturalMetrics(HWArchitecturalMetrics)
   * @see org.safe.metamodel.safe10.Safe10Package#getHWQuantitativeFailureAnalysis_HwArchitecturalMetrics()
   * @model containment="true" required="true"
   *        annotation="MetaData guid='{7C813744-BCB3-44d7-98BE-9C355198EB60}' id='437796248' EA\040name=''"
   *        extendedMetaData="name='HW-ARCHITECTURAL-METRICS' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HW-ARCHITECTURAL-METRICSS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  HWArchitecturalMetrics getHwArchitecturalMetrics();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HWQuantitativeFailureAnalysis#getHwArchitecturalMetrics <em>Hw Architectural Metrics</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Hw Architectural Metrics</em>' containment reference.
   * @see #getHwArchitecturalMetrics()
   * @generated
   */
  void setHwArchitecturalMetrics(HWArchitecturalMetrics value);

  /**
   * Returns the value of the '<em><b>Hw Probalistic Value</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Hw Probalistic Value</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Hw Probalistic Value</em>' containment reference.
   * @see #setHwProbalisticValue(HWProbabilisticValue)
   * @see org.safe.metamodel.safe10.Safe10Package#getHWQuantitativeFailureAnalysis_HwProbalisticValue()
   * @model containment="true" required="true"
   *        annotation="MetaData guid='{FC725FC3-9AAB-4157-8EA1-1DEC2D55003A}' id='-1429291642' EA\040name=''"
   *        extendedMetaData="name='HW-PROBALISTIC-VALUE' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HW-PROBALISTIC-VALUES' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  HWProbabilisticValue getHwProbalisticValue();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HWQuantitativeFailureAnalysis#getHwProbalisticValue <em>Hw Probalistic Value</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Hw Probalistic Value</em>' containment reference.
   * @see #getHwProbalisticValue()
   * @generated
   */
  void setHwProbalisticValue(HWProbabilisticValue value);

  /**
   * Returns the value of the '<em><b>Name Was Not Set 5</b></em>' reference.
   * It is bidirectional and its opposite is '{@link org.safe.metamodel.safe10.HardwareFailureAnalysis#getHardwareQuantifiedAnalysis <em>Hardware Quantified Analysis</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Name Was Not Set 5</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Name Was Not Set 5</em>' reference.
   * @see #setNameWasNotSet_5(HardwareFailureAnalysis)
   * @see org.safe.metamodel.safe10.Safe10Package#getHWQuantitativeFailureAnalysis_NameWasNotSet_5()
   * @see org.safe.metamodel.safe10.HardwareFailureAnalysis#getHardwareQuantifiedAnalysis
   * @model opposite="hardwareQuantifiedAnalysis"
   *        annotation="MetaData guid='{4B7F9C9D-A743-4ee8-9E95-E5298B110864}' id='-520403363' EA\040name=''"
   *        extendedMetaData="name='NAME-WAS-NOT-SET-5-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='NAME-WAS-NOT-SET-5-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  HardwareFailureAnalysis getNameWasNotSet_5();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HWQuantitativeFailureAnalysis#getNameWasNotSet_5 <em>Name Was Not Set 5</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Name Was Not Set 5</em>' reference.
   * @see #getNameWasNotSet_5()
   * @generated
   */
  void setNameWasNotSet_5(HardwareFailureAnalysis value);

} // HWQuantitativeFailureAnalysis
