/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Hardware Component Failure</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * This class describes the failure data extension for all HWComponents, including failure rate and failure mode.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Hardware.Failure.HardwareComponentFailure</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.HardwareComponentFailure#getHwFailureRate <em>Hw Failure Rate</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HardwareComponentFailure#getHwFailureMode <em>Hw Failure Mode</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getHardwareComponentFailure()
 * @model abstract="true"
 *        annotation="MetaData guid='{9F96702C-C7D8-49bb-9E7C-81C924EDD135}' id='215288450' EA\040name='HardwareComponentFailure'"
 *        extendedMetaData="name='HARDWARE-COMPONENT-FAILURE' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HARDWARE-COMPONENT-FAILURES'"
 * @generated
 */
public interface HardwareComponentFailure extends Identifiable
{
  /**
   * Returns the value of the '<em><b>Hw Failure Rate</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Hw Failure Rate</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Hw Failure Rate</em>' containment reference.
   * @see #setHwFailureRate(HWFailureRate)
   * @see org.safe.metamodel.safe10.Safe10Package#getHardwareComponentFailure_HwFailureRate()
   * @model containment="true" required="true"
   *        annotation="MetaData guid='{FF71106F-D23B-4a8d-AE46-ECA3E9266614}' id='1879369852' EA\040name=''"
   *        extendedMetaData="name='HW-FAILURE-RATE' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HW-FAILURE-RATES' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  HWFailureRate getHwFailureRate();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HardwareComponentFailure#getHwFailureRate <em>Hw Failure Rate</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Hw Failure Rate</em>' containment reference.
   * @see #getHwFailureRate()
   * @generated
   */
  void setHwFailureRate(HWFailureRate value);

  /**
   * Returns the value of the '<em><b>Hw Failure Mode</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.HWFailureMode}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Hw Failure Mode</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Hw Failure Mode</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getHardwareComponentFailure_HwFailureMode()
   * @model containment="true" required="true"
   *        annotation="MetaData guid='{66DDDE36-8FDC-4031-89B8-C240A3D9D617}' id='165135646' EA\040name=''"
   *        extendedMetaData="name='HW-FAILURE-MODE' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HW-FAILURE-MODES' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<HWFailureMode> getHwFailureMode();

} // HardwareComponentFailure
