/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Hardware Failure Analysis</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * This class represent the container for all Hardware Failure Analysis.
 * Each safety goal (as malfunction) must lead to a safety analysis, so this class contains all the information related to the analysis as :
 * - the relation to the malfunction as the malfunctionPrototype for each analysis
 * - the HwComponentPrototypeScope to identify all hardware component specific to the context as HWComponentProtype inside a type composition
 * - the HWQuantifiedFailure Analysis performed on the level of the composition
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Hardware.Failure.HardwareFailureAnalysis</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.HardwareFailureAnalysis#getMalfunctionAnalysis <em>Malfunction Analysis</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HardwareFailureAnalysis#getHWComponentScope <em>HW Component Scope</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HardwareFailureAnalysis#getHardwareQuantifiedAnalysis <em>Hardware Quantified Analysis</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getHardwareFailureAnalysis()
 * @model annotation="MetaData guid='{9F535868-C076-4004-ABEA-A6662698FABE}' id='1420910910' EA\040name='HardwareFailureAnalysis'"
 *        extendedMetaData="name='HARDWARE-FAILURE-ANALYSIS' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HARDWARE-FAILURE-ANALYSISS'"
 * @generated
 */
public interface HardwareFailureAnalysis extends Identifiable
{
  /**
   * Returns the value of the '<em><b>Malfunction Analysis</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Malfunction Analysis</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Malfunction Analysis</em>' containment reference.
   * @see #setMalfunctionAnalysis(MalfunctionInstanceRef)
   * @see org.safe.metamodel.safe10.Safe10Package#getHardwareFailureAnalysis_MalfunctionAnalysis()
   * @model containment="true" required="true"
   *        annotation="MetaData guid='{0F5E4D42-8740-4323-9107-BFD9FC7BEE95}' id='1227029947' EA\040name=''"
   *        annotation="TaggedValues xml.name='MALFUNCTION-ANALYSIS-IREF' xml.namePlural='MALFUNCTION-ANALYSIS-IREFS' xml.roleElement='true' xml.typeElement='false' xml.typeWrapperElement='false'"
   *        extendedMetaData="name='MALFUNCTION-ANALYSIS-IREF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='MALFUNCTION-ANALYSIS-IREFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  MalfunctionInstanceRef getMalfunctionAnalysis();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HardwareFailureAnalysis#getMalfunctionAnalysis <em>Malfunction Analysis</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Malfunction Analysis</em>' containment reference.
   * @see #getMalfunctionAnalysis()
   * @generated
   */
  void setMalfunctionAnalysis(MalfunctionInstanceRef value);

  /**
   * Returns the value of the '<em><b>HW Component Scope</b></em>' reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.HWComponentPrototypeScope}.
   * It is bidirectional and its opposite is '{@link org.safe.metamodel.safe10.HWComponentPrototypeScope#getNameWasNotSet_0 <em>Name Was Not Set 0</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>HW Component Scope</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>HW Component Scope</em>' reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getHardwareFailureAnalysis_HWComponentScope()
   * @see org.safe.metamodel.safe10.HWComponentPrototypeScope#getNameWasNotSet_0
   * @model opposite="NameWasNotSet_0"
   *        extendedMetaData="name='H-W-COMPONENT-SCOPE-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='H-W-COMPONENT-SCOPE-REFS' xmlAttribute='false' featureWrapperElement='true' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  EList<HWComponentPrototypeScope> getHWComponentScope();

  /**
   * Returns the value of the '<em><b>Hardware Quantified Analysis</b></em>' reference.
   * It is bidirectional and its opposite is '{@link org.safe.metamodel.safe10.HWQuantitativeFailureAnalysis#getNameWasNotSet_5 <em>Name Was Not Set 5</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Hardware Quantified Analysis</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Hardware Quantified Analysis</em>' reference.
   * @see #setHardwareQuantifiedAnalysis(HWQuantitativeFailureAnalysis)
   * @see org.safe.metamodel.safe10.Safe10Package#getHardwareFailureAnalysis_HardwareQuantifiedAnalysis()
   * @see org.safe.metamodel.safe10.HWQuantitativeFailureAnalysis#getNameWasNotSet_5
   * @model opposite="NameWasNotSet_5"
   *        extendedMetaData="name='HARDWARE-QUANTIFIED-ANALYSIS-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HARDWARE-QUANTIFIED-ANALYSIS-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  HWQuantitativeFailureAnalysis getHardwareQuantifiedAnalysis();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HardwareFailureAnalysis#getHardwareQuantifiedAnalysis <em>Hardware Quantified Analysis</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Hardware Quantified Analysis</em>' reference.
   * @see #getHardwareQuantifiedAnalysis()
   * @generated
   */
  void setHardwareQuantifiedAnalysis(HWQuantitativeFailureAnalysis value);

} // HardwareFailureAnalysis
