/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eatop.eel.eastadl21.FunctionConnector;
import org.eatop.eel.eastadl21.FunctionPort;
import org.eatop.eel.eastadl21.HardwarePin;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Hardware Software Interface Element</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * An element within the HSI specification.
 * 
 * Constraint: (see EAST-ADL) the associated FunctionConnector has to be a specific connector that connects a BasicSoftwareFunctionType with a HardwareFunctionType. 
 * 
 * Note: The FunctionConnector is an optional information of the HSI Element as it can also be derived from the associated HardwarePin and FunctionPort.
 * 
 * Constraint: (see EAST-ADL) the HardwarePin is contained in a HardwareComponentType that is associated with the HardwareFunctionType which port is connected by the forementioned connector.
 * 
 * Constraint: (see EAST-ADL) the FunctionPort has to be associated with a BasicSoftwareFunctionType 
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.System.HardwareSoftwareInterfaceElement</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.HardwareSoftwareInterfaceElement#getType <em>Type</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HardwareSoftwareInterfaceElement#getRationale <em>Rationale</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HardwareSoftwareInterfaceElement#getHardwarePin <em>Hardware Pin</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HardwareSoftwareInterfaceElement#getBasicSoftwareFunctionPort <em>Basic Software Function Port</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HardwareSoftwareInterfaceElement#getConnector <em>Connector</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getHardwareSoftwareInterfaceElement()
 * @model annotation="MetaData guid='{00448081-A88A-4f68-9148-25F4CCD3E887}' id='-1657969463' EA\040name='HardwareSoftwareInterfaceElement'"
 *        extendedMetaData="name='HARDWARE-SOFTWARE-INTERFACE-ELEMENT' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HARDWARE-SOFTWARE-INTERFACE-ELEMENTS'"
 * @generated
 */
public interface HardwareSoftwareInterfaceElement extends Identifiable
{
  /**
   * Returns the value of the '<em><b>Type</b></em>' attribute.
   * The default value is <code>"VOLATILE_MEMORY"</code>.
   * The literals are from the enumeration {@link org.safe.metamodel.safe10.HSIElementCategory}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Type</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Type</em>' attribute.
   * @see org.safe.metamodel.safe10.HSIElementCategory
   * @see #isSetType()
   * @see #unsetType()
   * @see #setType(HSIElementCategory)
   * @see org.safe.metamodel.safe10.Safe10Package#getHardwareSoftwareInterfaceElement_Type()
   * @model default="VOLATILE_MEMORY" unsettable="true" required="true"
   *        annotation="MetaData guid='{2C3091AB-FB34-40b2-8ABA-058DF23773D7}' id='-261064029' EA\040name='type'"
   *        extendedMetaData="name='TYPE' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='TYPES' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  HSIElementCategory getType();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HardwareSoftwareInterfaceElement#getType <em>Type</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Type</em>' attribute.
   * @see org.safe.metamodel.safe10.HSIElementCategory
   * @see #isSetType()
   * @see #Type()
   * @see #getType()
   * @generated
   */
  void setType(HSIElementCategory value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.HardwareSoftwareInterfaceElement#getType <em>Type</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetType()
   * @see #getType()
   * @see #setType(HSIElementCategory)
   * @generated
   */
  void unsetType();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.HardwareSoftwareInterfaceElement#getType <em>Type</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Type</em>' attribute is set.
   * @see #Type()
   * @see #getType()
   * @see #setType(HSIElementCategory)
   * @generated
   */
  boolean isSetType();

  /**
   * Returns the value of the '<em><b>Rationale</b></em>' attribute.
   * The default value is <code>""</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Rationale</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Rationale</em>' attribute.
   * @see #isSetRationale()
   * @see #unsetRationale()
   * @see #setRationale(String)
   * @see org.safe.metamodel.safe10.Safe10Package#getHardwareSoftwareInterfaceElement_Rationale()
   * @model default="" unsettable="true" dataType="org.safe.metamodel.safe10.String" required="true"
   *        annotation="MetaData guid='{FBCACAD1-803E-4c86-AE91-99C1BE3192F1}' id='812279108' EA\040name='rationale'"
   *        extendedMetaData="name='RATIONALE' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='RATIONALES' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  String getRationale();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HardwareSoftwareInterfaceElement#getRationale <em>Rationale</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Rationale</em>' attribute.
   * @see #isSetRationale()
   * @see #Rationale()
   * @see #getRationale()
   * @generated
   */
  void setRationale(String value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.HardwareSoftwareInterfaceElement#getRationale <em>Rationale</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetRationale()
   * @see #getRationale()
   * @see #setRationale(String)
   * @generated
   */
  void unsetRationale();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.HardwareSoftwareInterfaceElement#getRationale <em>Rationale</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Rationale</em>' attribute is set.
   * @see #Rationale()
   * @see #getRationale()
   * @see #setRationale(String)
   * @generated
   */
  boolean isSetRationale();

  /**
   * Returns the value of the '<em><b>Hardware Pin</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Hardware Pin</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Hardware Pin</em>' reference.
   * @see #setHardwarePin(HardwarePin)
   * @see org.safe.metamodel.safe10.Safe10Package#getHardwareSoftwareInterfaceElement_HardwarePin()
   * @model required="true"
   *        annotation="MetaData guid='{2948D012-B139-4835-8F46-1849A765D28B}' id='-2080078889' EA\040name=''"
   *        extendedMetaData="name='HARDWARE-PIN-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HARDWARE-PIN-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  HardwarePin getHardwarePin();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HardwareSoftwareInterfaceElement#getHardwarePin <em>Hardware Pin</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Hardware Pin</em>' reference.
   * @see #getHardwarePin()
   * @generated
   */
  void setHardwarePin(HardwarePin value);

  /**
   * Returns the value of the '<em><b>Basic Software Function Port</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Basic Software Function Port</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Basic Software Function Port</em>' reference.
   * @see #setBasicSoftwareFunctionPort(FunctionPort)
   * @see org.safe.metamodel.safe10.Safe10Package#getHardwareSoftwareInterfaceElement_BasicSoftwareFunctionPort()
   * @model required="true"
   *        annotation="MetaData guid='{0FCCD870-4DDE-4d11-8E39-6E0ABC22758D}' id='-1566785741' EA\040name=''"
   *        extendedMetaData="name='BASIC-SOFTWARE-FUNCTION-PORT-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='BASIC-SOFTWARE-FUNCTION-PORT-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  FunctionPort getBasicSoftwareFunctionPort();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HardwareSoftwareInterfaceElement#getBasicSoftwareFunctionPort <em>Basic Software Function Port</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Basic Software Function Port</em>' reference.
   * @see #getBasicSoftwareFunctionPort()
   * @generated
   */
  void setBasicSoftwareFunctionPort(FunctionPort value);

  /**
   * Returns the value of the '<em><b>Connector</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Connector</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Connector</em>' reference.
   * @see #setConnector(FunctionConnector)
   * @see org.safe.metamodel.safe10.Safe10Package#getHardwareSoftwareInterfaceElement_Connector()
   * @model annotation="MetaData guid='{81376865-97DD-4280-A499-F6B30ED39BA6}' id='887915169' EA\040name=''"
   *        extendedMetaData="name='CONNECTOR-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='CONNECTOR-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  FunctionConnector getConnector();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HardwareSoftwareInterfaceElement#getConnector <em>Connector</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Connector</em>' reference.
   * @see #getConnector()
   * @generated
   */
  void setConnector(FunctionConnector value);

} // HardwareSoftwareInterfaceElement
