/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eatop.eel.eastadl21.FeatureModel;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Hazardand Risk Safety Extension</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * The HazardAndRiskSafetyExtension is used as interface to the VehicleFeature defined in EAST-ADL. This extension specifies the add-on needed to model the hazard analysis and risk assessment defined in ISO 26262 part 3 chapter 7. Further details according to modeling of hazards and safety goals are described in D3.1.1.b 
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.CommonStructure.SafetyExtensions.HazardandRiskSafetyExtension.HazardandRiskSafetyExtension</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.HazardandRiskSafetyExtension#getScope <em>Scope</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HazardandRiskSafetyExtension#getActor <em>Actor</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HazardandRiskSafetyExtension#getControllability <em>Controllability</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HazardandRiskSafetyExtension#getHazard <em>Hazard</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HazardandRiskSafetyExtension#getHazardousEvent <em>Hazardous Event</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HazardandRiskSafetyExtension#getItem <em>Item</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HazardandRiskSafetyExtension#getOperationalSituation <em>Operational Situation</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HazardandRiskSafetyExtension#getRisk <em>Risk</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HazardandRiskSafetyExtension#getSafetyGoal <em>Safety Goal</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getHazardandRiskSafetyExtension()
 * @model annotation="MetaData guid='{0BA3503D-0C1F-4d84-93DB-E24779C8ADDC}' id='1466722733' EA\040name='HazardandRiskSafetyExtension'"
 *        extendedMetaData="name='HAZARDAND-RISK-SAFETY-EXTENSION' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HAZARDAND-RISK-SAFETY-EXTENSIONS'"
 * @generated
 */
public interface HazardandRiskSafetyExtension extends SingleLevelSafetyExtension
{
  /**
   * Returns the value of the '<em><b>Scope</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Scope</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Scope</em>' reference.
   * @see #setScope(FeatureModel)
   * @see org.safe.metamodel.safe10.Safe10Package#getHazardandRiskSafetyExtension_Scope()
   * @model required="true"
   *        annotation="MetaData guid='{517E5385-F574-4f2f-8AC8-BFAC51D61C7F}' id='-1226699750' EA\040name=''"
   *        extendedMetaData="name='SCOPE-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SCOPE-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  FeatureModel getScope();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HazardandRiskSafetyExtension#getScope <em>Scope</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Scope</em>' reference.
   * @see #getScope()
   * @generated
   */
  void setScope(FeatureModel value);

  /**
   * Returns the value of the '<em><b>Actor</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.Actor}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Actor</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Actor</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getHazardandRiskSafetyExtension_Actor()
   * @model containment="true"
   *        annotation="MetaData guid='{5AA62A20-9162-460b-8123-932D87871BEF}' id='1596082583' EA\040name=''"
   *        extendedMetaData="name='ACTOR' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='ACTORS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<Actor> getActor();

  /**
   * Returns the value of the '<em><b>Controllability</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.ControllabilityReference}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Controllability</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Controllability</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getHazardandRiskSafetyExtension_Controllability()
   * @model containment="true" required="true"
   *        annotation="MetaData guid='{FABFA950-ED07-4add-AC33-DA0BD4635D32}' id='1480915219' EA\040name=''"
   *        extendedMetaData="name='CONTROLLABILITY' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='CONTROLLABILITYS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<ControllabilityReference> getControllability();

  /**
   * Returns the value of the '<em><b>Hazard</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.Hazard}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Hazard</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Hazard</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getHazardandRiskSafetyExtension_Hazard()
   * @model containment="true"
   *        annotation="MetaData guid='{5343517F-B6BE-4af3-9C0F-00FB9343C612}' id='908248477' EA\040name=''"
   *        extendedMetaData="name='HAZARD' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HAZARDS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<Hazard> getHazard();

  /**
   * Returns the value of the '<em><b>Hazardous Event</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.HazardousEvent}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Hazardous Event</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Hazardous Event</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getHazardandRiskSafetyExtension_HazardousEvent()
   * @model containment="true"
   *        annotation="MetaData guid='{72F61540-F685-435c-AFDB-35F53B1348CE}' id='-1418677068' EA\040name=''"
   *        extendedMetaData="name='HAZARDOUS-EVENT' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HAZARDOUS-EVENTS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<HazardousEvent> getHazardousEvent();

  /**
   * Returns the value of the '<em><b>Item</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.Item}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Item</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Item</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getHazardandRiskSafetyExtension_Item()
   * @model containment="true"
   *        annotation="MetaData guid='{52F87348-F9BA-47a9-9D26-83AD53F0C43E}' id='213823557' EA\040name=''"
   *        extendedMetaData="name='ITEM' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='ITEMS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<Item> getItem();

  /**
   * Returns the value of the '<em><b>Operational Situation</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.OperationalSituation}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Operational Situation</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Operational Situation</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getHazardandRiskSafetyExtension_OperationalSituation()
   * @model containment="true"
   *        annotation="MetaData guid='{1A39C022-4BC4-446f-83EA-A1DBAB8B3390}' id='-1926503209' EA\040name=''"
   *        extendedMetaData="name='OPERATIONAL-SITUATION' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='OPERATIONAL-SITUATIONS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<OperationalSituation> getOperationalSituation();

  /**
   * Returns the value of the '<em><b>Risk</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.RiskDescription}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Risk</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Risk</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getHazardandRiskSafetyExtension_Risk()
   * @model containment="true"
   *        annotation="MetaData guid='{8DAFFAA1-E91C-4f33-80CD-464492A0E29A}' id='1826735368' EA\040name=''"
   *        extendedMetaData="name='RISK' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='RISKS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<RiskDescription> getRisk();

  /**
   * Returns the value of the '<em><b>Safety Goal</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.FunctionalSafetyRequirement}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Safety Goal</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Safety Goal</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getHazardandRiskSafetyExtension_SafetyGoal()
   * @model containment="true"
   *        annotation="MetaData guid='{717AA556-870E-4ac4-BDA6-6127BF7312CB}' id='-1967467500' EA\040name=''"
   *        extendedMetaData="name='SAFETY-GOAL' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SAFETY-GOALS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<FunctionalSafetyRequirement> getSafetyGoal();

} // HazardandRiskSafetyExtension
