/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Heartbeat Config</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Configuration of Heartbeat SSR: timing of source and receiver.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.SoftwareSafetyRequirements.Heartbeat.HeartbeatConfig</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.HeartbeatConfig#getPeriodMs <em>Period Ms</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HeartbeatConfig#getDeadlineMs <em>Deadline Ms</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getHeartbeatConfig()
 * @model annotation="MetaData guid='{CE58168D-E7A9-491b-A499-4C4BE735852F}' id='1334929199' EA\040name='HeartbeatConfig'"
 *        extendedMetaData="name='HEARTBEAT-CONFIG' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HEARTBEAT-CONFIGS'"
 * @generated
 */
public interface HeartbeatConfig extends Identifiable
{
  /**
   * Returns the value of the '<em><b>Period Ms</b></em>' attribute.
   * The default value is <code>"0"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Period Ms</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Period Ms</em>' attribute.
   * @see #isSetPeriodMs()
   * @see #unsetPeriodMs()
   * @see #setPeriodMs(Integer)
   * @see org.safe.metamodel.safe10.Safe10Package#getHeartbeatConfig_PeriodMs()
   * @model default="0" unsettable="true" dataType="org.safe.metamodel.safe10.Integer" required="true"
   *        annotation="MetaData guid='{50174614-BED2-4b63-A4B1-05C55569C3BF}' id='-2102009813' EA\040name='periodMs'"
   *        extendedMetaData="name='PERIOD-MS' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='PERIOD-MSS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Integer getPeriodMs();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HeartbeatConfig#getPeriodMs <em>Period Ms</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Period Ms</em>' attribute.
   * @see #isSetPeriodMs()
   * @see #PeriodMs()
   * @see #getPeriodMs()
   * @generated
   */
  void setPeriodMs(Integer value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.HeartbeatConfig#getPeriodMs <em>Period Ms</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetPeriodMs()
   * @see #getPeriodMs()
   * @see #setPeriodMs(Integer)
   * @generated
   */
  void unsetPeriodMs();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.HeartbeatConfig#getPeriodMs <em>Period Ms</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Period Ms</em>' attribute is set.
   * @see #PeriodMs()
   * @see #getPeriodMs()
   * @see #setPeriodMs(Integer)
   * @generated
   */
  boolean isSetPeriodMs();

  /**
   * Returns the value of the '<em><b>Deadline Ms</b></em>' attribute.
   * The default value is <code>"0"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Deadline Ms</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Deadline Ms</em>' attribute.
   * @see #isSetDeadlineMs()
   * @see #unsetDeadlineMs()
   * @see #setDeadlineMs(Integer)
   * @see org.safe.metamodel.safe10.Safe10Package#getHeartbeatConfig_DeadlineMs()
   * @model default="0" unsettable="true" dataType="org.safe.metamodel.safe10.Integer" required="true"
   *        annotation="MetaData guid='{CB4568C3-3312-4233-B4F9-3C947CD713B4}' id='-719386224' EA\040name='deadlineMs'"
   *        extendedMetaData="name='DEADLINE-MS' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='DEADLINE-MSS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Integer getDeadlineMs();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HeartbeatConfig#getDeadlineMs <em>Deadline Ms</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Deadline Ms</em>' attribute.
   * @see #isSetDeadlineMs()
   * @see #DeadlineMs()
   * @see #getDeadlineMs()
   * @generated
   */
  void setDeadlineMs(Integer value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.HeartbeatConfig#getDeadlineMs <em>Deadline Ms</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetDeadlineMs()
   * @see #getDeadlineMs()
   * @see #setDeadlineMs(Integer)
   * @generated
   */
  void unsetDeadlineMs();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.HeartbeatConfig#getDeadlineMs <em>Deadline Ms</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Deadline Ms</em>' attribute is set.
   * @see #DeadlineMs()
   * @see #getDeadlineMs()
   * @see #setDeadlineMs(Integer)
   * @generated
   */
  boolean isSetDeadlineMs();

} // HeartbeatConfig
