/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eatop.eel.eastadl21.HardwareComponentPrototype;
import org.eatop.eel.eastadl21.HardwareComponentType;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Hw Component Scope Instance Ref</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * This "instanceRef" meta-class is the container for holding the relation of HWComponentPrototypeScope in context of HWComponentType for the use of HWComponentPrototype.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Hardware.Failure._instanceRef.HwComponentScopeInstanceRef</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.HwComponentScopeInstanceRef#getNameWasNotSet_1 <em>Name Was Not Set 1</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HwComponentScopeInstanceRef#getBase <em>Base</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HwComponentScopeInstanceRef#getContext <em>Context</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.HwComponentScopeInstanceRef#getTarget <em>Target</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getHwComponentScopeInstanceRef()
 * @model annotation="MetaData guid='{2985040D-A695-42e6-87FA-98D5FF88A549}' id='1867991550' EA\040name='HwComponentScopeInstanceRef'"
 *        annotation="Stereotype Stereotype='InstanceRef'"
 *        extendedMetaData="name='HW-COMPONENT-SCOPE-INSTANCE-REF' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='HW-COMPONENT-SCOPE-INSTANCE-REFS'"
 * @generated
 */
public interface HwComponentScopeInstanceRef extends EObject
{
  /**
   * Returns the value of the '<em><b>Name Was Not Set 1</b></em>' reference.
   * It is bidirectional and its opposite is '{@link org.safe.metamodel.safe10.HWComponentPrototypeScope#getScope <em>Scope</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Name Was Not Set 1</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Name Was Not Set 1</em>' reference.
   * @see #setNameWasNotSet_1(HWComponentPrototypeScope)
   * @see org.safe.metamodel.safe10.Safe10Package#getHwComponentScopeInstanceRef_NameWasNotSet_1()
   * @see org.safe.metamodel.safe10.HWComponentPrototypeScope#getScope
   * @model opposite="scope"
   *        annotation="MetaData guid='{3326848E-818E-4837-B06F-3A1B7F29C486}' id='-1184401316' EA\040name=''"
   *        extendedMetaData="name='NAME-WAS-NOT-SET-1-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='NAME-WAS-NOT-SET-1-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  HWComponentPrototypeScope getNameWasNotSet_1();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HwComponentScopeInstanceRef#getNameWasNotSet_1 <em>Name Was Not Set 1</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Name Was Not Set 1</em>' reference.
   * @see #getNameWasNotSet_1()
   * @generated
   */
  void setNameWasNotSet_1(HWComponentPrototypeScope value);

  /**
   * Returns the value of the '<em><b>Base</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Base</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Base</em>' reference.
   * @see #setBase(HardwareComponentType)
   * @see org.safe.metamodel.safe10.Safe10Package#getHwComponentScopeInstanceRef_Base()
   * @model annotation="MetaData guid='{288BDD73-1E0D-49ec-B54D-73ED0E745C89}' id='-1183828385' EA\040name=''"
   *        annotation="Stereotype Stereotype='instanceRef.base'"
   *        extendedMetaData="name='BASE-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='BASE-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  HardwareComponentType getBase();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HwComponentScopeInstanceRef#getBase <em>Base</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Base</em>' reference.
   * @see #getBase()
   * @generated
   */
  void setBase(HardwareComponentType value);

  /**
   * Returns the value of the '<em><b>Context</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Context</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Context</em>' reference.
   * @see #setContext(HardwareComponentPrototype)
   * @see org.safe.metamodel.safe10.Safe10Package#getHwComponentScopeInstanceRef_Context()
   * @model annotation="MetaData guid='{83E4ADBC-F389-4816-A58E-3AB026B30966}' id='71026216' EA\040name=''"
   *        annotation="Stereotype Stereotype='instanceRef.context'"
   *        extendedMetaData="name='CONTEXT-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='CONTEXT-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  HardwareComponentPrototype getContext();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HwComponentScopeInstanceRef#getContext <em>Context</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Context</em>' reference.
   * @see #getContext()
   * @generated
   */
  void setContext(HardwareComponentPrototype value);

  /**
   * Returns the value of the '<em><b>Target</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Target</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Target</em>' reference.
   * @see #setTarget(HardwareComponentPrototype)
   * @see org.safe.metamodel.safe10.Safe10Package#getHwComponentScopeInstanceRef_Target()
   * @model annotation="MetaData guid='{FBBD81F2-0AEE-430d-BD91-D49DCFC832D6}' id='1473709546' EA\040name=''"
   *        annotation="Stereotype Stereotype='instanceRef.target'"
   *        extendedMetaData="name='TARGET-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='TARGET-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  HardwareComponentPrototype getTarget();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.HwComponentScopeInstanceRef#getTarget <em>Target</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Target</em>' reference.
   * @see #getTarget()
   * @generated
   */
  void setTarget(HardwareComponentPrototype value);

} // HwComponentScopeInstanceRef
