/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eatop.eel.eastadl21.Requirement;
import org.eatop.eel.eastadl21.VehicleFeature;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Item</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * The item is, according to ISO 26262, a system or array of systems to implement a function at the vehicle level, to which ISO 26262 is applied. It is associated with the FunctionType since this class already allows decomposition of the function.
 * 
 * Note: E/E technology components in an other item are called "external measure".
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Hazards.Item</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.Item#getDevelopmentCategory <em>Development Category</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.Item#getPossibleItemMalfunction <em>Possible Item Malfunction</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.Item#getOtherItem <em>Other Item</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.Item#getOperationalSituation <em>Operational Situation</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.Item#getFeature <em>Feature</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.Item#getLegalRequirements <em>Legal Requirements</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.Item#getItemFunction <em>Item Function</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.Item#getOperatingMode <em>Operating Mode</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.Item#getSafeState <em>Safe State</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getItem()
 * @model annotation="MetaData guid='{24023B22-304E-4734-A727-8C89B94591B4}' id='-1307477706' EA\040name='Item'"
 *        extendedMetaData="name='ITEM' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='ITEMS'"
 * @generated
 */
public interface Item extends Identifiable
{
  /**
   * Returns the value of the '<em><b>Development Category</b></em>' attribute.
   * The default value is <code>"NEWITEMDEVELOPMENT"</code>.
   * The literals are from the enumeration {@link org.safe.metamodel.safe10.DevelopmentCategory}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Development Category</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Development Category</em>' attribute.
   * @see org.safe.metamodel.safe10.DevelopmentCategory
   * @see #isSetDevelopmentCategory()
   * @see #unsetDevelopmentCategory()
   * @see #setDevelopmentCategory(DevelopmentCategory)
   * @see org.safe.metamodel.safe10.Safe10Package#getItem_DevelopmentCategory()
   * @model default="NEWITEMDEVELOPMENT" unsettable="true" required="true"
   *        annotation="MetaData guid='{DE9E9FB6-16BF-4b12-A0F6-B57BD8B89266}' id='-1082600833' EA\040name='developmentCategory'"
   *        extendedMetaData="name='DEVELOPMENT-CATEGORY' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='DEVELOPMENT-CATEGORYS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  DevelopmentCategory getDevelopmentCategory();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.Item#getDevelopmentCategory <em>Development Category</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Development Category</em>' attribute.
   * @see org.safe.metamodel.safe10.DevelopmentCategory
   * @see #isSetDevelopmentCategory()
   * @see #DevelopmentCategory()
   * @see #getDevelopmentCategory()
   * @generated
   */
  void setDevelopmentCategory(DevelopmentCategory value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.Item#getDevelopmentCategory <em>Development Category</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetDevelopmentCategory()
   * @see #getDevelopmentCategory()
   * @see #setDevelopmentCategory(DevelopmentCategory)
   * @generated
   */
  void unsetDevelopmentCategory();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.Item#getDevelopmentCategory <em>Development Category</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Development Category</em>' attribute is set.
   * @see #DevelopmentCategory()
   * @see #getDevelopmentCategory()
   * @see #setDevelopmentCategory(DevelopmentCategory)
   * @generated
   */
  boolean isSetDevelopmentCategory();

  /**
   * Returns the value of the '<em><b>Possible Item Malfunction</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.MalfunctionPrototype}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Possible Item Malfunction</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Possible Item Malfunction</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getItem_PossibleItemMalfunction()
   * @model containment="true"
   *        annotation="MetaData guid='{9E2C82FD-425A-4dda-9124-18DB9FAB048A}' id='-754560986' EA\040name=''"
   *        extendedMetaData="name='POSSIBLE-ITEM-MALFUNCTION' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='POSSIBLE-ITEM-MALFUNCTIONS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<MalfunctionPrototype> getPossibleItemMalfunction();

  /**
   * Returns the value of the '<em><b>Other Item</b></em>' reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.Item}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Other Item</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Other Item</em>' reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getItem_OtherItem()
   * @model annotation="MetaData guid='{ED7D9C9C-CE6C-4a59-AB5F-363D9AF8A3E1}' id='-1709499820' EA\040name=''"
   *        extendedMetaData="name='OTHER-ITEM-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='OTHER-ITEM-REFS' xmlAttribute='false' featureWrapperElement='true' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  EList<Item> getOtherItem();

  /**
   * Returns the value of the '<em><b>Operational Situation</b></em>' reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.OperationalSituation}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Operational Situation</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Operational Situation</em>' reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getItem_OperationalSituation()
   * @model annotation="MetaData guid='{74669882-E411-43d4-B377-5F18A1B7DC1A}' id='-1594491333' EA\040name=''"
   *        extendedMetaData="name='OPERATIONAL-SITUATION-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='OPERATIONAL-SITUATION-REFS' xmlAttribute='false' featureWrapperElement='true' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  EList<OperationalSituation> getOperationalSituation();

  /**
   * Returns the value of the '<em><b>Feature</b></em>' reference list.
   * The list contents are of type {@link org.eatop.eel.eastadl21.VehicleFeature}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Feature</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Feature</em>' reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getItem_Feature()
   * @model required="true"
   *        annotation="MetaData guid='{E0CEFADE-5C40-4244-B155-B7C15D857EC7}' id='-531205872' EA\040name=''"
   *        extendedMetaData="name='FEATURE-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='FEATURE-REFS' xmlAttribute='false' featureWrapperElement='true' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  EList<VehicleFeature> getFeature();

  /**
   * Returns the value of the '<em><b>Legal Requirements</b></em>' reference list.
   * The list contents are of type {@link org.eatop.eel.eastadl21.Requirement}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Legal Requirements</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Legal Requirements</em>' reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getItem_LegalRequirements()
   * @model annotation="MetaData guid='{3BEECEF9-46EB-49e3-9A2D-6AB181EA25CE}' id='214319057' EA\040name=''"
   *        extendedMetaData="name='LEGAL-REQUIREMENTS-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='LEGAL-REQUIREMENTS-REFS' xmlAttribute='false' featureWrapperElement='true' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  EList<Requirement> getLegalRequirements();

  /**
   * Returns the value of the '<em><b>Item Function</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.ItemFunctionDescription}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Item Function</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Item Function</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getItem_ItemFunction()
   * @model containment="true"
   *        annotation="MetaData guid='{055E114E-A0E9-4324-AE65-0FF1067D448D}' id='2068177858' EA\040name=''"
   *        extendedMetaData="name='ITEM-FUNCTION' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='ITEM-FUNCTIONS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<ItemFunctionDescription> getItemFunction();

  /**
   * Returns the value of the '<em><b>Operating Mode</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.OperatingMode}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Operating Mode</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Operating Mode</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getItem_OperatingMode()
   * @model containment="true"
   *        annotation="MetaData guid='{5AE9D976-B0FC-4e21-8A51-909FE00D9823}' id='466240253' EA\040name=''"
   *        extendedMetaData="name='OPERATING-MODE' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='OPERATING-MODES' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<OperatingMode> getOperatingMode();

  /**
   * Returns the value of the '<em><b>Safe State</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.SafeState}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Safe State</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Safe State</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getItem_SafeState()
   * @model containment="true"
   *        annotation="MetaData guid='{E5723506-DEE7-459f-AD3E-2FD8ED1F2EEB}' id='1370524488' EA\040name=''"
   *        extendedMetaData="name='SAFE-STATE' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SAFE-STATES' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<SafeState> getSafeState();

} // Item
