/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>MFP Function Port</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * The MalfunctionPrototype pointing to a function port instance
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.ErrorModel.Malfunction.MFPFunctionPort</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.MFPFunctionPort#getTarget <em>Target</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getMFPFunctionPort()
 * @model annotation="MetaData guid='{D094444B-C473-4197-8396-FA2848A3DC1E}' id='-1424131444' EA\040name='MFPFunctionPort'"
 *        extendedMetaData="name='MFP-FUNCTION-PORT' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='MFP-FUNCTION-PORTS'"
 * @generated
 */
public interface MFPFunctionPort extends MalfunctionPrototype
{
  /**
   * Returns the value of the '<em><b>Target</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * A nominal function port instance as target of the malfunction prototype.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Target</em>' containment reference.
   * @see #setTarget(FaultFailurePort_functionTarget)
   * @see org.safe.metamodel.safe10.Safe10Package#getMFPFunctionPort_Target()
   * @model containment="true"
   *        annotation="MetaData guid='{F1125A77-0CA3-45b6-B816-69E5B46749F2}' id='857746161' EA\040name=''"
   *        annotation="TaggedValues xml.name='TARGET-IREF' xml.namePlural='TARGET-IREFS' xml.roleElement='true' xml.typeElement='false' xml.typeWrapperElement='false'"
   *        extendedMetaData="name='TARGET-IREF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='TARGET-IREFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  FaultFailurePort_functionTarget getTarget();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.MFPFunctionPort#getTarget <em>Target</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Target</em>' containment reference.
   * @see #getTarget()
   * @generated
   */
  void setTarget(FaultFailurePort_functionTarget value);

} // MFPFunctionPort
