/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>MFP Hardware Pin</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * The MalfunctionPrototype pointing to a HardwarPin instance
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.ErrorModel.Malfunction.MFPHardwarePin</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.MFPHardwarePin#getTarget <em>Target</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getMFPHardwarePin()
 * @model annotation="MetaData guid='{35EC48E3-623F-49fc-8CBE-9B31878CD578}' id='468586625' EA\040name='MFPHardwarePin'"
 *        extendedMetaData="name='MFP-HARDWARE-PIN' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='MFP-HARDWARE-PINS'"
 * @generated
 */
public interface MFPHardwarePin extends MalfunctionPrototype
{
  /**
   * Returns the value of the '<em><b>Target</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.FaultFailurePort_hwPinTarget}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * A nominal HW pin instance as target of the malfunction prototype.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Target</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getMFPHardwarePin_Target()
   * @model containment="true"
   *        annotation="MetaData guid='{0F0825E9-EE72-4132-90D1-A2ED253874DC}' id='-1108018296' EA\040name=''"
   *        annotation="TaggedValues xml.name='TARGET-IREF' xml.namePlural='TARGET-IREFS' xml.roleElement='true' xml.typeElement='false' xml.typeWrapperElement='false'"
   *        extendedMetaData="name='TARGET-IREF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='TARGET-IREFS' xmlAttribute='false' featureWrapperElement='true' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  EList<FaultFailurePort_hwPinTarget> getTarget();

} // MFPHardwarePin
