/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Memory Range</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * An address range is a class to specify the exact range of addresses in the node address space to be tested.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.SoftwareSafetyRequirements.MemorySelfTest.MemoryRange</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.MemoryRange#getStartAddress <em>Start Address</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.MemoryRange#getStopAddress <em>Stop Address</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getMemoryRange()
 * @model annotation="MetaData guid='{222FE1BA-9CB7-4f15-B97C-81FAA06AB55F}' id='275' EA\040name='MemoryRange'"
 *        extendedMetaData="name='MEMORY-RANGE' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='MEMORY-RANGES'"
 * @generated
 */
public interface MemoryRange extends Identifiable
{
  /**
   * Returns the value of the '<em><b>Start Address</b></em>' attribute.
   * The default value is <code>"0"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Start Address</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Start Address</em>' attribute.
   * @see #isSetStartAddress()
   * @see #unsetStartAddress()
   * @see #setStartAddress(Integer)
   * @see org.safe.metamodel.safe10.Safe10Package#getMemoryRange_StartAddress()
   * @model default="0" unsettable="true" dataType="org.safe.metamodel.safe10.Integer" required="true"
   *        annotation="MetaData guid='{6C899F58-6D1B-4fd1-9C8D-52E280E289F9}' id='54' EA\040name='startAddress'"
   *        extendedMetaData="name='START-ADDRESS' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='START-ADDRESSS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Integer getStartAddress();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.MemoryRange#getStartAddress <em>Start Address</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Start Address</em>' attribute.
   * @see #isSetStartAddress()
   * @see #StartAddress()
   * @see #getStartAddress()
   * @generated
   */
  void setStartAddress(Integer value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.MemoryRange#getStartAddress <em>Start Address</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetStartAddress()
   * @see #getStartAddress()
   * @see #setStartAddress(Integer)
   * @generated
   */
  void unsetStartAddress();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.MemoryRange#getStartAddress <em>Start Address</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Start Address</em>' attribute is set.
   * @see #StartAddress()
   * @see #getStartAddress()
   * @see #setStartAddress(Integer)
   * @generated
   */
  boolean isSetStartAddress();

  /**
   * Returns the value of the '<em><b>Stop Address</b></em>' attribute.
   * The default value is <code>"0"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Stop Address</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Stop Address</em>' attribute.
   * @see #isSetStopAddress()
   * @see #unsetStopAddress()
   * @see #setStopAddress(Integer)
   * @see org.safe.metamodel.safe10.Safe10Package#getMemoryRange_StopAddress()
   * @model default="0" unsettable="true" dataType="org.safe.metamodel.safe10.Integer" required="true"
   *        annotation="MetaData guid='{4018464A-ADBF-471b-BA5F-525D908BEE60}' id='55' EA\040name='stopAddress'"
   *        extendedMetaData="name='STOP-ADDRESS' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='STOP-ADDRESSS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Integer getStopAddress();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.MemoryRange#getStopAddress <em>Stop Address</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Stop Address</em>' attribute.
   * @see #isSetStopAddress()
   * @see #StopAddress()
   * @see #getStopAddress()
   * @generated
   */
  void setStopAddress(Integer value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.MemoryRange#getStopAddress <em>Stop Address</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetStopAddress()
   * @see #getStopAddress()
   * @see #setStopAddress(Integer)
   * @generated
   */
  void unsetStopAddress();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.MemoryRange#getStopAddress <em>Stop Address</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Stop Address</em>' attribute is set.
   * @see #StopAddress()
   * @see #getStopAddress()
   * @see #setStopAddress(Integer)
   * @generated
   */
  boolean isSetStopAddress();

} // MemoryRange
