/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Memory Self Test Config</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Specifies configuration parameters for MemorySelfTest SSR.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.SoftwareSafetyRequirements.MemorySelfTest.MemorySelfTestConfig</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.MemorySelfTestConfig#getPeriodMs <em>Period Ms</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.MemorySelfTestConfig#getExecuteInChunks <em>Execute In Chunks</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.MemorySelfTestConfig#getNumberOfChunks <em>Number Of Chunks</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.MemorySelfTestConfig#getTestAlgorithm <em>Test Algorithm</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.MemorySelfTestConfig#getMemoryRange <em>Memory Range</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getMemorySelfTestConfig()
 * @model annotation="MetaData guid='{70888C0D-B737-4a80-985E-624F3890C93A}' id='1869310367' EA\040name='MemorySelfTestConfig'"
 *        extendedMetaData="name='MEMORY-SELF-TEST-CONFIG' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='MEMORY-SELF-TEST-CONFIGS'"
 * @generated
 */
public interface MemorySelfTestConfig extends Identifiable
{
  /**
   * Returns the value of the '<em><b>Period Ms</b></em>' attribute.
   * The default value is <code>""</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Period Ms</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Period Ms</em>' attribute.
   * @see #isSetPeriodMs()
   * @see #unsetPeriodMs()
   * @see #setPeriodMs(String)
   * @see org.safe.metamodel.safe10.Safe10Package#getMemorySelfTestConfig_PeriodMs()
   * @model default="" unsettable="true" dataType="org.safe.metamodel.safe10.Identifier" required="true"
   *        annotation="MetaData guid='{67DD3263-9DE8-4677-8138-BE4A9483964F}' id='-1999083109' EA\040name='periodMs'"
   *        extendedMetaData="name='PERIOD-MS' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='PERIOD-MSS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  String getPeriodMs();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.MemorySelfTestConfig#getPeriodMs <em>Period Ms</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Period Ms</em>' attribute.
   * @see #isSetPeriodMs()
   * @see #PeriodMs()
   * @see #getPeriodMs()
   * @generated
   */
  void setPeriodMs(String value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.MemorySelfTestConfig#getPeriodMs <em>Period Ms</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetPeriodMs()
   * @see #getPeriodMs()
   * @see #setPeriodMs(String)
   * @generated
   */
  void unsetPeriodMs();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.MemorySelfTestConfig#getPeriodMs <em>Period Ms</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Period Ms</em>' attribute is set.
   * @see #PeriodMs()
   * @see #getPeriodMs()
   * @see #setPeriodMs(String)
   * @generated
   */
  boolean isSetPeriodMs();

  /**
   * Returns the value of the '<em><b>Execute In Chunks</b></em>' attribute.
   * The default value is <code>"false"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Execute In Chunks</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Execute In Chunks</em>' attribute.
   * @see #isSetExecuteInChunks()
   * @see #unsetExecuteInChunks()
   * @see #setExecuteInChunks(Boolean)
   * @see org.safe.metamodel.safe10.Safe10Package#getMemorySelfTestConfig_ExecuteInChunks()
   * @model default="false" unsettable="true" dataType="org.safe.metamodel.safe10.Boolean" required="true"
   *        annotation="MetaData guid='{00781A89-9D01-4c65-9681-FCD6124CB5C5}' id='481022528' EA\040name='executeInChunks'"
   *        extendedMetaData="name='EXECUTE-IN-CHUNKS' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='EXECUTE-IN-CHUNKSS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Boolean getExecuteInChunks();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.MemorySelfTestConfig#getExecuteInChunks <em>Execute In Chunks</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Execute In Chunks</em>' attribute.
   * @see #isSetExecuteInChunks()
   * @see #ExecuteInChunks()
   * @see #getExecuteInChunks()
   * @generated
   */
  void setExecuteInChunks(Boolean value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.MemorySelfTestConfig#getExecuteInChunks <em>Execute In Chunks</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetExecuteInChunks()
   * @see #getExecuteInChunks()
   * @see #setExecuteInChunks(Boolean)
   * @generated
   */
  void unsetExecuteInChunks();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.MemorySelfTestConfig#getExecuteInChunks <em>Execute In Chunks</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Execute In Chunks</em>' attribute is set.
   * @see #ExecuteInChunks()
   * @see #getExecuteInChunks()
   * @see #setExecuteInChunks(Boolean)
   * @generated
   */
  boolean isSetExecuteInChunks();

  /**
   * Returns the value of the '<em><b>Number Of Chunks</b></em>' attribute.
   * The default value is <code>"0"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Number Of Chunks</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Number Of Chunks</em>' attribute.
   * @see #isSetNumberOfChunks()
   * @see #unsetNumberOfChunks()
   * @see #setNumberOfChunks(Integer)
   * @see org.safe.metamodel.safe10.Safe10Package#getMemorySelfTestConfig_NumberOfChunks()
   * @model default="0" unsettable="true" dataType="org.safe.metamodel.safe10.Integer" required="true"
   *        annotation="MetaData guid='{D3434087-DF86-4f04-BEE7-1A2E411088B0}' id='-1189513919' EA\040name='numberOfChunks'"
   *        extendedMetaData="name='NUMBER-OF-CHUNKS' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='NUMBER-OF-CHUNKSS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Integer getNumberOfChunks();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.MemorySelfTestConfig#getNumberOfChunks <em>Number Of Chunks</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Number Of Chunks</em>' attribute.
   * @see #isSetNumberOfChunks()
   * @see #NumberOfChunks()
   * @see #getNumberOfChunks()
   * @generated
   */
  void setNumberOfChunks(Integer value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.MemorySelfTestConfig#getNumberOfChunks <em>Number Of Chunks</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetNumberOfChunks()
   * @see #getNumberOfChunks()
   * @see #setNumberOfChunks(Integer)
   * @generated
   */
  void unsetNumberOfChunks();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.MemorySelfTestConfig#getNumberOfChunks <em>Number Of Chunks</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Number Of Chunks</em>' attribute is set.
   * @see #NumberOfChunks()
   * @see #getNumberOfChunks()
   * @see #setNumberOfChunks(Integer)
   * @generated
   */
  boolean isSetNumberOfChunks();

  /**
   * Returns the value of the '<em><b>Test Algorithm</b></em>' attribute.
   * The default value is <code>"GALPAT"</code>.
   * The literals are from the enumeration {@link org.safe.metamodel.safe10.MemoryTestAlgorithmsEnum}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Test Algorithm</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Test Algorithm</em>' attribute.
   * @see org.safe.metamodel.safe10.MemoryTestAlgorithmsEnum
   * @see #isSetTestAlgorithm()
   * @see #unsetTestAlgorithm()
   * @see #setTestAlgorithm(MemoryTestAlgorithmsEnum)
   * @see org.safe.metamodel.safe10.Safe10Package#getMemorySelfTestConfig_TestAlgorithm()
   * @model default="GALPAT" unsettable="true" required="true"
   *        annotation="MetaData guid='{BD6A4F3F-B395-4260-BB5C-8D5774BB3F9A}' id='-736309800' EA\040name='testAlgorithm'"
   *        extendedMetaData="name='TEST-ALGORITHM' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='TEST-ALGORITHMS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  MemoryTestAlgorithmsEnum getTestAlgorithm();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.MemorySelfTestConfig#getTestAlgorithm <em>Test Algorithm</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Test Algorithm</em>' attribute.
   * @see org.safe.metamodel.safe10.MemoryTestAlgorithmsEnum
   * @see #isSetTestAlgorithm()
   * @see #TestAlgorithm()
   * @see #getTestAlgorithm()
   * @generated
   */
  void setTestAlgorithm(MemoryTestAlgorithmsEnum value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.MemorySelfTestConfig#getTestAlgorithm <em>Test Algorithm</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetTestAlgorithm()
   * @see #getTestAlgorithm()
   * @see #setTestAlgorithm(MemoryTestAlgorithmsEnum)
   * @generated
   */
  void unsetTestAlgorithm();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.MemorySelfTestConfig#getTestAlgorithm <em>Test Algorithm</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Test Algorithm</em>' attribute is set.
   * @see #TestAlgorithm()
   * @see #getTestAlgorithm()
   * @see #setTestAlgorithm(MemoryTestAlgorithmsEnum)
   * @generated
   */
  boolean isSetTestAlgorithm();

  /**
   * Returns the value of the '<em><b>Memory Range</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.MemoryRange}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Memory Range</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Memory Range</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getMemorySelfTestConfig_MemoryRange()
   * @model containment="true" required="true"
   *        annotation="MetaData guid='{782B457B-C6E4-4c36-BA3A-697026746E6F}' id='109' EA\040name=''"
   *        extendedMetaData="name='MEMORY-RANGE' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='MEMORY-RANGES' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<MemoryRange> getMemoryRange();

} // MemorySelfTestConfig
