/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Multi Level Safety Extension</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * null
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.CommonStructure.SafetyExtensions.MultiLevelSafetyExtension</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.MultiLevelSafetyExtension#getMalfunction <em>Malfunction</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.MultiLevelSafetyExtension#getSafetyConcept <em>Safety Concept</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.MultiLevelSafetyExtension#getSafetyCase <em>Safety Case</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getMultiLevelSafetyExtension()
 * @model annotation="MetaData guid='{4B95945E-E31A-4edb-B7BA-48B2D3117CCB}' id='-94560376' EA\040name='MultiLevelSafetyExtension'"
 *        extendedMetaData="name='MULTI-LEVEL-SAFETY-EXTENSION' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='MULTI-LEVEL-SAFETY-EXTENSIONS'"
 * @generated
 */
public interface MultiLevelSafetyExtension extends SafetyExtension
{
  /**
   * Returns the value of the '<em><b>Malfunction</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.MalfunctionType}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Malfunction</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Malfunction</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getMultiLevelSafetyExtension_Malfunction()
   * @model containment="true"
   *        annotation="MetaData guid='{B5797995-5B34-424d-BBEC-12A936BB4726}' id='-928540652' EA\040name=''"
   *        extendedMetaData="name='MALFUNCTION' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='MALFUNCTIONS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<MalfunctionType> getMalfunction();

  /**
   * Returns the value of the '<em><b>Safety Concept</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.SafetyConcept}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Safety Concept</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Safety Concept</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getMultiLevelSafetyExtension_SafetyConcept()
   * @model containment="true"
   *        annotation="MetaData guid='{2D8698DF-2721-4fe2-A577-73C4D4454352}' id='-385520799' EA\040name=''"
   *        extendedMetaData="name='SAFETY-CONCEPT' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SAFETY-CONCEPTS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<SafetyConcept> getSafetyConcept();

  /**
   * Returns the value of the '<em><b>Safety Case</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.SafetyCase}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Safety Case</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Safety Case</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getMultiLevelSafetyExtension_SafetyCase()
   * @model containment="true" required="true"
   *        annotation="MetaData guid='{0E428A34-23A1-4d24-B97F-AE619C8D2AF7}' id='321785136' EA\040name=''"
   *        extendedMetaData="name='SAFETY-CASE' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SAFETY-CASES' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<SafetyCase> getSafetyCase();

} // MultiLevelSafetyExtension
