/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Quantitative Error Model</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * This class is the container for all quantitative information relevant for the error model associated with this class.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.ErrorModel.ErrorModelType.QuantitativeErrorModel.QuantitativeErrorModel</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.QuantitativeErrorModel#getFailureRate <em>Failure Rate</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getQuantitativeErrorModel()
 * @model annotation="MetaData guid='{9E5EEEFF-206B-4b63-A368-FB132BB1F337}' id='-1030047135' EA\040name='QuantitativeErrorModel'"
 *        extendedMetaData="name='QUANTITATIVE-ERROR-MODEL' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='QUANTITATIVE-ERROR-MODELS'"
 * @generated
 */
public interface QuantitativeErrorModel extends Identifiable
{
  /**
   * Returns the value of the '<em><b>Failure Rate</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.FailureRate}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * Failures rates valid within the context of this error model.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Failure Rate</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getQuantitativeErrorModel_FailureRate()
   * @model containment="true"
   *        annotation="MetaData guid='{31AFE056-9609-4771-8B34-9E83F75B5F30}' id='-1566353873' EA\040name=''"
   *        extendedMetaData="name='FAILURE-RATE' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='FAILURE-RATES' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<FailureRate> getFailureRate();

} // QuantitativeErrorModel
