/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Range Check Context</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Defines the parameters used by  the range check SSR when the system is in a given AUTOSAR mode.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.SoftwareSafetyRequirements.ContextRangeCheck.RangeCheckContext</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.RangeCheckContext#getMax <em>Max</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.RangeCheckContext#getMin <em>Min</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getRangeCheckContext()
 * @model annotation="MetaData guid='{46C2D0F6-29B8-4c86-AA3F-8000CC000558}' id='244' EA\040name='RangeCheckContext'"
 *        extendedMetaData="name='RANGE-CHECK-CONTEXT' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='RANGE-CHECK-CONTEXTS'"
 * @generated
 */
public interface RangeCheckContext extends Identifiable
{
  /**
   * Returns the value of the '<em><b>Max</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * The maximal range for a given context.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Max</em>' containment reference.
   * @see #setMax(ContextParameter)
   * @see org.safe.metamodel.safe10.Safe10Package#getRangeCheckContext_Max()
   * @model containment="true" required="true"
   *        annotation="MetaData guid='{8213A306-0CAC-4312-A3B2-8CE754BC021F}' id='138' EA\040name=''"
   *        extendedMetaData="name='MAX' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='MAXS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  ContextParameter getMax();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.RangeCheckContext#getMax <em>Max</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Max</em>' containment reference.
   * @see #getMax()
   * @generated
   */
  void setMax(ContextParameter value);

  /**
   * Returns the value of the '<em><b>Min</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * The minimal range for a given context.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Min</em>' containment reference.
   * @see #setMin(ContextParameter)
   * @see org.safe.metamodel.safe10.Safe10Package#getRangeCheckContext_Min()
   * @model containment="true" required="true"
   *        annotation="MetaData guid='{2C2B8DB8-FD63-47a9-87D2-7275A0D09A3F}' id='139' EA\040name=''"
   *        extendedMetaData="name='MIN' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='MINS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  ContextParameter getMin();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.RangeCheckContext#getMin <em>Min</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Min</em>' containment reference.
   * @see #getMin()
   * @generated
   */
  void setMin(ContextParameter value);

} // RangeCheckContext
