/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import autosar40.commonstructure.internalbehavior.ExecutableEntity;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Runnable Entity Sequence Element</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * null
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.SoftwareSafetyRequirements.ControlFlowMonitor.RunnableEntitySequenceElement</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.RunnableEntitySequenceElement#getNextElement <em>Next Element</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.RunnableEntitySequenceElement#getExecutableEntity <em>Executable Entity</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getRunnableEntitySequenceElement()
 * @model annotation="MetaData guid='{65AF5801-026B-440b-BA3D-4CAA80F4528E}' id='1453692028' EA\040name='RunnableEntitySequenceElement'"
 *        extendedMetaData="name='RUNNABLE-ENTITY-SEQUENCE-ELEMENT' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='RUNNABLE-ENTITY-SEQUENCE-ELEMENTS'"
 * @generated
 */
public interface RunnableEntitySequenceElement extends Identifiable
{
  /**
   * Returns the value of the '<em><b>Next Element</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Next Element</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Next Element</em>' reference.
   * @see #setNextElement(RunnableEntitySequenceElement)
   * @see org.safe.metamodel.safe10.Safe10Package#getRunnableEntitySequenceElement_NextElement()
   * @model required="true"
   *        annotation="MetaData guid='{13DAE974-5CB7-4c52-9628-94F736FBDEEB}' id='-1080520134' EA\040name=''"
   *        extendedMetaData="name='NEXT-ELEMENT-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='NEXT-ELEMENT-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  RunnableEntitySequenceElement getNextElement();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.RunnableEntitySequenceElement#getNextElement <em>Next Element</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Next Element</em>' reference.
   * @see #getNextElement()
   * @generated
   */
  void setNextElement(RunnableEntitySequenceElement value);

  /**
   * Returns the value of the '<em><b>Executable Entity</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Executable Entity</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Executable Entity</em>' reference.
   * @see #setExecutableEntity(ExecutableEntity)
   * @see org.safe.metamodel.safe10.Safe10Package#getRunnableEntitySequenceElement_ExecutableEntity()
   * @model required="true"
   *        annotation="MetaData guid='{BEE159E3-5226-47e5-A7E1-F799719CB7CC}' id='1739143131' EA\040name=''"
   *        extendedMetaData="name='EXECUTABLE-ENTITY-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='EXECUTABLE-ENTITY-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  ExecutableEntity getExecutableEntity();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.RunnableEntitySequenceElement#getExecutableEntity <em>Executable Entity</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Executable Entity</em>' reference.
   * @see #getExecutableEntity()
   * @generated
   */
  void setExecutableEntity(ExecutableEntity value);

} // RunnableEntitySequenceElement
