/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>SAFE Element</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * This class serves as a base class for all SAFE class that represent something (i.e. not technical class).
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.CommonStructure.TopLevel.SAFEElement</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.SAFEElement#getName <em>Name</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getSAFEElement()
 * @model abstract="true"
 *        annotation="MetaData guid='{CFB77729-E305-4ee4-AC2F-F6398AACB2C4}' id='104' EA\040name='SAFEElement'"
 *        annotation="Stereotype Stereotype='abstract'"
 *        extendedMetaData="name='SAFE-ELEMENT' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SAFE-ELEMENTS'"
 * @generated
 */
public interface SAFEElement extends PackageableElement
{
  /**
   * Returns the value of the '<em><b>Name</b></em>' attribute.
   * The default value is <code>""</code>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * Optional descriptive name of the SAFEElement, this name does not have the length restrictions as found for the AUTOSAR Identfiable shortName.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Name</em>' attribute.
   * @see #isSetName()
   * @see #unsetName()
   * @see #setName(String)
   * @see org.safe.metamodel.safe10.Safe10Package#getSAFEElement_Name()
   * @model default="" unsettable="true" dataType="org.safe.metamodel.safe10.String" required="true"
   *        annotation="MetaData guid='{D35F201C-76B9-47e1-8983-9B0FA093C7FF}' id='403506661' EA\040name='name'"
   *        extendedMetaData="name='NAME' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='NAMES' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  String getName();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.SAFEElement#getName <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Name</em>' attribute.
   * @see #isSetName()
   * @see #Name()
   * @see #getName()
   * @generated
   */
  void setName(String value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.SAFEElement#getName <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetName()
   * @see #getName()
   * @see #setName(String)
   * @generated
   */
  void unsetName();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.SAFEElement#getName <em>Name</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Name</em>' attribute is set.
   * @see #Name()
   * @see #getName()
   * @see #setName(String)
   * @generated
   */
  boolean isSetName();

} // SAFEElement
