/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Satisfy</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Satisfy allows allocating requirements to elements of the preliminary architecture as well as HW-Elements and SW-Elements
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.Satisfy</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.Satisfy#getSatisfiedElement <em>Satisfied Element</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.Satisfy#getSatisfyingTargets <em>Satisfying Targets</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getSatisfy()
 * @model annotation="MetaData guid='{2813DE10-556A-4755-9783-406ABB84AFB1}' id='-626887992' EA\040name='Satisfy'"
 *        extendedMetaData="name='SATISFY' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SATISFYS'"
 * @generated
 */
public interface Satisfy extends RequirementsReleationship
{
  /**
   * Returns the value of the '<em><b>Satisfied Element</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.AllocatableElement}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Satisfied Element</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Satisfied Element</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getSatisfy_SatisfiedElement()
   * @model containment="true" required="true"
   *        annotation="MetaData guid='{67B1BB5C-E3C5-4070-B575-765854A810BC}' id='-2061922557' EA\040name=''"
   *        extendedMetaData="name='SATISFIED-ELEMENT' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SATISFIED-ELEMENTS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<AllocatableElement> getSatisfiedElement();

  /**
   * Returns the value of the '<em><b>Satisfying Targets</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Satisfying Targets</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Satisfying Targets</em>' containment reference.
   * @see #setSatisfyingTargets(AllocationTargets)
   * @see org.safe.metamodel.safe10.Safe10Package#getSatisfy_SatisfyingTargets()
   * @model containment="true" required="true"
   *        annotation="MetaData guid='{125ADA93-1C69-4454-8932-2659F6CDA709}' id='337683981' EA\040name=''"
   *        extendedMetaData="name='SATISFYING-TARGETS' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SATISFYING-TARGETSS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  AllocationTargets getSatisfyingTargets();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.Satisfy#getSatisfyingTargets <em>Satisfying Targets</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Satisfying Targets</em>' containment reference.
   * @see #getSatisfyingTargets()
   * @generated
   */
  void setSatisfyingTargets(AllocationTargets value);

} // Satisfy
