/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eatop.eel.eastadl21.DesignFunctionType;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Software Safety Extension</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * The SafetySoftwareExtension is used to specify the implementation of the safety relevant SoftwareDesignComponents that are allocated to the SafetySoftwareDesign.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.CommonStructure.SafetyExtensions.TechnicalSafetyExtension.SoftwareSafetyExtension</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.SoftwareSafetyExtension#getScope <em>Scope</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getSoftwareSafetyExtension()
 * @model annotation="MetaData guid='{A324CA57-7B08-4309-974B-F5F3757FBF2A}' id='201' EA\040name='SoftwareSafetyExtension'"
 *        extendedMetaData="name='SOFTWARE-SAFETY-EXTENSION' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SOFTWARE-SAFETY-EXTENSIONS'"
 * @generated
 */
public interface SoftwareSafetyExtension extends TechnicalSafetyExtension
{
  /**
   * Returns the value of the '<em><b>Scope</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Scope</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Scope</em>' reference.
   * @see #setScope(DesignFunctionType)
   * @see org.safe.metamodel.safe10.Safe10Package#getSoftwareSafetyExtension_Scope()
   * @model required="true"
   *        annotation="MetaData guid='{C26C8796-8053-4cbb-BCA8-0DA599DF4EA3}' id='1958859102' EA\040name=''"
   *        extendedMetaData="name='SCOPE-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SCOPE-REFS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  DesignFunctionType getScope();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.SoftwareSafetyExtension#getScope <em>Scope</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Scope</em>' reference.
   * @see #getScope()
   * @generated
   */
  void setScope(DesignFunctionType value);

} // SoftwareSafetyExtension
