/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Strategy</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * <ul>
 * 	<li>rendered as a parallelogram, </li>
 * 	<li>describe the nature of the inference that exists between a goal and its supporting goal(s)</li>
 * 	<li>and are used to describe the nature of the inference which is asserted as existing between sub-goals and the parent goal.</li>
 * </ul>
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.SafetyCase.Strategy</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.Strategy#getJustification <em>Justification</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.Strategy#getInContextOf <em>In Context Of</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.Strategy#getGoal <em>Goal</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.Strategy#getAssumption <em>Assumption</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getStrategy()
 * @model annotation="MetaData guid='{D67D98F8-21B5-4b7d-8BE8-5DA2BA64A4C0}' id='789423551' EA\040name='Strategy'"
 *        extendedMetaData="name='STRATEGY' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='STRATEGYS'"
 * @generated
 */
public interface Strategy extends EObject
{
  /**
   * Returns the value of the '<em><b>Justification</b></em>' reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.Justification}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Justification</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Justification</em>' reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getStrategy_Justification()
   * @model annotation="MetaData guid='{723B0D95-71E8-4d51-8DF6-3E46457E3C2A}' id='-1310969046' EA\040name=''"
   *        extendedMetaData="name='JUSTIFICATION-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='JUSTIFICATION-REFS' xmlAttribute='false' featureWrapperElement='true' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  EList<Justification> getJustification();

  /**
   * Returns the value of the '<em><b>In Context Of</b></em>' reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.Context}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>In Context Of</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>In Context Of</em>' reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getStrategy_InContextOf()
   * @model annotation="MetaData guid='{7C84198D-6521-4bc0-9CBC-EA8F9DC0B9A8}' id='-916341093' EA\040name=''"
   *        extendedMetaData="name='IN-CONTEXT-OF-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='IN-CONTEXT-OF-REFS' xmlAttribute='false' featureWrapperElement='true' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  EList<Context> getInContextOf();

  /**
   * Returns the value of the '<em><b>Goal</b></em>' reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.Goal}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Goal</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Goal</em>' reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getStrategy_Goal()
   * @model lower="2"
   *        annotation="MetaData guid='{6B197743-4631-4c1d-9CC6-019724E3F342}' id='-90158092' EA\040name=''"
   *        extendedMetaData="name='GOAL-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='GOAL-REFS' xmlAttribute='false' featureWrapperElement='true' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  EList<Goal> getGoal();

  /**
   * Returns the value of the '<em><b>Assumption</b></em>' reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.Assumption}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Assumption</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Assumption</em>' reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getStrategy_Assumption()
   * @model annotation="MetaData guid='{D957FFF9-AB36-464c-9CC5-6BBE04ABA54F}' id='1347579551' EA\040name=''"
   *        extendedMetaData="name='ASSUMPTION-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='ASSUMPTION-REFS' xmlAttribute='false' featureWrapperElement='true' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  EList<Assumption> getAssumption();

} // Strategy
