/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Technical Safety Extension</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * The TechnicalSafetyExtension is used as interface to the DesignLevel defined in EAST-ADL. This extension specifies the add-on needed to model a specific technical solution that is derived based on the functional safety concept. It contains the 
 * <ul>
 * 	<li>technical safety concept (ISO 26262 part 4 chapter 7) </li>
 * 	<li>hardware software interface specification (ISO 26262 part 4 chapter 7.4.6 )</li>
 * </ul>
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.CommonStructure.SafetyExtensions.TechnicalSafetyExtension.TechnicalSafetyExtension</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.TechnicalSafetyExtension#getRequirement <em>Requirement</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.TechnicalSafetyExtension#getHSISpecification <em>HSI Specification</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getTechnicalSafetyExtension()
 * @model abstract="true"
 *        annotation="MetaData guid='{DE3BFEB9-19DC-4e4e-BCB0-10DB27F87972}' id='1577305055' EA\040name='TechnicalSafetyExtension'"
 *        annotation="Stereotype Stereotype='abstract'"
 *        extendedMetaData="name='TECHNICAL-SAFETY-EXTENSION' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='TECHNICAL-SAFETY-EXTENSIONS'"
 * @generated
 */
public interface TechnicalSafetyExtension extends SingleLevelSafetyExtension
{
  /**
   * Returns the value of the '<em><b>Requirement</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.TechnicalSafetyRequirement}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Requirement</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Requirement</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getTechnicalSafetyExtension_Requirement()
   * @model containment="true"
   *        annotation="MetaData guid='{A2A965A1-78DC-4331-A1ED-B4F4EE0641E8}' id='-1860777023' EA\040name=''"
   *        extendedMetaData="name='REQUIREMENT' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='REQUIREMENTS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<TechnicalSafetyRequirement> getRequirement();

  /**
   * Returns the value of the '<em><b>HSI Specification</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>HSI Specification</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>HSI Specification</em>' containment reference.
   * @see #setHSISpecification(HardwareSoftwareInterfaceSpecification)
   * @see org.safe.metamodel.safe10.Safe10Package#getTechnicalSafetyExtension_HSISpecification()
   * @model containment="true" required="true"
   *        annotation="MetaData guid='{C0933E30-6BFD-45f6-B435-A706D8F964AE}' id='9481922' EA\040name=''"
   *        extendedMetaData="name='H-SI-SPECIFICATION' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='H-SI-SPECIFICATIONS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  HardwareSoftwareInterfaceSpecification getHSISpecification();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.TechnicalSafetyExtension#getHSISpecification <em>HSI Specification</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>HSI Specification</em>' containment reference.
   * @see #getHSISpecification()
   * @generated
   */
  void setHSISpecification(HardwareSoftwareInterfaceSpecification value);

} // TechnicalSafetyExtension
