/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Technical Safety Requirement</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * TechnicalSafetyRequirements are used to specify the implementation of the associated FunctionComponent . They are derived by the allocated FunctionalSafetyRequirements.
 * TechnicalSafetyRequirements include the specification of safety-related failure mitigation.  
 * 
 * The  technical safety requirements specification refines the functional safety concept, considering both the functional concept and the preliminary architectural assumptions
 * 
 * The technical safety requirements are allocated to hardware and software, and, if applicable, on other technologies 
 * 
 * <b><i><u>Reference:</u></i></b> 
 * <i>ISO26262-1-1.133</i>
 * <i>ISO26262-4- 6.4.9</i>
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.TechnicalSafetyRequirement</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.TechnicalSafetyRequirement#getQuantifiedProperty <em>Quantified Property</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.TechnicalSafetyRequirement#getCodegenconfiguration <em>Codegenconfiguration</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getTechnicalSafetyRequirement()
 * @model annotation="MetaData guid='{FFA0F059-B072-4ba1-97D6-E22382C284F9}' id='732814633' EA\040name='TechnicalSafetyRequirement'"
 *        extendedMetaData="name='TECHNICAL-SAFETY-REQUIREMENT' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='TECHNICAL-SAFETY-REQUIREMENTS'"
 * @generated
 */
public interface TechnicalSafetyRequirement extends AbstractQuantifiableSafetyRequirement
{
  /**
   * Returns the value of the '<em><b>Quantified Property</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.QuantifiedHWProperty}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Quantified Property</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Quantified Property</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getTechnicalSafetyRequirement_QuantifiedProperty()
   * @model containment="true"
   *        annotation="MetaData guid='{BA2FC607-16E2-430d-ABF3-A9F4D1E2336A}' id='1768331792' EA\040name=''"
   *        extendedMetaData="name='QUANTIFIED-PROPERTY' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='QUANTIFIED-PROPERTYS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<QuantifiedHWProperty> getQuantifiedProperty();

  /**
   * Returns the value of the '<em><b>Codegenconfiguration</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.CodeGenerationConfiguration}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Codegenconfiguration</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Codegenconfiguration</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getTechnicalSafetyRequirement_Codegenconfiguration()
   * @model containment="true"
   *        annotation="MetaData guid='{9ECA3CE4-BEC2-4e1b-BC76-8D2AA52D6FE3}' id='1585110012' EA\040name=''"
   *        extendedMetaData="name='CODEGENCONFIGURATION' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='CODEGENCONFIGURATIONS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<CodeGenerationConfiguration> getCodegenconfiguration();

} // TechnicalSafetyRequirement
