/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Voter</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * A meta-class representing the Voting software safety requirement.
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.SoftwareSafetyRequirements.Voting.Voter</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.Voter#getConfig <em>Config</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.Voter#getResult <em>Result</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.Voter#getInputData <em>Input Data</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getVoter()
 * @model annotation="MetaData guid='{C2BC1796-FBAA-4d87-8A92-02871AC94CC3}' id='278' EA\040name='Voter'"
 *        extendedMetaData="name='VOTER' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='VOTERS'"
 * @generated
 */
public interface Voter extends SoftwareSafetyRequirement
{
  /**
   * Returns the value of the '<em><b>Config</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * Configuration of a Voting SSR
   * <!-- end-model-doc -->
   * @return the value of the '<em>Config</em>' containment reference.
   * @see #setConfig(VoterConfig)
   * @see org.safe.metamodel.safe10.Safe10Package#getVoter_Config()
   * @model containment="true" required="true"
   *        annotation="MetaData guid='{5DDB089B-A820-4383-B3B0-8558121F8E46}' id='520073644' EA\040name=''"
   *        extendedMetaData="name='CONFIG' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='CONFIGS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  VoterConfig getConfig();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.Voter#getConfig <em>Config</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Config</em>' containment reference.
   * @see #getConfig()
   * @generated
   */
  void setConfig(VoterConfig value);

  /**
   * Returns the value of the '<em><b>Result</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * Voting result
   * <!-- end-model-doc -->
   * @return the value of the '<em>Result</em>' containment reference.
   * @see #setResult(VoterParameter)
   * @see org.safe.metamodel.safe10.Safe10Package#getVoter_Result()
   * @model containment="true" required="true"
   *        annotation="MetaData guid='{184A2A28-3E44-4b2e-89D7-08BFE4D2B84F}' id='-2102482348' EA\040name=''"
   *        extendedMetaData="name='RESULT' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='RESULTS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  VoterParameter getResult();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.Voter#getResult <em>Result</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Result</em>' containment reference.
   * @see #getResult()
   * @generated
   */
  void setResult(VoterParameter value);

  /**
   * Returns the value of the '<em><b>Input Data</b></em>' containment reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.VoterParameter}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * Input data for voting.
   * <!-- end-model-doc -->
   * @return the value of the '<em>Input Data</em>' containment reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getVoter_InputData()
   * @model containment="true" required="true"
   *        annotation="MetaData guid='{8EB8A15B-B4A0-407b-9012-48D5250D11D3}' id='108' EA\040name=''"
   *        extendedMetaData="name='INPUT-DATA' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='INPUT-DATAS' xmlAttribute='false' featureWrapperElement='true' featureElement='false' classifierWrapperElement='false' classifierElement='true'"
   * @generated
   */
  EList<VoterParameter> getInputData();

} // Voter
