/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Warning And Degradation Handle</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * null
 * 
 * Original fully qualified name: 
 * <em><b>safe10.ClassModel.Requirements.FunctionalSafetyRequirements.WarningAndDegradation.WarningAndDegradationHandle</b></em> 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.WarningAndDegradationHandle#getGuaranteedOperationsTimeInterval <em>Guaranteed Operations Time Interval</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.WarningAndDegradationHandle#getSafeState <em>Safe State</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.safe.metamodel.safe10.Safe10Package#getWarningAndDegradationHandle()
 * @model annotation="MetaData guid='{2341A942-5950-4eda-85DD-5D07C80F3963}' id='-796604436' EA\040name='WarningAndDegradationHandle'"
 *        extendedMetaData="name='WARNING-AND-DEGRADATION-HANDLE' kind='elementOnly'"
 *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='WARNING-AND-DEGRADATION-HANDLES'"
 * @generated
 */
public interface WarningAndDegradationHandle extends Handle
{
  /**
   * Returns the value of the '<em><b>Guaranteed Operations Time Interval</b></em>' attribute.
   * The default value is <code>"0"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Guaranteed Operations Time Interval</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Guaranteed Operations Time Interval</em>' attribute.
   * @see #isSetGuaranteedOperationsTimeInterval()
   * @see #unsetGuaranteedOperationsTimeInterval()
   * @see #setGuaranteedOperationsTimeInterval(Integer)
   * @see org.safe.metamodel.safe10.Safe10Package#getWarningAndDegradationHandle_GuaranteedOperationsTimeInterval()
   * @model default="0" unsettable="true" dataType="org.safe.metamodel.safe10.Integer" required="true"
   *        annotation="MetaData guid='{45BA1D5A-BCDE-4333-B26B-9A9C004F781E}' id='2038250227' EA\040name='guaranteedOperationsTimeInterval'"
   *        extendedMetaData="name='GUARANTEED-OPERATIONS-TIME-INTERVAL' kind='element'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='GUARANTEED-OPERATIONS-TIME-INTERVALS' xmlAttribute='false' featureWrapperElement='false' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  Integer getGuaranteedOperationsTimeInterval();

  /**
   * Sets the value of the '{@link org.safe.metamodel.safe10.WarningAndDegradationHandle#getGuaranteedOperationsTimeInterval <em>Guaranteed Operations Time Interval</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Guaranteed Operations Time Interval</em>' attribute.
   * @see #isSetGuaranteedOperationsTimeInterval()
   * @see #GuaranteedOperationsTimeInterval()
   * @see #getGuaranteedOperationsTimeInterval()
   * @generated
   */
  void setGuaranteedOperationsTimeInterval(Integer value);

  /**
   * Unsets the value of the '{@link org.safe.metamodel.safe10.WarningAndDegradationHandle#getGuaranteedOperationsTimeInterval <em>Guaranteed Operations Time Interval</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isSetGuaranteedOperationsTimeInterval()
   * @see #getGuaranteedOperationsTimeInterval()
   * @see #setGuaranteedOperationsTimeInterval(Integer)
   * @generated
   */
  void unsetGuaranteedOperationsTimeInterval();

  /**
   * Returns whether the value of the '{@link org.safe.metamodel.safe10.WarningAndDegradationHandle#getGuaranteedOperationsTimeInterval <em>Guaranteed Operations Time Interval</em>}' attribute is set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return whether the value of the '<em>Guaranteed Operations Time Interval</em>' attribute is set.
   * @see #GuaranteedOperationsTimeInterval()
   * @see #getGuaranteedOperationsTimeInterval()
   * @see #setGuaranteedOperationsTimeInterval(Integer)
   * @generated
   */
  boolean isSetGuaranteedOperationsTimeInterval();

  /**
   * Returns the value of the '<em><b>Safe State</b></em>' reference list.
   * The list contents are of type {@link org.safe.metamodel.safe10.SafeState}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Safe State</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Safe State</em>' reference list.
   * @see org.safe.metamodel.safe10.Safe10Package#getWarningAndDegradationHandle_SafeState()
   * @model annotation="MetaData guid='{B2F79DCF-5CFE-451b-BFE1-1161A5A05B74}' id='447106711' EA\040name=''"
   *        extendedMetaData="name='SAFE-STATE-REF' kind='element' namespace='http://safe-project.eu/1.0.1'"
   *        annotation="http:///org/eclipse/sphinx/emf/serialization/XMLPersistenceMappingExtendedMetaData wrapperName='SAFE-STATE-REFS' xmlAttribute='false' featureWrapperElement='true' featureElement='true' classifierWrapperElement='false' classifierElement='false'"
   * @generated
   */
  EList<SafeState> getSafeState();

} // WarningAndDegradationHandle
