/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.safe.metamodel.safe10.AUTOSARRunnableEntitySequenceConstraint;
import org.safe.metamodel.safe10.RunnableEntitySequenceElement;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>AUTOSAR Runnable Entity Sequence Constraint</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.AUTOSARRunnableEntitySequenceConstraintImpl#getSequenceElement <em>Sequence Element</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class AUTOSARRunnableEntitySequenceConstraintImpl extends SequenceBlockImpl implements AUTOSARRunnableEntitySequenceConstraint
{
  /**
   * The cached value of the '{@link #getSequenceElement() <em>Sequence Element</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSequenceElement()
   * @generated
   * @ordered
   */
  protected EList<RunnableEntitySequenceElement> sequenceElement;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected AUTOSARRunnableEntitySequenceConstraintImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getAUTOSARRunnableEntitySequenceConstraint();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<RunnableEntitySequenceElement> getSequenceElement()
  {
    if (sequenceElement == null)
    {
      sequenceElement = new EObjectContainmentEList<RunnableEntitySequenceElement>(RunnableEntitySequenceElement.class, this, Safe10Package.AUTOSAR_RUNNABLE_ENTITY_SEQUENCE_CONSTRAINT__SEQUENCE_ELEMENT);
    }
    return sequenceElement;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_RUNNABLE_ENTITY_SEQUENCE_CONSTRAINT__SEQUENCE_ELEMENT:
        return ((InternalEList<?>)getSequenceElement()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_RUNNABLE_ENTITY_SEQUENCE_CONSTRAINT__SEQUENCE_ELEMENT:
        return getSequenceElement();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_RUNNABLE_ENTITY_SEQUENCE_CONSTRAINT__SEQUENCE_ELEMENT:
        getSequenceElement().clear();
        getSequenceElement().addAll((Collection<? extends RunnableEntitySequenceElement>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_RUNNABLE_ENTITY_SEQUENCE_CONSTRAINT__SEQUENCE_ELEMENT:
        getSequenceElement().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_RUNNABLE_ENTITY_SEQUENCE_CONSTRAINT__SEQUENCE_ELEMENT:
        return sequenceElement != null && !sequenceElement.isEmpty();
    }
    return super.eIsSet(featureID);
  }

} //AUTOSARRunnableEntitySequenceConstraintImpl
