/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.safe.metamodel.safe10.AUTOSARSequenceConstraint;
import org.safe.metamodel.safe10.AutosarUndefinedInstanceRef;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>AUTOSAR Sequence Constraint</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.AUTOSARSequenceConstraintImpl#getAutosarExecutionOrderConstraint <em>Autosar Execution Order Constraint</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class AUTOSARSequenceConstraintImpl extends SequenceBlockImpl implements AUTOSARSequenceConstraint
{
  /**
   * The cached value of the '{@link #getAutosarExecutionOrderConstraint() <em>Autosar Execution Order Constraint</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getAutosarExecutionOrderConstraint()
   * @generated
   * @ordered
   */
  protected AutosarUndefinedInstanceRef autosarExecutionOrderConstraint;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected AUTOSARSequenceConstraintImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getAUTOSARSequenceConstraint();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AutosarUndefinedInstanceRef getAutosarExecutionOrderConstraint()
  {
    return autosarExecutionOrderConstraint;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetAutosarExecutionOrderConstraint(AutosarUndefinedInstanceRef newAutosarExecutionOrderConstraint, NotificationChain msgs)
  {
    AutosarUndefinedInstanceRef oldAutosarExecutionOrderConstraint = autosarExecutionOrderConstraint;
    autosarExecutionOrderConstraint = newAutosarExecutionOrderConstraint;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Safe10Package.AUTOSAR_SEQUENCE_CONSTRAINT__AUTOSAR_EXECUTION_ORDER_CONSTRAINT, oldAutosarExecutionOrderConstraint, newAutosarExecutionOrderConstraint);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setAutosarExecutionOrderConstraint(AutosarUndefinedInstanceRef newAutosarExecutionOrderConstraint)
  {
    if (newAutosarExecutionOrderConstraint != autosarExecutionOrderConstraint)
    {
      NotificationChain msgs = null;
      if (autosarExecutionOrderConstraint != null)
        msgs = ((InternalEObject)autosarExecutionOrderConstraint).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Safe10Package.AUTOSAR_SEQUENCE_CONSTRAINT__AUTOSAR_EXECUTION_ORDER_CONSTRAINT, null, msgs);
      if (newAutosarExecutionOrderConstraint != null)
        msgs = ((InternalEObject)newAutosarExecutionOrderConstraint).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - Safe10Package.AUTOSAR_SEQUENCE_CONSTRAINT__AUTOSAR_EXECUTION_ORDER_CONSTRAINT, null, msgs);
      msgs = basicSetAutosarExecutionOrderConstraint(newAutosarExecutionOrderConstraint, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.AUTOSAR_SEQUENCE_CONSTRAINT__AUTOSAR_EXECUTION_ORDER_CONSTRAINT, newAutosarExecutionOrderConstraint, newAutosarExecutionOrderConstraint));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_SEQUENCE_CONSTRAINT__AUTOSAR_EXECUTION_ORDER_CONSTRAINT:
        return basicSetAutosarExecutionOrderConstraint(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_SEQUENCE_CONSTRAINT__AUTOSAR_EXECUTION_ORDER_CONSTRAINT:
        return getAutosarExecutionOrderConstraint();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_SEQUENCE_CONSTRAINT__AUTOSAR_EXECUTION_ORDER_CONSTRAINT:
   			setAutosarExecutionOrderConstraint((AutosarUndefinedInstanceRef)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_SEQUENCE_CONSTRAINT__AUTOSAR_EXECUTION_ORDER_CONSTRAINT:
        	setAutosarExecutionOrderConstraint((AutosarUndefinedInstanceRef)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_SEQUENCE_CONSTRAINT__AUTOSAR_EXECUTION_ORDER_CONSTRAINT:
        return autosarExecutionOrderConstraint != null;
    }
    return super.eIsSet(featureID);
  }

} //AUTOSARSequenceConstraintImpl
