/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.safe.metamodel.safe10.AutosarActuatorMonitor;
import org.safe.metamodel.safe10.AutosarComponentInCompositionInstanceRef;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Autosar Actuator Monitor</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.AutosarActuatorMonitorImpl#getActuator <em>Actuator</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class AutosarActuatorMonitorImpl extends ActuatorMonitorImpl implements AutosarActuatorMonitor
{
  /**
   * The cached value of the '{@link #getActuator() <em>Actuator</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getActuator()
   * @generated
   * @ordered
   */
  protected AutosarComponentInCompositionInstanceRef actuator;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected AutosarActuatorMonitorImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getAutosarActuatorMonitor();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AutosarComponentInCompositionInstanceRef getActuator()
  {
    return actuator;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetActuator(AutosarComponentInCompositionInstanceRef newActuator, NotificationChain msgs)
  {
    AutosarComponentInCompositionInstanceRef oldActuator = actuator;
    actuator = newActuator;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Safe10Package.AUTOSAR_ACTUATOR_MONITOR__ACTUATOR, oldActuator, newActuator);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setActuator(AutosarComponentInCompositionInstanceRef newActuator)
  {
    if (newActuator != actuator)
    {
      NotificationChain msgs = null;
      if (actuator != null)
        msgs = ((InternalEObject)actuator).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Safe10Package.AUTOSAR_ACTUATOR_MONITOR__ACTUATOR, null, msgs);
      if (newActuator != null)
        msgs = ((InternalEObject)newActuator).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - Safe10Package.AUTOSAR_ACTUATOR_MONITOR__ACTUATOR, null, msgs);
      msgs = basicSetActuator(newActuator, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.AUTOSAR_ACTUATOR_MONITOR__ACTUATOR, newActuator, newActuator));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_ACTUATOR_MONITOR__ACTUATOR:
        return basicSetActuator(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_ACTUATOR_MONITOR__ACTUATOR:
        return getActuator();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_ACTUATOR_MONITOR__ACTUATOR:
   			setActuator((AutosarComponentInCompositionInstanceRef)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_ACTUATOR_MONITOR__ACTUATOR:
        	setActuator((AutosarComponentInCompositionInstanceRef)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_ACTUATOR_MONITOR__ACTUATOR:
        return actuator != null;
    }
    return super.eIsSet(featureID);
  }

} //AutosarActuatorMonitorImpl
