/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import autosar40.commonstructure.internalbehavior.ExecutableEntity;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.safe.metamodel.safe10.AutosarCheckPoint;
import org.safe.metamodel.safe10.AutosarComponentInCompositionInstanceRef;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Autosar Check Point</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.AutosarCheckPointImpl#getComponent <em>Component</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.AutosarCheckPointImpl#getTargetRunnable <em>Target Runnable</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class AutosarCheckPointImpl extends CheckPointImpl implements AutosarCheckPoint
{
  /**
   * The cached value of the '{@link #getComponent() <em>Component</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getComponent()
   * @generated
   * @ordered
   */
  protected AutosarComponentInCompositionInstanceRef component;

  /**
   * The cached value of the '{@link #getTargetRunnable() <em>Target Runnable</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTargetRunnable()
   * @generated
   * @ordered
   */
  protected ExecutableEntity targetRunnable;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected AutosarCheckPointImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getAutosarCheckPoint();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AutosarComponentInCompositionInstanceRef getComponent()
  {
    return component;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetComponent(AutosarComponentInCompositionInstanceRef newComponent, NotificationChain msgs)
  {
    AutosarComponentInCompositionInstanceRef oldComponent = component;
    component = newComponent;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Safe10Package.AUTOSAR_CHECK_POINT__COMPONENT, oldComponent, newComponent);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setComponent(AutosarComponentInCompositionInstanceRef newComponent)
  {
    if (newComponent != component)
    {
      NotificationChain msgs = null;
      if (component != null)
        msgs = ((InternalEObject)component).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Safe10Package.AUTOSAR_CHECK_POINT__COMPONENT, null, msgs);
      if (newComponent != null)
        msgs = ((InternalEObject)newComponent).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - Safe10Package.AUTOSAR_CHECK_POINT__COMPONENT, null, msgs);
      msgs = basicSetComponent(newComponent, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.AUTOSAR_CHECK_POINT__COMPONENT, newComponent, newComponent));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ExecutableEntity getTargetRunnable()
  {
    if (targetRunnable != null && targetRunnable.eIsProxy())
    {
      InternalEObject oldTargetRunnable = (InternalEObject)targetRunnable;
      targetRunnable = (ExecutableEntity)eResolveProxy(oldTargetRunnable);
      if (targetRunnable != oldTargetRunnable)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.AUTOSAR_CHECK_POINT__TARGET_RUNNABLE, oldTargetRunnable, targetRunnable));
      }
    }
    return targetRunnable;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ExecutableEntity basicGetTargetRunnable()
  {
    return targetRunnable;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setTargetRunnable(ExecutableEntity newTargetRunnable)
  {
    ExecutableEntity oldTargetRunnable = targetRunnable;
    targetRunnable = newTargetRunnable;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.AUTOSAR_CHECK_POINT__TARGET_RUNNABLE, oldTargetRunnable, targetRunnable));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_CHECK_POINT__COMPONENT:
        return basicSetComponent(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_CHECK_POINT__COMPONENT:
        return getComponent();
      case Safe10Package.AUTOSAR_CHECK_POINT__TARGET_RUNNABLE:
        if (resolve) return getTargetRunnable();
        return basicGetTargetRunnable();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_CHECK_POINT__COMPONENT:
   			setComponent((AutosarComponentInCompositionInstanceRef)newValue);
        return;
      case Safe10Package.AUTOSAR_CHECK_POINT__TARGET_RUNNABLE:
   			setTargetRunnable((ExecutableEntity)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_CHECK_POINT__COMPONENT:
        	setComponent((AutosarComponentInCompositionInstanceRef)null);
        return;
      case Safe10Package.AUTOSAR_CHECK_POINT__TARGET_RUNNABLE:
        	setTargetRunnable((ExecutableEntity)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_CHECK_POINT__COMPONENT:
        return component != null;
      case Safe10Package.AUTOSAR_CHECK_POINT__TARGET_RUNNABLE:
        return targetRunnable != null;
    }
    return super.eIsSet(featureID);
  }

} //AutosarCheckPointImpl
