/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.safe.metamodel.safe10.AutosarContextRangeCheck;
import org.safe.metamodel.safe10.AutosarVariableDataPrototypeInstanceRef;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Autosar Context Range Check</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.AutosarContextRangeCheckImpl#getChecked <em>Checked</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class AutosarContextRangeCheckImpl extends ContextRangeCheckImpl implements AutosarContextRangeCheck
{
  /**
   * The cached value of the '{@link #getChecked() <em>Checked</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getChecked()
   * @generated
   * @ordered
   */
  protected AutosarVariableDataPrototypeInstanceRef checked;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected AutosarContextRangeCheckImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getAutosarContextRangeCheck();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AutosarVariableDataPrototypeInstanceRef getChecked()
  {
    return checked;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetChecked(AutosarVariableDataPrototypeInstanceRef newChecked, NotificationChain msgs)
  {
    AutosarVariableDataPrototypeInstanceRef oldChecked = checked;
    checked = newChecked;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Safe10Package.AUTOSAR_CONTEXT_RANGE_CHECK__CHECKED, oldChecked, newChecked);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setChecked(AutosarVariableDataPrototypeInstanceRef newChecked)
  {
    if (newChecked != checked)
    {
      NotificationChain msgs = null;
      if (checked != null)
        msgs = ((InternalEObject)checked).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Safe10Package.AUTOSAR_CONTEXT_RANGE_CHECK__CHECKED, null, msgs);
      if (newChecked != null)
        msgs = ((InternalEObject)newChecked).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - Safe10Package.AUTOSAR_CONTEXT_RANGE_CHECK__CHECKED, null, msgs);
      msgs = basicSetChecked(newChecked, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.AUTOSAR_CONTEXT_RANGE_CHECK__CHECKED, newChecked, newChecked));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_CONTEXT_RANGE_CHECK__CHECKED:
        return basicSetChecked(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_CONTEXT_RANGE_CHECK__CHECKED:
        return getChecked();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_CONTEXT_RANGE_CHECK__CHECKED:
   			setChecked((AutosarVariableDataPrototypeInstanceRef)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_CONTEXT_RANGE_CHECK__CHECKED:
        	setChecked((AutosarVariableDataPrototypeInstanceRef)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.AUTOSAR_CONTEXT_RANGE_CHECK__CHECKED:
        return checked != null;
    }
    return super.eIsSet(featureID);
  }

} //AutosarContextRangeCheckImpl
