/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.safe.metamodel.safe10.CHROMOSOMEHealthMonitorNotification;
import org.safe.metamodel.safe10.Safe10Package;
import org.safe.metamodel.safe10.Topic;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>CHROMOSOME Health Monitor Notification</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.CHROMOSOMEHealthMonitorNotificationImpl#getPublishedVia <em>Published Via</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class CHROMOSOMEHealthMonitorNotificationImpl extends SoftwareSafetyRequirementImpl implements CHROMOSOMEHealthMonitorNotification
{
  /**
   * The cached value of the '{@link #getPublishedVia() <em>Published Via</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getPublishedVia()
   * @generated
   * @ordered
   */
  protected Topic publishedVia;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected CHROMOSOMEHealthMonitorNotificationImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getCHROMOSOMEHealthMonitorNotification();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Topic getPublishedVia()
  {
    if (publishedVia != null && publishedVia.eIsProxy())
    {
      InternalEObject oldPublishedVia = (InternalEObject)publishedVia;
      publishedVia = (Topic)eResolveProxy(oldPublishedVia);
      if (publishedVia != oldPublishedVia)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.CHROMOSOME_HEALTH_MONITOR_NOTIFICATION__PUBLISHED_VIA, oldPublishedVia, publishedVia));
      }
    }
    return publishedVia;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Topic basicGetPublishedVia()
  {
    return publishedVia;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setPublishedVia(Topic newPublishedVia)
  {
    Topic oldPublishedVia = publishedVia;
    publishedVia = newPublishedVia;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.CHROMOSOME_HEALTH_MONITOR_NOTIFICATION__PUBLISHED_VIA, oldPublishedVia, publishedVia));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.CHROMOSOME_HEALTH_MONITOR_NOTIFICATION__PUBLISHED_VIA:
        if (resolve) return getPublishedVia();
        return basicGetPublishedVia();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.CHROMOSOME_HEALTH_MONITOR_NOTIFICATION__PUBLISHED_VIA:
   			setPublishedVia((Topic)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.CHROMOSOME_HEALTH_MONITOR_NOTIFICATION__PUBLISHED_VIA:
        	setPublishedVia((Topic)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.CHROMOSOME_HEALTH_MONITOR_NOTIFICATION__PUBLISHED_VIA:
        return publishedVia != null;
    }
    return super.eIsSet(featureID);
  }

} //CHROMOSOMEHealthMonitorNotificationImpl
