/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.safe.metamodel.safe10.Application;
import org.safe.metamodel.safe10.ChromosomeApplicationHealthMonitor;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Chromosome Application Health Monitor</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.ChromosomeApplicationHealthMonitorImpl#getMonitors <em>Monitors</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ChromosomeApplicationHealthMonitorImpl extends ChromosomeHealthMonitorImpl implements ChromosomeApplicationHealthMonitor
{
  /**
   * The cached value of the '{@link #getMonitors() <em>Monitors</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMonitors()
   * @generated
   * @ordered
   */
  protected Application monitors;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ChromosomeApplicationHealthMonitorImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getChromosomeApplicationHealthMonitor();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Application getMonitors()
  {
    if (monitors != null && monitors.eIsProxy())
    {
      InternalEObject oldMonitors = (InternalEObject)monitors;
      monitors = (Application)eResolveProxy(oldMonitors);
      if (monitors != oldMonitors)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.CHROMOSOME_APPLICATION_HEALTH_MONITOR__MONITORS, oldMonitors, monitors));
      }
    }
    return monitors;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Application basicGetMonitors()
  {
    return monitors;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setMonitors(Application newMonitors)
  {
    Application oldMonitors = monitors;
    monitors = newMonitors;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.CHROMOSOME_APPLICATION_HEALTH_MONITOR__MONITORS, oldMonitors, monitors));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.CHROMOSOME_APPLICATION_HEALTH_MONITOR__MONITORS:
        if (resolve) return getMonitors();
        return basicGetMonitors();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.CHROMOSOME_APPLICATION_HEALTH_MONITOR__MONITORS:
   			setMonitors((Application)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.CHROMOSOME_APPLICATION_HEALTH_MONITOR__MONITORS:
        	setMonitors((Application)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.CHROMOSOME_APPLICATION_HEALTH_MONITOR__MONITORS:
        return monitors != null;
    }
    return super.eIsSet(featureID);
  }

} //ChromosomeApplicationHealthMonitorImpl
