/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.safe.metamodel.safe10.ChromosomeErrorEventCondition;
import org.safe.metamodel.safe10.Safe10Package;
import org.safe.metamodel.safe10.Topic;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Chromosome Error Event Condition</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.ChromosomeErrorEventConditionImpl#getTriggeredBy <em>Triggered By</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ChromosomeErrorEventConditionImpl extends HealthMonitorErrorConditionImpl implements ChromosomeErrorEventCondition
{
  /**
   * The cached value of the '{@link #getTriggeredBy() <em>Triggered By</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTriggeredBy()
   * @generated
   * @ordered
   */
  protected Topic triggeredBy;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ChromosomeErrorEventConditionImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getChromosomeErrorEventCondition();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Topic getTriggeredBy()
  {
    if (triggeredBy != null && triggeredBy.eIsProxy())
    {
      InternalEObject oldTriggeredBy = (InternalEObject)triggeredBy;
      triggeredBy = (Topic)eResolveProxy(oldTriggeredBy);
      if (triggeredBy != oldTriggeredBy)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.CHROMOSOME_ERROR_EVENT_CONDITION__TRIGGERED_BY, oldTriggeredBy, triggeredBy));
      }
    }
    return triggeredBy;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Topic basicGetTriggeredBy()
  {
    return triggeredBy;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setTriggeredBy(Topic newTriggeredBy)
  {
    Topic oldTriggeredBy = triggeredBy;
    triggeredBy = newTriggeredBy;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.CHROMOSOME_ERROR_EVENT_CONDITION__TRIGGERED_BY, oldTriggeredBy, triggeredBy));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.CHROMOSOME_ERROR_EVENT_CONDITION__TRIGGERED_BY:
        if (resolve) return getTriggeredBy();
        return basicGetTriggeredBy();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.CHROMOSOME_ERROR_EVENT_CONDITION__TRIGGERED_BY:
   			setTriggeredBy((Topic)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.CHROMOSOME_ERROR_EVENT_CONDITION__TRIGGERED_BY:
        	setTriggeredBy((Topic)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.CHROMOSOME_ERROR_EVENT_CONDITION__TRIGGERED_BY:
        return triggeredBy != null;
    }
    return super.eIsSet(featureID);
  }

} //ChromosomeErrorEventConditionImpl
