/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.safe.metamodel.safe10.Comparison;
import org.safe.metamodel.safe10.ComparisonOperationEnum;
import org.safe.metamodel.safe10.ComparisonParameter;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Comparison</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.ComparisonImpl#getTolerance <em>Tolerance</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.ComparisonImpl#getOperation <em>Operation</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.ComparisonImpl#getParamB <em>Param B</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.ComparisonImpl#getParamA <em>Param A</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ComparisonImpl extends SoftwareSafetyRequirementImpl implements Comparison
{
  /**
   * The default value of the '{@link #getTolerance() <em>Tolerance</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTolerance()
   * @generated
   * @ordered
   */
  protected static final Double TOLERANCE_EDEFAULT = new Double(0.0);

  /**
   * The cached value of the '{@link #getTolerance() <em>Tolerance</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTolerance()
   * @generated
   * @ordered
   */
  protected Double tolerance = TOLERANCE_EDEFAULT;

  /**
   * This is true if the Tolerance attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean toleranceESet;

  /**
   * The default value of the '{@link #getOperation() <em>Operation</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getOperation()
   * @generated
   * @ordered
   */
  protected static final ComparisonOperationEnum OPERATION_EDEFAULT = ComparisonOperationEnum.LT;

  /**
   * The cached value of the '{@link #getOperation() <em>Operation</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getOperation()
   * @generated
   * @ordered
   */
  protected ComparisonOperationEnum operation = OPERATION_EDEFAULT;

  /**
   * This is true if the Operation attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean operationESet;

  /**
   * The cached value of the '{@link #getParamB() <em>Param B</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getParamB()
   * @generated
   * @ordered
   */
  protected ComparisonParameter paramB;

  /**
   * The cached value of the '{@link #getParamA() <em>Param A</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getParamA()
   * @generated
   * @ordered
   */
  protected ComparisonParameter paramA;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ComparisonImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getComparison();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Double getTolerance()
  {
    return tolerance;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setTolerance(Double newTolerance)
  {
    Double oldTolerance = tolerance;
    tolerance = newTolerance;
    boolean oldToleranceESet = toleranceESet;
    toleranceESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.COMPARISON__TOLERANCE, oldTolerance, tolerance, !oldToleranceESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetTolerance()
  {
    Double oldTolerance = tolerance;
    boolean oldToleranceESet = toleranceESet;
    tolerance = TOLERANCE_EDEFAULT;
    toleranceESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.COMPARISON__TOLERANCE, oldTolerance, TOLERANCE_EDEFAULT, oldToleranceESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetTolerance()
  {
    return toleranceESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ComparisonOperationEnum getOperation()
  {
    return operation;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setOperation(ComparisonOperationEnum newOperation)
  {
    ComparisonOperationEnum oldOperation = operation;
    operation = newOperation == null ? OPERATION_EDEFAULT : newOperation;
    boolean oldOperationESet = operationESet;
    operationESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.COMPARISON__OPERATION, oldOperation, operation, !oldOperationESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetOperation()
  {
    ComparisonOperationEnum oldOperation = operation;
    boolean oldOperationESet = operationESet;
    operation = OPERATION_EDEFAULT;
    operationESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.COMPARISON__OPERATION, oldOperation, OPERATION_EDEFAULT, oldOperationESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetOperation()
  {
    return operationESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ComparisonParameter getParamB()
  {
    if (paramB != null && paramB.eIsProxy())
    {
      InternalEObject oldParamB = (InternalEObject)paramB;
      paramB = (ComparisonParameter)eResolveProxy(oldParamB);
      if (paramB != oldParamB)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.COMPARISON__PARAM_B, oldParamB, paramB));
      }
    }
    return paramB;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ComparisonParameter basicGetParamB()
  {
    return paramB;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setParamB(ComparisonParameter newParamB)
  {
    ComparisonParameter oldParamB = paramB;
    paramB = newParamB;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.COMPARISON__PARAM_B, oldParamB, paramB));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ComparisonParameter getParamA()
  {
    if (paramA != null && paramA.eIsProxy())
    {
      InternalEObject oldParamA = (InternalEObject)paramA;
      paramA = (ComparisonParameter)eResolveProxy(oldParamA);
      if (paramA != oldParamA)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.COMPARISON__PARAM_A, oldParamA, paramA));
      }
    }
    return paramA;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ComparisonParameter basicGetParamA()
  {
    return paramA;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setParamA(ComparisonParameter newParamA)
  {
    ComparisonParameter oldParamA = paramA;
    paramA = newParamA;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.COMPARISON__PARAM_A, oldParamA, paramA));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.COMPARISON__TOLERANCE:
        return getTolerance();
      case Safe10Package.COMPARISON__OPERATION:
        return getOperation();
      case Safe10Package.COMPARISON__PARAM_B:
        if (resolve) return getParamB();
        return basicGetParamB();
      case Safe10Package.COMPARISON__PARAM_A:
        if (resolve) return getParamA();
        return basicGetParamA();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.COMPARISON__TOLERANCE:
   			setTolerance((Double)newValue);
        return;
      case Safe10Package.COMPARISON__OPERATION:
   			setOperation((ComparisonOperationEnum)newValue);
        return;
      case Safe10Package.COMPARISON__PARAM_B:
   			setParamB((ComparisonParameter)newValue);
        return;
      case Safe10Package.COMPARISON__PARAM_A:
   			setParamA((ComparisonParameter)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.COMPARISON__TOLERANCE:
        unsetTolerance();
        return;
      case Safe10Package.COMPARISON__OPERATION:
        unsetOperation();
        return;
      case Safe10Package.COMPARISON__PARAM_B:
        	setParamB((ComparisonParameter)null);
        return;
      case Safe10Package.COMPARISON__PARAM_A:
        	setParamA((ComparisonParameter)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.COMPARISON__TOLERANCE:
        return isSetTolerance();
      case Safe10Package.COMPARISON__OPERATION:
        return isSetOperation();
      case Safe10Package.COMPARISON__PARAM_B:
        return paramB != null;
      case Safe10Package.COMPARISON__PARAM_A:
        return paramA != null;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (tolerance: ");
    if (toleranceESet) result.append(tolerance); else result.append("<unset>");
    result.append(", operation: ");
    if (operationESet) result.append(operation); else result.append("<unset>");
    result.append(')');
    return result.toString();
  }

} //ComparisonImpl
