/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.safe.metamodel.safe10.ComparisonParameter;
import org.safe.metamodel.safe10.ConstantComparisonParameter;
import org.safe.metamodel.safe10.Identifiable;
import org.safe.metamodel.safe10.Referrable;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Constant Comparison Parameter</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.ConstantComparisonParameterImpl#getShortName <em>Short Name</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.ConstantComparisonParameterImpl#getCategory <em>Category</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.ConstantComparisonParameterImpl#getUuid <em>Uuid</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ConstantComparisonParameterImpl extends ConfigParameterValueImpl implements ConstantComparisonParameter
{
  /**
   * The default value of the '{@link #getShortName() <em>Short Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getShortName()
   * @generated
   * @ordered
   */
  protected static final String SHORT_NAME_EDEFAULT = "";

  /**
   * The cached value of the '{@link #getShortName() <em>Short Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getShortName()
   * @generated
   * @ordered
   */
  protected String shortName = SHORT_NAME_EDEFAULT;

  /**
   * This is true if the Short Name attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean shortNameESet;

  /**
   * The default value of the '{@link #getCategory() <em>Category</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCategory()
   * @generated
   * @ordered
   */
  protected static final String CATEGORY_EDEFAULT = "";

  /**
   * The cached value of the '{@link #getCategory() <em>Category</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCategory()
   * @generated
   * @ordered
   */
  protected String category = CATEGORY_EDEFAULT;

  /**
   * This is true if the Category attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean categoryESet;

  /**
   * The default value of the '{@link #getUuid() <em>Uuid</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getUuid()
   * @generated
   * @ordered
   */
  protected static final String UUID_EDEFAULT = "";

  /**
   * The cached value of the '{@link #getUuid() <em>Uuid</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getUuid()
   * @generated
   * @ordered
   */
  protected String uuid = UUID_EDEFAULT;

  /**
   * This is true if the Uuid attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean uuidESet;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ConstantComparisonParameterImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getConstantComparisonParameter();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getShortName()
  {
    return shortName;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setShortName(String newShortName)
  {
    String oldShortName = shortName;
    shortName = newShortName;
    boolean oldShortNameESet = shortNameESet;
    shortNameESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.CONSTANT_COMPARISON_PARAMETER__SHORT_NAME, oldShortName, shortName, !oldShortNameESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetShortName()
  {
    String oldShortName = shortName;
    boolean oldShortNameESet = shortNameESet;
    shortName = SHORT_NAME_EDEFAULT;
    shortNameESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.CONSTANT_COMPARISON_PARAMETER__SHORT_NAME, oldShortName, SHORT_NAME_EDEFAULT, oldShortNameESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetShortName()
  {
    return shortNameESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getCategory()
  {
    return category;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setCategory(String newCategory)
  {
    String oldCategory = category;
    category = newCategory;
    boolean oldCategoryESet = categoryESet;
    categoryESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.CONSTANT_COMPARISON_PARAMETER__CATEGORY, oldCategory, category, !oldCategoryESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetCategory()
  {
    String oldCategory = category;
    boolean oldCategoryESet = categoryESet;
    category = CATEGORY_EDEFAULT;
    categoryESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.CONSTANT_COMPARISON_PARAMETER__CATEGORY, oldCategory, CATEGORY_EDEFAULT, oldCategoryESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetCategory()
  {
    return categoryESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getUuid()
  {
    return uuid;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setUuid(String newUuid)
  {
    String oldUuid = uuid;
    uuid = newUuid;
    boolean oldUuidESet = uuidESet;
    uuidESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.CONSTANT_COMPARISON_PARAMETER__UUID, oldUuid, uuid, !oldUuidESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetUuid()
  {
    String oldUuid = uuid;
    boolean oldUuidESet = uuidESet;
    uuid = UUID_EDEFAULT;
    uuidESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.CONSTANT_COMPARISON_PARAMETER__UUID, oldUuid, UUID_EDEFAULT, oldUuidESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetUuid()
  {
    return uuidESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.CONSTANT_COMPARISON_PARAMETER__SHORT_NAME:
        return getShortName();
      case Safe10Package.CONSTANT_COMPARISON_PARAMETER__CATEGORY:
        return getCategory();
      case Safe10Package.CONSTANT_COMPARISON_PARAMETER__UUID:
        return getUuid();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.CONSTANT_COMPARISON_PARAMETER__SHORT_NAME:
   			setShortName((String)newValue);
        return;
      case Safe10Package.CONSTANT_COMPARISON_PARAMETER__CATEGORY:
   			setCategory((String)newValue);
        return;
      case Safe10Package.CONSTANT_COMPARISON_PARAMETER__UUID:
   			setUuid((String)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.CONSTANT_COMPARISON_PARAMETER__SHORT_NAME:
        unsetShortName();
        return;
      case Safe10Package.CONSTANT_COMPARISON_PARAMETER__CATEGORY:
        unsetCategory();
        return;
      case Safe10Package.CONSTANT_COMPARISON_PARAMETER__UUID:
        unsetUuid();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.CONSTANT_COMPARISON_PARAMETER__SHORT_NAME:
        return isSetShortName();
      case Safe10Package.CONSTANT_COMPARISON_PARAMETER__CATEGORY:
        return isSetCategory();
      case Safe10Package.CONSTANT_COMPARISON_PARAMETER__UUID:
        return isSetUuid();
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass)
  {
    if (baseClass == Referrable.class)
    {
      switch (derivedFeatureID)
      {
        case Safe10Package.CONSTANT_COMPARISON_PARAMETER__SHORT_NAME: return Safe10Package.REFERRABLE__SHORT_NAME;
        default: return -1;
      }
    }
    if (baseClass == Identifiable.class)
    {
      switch (derivedFeatureID)
      {
        case Safe10Package.CONSTANT_COMPARISON_PARAMETER__CATEGORY: return Safe10Package.IDENTIFIABLE__CATEGORY;
        case Safe10Package.CONSTANT_COMPARISON_PARAMETER__UUID: return Safe10Package.IDENTIFIABLE__UUID;
        default: return -1;
      }
    }
    if (baseClass == ComparisonParameter.class)
    {
      switch (derivedFeatureID)
      {
        default: return -1;
      }
    }
    return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass)
  {
    if (baseClass == Referrable.class)
    {
      switch (baseFeatureID)
      {
        case Safe10Package.REFERRABLE__SHORT_NAME: return Safe10Package.CONSTANT_COMPARISON_PARAMETER__SHORT_NAME;
        default: return -1;
      }
    }
    if (baseClass == Identifiable.class)
    {
      switch (baseFeatureID)
      {
        case Safe10Package.IDENTIFIABLE__CATEGORY: return Safe10Package.CONSTANT_COMPARISON_PARAMETER__CATEGORY;
        case Safe10Package.IDENTIFIABLE__UUID: return Safe10Package.CONSTANT_COMPARISON_PARAMETER__UUID;
        default: return -1;
      }
    }
    if (baseClass == ComparisonParameter.class)
    {
      switch (baseFeatureID)
      {
        default: return -1;
      }
    }
    return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (shortName: ");
    if (shortNameESet) result.append(shortName); else result.append("<unset>");
    result.append(", category: ");
    if (categoryESet) result.append(category); else result.append("<unset>");
    result.append(", uuid: ");
    if (uuidESet) result.append(uuid); else result.append("<unset>");
    result.append(')');
    return result.toString();
  }

} //ConstantComparisonParameterImpl
