/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.safe.metamodel.safe10.AutosarComponentInCompositionInstanceRef;
import org.safe.metamodel.safe10.ControlBlock;
import org.safe.metamodel.safe10.ControlFlowMonitor;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Control Flow Monitor</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.ControlFlowMonitorImpl#getComponent <em>Component</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.ControlFlowMonitorImpl#getControlBlock <em>Control Block</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ControlFlowMonitorImpl extends SoftwareSafetyRequirementImpl implements ControlFlowMonitor
{
  /**
   * The cached value of the '{@link #getComponent() <em>Component</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getComponent()
   * @generated
   * @ordered
   */
  protected AutosarComponentInCompositionInstanceRef component;

  /**
   * The cached value of the '{@link #getControlBlock() <em>Control Block</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getControlBlock()
   * @generated
   * @ordered
   */
  protected EList<ControlBlock> controlBlock;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ControlFlowMonitorImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getControlFlowMonitor();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AutosarComponentInCompositionInstanceRef getComponent()
  {
    return component;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetComponent(AutosarComponentInCompositionInstanceRef newComponent, NotificationChain msgs)
  {
    AutosarComponentInCompositionInstanceRef oldComponent = component;
    component = newComponent;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Safe10Package.CONTROL_FLOW_MONITOR__COMPONENT, oldComponent, newComponent);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setComponent(AutosarComponentInCompositionInstanceRef newComponent)
  {
    if (newComponent != component)
    {
      NotificationChain msgs = null;
      if (component != null)
        msgs = ((InternalEObject)component).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Safe10Package.CONTROL_FLOW_MONITOR__COMPONENT, null, msgs);
      if (newComponent != null)
        msgs = ((InternalEObject)newComponent).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - Safe10Package.CONTROL_FLOW_MONITOR__COMPONENT, null, msgs);
      msgs = basicSetComponent(newComponent, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.CONTROL_FLOW_MONITOR__COMPONENT, newComponent, newComponent));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<ControlBlock> getControlBlock()
  {
    if (controlBlock == null)
    {
      controlBlock = new EObjectContainmentEList<ControlBlock>(ControlBlock.class, this, Safe10Package.CONTROL_FLOW_MONITOR__CONTROL_BLOCK);
    }
    return controlBlock;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.CONTROL_FLOW_MONITOR__COMPONENT:
        return basicSetComponent(null, msgs);
      case Safe10Package.CONTROL_FLOW_MONITOR__CONTROL_BLOCK:
        return ((InternalEList<?>)getControlBlock()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.CONTROL_FLOW_MONITOR__COMPONENT:
        return getComponent();
      case Safe10Package.CONTROL_FLOW_MONITOR__CONTROL_BLOCK:
        return getControlBlock();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.CONTROL_FLOW_MONITOR__COMPONENT:
   			setComponent((AutosarComponentInCompositionInstanceRef)newValue);
        return;
      case Safe10Package.CONTROL_FLOW_MONITOR__CONTROL_BLOCK:
        getControlBlock().clear();
        getControlBlock().addAll((Collection<? extends ControlBlock>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.CONTROL_FLOW_MONITOR__COMPONENT:
        	setComponent((AutosarComponentInCompositionInstanceRef)null);
        return;
      case Safe10Package.CONTROL_FLOW_MONITOR__CONTROL_BLOCK:
        getControlBlock().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.CONTROL_FLOW_MONITOR__COMPONENT:
        return component != null;
      case Safe10Package.CONTROL_FLOW_MONITOR__CONTROL_BLOCK:
        return controlBlock != null && !controlBlock.isEmpty();
    }
    return super.eIsSet(featureID);
  }

} //ControlFlowMonitorImpl
