/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import autosar40.system.fibex.fibexcore.coretopology.EcuInstance;

import autosar40.system.swmapping.EcuPartition;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.safe.metamodel.safe10.EMTypeApplicationEnvironment;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>EM Type Application Environment</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.EMTypeApplicationEnvironmentImpl#getTargetPartition <em>Target Partition</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.EMTypeApplicationEnvironmentImpl#getTargetECU <em>Target ECU</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class EMTypeApplicationEnvironmentImpl extends ErrorModelTypeImpl implements EMTypeApplicationEnvironment
{
  /**
   * The cached value of the '{@link #getTargetPartition() <em>Target Partition</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTargetPartition()
   * @generated
   * @ordered
   */
  protected EcuPartition targetPartition;

  /**
   * The cached value of the '{@link #getTargetECU() <em>Target ECU</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTargetECU()
   * @generated
   * @ordered
   */
  protected EcuInstance targetECU;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected EMTypeApplicationEnvironmentImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getEMTypeApplicationEnvironment();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EcuPartition getTargetPartition()
  {
    if (targetPartition != null && targetPartition.eIsProxy())
    {
      InternalEObject oldTargetPartition = (InternalEObject)targetPartition;
      targetPartition = (EcuPartition)eResolveProxy(oldTargetPartition);
      if (targetPartition != oldTargetPartition)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.EM_TYPE_APPLICATION_ENVIRONMENT__TARGET_PARTITION, oldTargetPartition, targetPartition));
      }
    }
    return targetPartition;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EcuPartition basicGetTargetPartition()
  {
    return targetPartition;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setTargetPartition(EcuPartition newTargetPartition)
  {
    EcuPartition oldTargetPartition = targetPartition;
    targetPartition = newTargetPartition;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.EM_TYPE_APPLICATION_ENVIRONMENT__TARGET_PARTITION, oldTargetPartition, targetPartition));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EcuInstance getTargetECU()
  {
    if (targetECU != null && targetECU.eIsProxy())
    {
      InternalEObject oldTargetECU = (InternalEObject)targetECU;
      targetECU = (EcuInstance)eResolveProxy(oldTargetECU);
      if (targetECU != oldTargetECU)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.EM_TYPE_APPLICATION_ENVIRONMENT__TARGET_ECU, oldTargetECU, targetECU));
      }
    }
    return targetECU;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EcuInstance basicGetTargetECU()
  {
    return targetECU;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setTargetECU(EcuInstance newTargetECU)
  {
    EcuInstance oldTargetECU = targetECU;
    targetECU = newTargetECU;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.EM_TYPE_APPLICATION_ENVIRONMENT__TARGET_ECU, oldTargetECU, targetECU));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.EM_TYPE_APPLICATION_ENVIRONMENT__TARGET_PARTITION:
        if (resolve) return getTargetPartition();
        return basicGetTargetPartition();
      case Safe10Package.EM_TYPE_APPLICATION_ENVIRONMENT__TARGET_ECU:
        if (resolve) return getTargetECU();
        return basicGetTargetECU();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.EM_TYPE_APPLICATION_ENVIRONMENT__TARGET_PARTITION:
   			setTargetPartition((EcuPartition)newValue);
        return;
      case Safe10Package.EM_TYPE_APPLICATION_ENVIRONMENT__TARGET_ECU:
   			setTargetECU((EcuInstance)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.EM_TYPE_APPLICATION_ENVIRONMENT__TARGET_PARTITION:
        	setTargetPartition((EcuPartition)null);
        return;
      case Safe10Package.EM_TYPE_APPLICATION_ENVIRONMENT__TARGET_ECU:
        	setTargetECU((EcuInstance)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.EM_TYPE_APPLICATION_ENVIRONMENT__TARGET_PARTITION:
        return targetPartition != null;
      case Safe10Package.EM_TYPE_APPLICATION_ENVIRONMENT__TARGET_ECU:
        return targetECU != null;
    }
    return super.eIsSet(featureID);
  }

} //EMTypeApplicationEnvironmentImpl
