/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.safe.metamodel.safe10.AbstractErrorBehavior;
import org.safe.metamodel.safe10.ErrorModel;
import org.safe.metamodel.safe10.ErrorModelMapping;
import org.safe.metamodel.safe10.ErrorModelType;
import org.safe.metamodel.safe10.MalfunctionType;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Error Model</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.ErrorModelImpl#getRootErrorModelType <em>Root Error Model Type</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.ErrorModelImpl#getBehavior <em>Behavior</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.ErrorModelImpl#getType <em>Type</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.ErrorModelImpl#getMalfunction <em>Malfunction</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.ErrorModelImpl#getMapping <em>Mapping</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ErrorModelImpl extends IdentifiableImpl implements ErrorModel
{
  /**
   * The cached value of the '{@link #getRootErrorModelType() <em>Root Error Model Type</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRootErrorModelType()
   * @generated
   * @ordered
   */
  protected ErrorModelType rootErrorModelType;

  /**
   * The cached value of the '{@link #getBehavior() <em>Behavior</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getBehavior()
   * @generated
   * @ordered
   */
  protected EList<AbstractErrorBehavior> behavior;

  /**
   * The cached value of the '{@link #getType() <em>Type</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getType()
   * @generated
   * @ordered
   */
  protected EList<ErrorModelType> type;

  /**
   * The cached value of the '{@link #getMalfunction() <em>Malfunction</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMalfunction()
   * @generated
   * @ordered
   */
  protected EList<MalfunctionType> malfunction;

  /**
   * The cached value of the '{@link #getMapping() <em>Mapping</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMapping()
   * @generated
   * @ordered
   */
  protected EList<ErrorModelMapping> mapping;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ErrorModelImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getErrorModel();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ErrorModelType getRootErrorModelType()
  {
    if (rootErrorModelType != null && rootErrorModelType.eIsProxy())
    {
      InternalEObject oldRootErrorModelType = (InternalEObject)rootErrorModelType;
      rootErrorModelType = (ErrorModelType)eResolveProxy(oldRootErrorModelType);
      if (rootErrorModelType != oldRootErrorModelType)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.ERROR_MODEL__ROOT_ERROR_MODEL_TYPE, oldRootErrorModelType, rootErrorModelType));
      }
    }
    return rootErrorModelType;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ErrorModelType basicGetRootErrorModelType()
  {
    return rootErrorModelType;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setRootErrorModelType(ErrorModelType newRootErrorModelType)
  {
    ErrorModelType oldRootErrorModelType = rootErrorModelType;
    rootErrorModelType = newRootErrorModelType;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.ERROR_MODEL__ROOT_ERROR_MODEL_TYPE, oldRootErrorModelType, rootErrorModelType));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<AbstractErrorBehavior> getBehavior()
  {
    if (behavior == null)
    {
      behavior = new EObjectContainmentEList<AbstractErrorBehavior>(AbstractErrorBehavior.class, this, Safe10Package.ERROR_MODEL__BEHAVIOR);
    }
    return behavior;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<ErrorModelType> getType()
  {
    if (type == null)
    {
      type = new EObjectContainmentEList<ErrorModelType>(ErrorModelType.class, this, Safe10Package.ERROR_MODEL__TYPE);
    }
    return type;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<MalfunctionType> getMalfunction()
  {
    if (malfunction == null)
    {
      malfunction = new EObjectContainmentEList<MalfunctionType>(MalfunctionType.class, this, Safe10Package.ERROR_MODEL__MALFUNCTION);
    }
    return malfunction;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<ErrorModelMapping> getMapping()
  {
    if (mapping == null)
    {
      mapping = new EObjectContainmentEList<ErrorModelMapping>(ErrorModelMapping.class, this, Safe10Package.ERROR_MODEL__MAPPING);
    }
    return mapping;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.ERROR_MODEL__BEHAVIOR:
        return ((InternalEList<?>)getBehavior()).basicRemove(otherEnd, msgs);
      case Safe10Package.ERROR_MODEL__TYPE:
        return ((InternalEList<?>)getType()).basicRemove(otherEnd, msgs);
      case Safe10Package.ERROR_MODEL__MALFUNCTION:
        return ((InternalEList<?>)getMalfunction()).basicRemove(otherEnd, msgs);
      case Safe10Package.ERROR_MODEL__MAPPING:
        return ((InternalEList<?>)getMapping()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.ERROR_MODEL__ROOT_ERROR_MODEL_TYPE:
        if (resolve) return getRootErrorModelType();
        return basicGetRootErrorModelType();
      case Safe10Package.ERROR_MODEL__BEHAVIOR:
        return getBehavior();
      case Safe10Package.ERROR_MODEL__TYPE:
        return getType();
      case Safe10Package.ERROR_MODEL__MALFUNCTION:
        return getMalfunction();
      case Safe10Package.ERROR_MODEL__MAPPING:
        return getMapping();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.ERROR_MODEL__ROOT_ERROR_MODEL_TYPE:
   			setRootErrorModelType((ErrorModelType)newValue);
        return;
      case Safe10Package.ERROR_MODEL__BEHAVIOR:
        getBehavior().clear();
        getBehavior().addAll((Collection<? extends AbstractErrorBehavior>)newValue);
        return;
      case Safe10Package.ERROR_MODEL__TYPE:
        getType().clear();
        getType().addAll((Collection<? extends ErrorModelType>)newValue);
        return;
      case Safe10Package.ERROR_MODEL__MALFUNCTION:
        getMalfunction().clear();
        getMalfunction().addAll((Collection<? extends MalfunctionType>)newValue);
        return;
      case Safe10Package.ERROR_MODEL__MAPPING:
        getMapping().clear();
        getMapping().addAll((Collection<? extends ErrorModelMapping>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.ERROR_MODEL__ROOT_ERROR_MODEL_TYPE:
        	setRootErrorModelType((ErrorModelType)null);
        return;
      case Safe10Package.ERROR_MODEL__BEHAVIOR:
        getBehavior().clear();
        return;
      case Safe10Package.ERROR_MODEL__TYPE:
        getType().clear();
        return;
      case Safe10Package.ERROR_MODEL__MALFUNCTION:
        getMalfunction().clear();
        return;
      case Safe10Package.ERROR_MODEL__MAPPING:
        getMapping().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.ERROR_MODEL__ROOT_ERROR_MODEL_TYPE:
        return rootErrorModelType != null;
      case Safe10Package.ERROR_MODEL__BEHAVIOR:
        return behavior != null && !behavior.isEmpty();
      case Safe10Package.ERROR_MODEL__TYPE:
        return type != null && !type.isEmpty();
      case Safe10Package.ERROR_MODEL__MALFUNCTION:
        return malfunction != null && !malfunction.isEmpty();
      case Safe10Package.ERROR_MODEL__MAPPING:
        return mapping != null && !mapping.isEmpty();
    }
    return super.eIsSet(featureID);
  }

} //ErrorModelImpl
