/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eatop.eel.eastadl21.FunctionPort;
import org.eatop.eel.eastadl21.FunctionPrototype;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectResolvingEList;

import org.eclipse.sphinx.emf.ecore.ExtendedEObjectImpl;

import org.safe.metamodel.safe10.FaultFailurePort_functionTarget;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Fault Failure Port function Target</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.FaultFailurePort_functionTargetImpl#getTarget <em>Target</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.FaultFailurePort_functionTargetImpl#getContext <em>Context</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class FaultFailurePort_functionTargetImpl extends ExtendedEObjectImpl implements FaultFailurePort_functionTarget
{
  /**
   * The cached value of the '{@link #getTarget() <em>Target</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTarget()
   * @generated
   * @ordered
   */
  protected FunctionPort target;

  /**
   * The cached value of the '{@link #getContext() <em>Context</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getContext()
   * @generated
   * @ordered
   */
  protected EList<FunctionPrototype> context;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected FaultFailurePort_functionTargetImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getFaultFailurePort_functionTarget();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FunctionPort getTarget()
  {
    if (target != null && target.eIsProxy())
    {
      InternalEObject oldTarget = (InternalEObject)target;
      target = (FunctionPort)eResolveProxy(oldTarget);
      if (target != oldTarget)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.FAULT_FAILURE_PORT_FUNCTION_TARGET__TARGET, oldTarget, target));
      }
    }
    return target;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FunctionPort basicGetTarget()
  {
    return target;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setTarget(FunctionPort newTarget)
  {
    FunctionPort oldTarget = target;
    target = newTarget;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.FAULT_FAILURE_PORT_FUNCTION_TARGET__TARGET, oldTarget, target));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<FunctionPrototype> getContext()
  {
    if (context == null)
    {
      context = new EObjectResolvingEList<FunctionPrototype>(FunctionPrototype.class, this, Safe10Package.FAULT_FAILURE_PORT_FUNCTION_TARGET__CONTEXT);
    }
    return context;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.FAULT_FAILURE_PORT_FUNCTION_TARGET__TARGET:
        if (resolve) return getTarget();
        return basicGetTarget();
      case Safe10Package.FAULT_FAILURE_PORT_FUNCTION_TARGET__CONTEXT:
        return getContext();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.FAULT_FAILURE_PORT_FUNCTION_TARGET__TARGET:
   			setTarget((FunctionPort)newValue);
        return;
      case Safe10Package.FAULT_FAILURE_PORT_FUNCTION_TARGET__CONTEXT:
        getContext().clear();
        getContext().addAll((Collection<? extends FunctionPrototype>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.FAULT_FAILURE_PORT_FUNCTION_TARGET__TARGET:
        	setTarget((FunctionPort)null);
        return;
      case Safe10Package.FAULT_FAILURE_PORT_FUNCTION_TARGET__CONTEXT:
        getContext().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.FAULT_FAILURE_PORT_FUNCTION_TARGET__TARGET:
        return target != null;
      case Safe10Package.FAULT_FAILURE_PORT_FUNCTION_TARGET__CONTEXT:
        return context != null && !context.isEmpty();
    }
    return super.eIsSet(featureID);
  }

} //FaultFailurePort_functionTargetImpl
