/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.safe.metamodel.safe10.HWElementFailureRateClass;
import org.safe.metamodel.safe10.HWFailureClassContributionFormula;
import org.safe.metamodel.safe10.HWLFTargetFailureRateClassEnum;
import org.safe.metamodel.safe10.HWRFTargetFailureRateClassEnum;
import org.safe.metamodel.safe10.HWSPFTargetFailureRateClassEnum;
import org.safe.metamodel.safe10.HWValuesFailureRateClassEnum;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>HW Element Failure Rate Class</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWElementFailureRateClassImpl#getHwElementFailureClass <em>Hw Element Failure Class</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWElementFailureRateClassImpl#getHwElementLatentDiagnosisCoverage <em>Hw Element Latent Diagnosis Coverage</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWElementFailureRateClassImpl#getHwElementResidualDiagnosisCoverage <em>Hw Element Residual Diagnosis Coverage</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWElementFailureRateClassImpl#getLFTargetFailureRateClass <em>LF Target Failure Rate Class</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWElementFailureRateClassImpl#getRationaleDedicatedMeasures <em>Rationale Dedicated Measures</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWElementFailureRateClassImpl#getRationaleFailureRateClass <em>Rationale Failure Rate Class</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWElementFailureRateClassImpl#getRFTargetFailureRateClass <em>RF Target Failure Rate Class</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWElementFailureRateClassImpl#getSPFTargetFailureRateClass <em>SPF Target Failure Rate Class</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWElementFailureRateClassImpl#getHwEFRChwElementValue <em>Hw EFR Chw Element Value</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class HWElementFailureRateClassImpl extends IdentifiableImpl implements HWElementFailureRateClass
{
  /**
   * The default value of the '{@link #getHwElementFailureClass() <em>Hw Element Failure Class</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHwElementFailureClass()
   * @generated
   * @ordered
   */
  protected static final HWValuesFailureRateClassEnum HW_ELEMENT_FAILURE_CLASS_EDEFAULT = HWValuesFailureRateClassEnum.FAILURE_RATE_CLASS1;

  /**
   * The cached value of the '{@link #getHwElementFailureClass() <em>Hw Element Failure Class</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHwElementFailureClass()
   * @generated
   * @ordered
   */
  protected HWValuesFailureRateClassEnum hwElementFailureClass = HW_ELEMENT_FAILURE_CLASS_EDEFAULT;

  /**
   * This is true if the Hw Element Failure Class attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean hwElementFailureClassESet;

  /**
   * The default value of the '{@link #getHwElementLatentDiagnosisCoverage() <em>Hw Element Latent Diagnosis Coverage</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHwElementLatentDiagnosisCoverage()
   * @generated
   * @ordered
   */
  protected static final Double HW_ELEMENT_LATENT_DIAGNOSIS_COVERAGE_EDEFAULT = new Double(0.0);

  /**
   * The cached value of the '{@link #getHwElementLatentDiagnosisCoverage() <em>Hw Element Latent Diagnosis Coverage</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHwElementLatentDiagnosisCoverage()
   * @generated
   * @ordered
   */
  protected Double hwElementLatentDiagnosisCoverage = HW_ELEMENT_LATENT_DIAGNOSIS_COVERAGE_EDEFAULT;

  /**
   * This is true if the Hw Element Latent Diagnosis Coverage attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean hwElementLatentDiagnosisCoverageESet;

  /**
   * The default value of the '{@link #getHwElementResidualDiagnosisCoverage() <em>Hw Element Residual Diagnosis Coverage</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHwElementResidualDiagnosisCoverage()
   * @generated
   * @ordered
   */
  protected static final Double HW_ELEMENT_RESIDUAL_DIAGNOSIS_COVERAGE_EDEFAULT = new Double(0.0);

  /**
   * The cached value of the '{@link #getHwElementResidualDiagnosisCoverage() <em>Hw Element Residual Diagnosis Coverage</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHwElementResidualDiagnosisCoverage()
   * @generated
   * @ordered
   */
  protected Double hwElementResidualDiagnosisCoverage = HW_ELEMENT_RESIDUAL_DIAGNOSIS_COVERAGE_EDEFAULT;

  /**
   * This is true if the Hw Element Residual Diagnosis Coverage attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean hwElementResidualDiagnosisCoverageESet;

  /**
   * The default value of the '{@link #getLFTargetFailureRateClass() <em>LF Target Failure Rate Class</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getLFTargetFailureRateClass()
   * @generated
   * @ordered
   */
  protected static final HWLFTargetFailureRateClassEnum LF_TARGET_FAILURE_RATE_CLASS_EDEFAULT = HWLFTargetFailureRateClassEnum.OUT_OF_SCOPE;

  /**
   * The cached value of the '{@link #getLFTargetFailureRateClass() <em>LF Target Failure Rate Class</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getLFTargetFailureRateClass()
   * @generated
   * @ordered
   */
  protected HWLFTargetFailureRateClassEnum lfTargetFailureRateClass = LF_TARGET_FAILURE_RATE_CLASS_EDEFAULT;

  /**
   * This is true if the LF Target Failure Rate Class attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean lfTargetFailureRateClassESet;

  /**
   * The default value of the '{@link #getRationaleDedicatedMeasures() <em>Rationale Dedicated Measures</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRationaleDedicatedMeasures()
   * @generated
   * @ordered
   */
  protected static final String RATIONALE_DEDICATED_MEASURES_EDEFAULT = "";

  /**
   * The cached value of the '{@link #getRationaleDedicatedMeasures() <em>Rationale Dedicated Measures</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRationaleDedicatedMeasures()
   * @generated
   * @ordered
   */
  protected String rationaleDedicatedMeasures = RATIONALE_DEDICATED_MEASURES_EDEFAULT;

  /**
   * This is true if the Rationale Dedicated Measures attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean rationaleDedicatedMeasuresESet;

  /**
   * The default value of the '{@link #getRationaleFailureRateClass() <em>Rationale Failure Rate Class</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRationaleFailureRateClass()
   * @generated
   * @ordered
   */
  protected static final String RATIONALE_FAILURE_RATE_CLASS_EDEFAULT = "";

  /**
   * The cached value of the '{@link #getRationaleFailureRateClass() <em>Rationale Failure Rate Class</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRationaleFailureRateClass()
   * @generated
   * @ordered
   */
  protected String rationaleFailureRateClass = RATIONALE_FAILURE_RATE_CLASS_EDEFAULT;

  /**
   * This is true if the Rationale Failure Rate Class attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean rationaleFailureRateClassESet;

  /**
   * The default value of the '{@link #getRFTargetFailureRateClass() <em>RF Target Failure Rate Class</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRFTargetFailureRateClass()
   * @generated
   * @ordered
   */
  protected static final HWRFTargetFailureRateClassEnum RF_TARGET_FAILURE_RATE_CLASS_EDEFAULT = HWRFTargetFailureRateClassEnum.OUT_OF_SCOPE;

  /**
   * The cached value of the '{@link #getRFTargetFailureRateClass() <em>RF Target Failure Rate Class</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRFTargetFailureRateClass()
   * @generated
   * @ordered
   */
  protected HWRFTargetFailureRateClassEnum rfTargetFailureRateClass = RF_TARGET_FAILURE_RATE_CLASS_EDEFAULT;

  /**
   * This is true if the RF Target Failure Rate Class attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean rfTargetFailureRateClassESet;

  /**
   * The default value of the '{@link #getSPFTargetFailureRateClass() <em>SPF Target Failure Rate Class</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSPFTargetFailureRateClass()
   * @generated
   * @ordered
   */
  protected static final HWSPFTargetFailureRateClassEnum SPF_TARGET_FAILURE_RATE_CLASS_EDEFAULT = HWSPFTargetFailureRateClassEnum.OUT_OF_SCOPE;

  /**
   * The cached value of the '{@link #getSPFTargetFailureRateClass() <em>SPF Target Failure Rate Class</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSPFTargetFailureRateClass()
   * @generated
   * @ordered
   */
  protected HWSPFTargetFailureRateClassEnum spfTargetFailureRateClass = SPF_TARGET_FAILURE_RATE_CLASS_EDEFAULT;

  /**
   * This is true if the SPF Target Failure Rate Class attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean spfTargetFailureRateClassESet;

  /**
   * The cached value of the '{@link #getHwEFRChwElementValue() <em>Hw EFR Chw Element Value</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHwEFRChwElementValue()
   * @generated
   * @ordered
   */
  protected HWFailureClassContributionFormula hwEFRChwElementValue;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected HWElementFailureRateClassImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getHWElementFailureRateClass();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWValuesFailureRateClassEnum getHwElementFailureClass()
  {
    return hwElementFailureClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setHwElementFailureClass(HWValuesFailureRateClassEnum newHwElementFailureClass)
  {
    HWValuesFailureRateClassEnum oldHwElementFailureClass = hwElementFailureClass;
    hwElementFailureClass = newHwElementFailureClass == null ? HW_ELEMENT_FAILURE_CLASS_EDEFAULT : newHwElementFailureClass;
    boolean oldHwElementFailureClassESet = hwElementFailureClassESet;
    hwElementFailureClassESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__HW_ELEMENT_FAILURE_CLASS, oldHwElementFailureClass, hwElementFailureClass, !oldHwElementFailureClassESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetHwElementFailureClass()
  {
    HWValuesFailureRateClassEnum oldHwElementFailureClass = hwElementFailureClass;
    boolean oldHwElementFailureClassESet = hwElementFailureClassESet;
    hwElementFailureClass = HW_ELEMENT_FAILURE_CLASS_EDEFAULT;
    hwElementFailureClassESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__HW_ELEMENT_FAILURE_CLASS, oldHwElementFailureClass, HW_ELEMENT_FAILURE_CLASS_EDEFAULT, oldHwElementFailureClassESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetHwElementFailureClass()
  {
    return hwElementFailureClassESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Double getHwElementLatentDiagnosisCoverage()
  {
    return hwElementLatentDiagnosisCoverage;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setHwElementLatentDiagnosisCoverage(Double newHwElementLatentDiagnosisCoverage)
  {
    Double oldHwElementLatentDiagnosisCoverage = hwElementLatentDiagnosisCoverage;
    hwElementLatentDiagnosisCoverage = newHwElementLatentDiagnosisCoverage;
    boolean oldHwElementLatentDiagnosisCoverageESet = hwElementLatentDiagnosisCoverageESet;
    hwElementLatentDiagnosisCoverageESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__HW_ELEMENT_LATENT_DIAGNOSIS_COVERAGE, oldHwElementLatentDiagnosisCoverage, hwElementLatentDiagnosisCoverage, !oldHwElementLatentDiagnosisCoverageESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetHwElementLatentDiagnosisCoverage()
  {
    Double oldHwElementLatentDiagnosisCoverage = hwElementLatentDiagnosisCoverage;
    boolean oldHwElementLatentDiagnosisCoverageESet = hwElementLatentDiagnosisCoverageESet;
    hwElementLatentDiagnosisCoverage = HW_ELEMENT_LATENT_DIAGNOSIS_COVERAGE_EDEFAULT;
    hwElementLatentDiagnosisCoverageESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__HW_ELEMENT_LATENT_DIAGNOSIS_COVERAGE, oldHwElementLatentDiagnosisCoverage, HW_ELEMENT_LATENT_DIAGNOSIS_COVERAGE_EDEFAULT, oldHwElementLatentDiagnosisCoverageESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetHwElementLatentDiagnosisCoverage()
  {
    return hwElementLatentDiagnosisCoverageESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Double getHwElementResidualDiagnosisCoverage()
  {
    return hwElementResidualDiagnosisCoverage;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setHwElementResidualDiagnosisCoverage(Double newHwElementResidualDiagnosisCoverage)
  {
    Double oldHwElementResidualDiagnosisCoverage = hwElementResidualDiagnosisCoverage;
    hwElementResidualDiagnosisCoverage = newHwElementResidualDiagnosisCoverage;
    boolean oldHwElementResidualDiagnosisCoverageESet = hwElementResidualDiagnosisCoverageESet;
    hwElementResidualDiagnosisCoverageESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__HW_ELEMENT_RESIDUAL_DIAGNOSIS_COVERAGE, oldHwElementResidualDiagnosisCoverage, hwElementResidualDiagnosisCoverage, !oldHwElementResidualDiagnosisCoverageESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetHwElementResidualDiagnosisCoverage()
  {
    Double oldHwElementResidualDiagnosisCoverage = hwElementResidualDiagnosisCoverage;
    boolean oldHwElementResidualDiagnosisCoverageESet = hwElementResidualDiagnosisCoverageESet;
    hwElementResidualDiagnosisCoverage = HW_ELEMENT_RESIDUAL_DIAGNOSIS_COVERAGE_EDEFAULT;
    hwElementResidualDiagnosisCoverageESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__HW_ELEMENT_RESIDUAL_DIAGNOSIS_COVERAGE, oldHwElementResidualDiagnosisCoverage, HW_ELEMENT_RESIDUAL_DIAGNOSIS_COVERAGE_EDEFAULT, oldHwElementResidualDiagnosisCoverageESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetHwElementResidualDiagnosisCoverage()
  {
    return hwElementResidualDiagnosisCoverageESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWLFTargetFailureRateClassEnum getLFTargetFailureRateClass()
  {
    return lfTargetFailureRateClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setLFTargetFailureRateClass(HWLFTargetFailureRateClassEnum newLFTargetFailureRateClass)
  {
    HWLFTargetFailureRateClassEnum oldLFTargetFailureRateClass = lfTargetFailureRateClass;
    lfTargetFailureRateClass = newLFTargetFailureRateClass == null ? LF_TARGET_FAILURE_RATE_CLASS_EDEFAULT : newLFTargetFailureRateClass;
    boolean oldLFTargetFailureRateClassESet = lfTargetFailureRateClassESet;
    lfTargetFailureRateClassESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__LF_TARGET_FAILURE_RATE_CLASS, oldLFTargetFailureRateClass, lfTargetFailureRateClass, !oldLFTargetFailureRateClassESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetLFTargetFailureRateClass()
  {
    HWLFTargetFailureRateClassEnum oldLFTargetFailureRateClass = lfTargetFailureRateClass;
    boolean oldLFTargetFailureRateClassESet = lfTargetFailureRateClassESet;
    lfTargetFailureRateClass = LF_TARGET_FAILURE_RATE_CLASS_EDEFAULT;
    lfTargetFailureRateClassESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__LF_TARGET_FAILURE_RATE_CLASS, oldLFTargetFailureRateClass, LF_TARGET_FAILURE_RATE_CLASS_EDEFAULT, oldLFTargetFailureRateClassESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetLFTargetFailureRateClass()
  {
    return lfTargetFailureRateClassESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getRationaleDedicatedMeasures()
  {
    return rationaleDedicatedMeasures;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setRationaleDedicatedMeasures(String newRationaleDedicatedMeasures)
  {
    String oldRationaleDedicatedMeasures = rationaleDedicatedMeasures;
    rationaleDedicatedMeasures = newRationaleDedicatedMeasures;
    boolean oldRationaleDedicatedMeasuresESet = rationaleDedicatedMeasuresESet;
    rationaleDedicatedMeasuresESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__RATIONALE_DEDICATED_MEASURES, oldRationaleDedicatedMeasures, rationaleDedicatedMeasures, !oldRationaleDedicatedMeasuresESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetRationaleDedicatedMeasures()
  {
    String oldRationaleDedicatedMeasures = rationaleDedicatedMeasures;
    boolean oldRationaleDedicatedMeasuresESet = rationaleDedicatedMeasuresESet;
    rationaleDedicatedMeasures = RATIONALE_DEDICATED_MEASURES_EDEFAULT;
    rationaleDedicatedMeasuresESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__RATIONALE_DEDICATED_MEASURES, oldRationaleDedicatedMeasures, RATIONALE_DEDICATED_MEASURES_EDEFAULT, oldRationaleDedicatedMeasuresESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetRationaleDedicatedMeasures()
  {
    return rationaleDedicatedMeasuresESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getRationaleFailureRateClass()
  {
    return rationaleFailureRateClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setRationaleFailureRateClass(String newRationaleFailureRateClass)
  {
    String oldRationaleFailureRateClass = rationaleFailureRateClass;
    rationaleFailureRateClass = newRationaleFailureRateClass;
    boolean oldRationaleFailureRateClassESet = rationaleFailureRateClassESet;
    rationaleFailureRateClassESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__RATIONALE_FAILURE_RATE_CLASS, oldRationaleFailureRateClass, rationaleFailureRateClass, !oldRationaleFailureRateClassESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetRationaleFailureRateClass()
  {
    String oldRationaleFailureRateClass = rationaleFailureRateClass;
    boolean oldRationaleFailureRateClassESet = rationaleFailureRateClassESet;
    rationaleFailureRateClass = RATIONALE_FAILURE_RATE_CLASS_EDEFAULT;
    rationaleFailureRateClassESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__RATIONALE_FAILURE_RATE_CLASS, oldRationaleFailureRateClass, RATIONALE_FAILURE_RATE_CLASS_EDEFAULT, oldRationaleFailureRateClassESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetRationaleFailureRateClass()
  {
    return rationaleFailureRateClassESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWRFTargetFailureRateClassEnum getRFTargetFailureRateClass()
  {
    return rfTargetFailureRateClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setRFTargetFailureRateClass(HWRFTargetFailureRateClassEnum newRFTargetFailureRateClass)
  {
    HWRFTargetFailureRateClassEnum oldRFTargetFailureRateClass = rfTargetFailureRateClass;
    rfTargetFailureRateClass = newRFTargetFailureRateClass == null ? RF_TARGET_FAILURE_RATE_CLASS_EDEFAULT : newRFTargetFailureRateClass;
    boolean oldRFTargetFailureRateClassESet = rfTargetFailureRateClassESet;
    rfTargetFailureRateClassESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__RF_TARGET_FAILURE_RATE_CLASS, oldRFTargetFailureRateClass, rfTargetFailureRateClass, !oldRFTargetFailureRateClassESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetRFTargetFailureRateClass()
  {
    HWRFTargetFailureRateClassEnum oldRFTargetFailureRateClass = rfTargetFailureRateClass;
    boolean oldRFTargetFailureRateClassESet = rfTargetFailureRateClassESet;
    rfTargetFailureRateClass = RF_TARGET_FAILURE_RATE_CLASS_EDEFAULT;
    rfTargetFailureRateClassESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__RF_TARGET_FAILURE_RATE_CLASS, oldRFTargetFailureRateClass, RF_TARGET_FAILURE_RATE_CLASS_EDEFAULT, oldRFTargetFailureRateClassESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetRFTargetFailureRateClass()
  {
    return rfTargetFailureRateClassESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWSPFTargetFailureRateClassEnum getSPFTargetFailureRateClass()
  {
    return spfTargetFailureRateClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setSPFTargetFailureRateClass(HWSPFTargetFailureRateClassEnum newSPFTargetFailureRateClass)
  {
    HWSPFTargetFailureRateClassEnum oldSPFTargetFailureRateClass = spfTargetFailureRateClass;
    spfTargetFailureRateClass = newSPFTargetFailureRateClass == null ? SPF_TARGET_FAILURE_RATE_CLASS_EDEFAULT : newSPFTargetFailureRateClass;
    boolean oldSPFTargetFailureRateClassESet = spfTargetFailureRateClassESet;
    spfTargetFailureRateClassESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__SPF_TARGET_FAILURE_RATE_CLASS, oldSPFTargetFailureRateClass, spfTargetFailureRateClass, !oldSPFTargetFailureRateClassESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetSPFTargetFailureRateClass()
  {
    HWSPFTargetFailureRateClassEnum oldSPFTargetFailureRateClass = spfTargetFailureRateClass;
    boolean oldSPFTargetFailureRateClassESet = spfTargetFailureRateClassESet;
    spfTargetFailureRateClass = SPF_TARGET_FAILURE_RATE_CLASS_EDEFAULT;
    spfTargetFailureRateClassESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__SPF_TARGET_FAILURE_RATE_CLASS, oldSPFTargetFailureRateClass, SPF_TARGET_FAILURE_RATE_CLASS_EDEFAULT, oldSPFTargetFailureRateClassESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetSPFTargetFailureRateClass()
  {
    return spfTargetFailureRateClassESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWFailureClassContributionFormula getHwEFRChwElementValue()
  {
    return hwEFRChwElementValue;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetHwEFRChwElementValue(HWFailureClassContributionFormula newHwEFRChwElementValue, NotificationChain msgs)
  {
    HWFailureClassContributionFormula oldHwEFRChwElementValue = hwEFRChwElementValue;
    hwEFRChwElementValue = newHwEFRChwElementValue;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__HW_EFR_CHW_ELEMENT_VALUE, oldHwEFRChwElementValue, newHwEFRChwElementValue);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setHwEFRChwElementValue(HWFailureClassContributionFormula newHwEFRChwElementValue)
  {
    if (newHwEFRChwElementValue != hwEFRChwElementValue)
    {
      NotificationChain msgs = null;
      if (hwEFRChwElementValue != null)
        msgs = ((InternalEObject)hwEFRChwElementValue).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__HW_EFR_CHW_ELEMENT_VALUE, null, msgs);
      if (newHwEFRChwElementValue != null)
        msgs = ((InternalEObject)newHwEFRChwElementValue).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__HW_EFR_CHW_ELEMENT_VALUE, null, msgs);
      msgs = basicSetHwEFRChwElementValue(newHwEFRChwElementValue, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__HW_EFR_CHW_ELEMENT_VALUE, newHwEFRChwElementValue, newHwEFRChwElementValue));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__HW_EFR_CHW_ELEMENT_VALUE:
        return basicSetHwEFRChwElementValue(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__HW_ELEMENT_FAILURE_CLASS:
        return getHwElementFailureClass();
      case Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__HW_ELEMENT_LATENT_DIAGNOSIS_COVERAGE:
        return getHwElementLatentDiagnosisCoverage();
      case Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__HW_ELEMENT_RESIDUAL_DIAGNOSIS_COVERAGE:
        return getHwElementResidualDiagnosisCoverage();
      case Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__LF_TARGET_FAILURE_RATE_CLASS:
        return getLFTargetFailureRateClass();
      case Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__RATIONALE_DEDICATED_MEASURES:
        return getRationaleDedicatedMeasures();
      case Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__RATIONALE_FAILURE_RATE_CLASS:
        return getRationaleFailureRateClass();
      case Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__RF_TARGET_FAILURE_RATE_CLASS:
        return getRFTargetFailureRateClass();
      case Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__SPF_TARGET_FAILURE_RATE_CLASS:
        return getSPFTargetFailureRateClass();
      case Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__HW_EFR_CHW_ELEMENT_VALUE:
        return getHwEFRChwElementValue();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__HW_ELEMENT_FAILURE_CLASS:
   			setHwElementFailureClass((HWValuesFailureRateClassEnum)newValue);
        return;
      case Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__HW_ELEMENT_LATENT_DIAGNOSIS_COVERAGE:
   			setHwElementLatentDiagnosisCoverage((Double)newValue);
        return;
      case Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__HW_ELEMENT_RESIDUAL_DIAGNOSIS_COVERAGE:
   			setHwElementResidualDiagnosisCoverage((Double)newValue);
        return;
      case Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__LF_TARGET_FAILURE_RATE_CLASS:
   			setLFTargetFailureRateClass((HWLFTargetFailureRateClassEnum)newValue);
        return;
      case Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__RATIONALE_DEDICATED_MEASURES:
   			setRationaleDedicatedMeasures((String)newValue);
        return;
      case Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__RATIONALE_FAILURE_RATE_CLASS:
   			setRationaleFailureRateClass((String)newValue);
        return;
      case Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__RF_TARGET_FAILURE_RATE_CLASS:
   			setRFTargetFailureRateClass((HWRFTargetFailureRateClassEnum)newValue);
        return;
      case Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__SPF_TARGET_FAILURE_RATE_CLASS:
   			setSPFTargetFailureRateClass((HWSPFTargetFailureRateClassEnum)newValue);
        return;
      case Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__HW_EFR_CHW_ELEMENT_VALUE:
   			setHwEFRChwElementValue((HWFailureClassContributionFormula)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__HW_ELEMENT_FAILURE_CLASS:
        unsetHwElementFailureClass();
        return;
      case Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__HW_ELEMENT_LATENT_DIAGNOSIS_COVERAGE:
        unsetHwElementLatentDiagnosisCoverage();
        return;
      case Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__HW_ELEMENT_RESIDUAL_DIAGNOSIS_COVERAGE:
        unsetHwElementResidualDiagnosisCoverage();
        return;
      case Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__LF_TARGET_FAILURE_RATE_CLASS:
        unsetLFTargetFailureRateClass();
        return;
      case Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__RATIONALE_DEDICATED_MEASURES:
        unsetRationaleDedicatedMeasures();
        return;
      case Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__RATIONALE_FAILURE_RATE_CLASS:
        unsetRationaleFailureRateClass();
        return;
      case Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__RF_TARGET_FAILURE_RATE_CLASS:
        unsetRFTargetFailureRateClass();
        return;
      case Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__SPF_TARGET_FAILURE_RATE_CLASS:
        unsetSPFTargetFailureRateClass();
        return;
      case Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__HW_EFR_CHW_ELEMENT_VALUE:
        	setHwEFRChwElementValue((HWFailureClassContributionFormula)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__HW_ELEMENT_FAILURE_CLASS:
        return isSetHwElementFailureClass();
      case Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__HW_ELEMENT_LATENT_DIAGNOSIS_COVERAGE:
        return isSetHwElementLatentDiagnosisCoverage();
      case Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__HW_ELEMENT_RESIDUAL_DIAGNOSIS_COVERAGE:
        return isSetHwElementResidualDiagnosisCoverage();
      case Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__LF_TARGET_FAILURE_RATE_CLASS:
        return isSetLFTargetFailureRateClass();
      case Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__RATIONALE_DEDICATED_MEASURES:
        return isSetRationaleDedicatedMeasures();
      case Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__RATIONALE_FAILURE_RATE_CLASS:
        return isSetRationaleFailureRateClass();
      case Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__RF_TARGET_FAILURE_RATE_CLASS:
        return isSetRFTargetFailureRateClass();
      case Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__SPF_TARGET_FAILURE_RATE_CLASS:
        return isSetSPFTargetFailureRateClass();
      case Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS__HW_EFR_CHW_ELEMENT_VALUE:
        return hwEFRChwElementValue != null;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (hwElementFailureClass: ");
    if (hwElementFailureClassESet) result.append(hwElementFailureClass); else result.append("<unset>");
    result.append(", hwElementLatentDiagnosisCoverage: ");
    if (hwElementLatentDiagnosisCoverageESet) result.append(hwElementLatentDiagnosisCoverage); else result.append("<unset>");
    result.append(", hwElementResidualDiagnosisCoverage: ");
    if (hwElementResidualDiagnosisCoverageESet) result.append(hwElementResidualDiagnosisCoverage); else result.append("<unset>");
    result.append(", LFTargetFailureRateClass: ");
    if (lfTargetFailureRateClassESet) result.append(lfTargetFailureRateClass); else result.append("<unset>");
    result.append(", rationaleDedicatedMeasures: ");
    if (rationaleDedicatedMeasuresESet) result.append(rationaleDedicatedMeasures); else result.append("<unset>");
    result.append(", rationaleFailureRateClass: ");
    if (rationaleFailureRateClassESet) result.append(rationaleFailureRateClass); else result.append("<unset>");
    result.append(", RFTargetFailureRateClass: ");
    if (rfTargetFailureRateClassESet) result.append(rfTargetFailureRateClass); else result.append("<unset>");
    result.append(", SPFTargetFailureRateClass: ");
    if (spfTargetFailureRateClassESet) result.append(spfTargetFailureRateClass); else result.append("<unset>");
    result.append(')');
    return result.toString();
  }

} //HWElementFailureRateClassImpl
