/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.sphinx.emf.ecore.ExtendedEObjectImpl;

import org.safe.metamodel.safe10.HWElementPrototypeScope;
import org.safe.metamodel.safe10.HWElementScopeInstanceRef;
import org.safe.metamodel.safe10.HWPartFailureAnalysis;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>HW Element Prototype Scope</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWElementPrototypeScopeImpl#getSafetyRelated <em>Safety Related</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWElementPrototypeScopeImpl#getNameWasNotSet_2 <em>Name Was Not Set 2</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWElementPrototypeScopeImpl#getScope <em>Scope</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class HWElementPrototypeScopeImpl extends ExtendedEObjectImpl implements HWElementPrototypeScope
{
  /**
   * The default value of the '{@link #getSafetyRelated() <em>Safety Related</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSafetyRelated()
   * @generated
   * @ordered
   */
  protected static final Boolean SAFETY_RELATED_EDEFAULT = Boolean.FALSE;

  /**
   * The cached value of the '{@link #getSafetyRelated() <em>Safety Related</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSafetyRelated()
   * @generated
   * @ordered
   */
  protected Boolean safetyRelated = SAFETY_RELATED_EDEFAULT;

  /**
   * This is true if the Safety Related attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean safetyRelatedESet;

  /**
   * The cached value of the '{@link #getNameWasNotSet_2() <em>Name Was Not Set 2</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNameWasNotSet_2()
   * @generated
   * @ordered
   */
  protected HWPartFailureAnalysis nameWasNotSet_2;

  /**
   * The cached value of the '{@link #getScope() <em>Scope</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getScope()
   * @generated
   * @ordered
   */
  protected HWElementScopeInstanceRef scope;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected HWElementPrototypeScopeImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getHWElementPrototypeScope();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Boolean getSafetyRelated()
  {
    return safetyRelated;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setSafetyRelated(Boolean newSafetyRelated)
  {
    Boolean oldSafetyRelated = safetyRelated;
    safetyRelated = newSafetyRelated;
    boolean oldSafetyRelatedESet = safetyRelatedESet;
    safetyRelatedESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HW_ELEMENT_PROTOTYPE_SCOPE__SAFETY_RELATED, oldSafetyRelated, safetyRelated, !oldSafetyRelatedESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetSafetyRelated()
  {
    Boolean oldSafetyRelated = safetyRelated;
    boolean oldSafetyRelatedESet = safetyRelatedESet;
    safetyRelated = SAFETY_RELATED_EDEFAULT;
    safetyRelatedESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.HW_ELEMENT_PROTOTYPE_SCOPE__SAFETY_RELATED, oldSafetyRelated, SAFETY_RELATED_EDEFAULT, oldSafetyRelatedESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetSafetyRelated()
  {
    return safetyRelatedESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWPartFailureAnalysis getNameWasNotSet_2()
  {
    if (nameWasNotSet_2 != null && nameWasNotSet_2.eIsProxy())
    {
      InternalEObject oldNameWasNotSet_2 = (InternalEObject)nameWasNotSet_2;
      nameWasNotSet_2 = (HWPartFailureAnalysis)eResolveProxy(oldNameWasNotSet_2);
      if (nameWasNotSet_2 != oldNameWasNotSet_2)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.HW_ELEMENT_PROTOTYPE_SCOPE__NAME_WAS_NOT_SET_2, oldNameWasNotSet_2, nameWasNotSet_2));
      }
    }
    return nameWasNotSet_2;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWPartFailureAnalysis basicGetNameWasNotSet_2()
  {
    return nameWasNotSet_2;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetNameWasNotSet_2(HWPartFailureAnalysis newNameWasNotSet_2, NotificationChain msgs)
  {
    HWPartFailureAnalysis oldNameWasNotSet_2 = nameWasNotSet_2;
    nameWasNotSet_2 = newNameWasNotSet_2;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Safe10Package.HW_ELEMENT_PROTOTYPE_SCOPE__NAME_WAS_NOT_SET_2, oldNameWasNotSet_2, newNameWasNotSet_2);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setNameWasNotSet_2(HWPartFailureAnalysis newNameWasNotSet_2)
  {
    if (newNameWasNotSet_2 != nameWasNotSet_2)
    {
      NotificationChain msgs = null;
      if (nameWasNotSet_2 != null)
        msgs = ((InternalEObject)nameWasNotSet_2).eInverseRemove(this, Safe10Package.HW_PART_FAILURE_ANALYSIS__HW_ELEMENT_SCOPE, HWPartFailureAnalysis.class, msgs);
      if (newNameWasNotSet_2 != null)
        msgs = ((InternalEObject)newNameWasNotSet_2).eInverseAdd(this, Safe10Package.HW_PART_FAILURE_ANALYSIS__HW_ELEMENT_SCOPE, HWPartFailureAnalysis.class, msgs);
      msgs = basicSetNameWasNotSet_2(newNameWasNotSet_2, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HW_ELEMENT_PROTOTYPE_SCOPE__NAME_WAS_NOT_SET_2, newNameWasNotSet_2, newNameWasNotSet_2));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWElementScopeInstanceRef getScope()
  {
    if (scope != null && scope.eIsProxy())
    {
      InternalEObject oldScope = (InternalEObject)scope;
      scope = (HWElementScopeInstanceRef)eResolveProxy(oldScope);
      if (scope != oldScope)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.HW_ELEMENT_PROTOTYPE_SCOPE__SCOPE, oldScope, scope));
      }
    }
    return scope;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWElementScopeInstanceRef basicGetScope()
  {
    return scope;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setScope(HWElementScopeInstanceRef newScope)
  {
    HWElementScopeInstanceRef oldScope = scope;
    scope = newScope;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HW_ELEMENT_PROTOTYPE_SCOPE__SCOPE, oldScope, scope));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.HW_ELEMENT_PROTOTYPE_SCOPE__NAME_WAS_NOT_SET_2:
        if (nameWasNotSet_2 != null)
          msgs = ((InternalEObject)nameWasNotSet_2).eInverseRemove(this, Safe10Package.HW_PART_FAILURE_ANALYSIS__HW_ELEMENT_SCOPE, HWPartFailureAnalysis.class, msgs);
        return basicSetNameWasNotSet_2((HWPartFailureAnalysis)otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.HW_ELEMENT_PROTOTYPE_SCOPE__NAME_WAS_NOT_SET_2:
        return basicSetNameWasNotSet_2(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.HW_ELEMENT_PROTOTYPE_SCOPE__SAFETY_RELATED:
        return getSafetyRelated();
      case Safe10Package.HW_ELEMENT_PROTOTYPE_SCOPE__NAME_WAS_NOT_SET_2:
        if (resolve) return getNameWasNotSet_2();
        return basicGetNameWasNotSet_2();
      case Safe10Package.HW_ELEMENT_PROTOTYPE_SCOPE__SCOPE:
        if (resolve) return getScope();
        return basicGetScope();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.HW_ELEMENT_PROTOTYPE_SCOPE__SAFETY_RELATED:
   			setSafetyRelated((Boolean)newValue);
        return;
      case Safe10Package.HW_ELEMENT_PROTOTYPE_SCOPE__NAME_WAS_NOT_SET_2:
   			setNameWasNotSet_2((HWPartFailureAnalysis)newValue);
        return;
      case Safe10Package.HW_ELEMENT_PROTOTYPE_SCOPE__SCOPE:
   			setScope((HWElementScopeInstanceRef)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HW_ELEMENT_PROTOTYPE_SCOPE__SAFETY_RELATED:
        unsetSafetyRelated();
        return;
      case Safe10Package.HW_ELEMENT_PROTOTYPE_SCOPE__NAME_WAS_NOT_SET_2:
        	setNameWasNotSet_2((HWPartFailureAnalysis)null);
        return;
      case Safe10Package.HW_ELEMENT_PROTOTYPE_SCOPE__SCOPE:
        	setScope((HWElementScopeInstanceRef)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HW_ELEMENT_PROTOTYPE_SCOPE__SAFETY_RELATED:
        return isSetSafetyRelated();
      case Safe10Package.HW_ELEMENT_PROTOTYPE_SCOPE__NAME_WAS_NOT_SET_2:
        return nameWasNotSet_2 != null;
      case Safe10Package.HW_ELEMENT_PROTOTYPE_SCOPE__SCOPE:
        return scope != null;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (safetyRelated: ");
    if (safetyRelatedESet) result.append(safetyRelated); else result.append("<unset>");
    result.append(')');
    return result.toString();
  }

} //HWElementPrototypeScopeImpl
