/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.sphinx.emf.ecore.ExtendedEObjectImpl;

import org.safe.metamodel.safe10.HWFMSingleContribution;
import org.safe.metamodel.safe10.HWFMSingleContributionFormula;
import org.safe.metamodel.safe10.HWFault;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>HWFM Single Contribution</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWFMSingleContributionImpl#getLambdaMultiplePointFaultLatent <em>Lambda Multiple Point Fault Latent</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWFMSingleContributionImpl#getLambdaResidualFault <em>Lambda Residual Fault</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWFMSingleContributionImpl#getLambdaSafeFault <em>Lambda Safe Fault</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWFMSingleContributionImpl#getLambdaSafetyComponent <em>Lambda Safety Component</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWFMSingleContributionImpl#getLambdaSinglePointFault <em>Lambda Single Point Fault</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWFMSingleContributionImpl#getSafetyComponentClassName <em>Safety Component Class Name</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWFMSingleContributionImpl#getHwFMSCLambdaValue <em>Hw FMSC Lambda Value</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWFMSingleContributionImpl#getNameWasNotSet_4 <em>Name Was Not Set 4</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class HWFMSingleContributionImpl extends ExtendedEObjectImpl implements HWFMSingleContribution
{
  /**
   * The default value of the '{@link #getLambdaMultiplePointFaultLatent() <em>Lambda Multiple Point Fault Latent</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getLambdaMultiplePointFaultLatent()
   * @generated
   * @ordered
   */
  protected static final Double LAMBDA_MULTIPLE_POINT_FAULT_LATENT_EDEFAULT = new Double(0.0);

  /**
   * The cached value of the '{@link #getLambdaMultiplePointFaultLatent() <em>Lambda Multiple Point Fault Latent</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getLambdaMultiplePointFaultLatent()
   * @generated
   * @ordered
   */
  protected Double lambdaMultiplePointFaultLatent = LAMBDA_MULTIPLE_POINT_FAULT_LATENT_EDEFAULT;

  /**
   * This is true if the Lambda Multiple Point Fault Latent attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean lambdaMultiplePointFaultLatentESet;

  /**
   * The default value of the '{@link #getLambdaResidualFault() <em>Lambda Residual Fault</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getLambdaResidualFault()
   * @generated
   * @ordered
   */
  protected static final Double LAMBDA_RESIDUAL_FAULT_EDEFAULT = new Double(0.0);

  /**
   * The cached value of the '{@link #getLambdaResidualFault() <em>Lambda Residual Fault</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getLambdaResidualFault()
   * @generated
   * @ordered
   */
  protected Double lambdaResidualFault = LAMBDA_RESIDUAL_FAULT_EDEFAULT;

  /**
   * This is true if the Lambda Residual Fault attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean lambdaResidualFaultESet;

  /**
   * The default value of the '{@link #getLambdaSafeFault() <em>Lambda Safe Fault</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getLambdaSafeFault()
   * @generated
   * @ordered
   */
  protected static final Double LAMBDA_SAFE_FAULT_EDEFAULT = new Double(0.0);

  /**
   * The cached value of the '{@link #getLambdaSafeFault() <em>Lambda Safe Fault</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getLambdaSafeFault()
   * @generated
   * @ordered
   */
  protected Double lambdaSafeFault = LAMBDA_SAFE_FAULT_EDEFAULT;

  /**
   * This is true if the Lambda Safe Fault attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean lambdaSafeFaultESet;

  /**
   * The default value of the '{@link #getLambdaSafetyComponent() <em>Lambda Safety Component</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getLambdaSafetyComponent()
   * @generated
   * @ordered
   */
  protected static final Double LAMBDA_SAFETY_COMPONENT_EDEFAULT = new Double(0.0);

  /**
   * The cached value of the '{@link #getLambdaSafetyComponent() <em>Lambda Safety Component</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getLambdaSafetyComponent()
   * @generated
   * @ordered
   */
  protected Double lambdaSafetyComponent = LAMBDA_SAFETY_COMPONENT_EDEFAULT;

  /**
   * This is true if the Lambda Safety Component attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean lambdaSafetyComponentESet;

  /**
   * The default value of the '{@link #getLambdaSinglePointFault() <em>Lambda Single Point Fault</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getLambdaSinglePointFault()
   * @generated
   * @ordered
   */
  protected static final Double LAMBDA_SINGLE_POINT_FAULT_EDEFAULT = new Double(0.0);

  /**
   * The cached value of the '{@link #getLambdaSinglePointFault() <em>Lambda Single Point Fault</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getLambdaSinglePointFault()
   * @generated
   * @ordered
   */
  protected Double lambdaSinglePointFault = LAMBDA_SINGLE_POINT_FAULT_EDEFAULT;

  /**
   * This is true if the Lambda Single Point Fault attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean lambdaSinglePointFaultESet;

  /**
   * The default value of the '{@link #getSafetyComponentClassName() <em>Safety Component Class Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSafetyComponentClassName()
   * @generated
   * @ordered
   */
  protected static final String SAFETY_COMPONENT_CLASS_NAME_EDEFAULT = "";

  /**
   * The cached value of the '{@link #getSafetyComponentClassName() <em>Safety Component Class Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSafetyComponentClassName()
   * @generated
   * @ordered
   */
  protected String safetyComponentClassName = SAFETY_COMPONENT_CLASS_NAME_EDEFAULT;

  /**
   * This is true if the Safety Component Class Name attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean safetyComponentClassNameESet;

  /**
   * The cached value of the '{@link #getHwFMSCLambdaValue() <em>Hw FMSC Lambda Value</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHwFMSCLambdaValue()
   * @generated
   * @ordered
   */
  protected HWFMSingleContributionFormula hwFMSCLambdaValue;

  /**
   * The cached value of the '{@link #getNameWasNotSet_4() <em>Name Was Not Set 4</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNameWasNotSet_4()
   * @generated
   * @ordered
   */
  protected HWFault nameWasNotSet_4;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected HWFMSingleContributionImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getHWFMSingleContribution();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Double getLambdaMultiplePointFaultLatent()
  {
    return lambdaMultiplePointFaultLatent;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setLambdaMultiplePointFaultLatent(Double newLambdaMultiplePointFaultLatent)
  {
    Double oldLambdaMultiplePointFaultLatent = lambdaMultiplePointFaultLatent;
    lambdaMultiplePointFaultLatent = newLambdaMultiplePointFaultLatent;
    boolean oldLambdaMultiplePointFaultLatentESet = lambdaMultiplePointFaultLatentESet;
    lambdaMultiplePointFaultLatentESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HWFM_SINGLE_CONTRIBUTION__LAMBDA_MULTIPLE_POINT_FAULT_LATENT, oldLambdaMultiplePointFaultLatent, lambdaMultiplePointFaultLatent, !oldLambdaMultiplePointFaultLatentESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetLambdaMultiplePointFaultLatent()
  {
    Double oldLambdaMultiplePointFaultLatent = lambdaMultiplePointFaultLatent;
    boolean oldLambdaMultiplePointFaultLatentESet = lambdaMultiplePointFaultLatentESet;
    lambdaMultiplePointFaultLatent = LAMBDA_MULTIPLE_POINT_FAULT_LATENT_EDEFAULT;
    lambdaMultiplePointFaultLatentESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.HWFM_SINGLE_CONTRIBUTION__LAMBDA_MULTIPLE_POINT_FAULT_LATENT, oldLambdaMultiplePointFaultLatent, LAMBDA_MULTIPLE_POINT_FAULT_LATENT_EDEFAULT, oldLambdaMultiplePointFaultLatentESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetLambdaMultiplePointFaultLatent()
  {
    return lambdaMultiplePointFaultLatentESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Double getLambdaResidualFault()
  {
    return lambdaResidualFault;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setLambdaResidualFault(Double newLambdaResidualFault)
  {
    Double oldLambdaResidualFault = lambdaResidualFault;
    lambdaResidualFault = newLambdaResidualFault;
    boolean oldLambdaResidualFaultESet = lambdaResidualFaultESet;
    lambdaResidualFaultESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HWFM_SINGLE_CONTRIBUTION__LAMBDA_RESIDUAL_FAULT, oldLambdaResidualFault, lambdaResidualFault, !oldLambdaResidualFaultESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetLambdaResidualFault()
  {
    Double oldLambdaResidualFault = lambdaResidualFault;
    boolean oldLambdaResidualFaultESet = lambdaResidualFaultESet;
    lambdaResidualFault = LAMBDA_RESIDUAL_FAULT_EDEFAULT;
    lambdaResidualFaultESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.HWFM_SINGLE_CONTRIBUTION__LAMBDA_RESIDUAL_FAULT, oldLambdaResidualFault, LAMBDA_RESIDUAL_FAULT_EDEFAULT, oldLambdaResidualFaultESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetLambdaResidualFault()
  {
    return lambdaResidualFaultESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Double getLambdaSafeFault()
  {
    return lambdaSafeFault;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setLambdaSafeFault(Double newLambdaSafeFault)
  {
    Double oldLambdaSafeFault = lambdaSafeFault;
    lambdaSafeFault = newLambdaSafeFault;
    boolean oldLambdaSafeFaultESet = lambdaSafeFaultESet;
    lambdaSafeFaultESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HWFM_SINGLE_CONTRIBUTION__LAMBDA_SAFE_FAULT, oldLambdaSafeFault, lambdaSafeFault, !oldLambdaSafeFaultESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetLambdaSafeFault()
  {
    Double oldLambdaSafeFault = lambdaSafeFault;
    boolean oldLambdaSafeFaultESet = lambdaSafeFaultESet;
    lambdaSafeFault = LAMBDA_SAFE_FAULT_EDEFAULT;
    lambdaSafeFaultESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.HWFM_SINGLE_CONTRIBUTION__LAMBDA_SAFE_FAULT, oldLambdaSafeFault, LAMBDA_SAFE_FAULT_EDEFAULT, oldLambdaSafeFaultESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetLambdaSafeFault()
  {
    return lambdaSafeFaultESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Double getLambdaSafetyComponent()
  {
    return lambdaSafetyComponent;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setLambdaSafetyComponent(Double newLambdaSafetyComponent)
  {
    Double oldLambdaSafetyComponent = lambdaSafetyComponent;
    lambdaSafetyComponent = newLambdaSafetyComponent;
    boolean oldLambdaSafetyComponentESet = lambdaSafetyComponentESet;
    lambdaSafetyComponentESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HWFM_SINGLE_CONTRIBUTION__LAMBDA_SAFETY_COMPONENT, oldLambdaSafetyComponent, lambdaSafetyComponent, !oldLambdaSafetyComponentESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetLambdaSafetyComponent()
  {
    Double oldLambdaSafetyComponent = lambdaSafetyComponent;
    boolean oldLambdaSafetyComponentESet = lambdaSafetyComponentESet;
    lambdaSafetyComponent = LAMBDA_SAFETY_COMPONENT_EDEFAULT;
    lambdaSafetyComponentESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.HWFM_SINGLE_CONTRIBUTION__LAMBDA_SAFETY_COMPONENT, oldLambdaSafetyComponent, LAMBDA_SAFETY_COMPONENT_EDEFAULT, oldLambdaSafetyComponentESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetLambdaSafetyComponent()
  {
    return lambdaSafetyComponentESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Double getLambdaSinglePointFault()
  {
    return lambdaSinglePointFault;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setLambdaSinglePointFault(Double newLambdaSinglePointFault)
  {
    Double oldLambdaSinglePointFault = lambdaSinglePointFault;
    lambdaSinglePointFault = newLambdaSinglePointFault;
    boolean oldLambdaSinglePointFaultESet = lambdaSinglePointFaultESet;
    lambdaSinglePointFaultESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HWFM_SINGLE_CONTRIBUTION__LAMBDA_SINGLE_POINT_FAULT, oldLambdaSinglePointFault, lambdaSinglePointFault, !oldLambdaSinglePointFaultESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetLambdaSinglePointFault()
  {
    Double oldLambdaSinglePointFault = lambdaSinglePointFault;
    boolean oldLambdaSinglePointFaultESet = lambdaSinglePointFaultESet;
    lambdaSinglePointFault = LAMBDA_SINGLE_POINT_FAULT_EDEFAULT;
    lambdaSinglePointFaultESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.HWFM_SINGLE_CONTRIBUTION__LAMBDA_SINGLE_POINT_FAULT, oldLambdaSinglePointFault, LAMBDA_SINGLE_POINT_FAULT_EDEFAULT, oldLambdaSinglePointFaultESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetLambdaSinglePointFault()
  {
    return lambdaSinglePointFaultESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getSafetyComponentClassName()
  {
    return safetyComponentClassName;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setSafetyComponentClassName(String newSafetyComponentClassName)
  {
    String oldSafetyComponentClassName = safetyComponentClassName;
    safetyComponentClassName = newSafetyComponentClassName;
    boolean oldSafetyComponentClassNameESet = safetyComponentClassNameESet;
    safetyComponentClassNameESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HWFM_SINGLE_CONTRIBUTION__SAFETY_COMPONENT_CLASS_NAME, oldSafetyComponentClassName, safetyComponentClassName, !oldSafetyComponentClassNameESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetSafetyComponentClassName()
  {
    String oldSafetyComponentClassName = safetyComponentClassName;
    boolean oldSafetyComponentClassNameESet = safetyComponentClassNameESet;
    safetyComponentClassName = SAFETY_COMPONENT_CLASS_NAME_EDEFAULT;
    safetyComponentClassNameESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.HWFM_SINGLE_CONTRIBUTION__SAFETY_COMPONENT_CLASS_NAME, oldSafetyComponentClassName, SAFETY_COMPONENT_CLASS_NAME_EDEFAULT, oldSafetyComponentClassNameESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetSafetyComponentClassName()
  {
    return safetyComponentClassNameESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWFMSingleContributionFormula getHwFMSCLambdaValue()
  {
    return hwFMSCLambdaValue;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetHwFMSCLambdaValue(HWFMSingleContributionFormula newHwFMSCLambdaValue, NotificationChain msgs)
  {
    HWFMSingleContributionFormula oldHwFMSCLambdaValue = hwFMSCLambdaValue;
    hwFMSCLambdaValue = newHwFMSCLambdaValue;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Safe10Package.HWFM_SINGLE_CONTRIBUTION__HW_FMSC_LAMBDA_VALUE, oldHwFMSCLambdaValue, newHwFMSCLambdaValue);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setHwFMSCLambdaValue(HWFMSingleContributionFormula newHwFMSCLambdaValue)
  {
    if (newHwFMSCLambdaValue != hwFMSCLambdaValue)
    {
      NotificationChain msgs = null;
      if (hwFMSCLambdaValue != null)
        msgs = ((InternalEObject)hwFMSCLambdaValue).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Safe10Package.HWFM_SINGLE_CONTRIBUTION__HW_FMSC_LAMBDA_VALUE, null, msgs);
      if (newHwFMSCLambdaValue != null)
        msgs = ((InternalEObject)newHwFMSCLambdaValue).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - Safe10Package.HWFM_SINGLE_CONTRIBUTION__HW_FMSC_LAMBDA_VALUE, null, msgs);
      msgs = basicSetHwFMSCLambdaValue(newHwFMSCLambdaValue, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HWFM_SINGLE_CONTRIBUTION__HW_FMSC_LAMBDA_VALUE, newHwFMSCLambdaValue, newHwFMSCLambdaValue));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWFault getNameWasNotSet_4()
  {
    if (nameWasNotSet_4 != null && nameWasNotSet_4.eIsProxy())
    {
      InternalEObject oldNameWasNotSet_4 = (InternalEObject)nameWasNotSet_4;
      nameWasNotSet_4 = (HWFault)eResolveProxy(oldNameWasNotSet_4);
      if (nameWasNotSet_4 != oldNameWasNotSet_4)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.HWFM_SINGLE_CONTRIBUTION__NAME_WAS_NOT_SET_4, oldNameWasNotSet_4, nameWasNotSet_4));
      }
    }
    return nameWasNotSet_4;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWFault basicGetNameWasNotSet_4()
  {
    return nameWasNotSet_4;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetNameWasNotSet_4(HWFault newNameWasNotSet_4, NotificationChain msgs)
  {
    HWFault oldNameWasNotSet_4 = nameWasNotSet_4;
    nameWasNotSet_4 = newNameWasNotSet_4;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Safe10Package.HWFM_SINGLE_CONTRIBUTION__NAME_WAS_NOT_SET_4, oldNameWasNotSet_4, newNameWasNotSet_4);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setNameWasNotSet_4(HWFault newNameWasNotSet_4)
  {
    if (newNameWasNotSet_4 != nameWasNotSet_4)
    {
      NotificationChain msgs = null;
      if (nameWasNotSet_4 != null)
        msgs = ((InternalEObject)nameWasNotSet_4).eInverseRemove(this, Safe10Package.HW_FAULT__HW_FAILURE_MODE_SINGLE_CONTRIBUTION, HWFault.class, msgs);
      if (newNameWasNotSet_4 != null)
        msgs = ((InternalEObject)newNameWasNotSet_4).eInverseAdd(this, Safe10Package.HW_FAULT__HW_FAILURE_MODE_SINGLE_CONTRIBUTION, HWFault.class, msgs);
      msgs = basicSetNameWasNotSet_4(newNameWasNotSet_4, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HWFM_SINGLE_CONTRIBUTION__NAME_WAS_NOT_SET_4, newNameWasNotSet_4, newNameWasNotSet_4));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION__NAME_WAS_NOT_SET_4:
        if (nameWasNotSet_4 != null)
          msgs = ((InternalEObject)nameWasNotSet_4).eInverseRemove(this, Safe10Package.HW_FAULT__HW_FAILURE_MODE_SINGLE_CONTRIBUTION, HWFault.class, msgs);
        return basicSetNameWasNotSet_4((HWFault)otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION__HW_FMSC_LAMBDA_VALUE:
        return basicSetHwFMSCLambdaValue(null, msgs);
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION__NAME_WAS_NOT_SET_4:
        return basicSetNameWasNotSet_4(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION__LAMBDA_MULTIPLE_POINT_FAULT_LATENT:
        return getLambdaMultiplePointFaultLatent();
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION__LAMBDA_RESIDUAL_FAULT:
        return getLambdaResidualFault();
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION__LAMBDA_SAFE_FAULT:
        return getLambdaSafeFault();
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION__LAMBDA_SAFETY_COMPONENT:
        return getLambdaSafetyComponent();
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION__LAMBDA_SINGLE_POINT_FAULT:
        return getLambdaSinglePointFault();
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION__SAFETY_COMPONENT_CLASS_NAME:
        return getSafetyComponentClassName();
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION__HW_FMSC_LAMBDA_VALUE:
        return getHwFMSCLambdaValue();
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION__NAME_WAS_NOT_SET_4:
        if (resolve) return getNameWasNotSet_4();
        return basicGetNameWasNotSet_4();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION__LAMBDA_MULTIPLE_POINT_FAULT_LATENT:
   			setLambdaMultiplePointFaultLatent((Double)newValue);
        return;
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION__LAMBDA_RESIDUAL_FAULT:
   			setLambdaResidualFault((Double)newValue);
        return;
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION__LAMBDA_SAFE_FAULT:
   			setLambdaSafeFault((Double)newValue);
        return;
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION__LAMBDA_SAFETY_COMPONENT:
   			setLambdaSafetyComponent((Double)newValue);
        return;
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION__LAMBDA_SINGLE_POINT_FAULT:
   			setLambdaSinglePointFault((Double)newValue);
        return;
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION__SAFETY_COMPONENT_CLASS_NAME:
   			setSafetyComponentClassName((String)newValue);
        return;
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION__HW_FMSC_LAMBDA_VALUE:
   			setHwFMSCLambdaValue((HWFMSingleContributionFormula)newValue);
        return;
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION__NAME_WAS_NOT_SET_4:
   			setNameWasNotSet_4((HWFault)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION__LAMBDA_MULTIPLE_POINT_FAULT_LATENT:
        unsetLambdaMultiplePointFaultLatent();
        return;
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION__LAMBDA_RESIDUAL_FAULT:
        unsetLambdaResidualFault();
        return;
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION__LAMBDA_SAFE_FAULT:
        unsetLambdaSafeFault();
        return;
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION__LAMBDA_SAFETY_COMPONENT:
        unsetLambdaSafetyComponent();
        return;
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION__LAMBDA_SINGLE_POINT_FAULT:
        unsetLambdaSinglePointFault();
        return;
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION__SAFETY_COMPONENT_CLASS_NAME:
        unsetSafetyComponentClassName();
        return;
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION__HW_FMSC_LAMBDA_VALUE:
        	setHwFMSCLambdaValue((HWFMSingleContributionFormula)null);
        return;
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION__NAME_WAS_NOT_SET_4:
        	setNameWasNotSet_4((HWFault)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION__LAMBDA_MULTIPLE_POINT_FAULT_LATENT:
        return isSetLambdaMultiplePointFaultLatent();
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION__LAMBDA_RESIDUAL_FAULT:
        return isSetLambdaResidualFault();
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION__LAMBDA_SAFE_FAULT:
        return isSetLambdaSafeFault();
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION__LAMBDA_SAFETY_COMPONENT:
        return isSetLambdaSafetyComponent();
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION__LAMBDA_SINGLE_POINT_FAULT:
        return isSetLambdaSinglePointFault();
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION__SAFETY_COMPONENT_CLASS_NAME:
        return isSetSafetyComponentClassName();
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION__HW_FMSC_LAMBDA_VALUE:
        return hwFMSCLambdaValue != null;
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION__NAME_WAS_NOT_SET_4:
        return nameWasNotSet_4 != null;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (lambdaMultiplePointFaultLatent: ");
    if (lambdaMultiplePointFaultLatentESet) result.append(lambdaMultiplePointFaultLatent); else result.append("<unset>");
    result.append(", lambdaResidualFault: ");
    if (lambdaResidualFaultESet) result.append(lambdaResidualFault); else result.append("<unset>");
    result.append(", lambdaSafeFault: ");
    if (lambdaSafeFaultESet) result.append(lambdaSafeFault); else result.append("<unset>");
    result.append(", lambdaSafetyComponent: ");
    if (lambdaSafetyComponentESet) result.append(lambdaSafetyComponent); else result.append("<unset>");
    result.append(", lambdaSinglePointFault: ");
    if (lambdaSinglePointFaultESet) result.append(lambdaSinglePointFault); else result.append("<unset>");
    result.append(", safetyComponentClassName: ");
    if (safetyComponentClassNameESet) result.append(safetyComponentClassName); else result.append("<unset>");
    result.append(')');
    return result.toString();
  }

} //HWFMSingleContributionImpl
