/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.safe.metamodel.safe10.HWComponentQuantifiedFMFromPart;
import org.safe.metamodel.safe10.HWElementPrototypeScope;
import org.safe.metamodel.safe10.HWPartFailureAnalysis;
import org.safe.metamodel.safe10.MalfunctionInstanceRef;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>HW Part Failure Analysis</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWPartFailureAnalysisImpl#getMalfunctionPartAnalysis <em>Malfunction Part Analysis</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWPartFailureAnalysisImpl#getHwElementScope <em>Hw Element Scope</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWPartFailureAnalysisImpl#getQuantifiedHardwareFMFromPart <em>Quantified Hardware FM From Part</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class HWPartFailureAnalysisImpl extends IdentifiableImpl implements HWPartFailureAnalysis
{
  /**
   * The cached value of the '{@link #getMalfunctionPartAnalysis() <em>Malfunction Part Analysis</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMalfunctionPartAnalysis()
   * @generated
   * @ordered
   */
  protected MalfunctionInstanceRef malfunctionPartAnalysis;

  /**
   * The cached value of the '{@link #getHwElementScope() <em>Hw Element Scope</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHwElementScope()
   * @generated
   * @ordered
   */
  protected EList<HWElementPrototypeScope> hwElementScope;

  /**
   * The cached value of the '{@link #getQuantifiedHardwareFMFromPart() <em>Quantified Hardware FM From Part</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getQuantifiedHardwareFMFromPart()
   * @generated
   * @ordered
   */
  protected HWComponentQuantifiedFMFromPart quantifiedHardwareFMFromPart;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected HWPartFailureAnalysisImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getHWPartFailureAnalysis();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MalfunctionInstanceRef getMalfunctionPartAnalysis()
  {
    return malfunctionPartAnalysis;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetMalfunctionPartAnalysis(MalfunctionInstanceRef newMalfunctionPartAnalysis, NotificationChain msgs)
  {
    MalfunctionInstanceRef oldMalfunctionPartAnalysis = malfunctionPartAnalysis;
    malfunctionPartAnalysis = newMalfunctionPartAnalysis;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Safe10Package.HW_PART_FAILURE_ANALYSIS__MALFUNCTION_PART_ANALYSIS, oldMalfunctionPartAnalysis, newMalfunctionPartAnalysis);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setMalfunctionPartAnalysis(MalfunctionInstanceRef newMalfunctionPartAnalysis)
  {
    if (newMalfunctionPartAnalysis != malfunctionPartAnalysis)
    {
      NotificationChain msgs = null;
      if (malfunctionPartAnalysis != null)
        msgs = ((InternalEObject)malfunctionPartAnalysis).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Safe10Package.HW_PART_FAILURE_ANALYSIS__MALFUNCTION_PART_ANALYSIS, null, msgs);
      if (newMalfunctionPartAnalysis != null)
        msgs = ((InternalEObject)newMalfunctionPartAnalysis).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - Safe10Package.HW_PART_FAILURE_ANALYSIS__MALFUNCTION_PART_ANALYSIS, null, msgs);
      msgs = basicSetMalfunctionPartAnalysis(newMalfunctionPartAnalysis, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HW_PART_FAILURE_ANALYSIS__MALFUNCTION_PART_ANALYSIS, newMalfunctionPartAnalysis, newMalfunctionPartAnalysis));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<HWElementPrototypeScope> getHwElementScope()
  {
    if (hwElementScope == null)
    {
      hwElementScope = new EObjectWithInverseResolvingEList<HWElementPrototypeScope>(HWElementPrototypeScope.class, this, Safe10Package.HW_PART_FAILURE_ANALYSIS__HW_ELEMENT_SCOPE, Safe10Package.HW_ELEMENT_PROTOTYPE_SCOPE__NAME_WAS_NOT_SET_2);
    }
    return hwElementScope;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWComponentQuantifiedFMFromPart getQuantifiedHardwareFMFromPart()
  {
    if (quantifiedHardwareFMFromPart != null && quantifiedHardwareFMFromPart.eIsProxy())
    {
      InternalEObject oldQuantifiedHardwareFMFromPart = (InternalEObject)quantifiedHardwareFMFromPart;
      quantifiedHardwareFMFromPart = (HWComponentQuantifiedFMFromPart)eResolveProxy(oldQuantifiedHardwareFMFromPart);
      if (quantifiedHardwareFMFromPart != oldQuantifiedHardwareFMFromPart)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.HW_PART_FAILURE_ANALYSIS__QUANTIFIED_HARDWARE_FM_FROM_PART, oldQuantifiedHardwareFMFromPart, quantifiedHardwareFMFromPart));
      }
    }
    return quantifiedHardwareFMFromPart;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWComponentQuantifiedFMFromPart basicGetQuantifiedHardwareFMFromPart()
  {
    return quantifiedHardwareFMFromPart;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setQuantifiedHardwareFMFromPart(HWComponentQuantifiedFMFromPart newQuantifiedHardwareFMFromPart)
  {
    HWComponentQuantifiedFMFromPart oldQuantifiedHardwareFMFromPart = quantifiedHardwareFMFromPart;
    quantifiedHardwareFMFromPart = newQuantifiedHardwareFMFromPart;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HW_PART_FAILURE_ANALYSIS__QUANTIFIED_HARDWARE_FM_FROM_PART, oldQuantifiedHardwareFMFromPart, quantifiedHardwareFMFromPart));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.HW_PART_FAILURE_ANALYSIS__HW_ELEMENT_SCOPE:
        return ((InternalEList<InternalEObject>)(InternalEList<?>)getHwElementScope()).basicAdd(otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.HW_PART_FAILURE_ANALYSIS__MALFUNCTION_PART_ANALYSIS:
        return basicSetMalfunctionPartAnalysis(null, msgs);
      case Safe10Package.HW_PART_FAILURE_ANALYSIS__HW_ELEMENT_SCOPE:
        return ((InternalEList<?>)getHwElementScope()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.HW_PART_FAILURE_ANALYSIS__MALFUNCTION_PART_ANALYSIS:
        return getMalfunctionPartAnalysis();
      case Safe10Package.HW_PART_FAILURE_ANALYSIS__HW_ELEMENT_SCOPE:
        return getHwElementScope();
      case Safe10Package.HW_PART_FAILURE_ANALYSIS__QUANTIFIED_HARDWARE_FM_FROM_PART:
        if (resolve) return getQuantifiedHardwareFMFromPart();
        return basicGetQuantifiedHardwareFMFromPart();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.HW_PART_FAILURE_ANALYSIS__MALFUNCTION_PART_ANALYSIS:
   			setMalfunctionPartAnalysis((MalfunctionInstanceRef)newValue);
        return;
      case Safe10Package.HW_PART_FAILURE_ANALYSIS__HW_ELEMENT_SCOPE:
        getHwElementScope().clear();
        getHwElementScope().addAll((Collection<? extends HWElementPrototypeScope>)newValue);
        return;
      case Safe10Package.HW_PART_FAILURE_ANALYSIS__QUANTIFIED_HARDWARE_FM_FROM_PART:
   			setQuantifiedHardwareFMFromPart((HWComponentQuantifiedFMFromPart)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HW_PART_FAILURE_ANALYSIS__MALFUNCTION_PART_ANALYSIS:
        	setMalfunctionPartAnalysis((MalfunctionInstanceRef)null);
        return;
      case Safe10Package.HW_PART_FAILURE_ANALYSIS__HW_ELEMENT_SCOPE:
        getHwElementScope().clear();
        return;
      case Safe10Package.HW_PART_FAILURE_ANALYSIS__QUANTIFIED_HARDWARE_FM_FROM_PART:
        	setQuantifiedHardwareFMFromPart((HWComponentQuantifiedFMFromPart)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HW_PART_FAILURE_ANALYSIS__MALFUNCTION_PART_ANALYSIS:
        return malfunctionPartAnalysis != null;
      case Safe10Package.HW_PART_FAILURE_ANALYSIS__HW_ELEMENT_SCOPE:
        return hwElementScope != null && !hwElementScope.isEmpty();
      case Safe10Package.HW_PART_FAILURE_ANALYSIS__QUANTIFIED_HARDWARE_FM_FROM_PART:
        return quantifiedHardwareFMFromPart != null;
    }
    return super.eIsSet(featureID);
  }

} //HWPartFailureAnalysisImpl
