/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.safe.metamodel.safe10.AutosarHardwareSafetyExtension;
import org.safe.metamodel.safe10.HWPartFailure;
import org.safe.metamodel.safe10.HWPartFailureMode;
import org.safe.metamodel.safe10.HWPartFailureRate;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>HW Part Failure</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWPartFailureImpl#getNameWasNotSet_3 <em>Name Was Not Set 3</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWPartFailureImpl#getHwPartFailureMode <em>Hw Part Failure Mode</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWPartFailureImpl#getHwPartFailureRate <em>Hw Part Failure Rate</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class HWPartFailureImpl extends IdentifiableImpl implements HWPartFailure
{
  /**
   * The cached value of the '{@link #getNameWasNotSet_3() <em>Name Was Not Set 3</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNameWasNotSet_3()
   * @generated
   * @ordered
   */
  protected AutosarHardwareSafetyExtension nameWasNotSet_3;

  /**
   * The cached value of the '{@link #getHwPartFailureMode() <em>Hw Part Failure Mode</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHwPartFailureMode()
   * @generated
   * @ordered
   */
  protected EList<HWPartFailureMode> hwPartFailureMode;

  /**
   * The cached value of the '{@link #getHwPartFailureRate() <em>Hw Part Failure Rate</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHwPartFailureRate()
   * @generated
   * @ordered
   */
  protected HWPartFailureRate hwPartFailureRate;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected HWPartFailureImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getHWPartFailure();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AutosarHardwareSafetyExtension getNameWasNotSet_3()
  {
    if (nameWasNotSet_3 != null && nameWasNotSet_3.eIsProxy())
    {
      InternalEObject oldNameWasNotSet_3 = (InternalEObject)nameWasNotSet_3;
      nameWasNotSet_3 = (AutosarHardwareSafetyExtension)eResolveProxy(oldNameWasNotSet_3);
      if (nameWasNotSet_3 != oldNameWasNotSet_3)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.HW_PART_FAILURE__NAME_WAS_NOT_SET_3, oldNameWasNotSet_3, nameWasNotSet_3));
      }
    }
    return nameWasNotSet_3;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AutosarHardwareSafetyExtension basicGetNameWasNotSet_3()
  {
    return nameWasNotSet_3;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetNameWasNotSet_3(AutosarHardwareSafetyExtension newNameWasNotSet_3, NotificationChain msgs)
  {
    AutosarHardwareSafetyExtension oldNameWasNotSet_3 = nameWasNotSet_3;
    nameWasNotSet_3 = newNameWasNotSet_3;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Safe10Package.HW_PART_FAILURE__NAME_WAS_NOT_SET_3, oldNameWasNotSet_3, newNameWasNotSet_3);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setNameWasNotSet_3(AutosarHardwareSafetyExtension newNameWasNotSet_3)
  {
    if (newNameWasNotSet_3 != nameWasNotSet_3)
    {
      NotificationChain msgs = null;
      if (nameWasNotSet_3 != null)
        msgs = ((InternalEObject)nameWasNotSet_3).eInverseRemove(this, Safe10Package.AUTOSAR_HARDWARE_SAFETY_EXTENSION__RAMDOM_HARDWARE_PART_FAILURE, AutosarHardwareSafetyExtension.class, msgs);
      if (newNameWasNotSet_3 != null)
        msgs = ((InternalEObject)newNameWasNotSet_3).eInverseAdd(this, Safe10Package.AUTOSAR_HARDWARE_SAFETY_EXTENSION__RAMDOM_HARDWARE_PART_FAILURE, AutosarHardwareSafetyExtension.class, msgs);
      msgs = basicSetNameWasNotSet_3(newNameWasNotSet_3, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HW_PART_FAILURE__NAME_WAS_NOT_SET_3, newNameWasNotSet_3, newNameWasNotSet_3));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<HWPartFailureMode> getHwPartFailureMode()
  {
    if (hwPartFailureMode == null)
    {
      hwPartFailureMode = new EObjectContainmentEList<HWPartFailureMode>(HWPartFailureMode.class, this, Safe10Package.HW_PART_FAILURE__HW_PART_FAILURE_MODE);
    }
    return hwPartFailureMode;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWPartFailureRate getHwPartFailureRate()
  {
    return hwPartFailureRate;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetHwPartFailureRate(HWPartFailureRate newHwPartFailureRate, NotificationChain msgs)
  {
    HWPartFailureRate oldHwPartFailureRate = hwPartFailureRate;
    hwPartFailureRate = newHwPartFailureRate;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Safe10Package.HW_PART_FAILURE__HW_PART_FAILURE_RATE, oldHwPartFailureRate, newHwPartFailureRate);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setHwPartFailureRate(HWPartFailureRate newHwPartFailureRate)
  {
    if (newHwPartFailureRate != hwPartFailureRate)
    {
      NotificationChain msgs = null;
      if (hwPartFailureRate != null)
        msgs = ((InternalEObject)hwPartFailureRate).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Safe10Package.HW_PART_FAILURE__HW_PART_FAILURE_RATE, null, msgs);
      if (newHwPartFailureRate != null)
        msgs = ((InternalEObject)newHwPartFailureRate).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - Safe10Package.HW_PART_FAILURE__HW_PART_FAILURE_RATE, null, msgs);
      msgs = basicSetHwPartFailureRate(newHwPartFailureRate, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HW_PART_FAILURE__HW_PART_FAILURE_RATE, newHwPartFailureRate, newHwPartFailureRate));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.HW_PART_FAILURE__NAME_WAS_NOT_SET_3:
        if (nameWasNotSet_3 != null)
          msgs = ((InternalEObject)nameWasNotSet_3).eInverseRemove(this, Safe10Package.AUTOSAR_HARDWARE_SAFETY_EXTENSION__RAMDOM_HARDWARE_PART_FAILURE, AutosarHardwareSafetyExtension.class, msgs);
        return basicSetNameWasNotSet_3((AutosarHardwareSafetyExtension)otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.HW_PART_FAILURE__NAME_WAS_NOT_SET_3:
        return basicSetNameWasNotSet_3(null, msgs);
      case Safe10Package.HW_PART_FAILURE__HW_PART_FAILURE_MODE:
        return ((InternalEList<?>)getHwPartFailureMode()).basicRemove(otherEnd, msgs);
      case Safe10Package.HW_PART_FAILURE__HW_PART_FAILURE_RATE:
        return basicSetHwPartFailureRate(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.HW_PART_FAILURE__NAME_WAS_NOT_SET_3:
        if (resolve) return getNameWasNotSet_3();
        return basicGetNameWasNotSet_3();
      case Safe10Package.HW_PART_FAILURE__HW_PART_FAILURE_MODE:
        return getHwPartFailureMode();
      case Safe10Package.HW_PART_FAILURE__HW_PART_FAILURE_RATE:
        return getHwPartFailureRate();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.HW_PART_FAILURE__NAME_WAS_NOT_SET_3:
   			setNameWasNotSet_3((AutosarHardwareSafetyExtension)newValue);
        return;
      case Safe10Package.HW_PART_FAILURE__HW_PART_FAILURE_MODE:
        getHwPartFailureMode().clear();
        getHwPartFailureMode().addAll((Collection<? extends HWPartFailureMode>)newValue);
        return;
      case Safe10Package.HW_PART_FAILURE__HW_PART_FAILURE_RATE:
   			setHwPartFailureRate((HWPartFailureRate)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HW_PART_FAILURE__NAME_WAS_NOT_SET_3:
        	setNameWasNotSet_3((AutosarHardwareSafetyExtension)null);
        return;
      case Safe10Package.HW_PART_FAILURE__HW_PART_FAILURE_MODE:
        getHwPartFailureMode().clear();
        return;
      case Safe10Package.HW_PART_FAILURE__HW_PART_FAILURE_RATE:
        	setHwPartFailureRate((HWPartFailureRate)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HW_PART_FAILURE__NAME_WAS_NOT_SET_3:
        return nameWasNotSet_3 != null;
      case Safe10Package.HW_PART_FAILURE__HW_PART_FAILURE_MODE:
        return hwPartFailureMode != null && !hwPartFailureMode.isEmpty();
      case Safe10Package.HW_PART_FAILURE__HW_PART_FAILURE_RATE:
        return hwPartFailureRate != null;
    }
    return super.eIsSet(featureID);
  }

} //HWPartFailureImpl
