/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.sphinx.emf.ecore.ExtendedEObjectImpl;

import org.safe.metamodel.safe10.HWSinglePointFaultMetric;
import org.safe.metamodel.safe10.HWSinglePointFaultMetricFormula;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>HW Single Point Fault Metric</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWSinglePointFaultMetricImpl#getCalculatedValue <em>Calculated Value</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HWSinglePointFaultMetricImpl#getSpfmCalculatedValue <em>Spfm Calculated Value</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class HWSinglePointFaultMetricImpl extends ExtendedEObjectImpl implements HWSinglePointFaultMetric
{
  /**
   * The default value of the '{@link #getCalculatedValue() <em>Calculated Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCalculatedValue()
   * @generated
   * @ordered
   */
  protected static final Double CALCULATED_VALUE_EDEFAULT = new Double(0.0);

  /**
   * The cached value of the '{@link #getCalculatedValue() <em>Calculated Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCalculatedValue()
   * @generated
   * @ordered
   */
  protected Double calculatedValue = CALCULATED_VALUE_EDEFAULT;

  /**
   * This is true if the Calculated Value attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean calculatedValueESet;

  /**
   * The cached value of the '{@link #getSpfmCalculatedValue() <em>Spfm Calculated Value</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSpfmCalculatedValue()
   * @generated
   * @ordered
   */
  protected HWSinglePointFaultMetricFormula spfmCalculatedValue;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected HWSinglePointFaultMetricImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getHWSinglePointFaultMetric();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Double getCalculatedValue()
  {
    return calculatedValue;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setCalculatedValue(Double newCalculatedValue)
  {
    Double oldCalculatedValue = calculatedValue;
    calculatedValue = newCalculatedValue;
    boolean oldCalculatedValueESet = calculatedValueESet;
    calculatedValueESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HW_SINGLE_POINT_FAULT_METRIC__CALCULATED_VALUE, oldCalculatedValue, calculatedValue, !oldCalculatedValueESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetCalculatedValue()
  {
    Double oldCalculatedValue = calculatedValue;
    boolean oldCalculatedValueESet = calculatedValueESet;
    calculatedValue = CALCULATED_VALUE_EDEFAULT;
    calculatedValueESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.HW_SINGLE_POINT_FAULT_METRIC__CALCULATED_VALUE, oldCalculatedValue, CALCULATED_VALUE_EDEFAULT, oldCalculatedValueESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetCalculatedValue()
  {
    return calculatedValueESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWSinglePointFaultMetricFormula getSpfmCalculatedValue()
  {
    return spfmCalculatedValue;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetSpfmCalculatedValue(HWSinglePointFaultMetricFormula newSpfmCalculatedValue, NotificationChain msgs)
  {
    HWSinglePointFaultMetricFormula oldSpfmCalculatedValue = spfmCalculatedValue;
    spfmCalculatedValue = newSpfmCalculatedValue;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Safe10Package.HW_SINGLE_POINT_FAULT_METRIC__SPFM_CALCULATED_VALUE, oldSpfmCalculatedValue, newSpfmCalculatedValue);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setSpfmCalculatedValue(HWSinglePointFaultMetricFormula newSpfmCalculatedValue)
  {
    if (newSpfmCalculatedValue != spfmCalculatedValue)
    {
      NotificationChain msgs = null;
      if (spfmCalculatedValue != null)
        msgs = ((InternalEObject)spfmCalculatedValue).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Safe10Package.HW_SINGLE_POINT_FAULT_METRIC__SPFM_CALCULATED_VALUE, null, msgs);
      if (newSpfmCalculatedValue != null)
        msgs = ((InternalEObject)newSpfmCalculatedValue).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - Safe10Package.HW_SINGLE_POINT_FAULT_METRIC__SPFM_CALCULATED_VALUE, null, msgs);
      msgs = basicSetSpfmCalculatedValue(newSpfmCalculatedValue, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HW_SINGLE_POINT_FAULT_METRIC__SPFM_CALCULATED_VALUE, newSpfmCalculatedValue, newSpfmCalculatedValue));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.HW_SINGLE_POINT_FAULT_METRIC__SPFM_CALCULATED_VALUE:
        return basicSetSpfmCalculatedValue(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.HW_SINGLE_POINT_FAULT_METRIC__CALCULATED_VALUE:
        return getCalculatedValue();
      case Safe10Package.HW_SINGLE_POINT_FAULT_METRIC__SPFM_CALCULATED_VALUE:
        return getSpfmCalculatedValue();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.HW_SINGLE_POINT_FAULT_METRIC__CALCULATED_VALUE:
   			setCalculatedValue((Double)newValue);
        return;
      case Safe10Package.HW_SINGLE_POINT_FAULT_METRIC__SPFM_CALCULATED_VALUE:
   			setSpfmCalculatedValue((HWSinglePointFaultMetricFormula)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HW_SINGLE_POINT_FAULT_METRIC__CALCULATED_VALUE:
        unsetCalculatedValue();
        return;
      case Safe10Package.HW_SINGLE_POINT_FAULT_METRIC__SPFM_CALCULATED_VALUE:
        	setSpfmCalculatedValue((HWSinglePointFaultMetricFormula)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HW_SINGLE_POINT_FAULT_METRIC__CALCULATED_VALUE:
        return isSetCalculatedValue();
      case Safe10Package.HW_SINGLE_POINT_FAULT_METRIC__SPFM_CALCULATED_VALUE:
        return spfmCalculatedValue != null;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (calculatedValue: ");
    if (calculatedValueESet) result.append(calculatedValue); else result.append("<unset>");
    result.append(')');
    return result.toString();
  }

} //HWSinglePointFaultMetricImpl
