/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.safe.metamodel.safe10.HWComponentPrototypeScope;
import org.safe.metamodel.safe10.HWQuantitativeFailureAnalysis;
import org.safe.metamodel.safe10.HardwareFailureAnalysis;
import org.safe.metamodel.safe10.MalfunctionInstanceRef;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Hardware Failure Analysis</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.HardwareFailureAnalysisImpl#getMalfunctionAnalysis <em>Malfunction Analysis</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HardwareFailureAnalysisImpl#getHWComponentScope <em>HW Component Scope</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HardwareFailureAnalysisImpl#getHardwareQuantifiedAnalysis <em>Hardware Quantified Analysis</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class HardwareFailureAnalysisImpl extends IdentifiableImpl implements HardwareFailureAnalysis
{
  /**
   * The cached value of the '{@link #getMalfunctionAnalysis() <em>Malfunction Analysis</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMalfunctionAnalysis()
   * @generated
   * @ordered
   */
  protected MalfunctionInstanceRef malfunctionAnalysis;

  /**
   * The cached value of the '{@link #getHWComponentScope() <em>HW Component Scope</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHWComponentScope()
   * @generated
   * @ordered
   */
  protected EList<HWComponentPrototypeScope> hWComponentScope;

  /**
   * The cached value of the '{@link #getHardwareQuantifiedAnalysis() <em>Hardware Quantified Analysis</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHardwareQuantifiedAnalysis()
   * @generated
   * @ordered
   */
  protected HWQuantitativeFailureAnalysis hardwareQuantifiedAnalysis;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected HardwareFailureAnalysisImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getHardwareFailureAnalysis();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MalfunctionInstanceRef getMalfunctionAnalysis()
  {
    return malfunctionAnalysis;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetMalfunctionAnalysis(MalfunctionInstanceRef newMalfunctionAnalysis, NotificationChain msgs)
  {
    MalfunctionInstanceRef oldMalfunctionAnalysis = malfunctionAnalysis;
    malfunctionAnalysis = newMalfunctionAnalysis;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Safe10Package.HARDWARE_FAILURE_ANALYSIS__MALFUNCTION_ANALYSIS, oldMalfunctionAnalysis, newMalfunctionAnalysis);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setMalfunctionAnalysis(MalfunctionInstanceRef newMalfunctionAnalysis)
  {
    if (newMalfunctionAnalysis != malfunctionAnalysis)
    {
      NotificationChain msgs = null;
      if (malfunctionAnalysis != null)
        msgs = ((InternalEObject)malfunctionAnalysis).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Safe10Package.HARDWARE_FAILURE_ANALYSIS__MALFUNCTION_ANALYSIS, null, msgs);
      if (newMalfunctionAnalysis != null)
        msgs = ((InternalEObject)newMalfunctionAnalysis).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - Safe10Package.HARDWARE_FAILURE_ANALYSIS__MALFUNCTION_ANALYSIS, null, msgs);
      msgs = basicSetMalfunctionAnalysis(newMalfunctionAnalysis, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HARDWARE_FAILURE_ANALYSIS__MALFUNCTION_ANALYSIS, newMalfunctionAnalysis, newMalfunctionAnalysis));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<HWComponentPrototypeScope> getHWComponentScope()
  {
    if (hWComponentScope == null)
    {
      hWComponentScope = new EObjectWithInverseResolvingEList<HWComponentPrototypeScope>(HWComponentPrototypeScope.class, this, Safe10Package.HARDWARE_FAILURE_ANALYSIS__HW_COMPONENT_SCOPE, Safe10Package.HW_COMPONENT_PROTOTYPE_SCOPE__NAME_WAS_NOT_SET_0);
    }
    return hWComponentScope;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWQuantitativeFailureAnalysis getHardwareQuantifiedAnalysis()
  {
    if (hardwareQuantifiedAnalysis != null && hardwareQuantifiedAnalysis.eIsProxy())
    {
      InternalEObject oldHardwareQuantifiedAnalysis = (InternalEObject)hardwareQuantifiedAnalysis;
      hardwareQuantifiedAnalysis = (HWQuantitativeFailureAnalysis)eResolveProxy(oldHardwareQuantifiedAnalysis);
      if (hardwareQuantifiedAnalysis != oldHardwareQuantifiedAnalysis)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.HARDWARE_FAILURE_ANALYSIS__HARDWARE_QUANTIFIED_ANALYSIS, oldHardwareQuantifiedAnalysis, hardwareQuantifiedAnalysis));
      }
    }
    return hardwareQuantifiedAnalysis;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HWQuantitativeFailureAnalysis basicGetHardwareQuantifiedAnalysis()
  {
    return hardwareQuantifiedAnalysis;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetHardwareQuantifiedAnalysis(HWQuantitativeFailureAnalysis newHardwareQuantifiedAnalysis, NotificationChain msgs)
  {
    HWQuantitativeFailureAnalysis oldHardwareQuantifiedAnalysis = hardwareQuantifiedAnalysis;
    hardwareQuantifiedAnalysis = newHardwareQuantifiedAnalysis;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Safe10Package.HARDWARE_FAILURE_ANALYSIS__HARDWARE_QUANTIFIED_ANALYSIS, oldHardwareQuantifiedAnalysis, newHardwareQuantifiedAnalysis);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setHardwareQuantifiedAnalysis(HWQuantitativeFailureAnalysis newHardwareQuantifiedAnalysis)
  {
    if (newHardwareQuantifiedAnalysis != hardwareQuantifiedAnalysis)
    {
      NotificationChain msgs = null;
      if (hardwareQuantifiedAnalysis != null)
        msgs = ((InternalEObject)hardwareQuantifiedAnalysis).eInverseRemove(this, Safe10Package.HW_QUANTITATIVE_FAILURE_ANALYSIS__NAME_WAS_NOT_SET_5, HWQuantitativeFailureAnalysis.class, msgs);
      if (newHardwareQuantifiedAnalysis != null)
        msgs = ((InternalEObject)newHardwareQuantifiedAnalysis).eInverseAdd(this, Safe10Package.HW_QUANTITATIVE_FAILURE_ANALYSIS__NAME_WAS_NOT_SET_5, HWQuantitativeFailureAnalysis.class, msgs);
      msgs = basicSetHardwareQuantifiedAnalysis(newHardwareQuantifiedAnalysis, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HARDWARE_FAILURE_ANALYSIS__HARDWARE_QUANTIFIED_ANALYSIS, newHardwareQuantifiedAnalysis, newHardwareQuantifiedAnalysis));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.HARDWARE_FAILURE_ANALYSIS__HW_COMPONENT_SCOPE:
        return ((InternalEList<InternalEObject>)(InternalEList<?>)getHWComponentScope()).basicAdd(otherEnd, msgs);
      case Safe10Package.HARDWARE_FAILURE_ANALYSIS__HARDWARE_QUANTIFIED_ANALYSIS:
        if (hardwareQuantifiedAnalysis != null)
          msgs = ((InternalEObject)hardwareQuantifiedAnalysis).eInverseRemove(this, Safe10Package.HW_QUANTITATIVE_FAILURE_ANALYSIS__NAME_WAS_NOT_SET_5, HWQuantitativeFailureAnalysis.class, msgs);
        return basicSetHardwareQuantifiedAnalysis((HWQuantitativeFailureAnalysis)otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.HARDWARE_FAILURE_ANALYSIS__MALFUNCTION_ANALYSIS:
        return basicSetMalfunctionAnalysis(null, msgs);
      case Safe10Package.HARDWARE_FAILURE_ANALYSIS__HW_COMPONENT_SCOPE:
        return ((InternalEList<?>)getHWComponentScope()).basicRemove(otherEnd, msgs);
      case Safe10Package.HARDWARE_FAILURE_ANALYSIS__HARDWARE_QUANTIFIED_ANALYSIS:
        return basicSetHardwareQuantifiedAnalysis(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.HARDWARE_FAILURE_ANALYSIS__MALFUNCTION_ANALYSIS:
        return getMalfunctionAnalysis();
      case Safe10Package.HARDWARE_FAILURE_ANALYSIS__HW_COMPONENT_SCOPE:
        return getHWComponentScope();
      case Safe10Package.HARDWARE_FAILURE_ANALYSIS__HARDWARE_QUANTIFIED_ANALYSIS:
        if (resolve) return getHardwareQuantifiedAnalysis();
        return basicGetHardwareQuantifiedAnalysis();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.HARDWARE_FAILURE_ANALYSIS__MALFUNCTION_ANALYSIS:
   			setMalfunctionAnalysis((MalfunctionInstanceRef)newValue);
        return;
      case Safe10Package.HARDWARE_FAILURE_ANALYSIS__HW_COMPONENT_SCOPE:
        getHWComponentScope().clear();
        getHWComponentScope().addAll((Collection<? extends HWComponentPrototypeScope>)newValue);
        return;
      case Safe10Package.HARDWARE_FAILURE_ANALYSIS__HARDWARE_QUANTIFIED_ANALYSIS:
   			setHardwareQuantifiedAnalysis((HWQuantitativeFailureAnalysis)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HARDWARE_FAILURE_ANALYSIS__MALFUNCTION_ANALYSIS:
        	setMalfunctionAnalysis((MalfunctionInstanceRef)null);
        return;
      case Safe10Package.HARDWARE_FAILURE_ANALYSIS__HW_COMPONENT_SCOPE:
        getHWComponentScope().clear();
        return;
      case Safe10Package.HARDWARE_FAILURE_ANALYSIS__HARDWARE_QUANTIFIED_ANALYSIS:
        	setHardwareQuantifiedAnalysis((HWQuantitativeFailureAnalysis)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HARDWARE_FAILURE_ANALYSIS__MALFUNCTION_ANALYSIS:
        return malfunctionAnalysis != null;
      case Safe10Package.HARDWARE_FAILURE_ANALYSIS__HW_COMPONENT_SCOPE:
        return hWComponentScope != null && !hWComponentScope.isEmpty();
      case Safe10Package.HARDWARE_FAILURE_ANALYSIS__HARDWARE_QUANTIFIED_ANALYSIS:
        return hardwareQuantifiedAnalysis != null;
    }
    return super.eIsSet(featureID);
  }

} //HardwareFailureAnalysisImpl
