/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eatop.eel.eastadl21.HardwareComponentType;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.safe.metamodel.safe10.HardwareComponentFailure;
import org.safe.metamodel.safe10.HardwareFailureAnalysis;
import org.safe.metamodel.safe10.HardwareSafetyExtension;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Hardware Safety Extension</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.HardwareSafetyExtensionImpl#getScope <em>Scope</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HardwareSafetyExtensionImpl#getHardwareSafetyAnalysis <em>Hardware Safety Analysis</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HardwareSafetyExtensionImpl#getRandomHardwareFailure <em>Random Hardware Failure</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class HardwareSafetyExtensionImpl extends TechnicalSafetyExtensionImpl implements HardwareSafetyExtension
{
  /**
   * The cached value of the '{@link #getScope() <em>Scope</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getScope()
   * @generated
   * @ordered
   */
  protected HardwareComponentType scope;

  /**
   * The cached value of the '{@link #getHardwareSafetyAnalysis() <em>Hardware Safety Analysis</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHardwareSafetyAnalysis()
   * @generated
   * @ordered
   */
  protected EList<HardwareFailureAnalysis> hardwareSafetyAnalysis;

  /**
   * The cached value of the '{@link #getRandomHardwareFailure() <em>Random Hardware Failure</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRandomHardwareFailure()
   * @generated
   * @ordered
   */
  protected HardwareComponentFailure randomHardwareFailure;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected HardwareSafetyExtensionImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getHardwareSafetyExtension();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HardwareComponentType getScope()
  {
    if (scope != null && scope.eIsProxy())
    {
      InternalEObject oldScope = (InternalEObject)scope;
      scope = (HardwareComponentType)eResolveProxy(oldScope);
      if (scope != oldScope)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.HARDWARE_SAFETY_EXTENSION__SCOPE, oldScope, scope));
      }
    }
    return scope;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HardwareComponentType basicGetScope()
  {
    return scope;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setScope(HardwareComponentType newScope)
  {
    HardwareComponentType oldScope = scope;
    scope = newScope;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HARDWARE_SAFETY_EXTENSION__SCOPE, oldScope, scope));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<HardwareFailureAnalysis> getHardwareSafetyAnalysis()
  {
    if (hardwareSafetyAnalysis == null)
    {
      hardwareSafetyAnalysis = new EObjectContainmentEList<HardwareFailureAnalysis>(HardwareFailureAnalysis.class, this, Safe10Package.HARDWARE_SAFETY_EXTENSION__HARDWARE_SAFETY_ANALYSIS);
    }
    return hardwareSafetyAnalysis;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HardwareComponentFailure getRandomHardwareFailure()
  {
    return randomHardwareFailure;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetRandomHardwareFailure(HardwareComponentFailure newRandomHardwareFailure, NotificationChain msgs)
  {
    HardwareComponentFailure oldRandomHardwareFailure = randomHardwareFailure;
    randomHardwareFailure = newRandomHardwareFailure;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Safe10Package.HARDWARE_SAFETY_EXTENSION__RANDOM_HARDWARE_FAILURE, oldRandomHardwareFailure, newRandomHardwareFailure);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setRandomHardwareFailure(HardwareComponentFailure newRandomHardwareFailure)
  {
    if (newRandomHardwareFailure != randomHardwareFailure)
    {
      NotificationChain msgs = null;
      if (randomHardwareFailure != null)
        msgs = ((InternalEObject)randomHardwareFailure).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Safe10Package.HARDWARE_SAFETY_EXTENSION__RANDOM_HARDWARE_FAILURE, null, msgs);
      if (newRandomHardwareFailure != null)
        msgs = ((InternalEObject)newRandomHardwareFailure).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - Safe10Package.HARDWARE_SAFETY_EXTENSION__RANDOM_HARDWARE_FAILURE, null, msgs);
      msgs = basicSetRandomHardwareFailure(newRandomHardwareFailure, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HARDWARE_SAFETY_EXTENSION__RANDOM_HARDWARE_FAILURE, newRandomHardwareFailure, newRandomHardwareFailure));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.HARDWARE_SAFETY_EXTENSION__HARDWARE_SAFETY_ANALYSIS:
        return ((InternalEList<?>)getHardwareSafetyAnalysis()).basicRemove(otherEnd, msgs);
      case Safe10Package.HARDWARE_SAFETY_EXTENSION__RANDOM_HARDWARE_FAILURE:
        return basicSetRandomHardwareFailure(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.HARDWARE_SAFETY_EXTENSION__SCOPE:
        if (resolve) return getScope();
        return basicGetScope();
      case Safe10Package.HARDWARE_SAFETY_EXTENSION__HARDWARE_SAFETY_ANALYSIS:
        return getHardwareSafetyAnalysis();
      case Safe10Package.HARDWARE_SAFETY_EXTENSION__RANDOM_HARDWARE_FAILURE:
        return getRandomHardwareFailure();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.HARDWARE_SAFETY_EXTENSION__SCOPE:
   			setScope((HardwareComponentType)newValue);
        return;
      case Safe10Package.HARDWARE_SAFETY_EXTENSION__HARDWARE_SAFETY_ANALYSIS:
        getHardwareSafetyAnalysis().clear();
        getHardwareSafetyAnalysis().addAll((Collection<? extends HardwareFailureAnalysis>)newValue);
        return;
      case Safe10Package.HARDWARE_SAFETY_EXTENSION__RANDOM_HARDWARE_FAILURE:
   			setRandomHardwareFailure((HardwareComponentFailure)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HARDWARE_SAFETY_EXTENSION__SCOPE:
        	setScope((HardwareComponentType)null);
        return;
      case Safe10Package.HARDWARE_SAFETY_EXTENSION__HARDWARE_SAFETY_ANALYSIS:
        getHardwareSafetyAnalysis().clear();
        return;
      case Safe10Package.HARDWARE_SAFETY_EXTENSION__RANDOM_HARDWARE_FAILURE:
        	setRandomHardwareFailure((HardwareComponentFailure)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HARDWARE_SAFETY_EXTENSION__SCOPE:
        return scope != null;
      case Safe10Package.HARDWARE_SAFETY_EXTENSION__HARDWARE_SAFETY_ANALYSIS:
        return hardwareSafetyAnalysis != null && !hardwareSafetyAnalysis.isEmpty();
      case Safe10Package.HARDWARE_SAFETY_EXTENSION__RANDOM_HARDWARE_FAILURE:
        return randomHardwareFailure != null;
    }
    return super.eIsSet(featureID);
  }

} //HardwareSafetyExtensionImpl
