/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.safe.metamodel.safe10.HardwareSafetyRequirement;
import org.safe.metamodel.safe10.QuantifiedHWProperty;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Hardware Safety Requirement</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.HardwareSafetyRequirementImpl#getQuantifiedProperty <em>Quantified Property</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class HardwareSafetyRequirementImpl extends AbstractQuantifiableSafetyRequirementImpl implements HardwareSafetyRequirement
{
  /**
   * The cached value of the '{@link #getQuantifiedProperty() <em>Quantified Property</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getQuantifiedProperty()
   * @generated
   * @ordered
   */
  protected EList<QuantifiedHWProperty> quantifiedProperty;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected HardwareSafetyRequirementImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getHardwareSafetyRequirement();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<QuantifiedHWProperty> getQuantifiedProperty()
  {
    if (quantifiedProperty == null)
    {
      quantifiedProperty = new EObjectContainmentEList<QuantifiedHWProperty>(QuantifiedHWProperty.class, this, Safe10Package.HARDWARE_SAFETY_REQUIREMENT__QUANTIFIED_PROPERTY);
    }
    return quantifiedProperty;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.HARDWARE_SAFETY_REQUIREMENT__QUANTIFIED_PROPERTY:
        return ((InternalEList<?>)getQuantifiedProperty()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.HARDWARE_SAFETY_REQUIREMENT__QUANTIFIED_PROPERTY:
        return getQuantifiedProperty();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.HARDWARE_SAFETY_REQUIREMENT__QUANTIFIED_PROPERTY:
        getQuantifiedProperty().clear();
        getQuantifiedProperty().addAll((Collection<? extends QuantifiedHWProperty>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HARDWARE_SAFETY_REQUIREMENT__QUANTIFIED_PROPERTY:
        getQuantifiedProperty().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HARDWARE_SAFETY_REQUIREMENT__QUANTIFIED_PROPERTY:
        return quantifiedProperty != null && !quantifiedProperty.isEmpty();
    }
    return super.eIsSet(featureID);
  }

} //HardwareSafetyRequirementImpl
