/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.safe.metamodel.safe10.HardwareSoftwareInterfaceElement;
import org.safe.metamodel.safe10.HardwareSoftwareInterfaceSpecification;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Hardware Software Interface Specification</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.HardwareSoftwareInterfaceSpecificationImpl#getHSIElements <em>HSI Elements</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class HardwareSoftwareInterfaceSpecificationImpl extends IdentifiableImpl implements HardwareSoftwareInterfaceSpecification
{
  /**
   * The cached value of the '{@link #getHSIElements() <em>HSI Elements</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHSIElements()
   * @generated
   * @ordered
   */
  protected EList<HardwareSoftwareInterfaceElement> hSIElements;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected HardwareSoftwareInterfaceSpecificationImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getHardwareSoftwareInterfaceSpecification();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<HardwareSoftwareInterfaceElement> getHSIElements()
  {
    if (hSIElements == null)
    {
      hSIElements = new EObjectContainmentEList<HardwareSoftwareInterfaceElement>(HardwareSoftwareInterfaceElement.class, this, Safe10Package.HARDWARE_SOFTWARE_INTERFACE_SPECIFICATION__HSI_ELEMENTS);
    }
    return hSIElements;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.HARDWARE_SOFTWARE_INTERFACE_SPECIFICATION__HSI_ELEMENTS:
        return ((InternalEList<?>)getHSIElements()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.HARDWARE_SOFTWARE_INTERFACE_SPECIFICATION__HSI_ELEMENTS:
        return getHSIElements();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.HARDWARE_SOFTWARE_INTERFACE_SPECIFICATION__HSI_ELEMENTS:
        getHSIElements().clear();
        getHSIElements().addAll((Collection<? extends HardwareSoftwareInterfaceElement>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HARDWARE_SOFTWARE_INTERFACE_SPECIFICATION__HSI_ELEMENTS:
        getHSIElements().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HARDWARE_SOFTWARE_INTERFACE_SPECIFICATION__HSI_ELEMENTS:
        return hSIElements != null && !hSIElements.isEmpty();
    }
    return super.eIsSet(featureID);
  }

} //HardwareSoftwareInterfaceSpecificationImpl
