/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eatop.eel.eastadl21.FeatureModel;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.safe.metamodel.safe10.Actor;
import org.safe.metamodel.safe10.ControllabilityReference;
import org.safe.metamodel.safe10.FunctionalSafetyRequirement;
import org.safe.metamodel.safe10.Hazard;
import org.safe.metamodel.safe10.HazardandRiskSafetyExtension;
import org.safe.metamodel.safe10.HazardousEvent;
import org.safe.metamodel.safe10.Item;
import org.safe.metamodel.safe10.OperationalSituation;
import org.safe.metamodel.safe10.RiskDescription;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Hazardand Risk Safety Extension</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.HazardandRiskSafetyExtensionImpl#getScope <em>Scope</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HazardandRiskSafetyExtensionImpl#getActor <em>Actor</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HazardandRiskSafetyExtensionImpl#getControllability <em>Controllability</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HazardandRiskSafetyExtensionImpl#getHazard <em>Hazard</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HazardandRiskSafetyExtensionImpl#getHazardousEvent <em>Hazardous Event</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HazardandRiskSafetyExtensionImpl#getItem <em>Item</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HazardandRiskSafetyExtensionImpl#getOperationalSituation <em>Operational Situation</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HazardandRiskSafetyExtensionImpl#getRisk <em>Risk</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HazardandRiskSafetyExtensionImpl#getSafetyGoal <em>Safety Goal</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class HazardandRiskSafetyExtensionImpl extends SingleLevelSafetyExtensionImpl implements HazardandRiskSafetyExtension
{
  /**
   * The cached value of the '{@link #getScope() <em>Scope</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getScope()
   * @generated
   * @ordered
   */
  protected FeatureModel scope;

  /**
   * The cached value of the '{@link #getActor() <em>Actor</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getActor()
   * @generated
   * @ordered
   */
  protected EList<Actor> actor;

  /**
   * The cached value of the '{@link #getControllability() <em>Controllability</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getControllability()
   * @generated
   * @ordered
   */
  protected EList<ControllabilityReference> controllability;

  /**
   * The cached value of the '{@link #getHazard() <em>Hazard</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHazard()
   * @generated
   * @ordered
   */
  protected EList<Hazard> hazard;

  /**
   * The cached value of the '{@link #getHazardousEvent() <em>Hazardous Event</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHazardousEvent()
   * @generated
   * @ordered
   */
  protected EList<HazardousEvent> hazardousEvent;

  /**
   * The cached value of the '{@link #getItem() <em>Item</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getItem()
   * @generated
   * @ordered
   */
  protected EList<Item> item;

  /**
   * The cached value of the '{@link #getOperationalSituation() <em>Operational Situation</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getOperationalSituation()
   * @generated
   * @ordered
   */
  protected EList<OperationalSituation> operationalSituation;

  /**
   * The cached value of the '{@link #getRisk() <em>Risk</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRisk()
   * @generated
   * @ordered
   */
  protected EList<RiskDescription> risk;

  /**
   * The cached value of the '{@link #getSafetyGoal() <em>Safety Goal</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSafetyGoal()
   * @generated
   * @ordered
   */
  protected EList<FunctionalSafetyRequirement> safetyGoal;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected HazardandRiskSafetyExtensionImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getHazardandRiskSafetyExtension();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FeatureModel getScope()
  {
    if (scope != null && scope.eIsProxy())
    {
      InternalEObject oldScope = (InternalEObject)scope;
      scope = (FeatureModel)eResolveProxy(oldScope);
      if (scope != oldScope)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__SCOPE, oldScope, scope));
      }
    }
    return scope;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FeatureModel basicGetScope()
  {
    return scope;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setScope(FeatureModel newScope)
  {
    FeatureModel oldScope = scope;
    scope = newScope;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__SCOPE, oldScope, scope));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Actor> getActor()
  {
    if (actor == null)
    {
      actor = new EObjectContainmentEList<Actor>(Actor.class, this, Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__ACTOR);
    }
    return actor;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<ControllabilityReference> getControllability()
  {
    if (controllability == null)
    {
      controllability = new EObjectContainmentEList<ControllabilityReference>(ControllabilityReference.class, this, Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__CONTROLLABILITY);
    }
    return controllability;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Hazard> getHazard()
  {
    if (hazard == null)
    {
      hazard = new EObjectContainmentEList<Hazard>(Hazard.class, this, Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__HAZARD);
    }
    return hazard;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<HazardousEvent> getHazardousEvent()
  {
    if (hazardousEvent == null)
    {
      hazardousEvent = new EObjectContainmentEList<HazardousEvent>(HazardousEvent.class, this, Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__HAZARDOUS_EVENT);
    }
    return hazardousEvent;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Item> getItem()
  {
    if (item == null)
    {
      item = new EObjectContainmentEList<Item>(Item.class, this, Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__ITEM);
    }
    return item;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<OperationalSituation> getOperationalSituation()
  {
    if (operationalSituation == null)
    {
      operationalSituation = new EObjectContainmentEList<OperationalSituation>(OperationalSituation.class, this, Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__OPERATIONAL_SITUATION);
    }
    return operationalSituation;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<RiskDescription> getRisk()
  {
    if (risk == null)
    {
      risk = new EObjectContainmentEList<RiskDescription>(RiskDescription.class, this, Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__RISK);
    }
    return risk;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<FunctionalSafetyRequirement> getSafetyGoal()
  {
    if (safetyGoal == null)
    {
      safetyGoal = new EObjectContainmentEList<FunctionalSafetyRequirement>(FunctionalSafetyRequirement.class, this, Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__SAFETY_GOAL);
    }
    return safetyGoal;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__ACTOR:
        return ((InternalEList<?>)getActor()).basicRemove(otherEnd, msgs);
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__CONTROLLABILITY:
        return ((InternalEList<?>)getControllability()).basicRemove(otherEnd, msgs);
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__HAZARD:
        return ((InternalEList<?>)getHazard()).basicRemove(otherEnd, msgs);
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__HAZARDOUS_EVENT:
        return ((InternalEList<?>)getHazardousEvent()).basicRemove(otherEnd, msgs);
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__ITEM:
        return ((InternalEList<?>)getItem()).basicRemove(otherEnd, msgs);
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__OPERATIONAL_SITUATION:
        return ((InternalEList<?>)getOperationalSituation()).basicRemove(otherEnd, msgs);
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__RISK:
        return ((InternalEList<?>)getRisk()).basicRemove(otherEnd, msgs);
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__SAFETY_GOAL:
        return ((InternalEList<?>)getSafetyGoal()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__SCOPE:
        if (resolve) return getScope();
        return basicGetScope();
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__ACTOR:
        return getActor();
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__CONTROLLABILITY:
        return getControllability();
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__HAZARD:
        return getHazard();
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__HAZARDOUS_EVENT:
        return getHazardousEvent();
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__ITEM:
        return getItem();
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__OPERATIONAL_SITUATION:
        return getOperationalSituation();
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__RISK:
        return getRisk();
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__SAFETY_GOAL:
        return getSafetyGoal();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__SCOPE:
   			setScope((FeatureModel)newValue);
        return;
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__ACTOR:
        getActor().clear();
        getActor().addAll((Collection<? extends Actor>)newValue);
        return;
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__CONTROLLABILITY:
        getControllability().clear();
        getControllability().addAll((Collection<? extends ControllabilityReference>)newValue);
        return;
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__HAZARD:
        getHazard().clear();
        getHazard().addAll((Collection<? extends Hazard>)newValue);
        return;
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__HAZARDOUS_EVENT:
        getHazardousEvent().clear();
        getHazardousEvent().addAll((Collection<? extends HazardousEvent>)newValue);
        return;
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__ITEM:
        getItem().clear();
        getItem().addAll((Collection<? extends Item>)newValue);
        return;
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__OPERATIONAL_SITUATION:
        getOperationalSituation().clear();
        getOperationalSituation().addAll((Collection<? extends OperationalSituation>)newValue);
        return;
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__RISK:
        getRisk().clear();
        getRisk().addAll((Collection<? extends RiskDescription>)newValue);
        return;
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__SAFETY_GOAL:
        getSafetyGoal().clear();
        getSafetyGoal().addAll((Collection<? extends FunctionalSafetyRequirement>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__SCOPE:
        	setScope((FeatureModel)null);
        return;
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__ACTOR:
        getActor().clear();
        return;
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__CONTROLLABILITY:
        getControllability().clear();
        return;
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__HAZARD:
        getHazard().clear();
        return;
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__HAZARDOUS_EVENT:
        getHazardousEvent().clear();
        return;
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__ITEM:
        getItem().clear();
        return;
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__OPERATIONAL_SITUATION:
        getOperationalSituation().clear();
        return;
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__RISK:
        getRisk().clear();
        return;
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__SAFETY_GOAL:
        getSafetyGoal().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__SCOPE:
        return scope != null;
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__ACTOR:
        return actor != null && !actor.isEmpty();
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__CONTROLLABILITY:
        return controllability != null && !controllability.isEmpty();
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__HAZARD:
        return hazard != null && !hazard.isEmpty();
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__HAZARDOUS_EVENT:
        return hazardousEvent != null && !hazardousEvent.isEmpty();
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__ITEM:
        return item != null && !item.isEmpty();
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__OPERATIONAL_SITUATION:
        return operationalSituation != null && !operationalSituation.isEmpty();
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__RISK:
        return risk != null && !risk.isEmpty();
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION__SAFETY_GOAL:
        return safetyGoal != null && !safetyGoal.isEmpty();
    }
    return super.eIsSet(featureID);
  }

} //HazardandRiskSafetyExtensionImpl
