/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectResolvingEList;

import org.safe.metamodel.safe10.ASILEnum;
import org.safe.metamodel.safe10.ControllabilityClassKind;
import org.safe.metamodel.safe10.ControllabilityReference;
import org.safe.metamodel.safe10.ExposureClassKind;
import org.safe.metamodel.safe10.FunctionalSafetyRequirement;
import org.safe.metamodel.safe10.Hazard;
import org.safe.metamodel.safe10.HazardousEvent;
import org.safe.metamodel.safe10.MalfunctionPrototype;
import org.safe.metamodel.safe10.OperationalSituation;
import org.safe.metamodel.safe10.Safe10Package;
import org.safe.metamodel.safe10.SeverityClassKind;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Hazardous Event</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.HazardousEventImpl#getConsequences <em>Consequences</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HazardousEventImpl#getHazardClassification <em>Hazard Classification</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HazardousEventImpl#getExposure <em>Exposure</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HazardousEventImpl#getSeverity <em>Severity</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HazardousEventImpl#getControllability <em>Controllability</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HazardousEventImpl#getSafetyGoal <em>Safety Goal</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HazardousEventImpl#getEnvironment <em>Environment</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HazardousEventImpl#getOperationalSituation <em>Operational Situation</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HazardousEventImpl#getTraffic <em>Traffic</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HazardousEventImpl#getControllabilityReference <em>Controllability Reference</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HazardousEventImpl#getHazard <em>Hazard</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.HazardousEventImpl#getContributor <em>Contributor</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class HazardousEventImpl extends IdentifiableImpl implements HazardousEvent
{
  /**
   * The default value of the '{@link #getConsequences() <em>Consequences</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getConsequences()
   * @generated
   * @ordered
   */
  protected static final String CONSEQUENCES_EDEFAULT = "";

  /**
   * The cached value of the '{@link #getConsequences() <em>Consequences</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getConsequences()
   * @generated
   * @ordered
   */
  protected String consequences = CONSEQUENCES_EDEFAULT;

  /**
   * This is true if the Consequences attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean consequencesESet;

  /**
   * The default value of the '{@link #getHazardClassification() <em>Hazard Classification</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHazardClassification()
   * @generated
   * @ordered
   */
  protected static final ASILEnum HAZARD_CLASSIFICATION_EDEFAULT = ASILEnum.ASIL_A;

  /**
   * The cached value of the '{@link #getHazardClassification() <em>Hazard Classification</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHazardClassification()
   * @generated
   * @ordered
   */
  protected ASILEnum hazardClassification = HAZARD_CLASSIFICATION_EDEFAULT;

  /**
   * This is true if the Hazard Classification attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean hazardClassificationESet;

  /**
   * The default value of the '{@link #getExposure() <em>Exposure</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getExposure()
   * @generated
   * @ordered
   */
  protected static final ExposureClassKind EXPOSURE_EDEFAULT = ExposureClassKind.E1;

  /**
   * The cached value of the '{@link #getExposure() <em>Exposure</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getExposure()
   * @generated
   * @ordered
   */
  protected ExposureClassKind exposure = EXPOSURE_EDEFAULT;

  /**
   * This is true if the Exposure attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean exposureESet;

  /**
   * The default value of the '{@link #getSeverity() <em>Severity</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSeverity()
   * @generated
   * @ordered
   */
  protected static final SeverityClassKind SEVERITY_EDEFAULT = SeverityClassKind.S0;

  /**
   * The cached value of the '{@link #getSeverity() <em>Severity</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSeverity()
   * @generated
   * @ordered
   */
  protected SeverityClassKind severity = SEVERITY_EDEFAULT;

  /**
   * This is true if the Severity attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean severityESet;

  /**
   * The default value of the '{@link #getControllability() <em>Controllability</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getControllability()
   * @generated
   * @ordered
   */
  protected static final ControllabilityClassKind CONTROLLABILITY_EDEFAULT = ControllabilityClassKind.C0;

  /**
   * The cached value of the '{@link #getControllability() <em>Controllability</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getControllability()
   * @generated
   * @ordered
   */
  protected ControllabilityClassKind controllability = CONTROLLABILITY_EDEFAULT;

  /**
   * This is true if the Controllability attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean controllabilityESet;

  /**
   * The cached value of the '{@link #getSafetyGoal() <em>Safety Goal</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSafetyGoal()
   * @generated
   * @ordered
   */
  protected EList<FunctionalSafetyRequirement> safetyGoal;

  /**
   * The cached value of the '{@link #getEnvironment() <em>Environment</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getEnvironment()
   * @generated
   * @ordered
   */
  protected EList<OperationalSituation> environment;

  /**
   * The cached value of the '{@link #getOperationalSituation() <em>Operational Situation</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getOperationalSituation()
   * @generated
   * @ordered
   */
  protected OperationalSituation operationalSituation;

  /**
   * The cached value of the '{@link #getTraffic() <em>Traffic</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTraffic()
   * @generated
   * @ordered
   */
  protected EList<OperationalSituation> traffic;

  /**
   * The cached value of the '{@link #getControllabilityReference() <em>Controllability Reference</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getControllabilityReference()
   * @generated
   * @ordered
   */
  protected ControllabilityReference controllabilityReference;

  /**
   * The cached value of the '{@link #getHazard() <em>Hazard</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHazard()
   * @generated
   * @ordered
   */
  protected Hazard hazard;

  /**
   * The cached value of the '{@link #getContributor() <em>Contributor</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getContributor()
   * @generated
   * @ordered
   */
  protected EList<MalfunctionPrototype> contributor;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected HazardousEventImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getHazardousEvent();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getConsequences()
  {
    return consequences;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setConsequences(String newConsequences)
  {
    String oldConsequences = consequences;
    consequences = newConsequences;
    boolean oldConsequencesESet = consequencesESet;
    consequencesESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HAZARDOUS_EVENT__CONSEQUENCES, oldConsequences, consequences, !oldConsequencesESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetConsequences()
  {
    String oldConsequences = consequences;
    boolean oldConsequencesESet = consequencesESet;
    consequences = CONSEQUENCES_EDEFAULT;
    consequencesESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.HAZARDOUS_EVENT__CONSEQUENCES, oldConsequences, CONSEQUENCES_EDEFAULT, oldConsequencesESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetConsequences()
  {
    return consequencesESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ASILEnum getHazardClassification()
  {
    return hazardClassification;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setHazardClassification(ASILEnum newHazardClassification)
  {
    ASILEnum oldHazardClassification = hazardClassification;
    hazardClassification = newHazardClassification == null ? HAZARD_CLASSIFICATION_EDEFAULT : newHazardClassification;
    boolean oldHazardClassificationESet = hazardClassificationESet;
    hazardClassificationESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HAZARDOUS_EVENT__HAZARD_CLASSIFICATION, oldHazardClassification, hazardClassification, !oldHazardClassificationESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetHazardClassification()
  {
    ASILEnum oldHazardClassification = hazardClassification;
    boolean oldHazardClassificationESet = hazardClassificationESet;
    hazardClassification = HAZARD_CLASSIFICATION_EDEFAULT;
    hazardClassificationESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.HAZARDOUS_EVENT__HAZARD_CLASSIFICATION, oldHazardClassification, HAZARD_CLASSIFICATION_EDEFAULT, oldHazardClassificationESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetHazardClassification()
  {
    return hazardClassificationESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ExposureClassKind getExposure()
  {
    return exposure;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setExposure(ExposureClassKind newExposure)
  {
    ExposureClassKind oldExposure = exposure;
    exposure = newExposure == null ? EXPOSURE_EDEFAULT : newExposure;
    boolean oldExposureESet = exposureESet;
    exposureESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HAZARDOUS_EVENT__EXPOSURE, oldExposure, exposure, !oldExposureESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetExposure()
  {
    ExposureClassKind oldExposure = exposure;
    boolean oldExposureESet = exposureESet;
    exposure = EXPOSURE_EDEFAULT;
    exposureESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.HAZARDOUS_EVENT__EXPOSURE, oldExposure, EXPOSURE_EDEFAULT, oldExposureESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetExposure()
  {
    return exposureESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SeverityClassKind getSeverity()
  {
    return severity;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setSeverity(SeverityClassKind newSeverity)
  {
    SeverityClassKind oldSeverity = severity;
    severity = newSeverity == null ? SEVERITY_EDEFAULT : newSeverity;
    boolean oldSeverityESet = severityESet;
    severityESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HAZARDOUS_EVENT__SEVERITY, oldSeverity, severity, !oldSeverityESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetSeverity()
  {
    SeverityClassKind oldSeverity = severity;
    boolean oldSeverityESet = severityESet;
    severity = SEVERITY_EDEFAULT;
    severityESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.HAZARDOUS_EVENT__SEVERITY, oldSeverity, SEVERITY_EDEFAULT, oldSeverityESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetSeverity()
  {
    return severityESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ControllabilityClassKind getControllability()
  {
    return controllability;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setControllability(ControllabilityClassKind newControllability)
  {
    ControllabilityClassKind oldControllability = controllability;
    controllability = newControllability == null ? CONTROLLABILITY_EDEFAULT : newControllability;
    boolean oldControllabilityESet = controllabilityESet;
    controllabilityESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HAZARDOUS_EVENT__CONTROLLABILITY, oldControllability, controllability, !oldControllabilityESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetControllability()
  {
    ControllabilityClassKind oldControllability = controllability;
    boolean oldControllabilityESet = controllabilityESet;
    controllability = CONTROLLABILITY_EDEFAULT;
    controllabilityESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.HAZARDOUS_EVENT__CONTROLLABILITY, oldControllability, CONTROLLABILITY_EDEFAULT, oldControllabilityESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetControllability()
  {
    return controllabilityESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<FunctionalSafetyRequirement> getSafetyGoal()
  {
    if (safetyGoal == null)
    {
      safetyGoal = new EObjectResolvingEList<FunctionalSafetyRequirement>(FunctionalSafetyRequirement.class, this, Safe10Package.HAZARDOUS_EVENT__SAFETY_GOAL);
    }
    return safetyGoal;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<OperationalSituation> getEnvironment()
  {
    if (environment == null)
    {
      environment = new EObjectResolvingEList<OperationalSituation>(OperationalSituation.class, this, Safe10Package.HAZARDOUS_EVENT__ENVIRONMENT);
    }
    return environment;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public OperationalSituation getOperationalSituation()
  {
    if (operationalSituation != null && operationalSituation.eIsProxy())
    {
      InternalEObject oldOperationalSituation = (InternalEObject)operationalSituation;
      operationalSituation = (OperationalSituation)eResolveProxy(oldOperationalSituation);
      if (operationalSituation != oldOperationalSituation)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.HAZARDOUS_EVENT__OPERATIONAL_SITUATION, oldOperationalSituation, operationalSituation));
      }
    }
    return operationalSituation;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public OperationalSituation basicGetOperationalSituation()
  {
    return operationalSituation;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setOperationalSituation(OperationalSituation newOperationalSituation)
  {
    OperationalSituation oldOperationalSituation = operationalSituation;
    operationalSituation = newOperationalSituation;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HAZARDOUS_EVENT__OPERATIONAL_SITUATION, oldOperationalSituation, operationalSituation));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<OperationalSituation> getTraffic()
  {
    if (traffic == null)
    {
      traffic = new EObjectResolvingEList<OperationalSituation>(OperationalSituation.class, this, Safe10Package.HAZARDOUS_EVENT__TRAFFIC);
    }
    return traffic;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ControllabilityReference getControllabilityReference()
  {
    if (controllabilityReference != null && controllabilityReference.eIsProxy())
    {
      InternalEObject oldControllabilityReference = (InternalEObject)controllabilityReference;
      controllabilityReference = (ControllabilityReference)eResolveProxy(oldControllabilityReference);
      if (controllabilityReference != oldControllabilityReference)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.HAZARDOUS_EVENT__CONTROLLABILITY_REFERENCE, oldControllabilityReference, controllabilityReference));
      }
    }
    return controllabilityReference;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ControllabilityReference basicGetControllabilityReference()
  {
    return controllabilityReference;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setControllabilityReference(ControllabilityReference newControllabilityReference)
  {
    ControllabilityReference oldControllabilityReference = controllabilityReference;
    controllabilityReference = newControllabilityReference;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HAZARDOUS_EVENT__CONTROLLABILITY_REFERENCE, oldControllabilityReference, controllabilityReference));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Hazard getHazard()
  {
    if (hazard != null && hazard.eIsProxy())
    {
      InternalEObject oldHazard = (InternalEObject)hazard;
      hazard = (Hazard)eResolveProxy(oldHazard);
      if (hazard != oldHazard)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.HAZARDOUS_EVENT__HAZARD, oldHazard, hazard));
      }
    }
    return hazard;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Hazard basicGetHazard()
  {
    return hazard;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setHazard(Hazard newHazard)
  {
    Hazard oldHazard = hazard;
    hazard = newHazard;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.HAZARDOUS_EVENT__HAZARD, oldHazard, hazard));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<MalfunctionPrototype> getContributor()
  {
    if (contributor == null)
    {
      contributor = new EObjectResolvingEList<MalfunctionPrototype>(MalfunctionPrototype.class, this, Safe10Package.HAZARDOUS_EVENT__CONTRIBUTOR);
    }
    return contributor;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.HAZARDOUS_EVENT__CONSEQUENCES:
        return getConsequences();
      case Safe10Package.HAZARDOUS_EVENT__HAZARD_CLASSIFICATION:
        return getHazardClassification();
      case Safe10Package.HAZARDOUS_EVENT__EXPOSURE:
        return getExposure();
      case Safe10Package.HAZARDOUS_EVENT__SEVERITY:
        return getSeverity();
      case Safe10Package.HAZARDOUS_EVENT__CONTROLLABILITY:
        return getControllability();
      case Safe10Package.HAZARDOUS_EVENT__SAFETY_GOAL:
        return getSafetyGoal();
      case Safe10Package.HAZARDOUS_EVENT__ENVIRONMENT:
        return getEnvironment();
      case Safe10Package.HAZARDOUS_EVENT__OPERATIONAL_SITUATION:
        if (resolve) return getOperationalSituation();
        return basicGetOperationalSituation();
      case Safe10Package.HAZARDOUS_EVENT__TRAFFIC:
        return getTraffic();
      case Safe10Package.HAZARDOUS_EVENT__CONTROLLABILITY_REFERENCE:
        if (resolve) return getControllabilityReference();
        return basicGetControllabilityReference();
      case Safe10Package.HAZARDOUS_EVENT__HAZARD:
        if (resolve) return getHazard();
        return basicGetHazard();
      case Safe10Package.HAZARDOUS_EVENT__CONTRIBUTOR:
        return getContributor();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.HAZARDOUS_EVENT__CONSEQUENCES:
   			setConsequences((String)newValue);
        return;
      case Safe10Package.HAZARDOUS_EVENT__HAZARD_CLASSIFICATION:
   			setHazardClassification((ASILEnum)newValue);
        return;
      case Safe10Package.HAZARDOUS_EVENT__EXPOSURE:
   			setExposure((ExposureClassKind)newValue);
        return;
      case Safe10Package.HAZARDOUS_EVENT__SEVERITY:
   			setSeverity((SeverityClassKind)newValue);
        return;
      case Safe10Package.HAZARDOUS_EVENT__CONTROLLABILITY:
   			setControllability((ControllabilityClassKind)newValue);
        return;
      case Safe10Package.HAZARDOUS_EVENT__SAFETY_GOAL:
        getSafetyGoal().clear();
        getSafetyGoal().addAll((Collection<? extends FunctionalSafetyRequirement>)newValue);
        return;
      case Safe10Package.HAZARDOUS_EVENT__ENVIRONMENT:
        getEnvironment().clear();
        getEnvironment().addAll((Collection<? extends OperationalSituation>)newValue);
        return;
      case Safe10Package.HAZARDOUS_EVENT__OPERATIONAL_SITUATION:
   			setOperationalSituation((OperationalSituation)newValue);
        return;
      case Safe10Package.HAZARDOUS_EVENT__TRAFFIC:
        getTraffic().clear();
        getTraffic().addAll((Collection<? extends OperationalSituation>)newValue);
        return;
      case Safe10Package.HAZARDOUS_EVENT__CONTROLLABILITY_REFERENCE:
   			setControllabilityReference((ControllabilityReference)newValue);
        return;
      case Safe10Package.HAZARDOUS_EVENT__HAZARD:
   			setHazard((Hazard)newValue);
        return;
      case Safe10Package.HAZARDOUS_EVENT__CONTRIBUTOR:
        getContributor().clear();
        getContributor().addAll((Collection<? extends MalfunctionPrototype>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HAZARDOUS_EVENT__CONSEQUENCES:
        unsetConsequences();
        return;
      case Safe10Package.HAZARDOUS_EVENT__HAZARD_CLASSIFICATION:
        unsetHazardClassification();
        return;
      case Safe10Package.HAZARDOUS_EVENT__EXPOSURE:
        unsetExposure();
        return;
      case Safe10Package.HAZARDOUS_EVENT__SEVERITY:
        unsetSeverity();
        return;
      case Safe10Package.HAZARDOUS_EVENT__CONTROLLABILITY:
        unsetControllability();
        return;
      case Safe10Package.HAZARDOUS_EVENT__SAFETY_GOAL:
        getSafetyGoal().clear();
        return;
      case Safe10Package.HAZARDOUS_EVENT__ENVIRONMENT:
        getEnvironment().clear();
        return;
      case Safe10Package.HAZARDOUS_EVENT__OPERATIONAL_SITUATION:
        	setOperationalSituation((OperationalSituation)null);
        return;
      case Safe10Package.HAZARDOUS_EVENT__TRAFFIC:
        getTraffic().clear();
        return;
      case Safe10Package.HAZARDOUS_EVENT__CONTROLLABILITY_REFERENCE:
        	setControllabilityReference((ControllabilityReference)null);
        return;
      case Safe10Package.HAZARDOUS_EVENT__HAZARD:
        	setHazard((Hazard)null);
        return;
      case Safe10Package.HAZARDOUS_EVENT__CONTRIBUTOR:
        getContributor().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.HAZARDOUS_EVENT__CONSEQUENCES:
        return isSetConsequences();
      case Safe10Package.HAZARDOUS_EVENT__HAZARD_CLASSIFICATION:
        return isSetHazardClassification();
      case Safe10Package.HAZARDOUS_EVENT__EXPOSURE:
        return isSetExposure();
      case Safe10Package.HAZARDOUS_EVENT__SEVERITY:
        return isSetSeverity();
      case Safe10Package.HAZARDOUS_EVENT__CONTROLLABILITY:
        return isSetControllability();
      case Safe10Package.HAZARDOUS_EVENT__SAFETY_GOAL:
        return safetyGoal != null && !safetyGoal.isEmpty();
      case Safe10Package.HAZARDOUS_EVENT__ENVIRONMENT:
        return environment != null && !environment.isEmpty();
      case Safe10Package.HAZARDOUS_EVENT__OPERATIONAL_SITUATION:
        return operationalSituation != null;
      case Safe10Package.HAZARDOUS_EVENT__TRAFFIC:
        return traffic != null && !traffic.isEmpty();
      case Safe10Package.HAZARDOUS_EVENT__CONTROLLABILITY_REFERENCE:
        return controllabilityReference != null;
      case Safe10Package.HAZARDOUS_EVENT__HAZARD:
        return hazard != null;
      case Safe10Package.HAZARDOUS_EVENT__CONTRIBUTOR:
        return contributor != null && !contributor.isEmpty();
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (consequences: ");
    if (consequencesESet) result.append(consequences); else result.append("<unset>");
    result.append(", hazardClassification: ");
    if (hazardClassificationESet) result.append(hazardClassification); else result.append("<unset>");
    result.append(", exposure: ");
    if (exposureESet) result.append(exposure); else result.append("<unset>");
    result.append(", severity: ");
    if (severityESet) result.append(severity); else result.append("<unset>");
    result.append(", controllability: ");
    if (controllabilityESet) result.append(controllability); else result.append("<unset>");
    result.append(')');
    return result.toString();
  }

} //HazardousEventImpl
