/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.safe.metamodel.safe10.CodeGenerationConfiguration;
import org.safe.metamodel.safe10.HardwareSafetyRequirement;
import org.safe.metamodel.safe10.ImplementationSafetyExtension;
import org.safe.metamodel.safe10.Safe10Package;
import org.safe.metamodel.safe10.SoftwareSafetyRequirement;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Implementation Safety Extension</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.ImplementationSafetyExtensionImpl#getHardwareSafetyRequirement <em>Hardware Safety Requirement</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.ImplementationSafetyExtensionImpl#getSoftwareRequirement <em>Software Requirement</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.ImplementationSafetyExtensionImpl#getCodeGenerationConfiguration <em>Code Generation Configuration</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ImplementationSafetyExtensionImpl extends SingleLevelSafetyExtensionImpl implements ImplementationSafetyExtension
{
  /**
   * The cached value of the '{@link #getHardwareSafetyRequirement() <em>Hardware Safety Requirement</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHardwareSafetyRequirement()
   * @generated
   * @ordered
   */
  protected EList<HardwareSafetyRequirement> hardwareSafetyRequirement;

  /**
   * The cached value of the '{@link #getSoftwareRequirement() <em>Software Requirement</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSoftwareRequirement()
   * @generated
   * @ordered
   */
  protected EList<SoftwareSafetyRequirement> softwareRequirement;

  /**
   * The cached value of the '{@link #getCodeGenerationConfiguration() <em>Code Generation Configuration</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCodeGenerationConfiguration()
   * @generated
   * @ordered
   */
  protected EList<CodeGenerationConfiguration> codeGenerationConfiguration;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ImplementationSafetyExtensionImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getImplementationSafetyExtension();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<HardwareSafetyRequirement> getHardwareSafetyRequirement()
  {
    if (hardwareSafetyRequirement == null)
    {
      hardwareSafetyRequirement = new EObjectContainmentEList<HardwareSafetyRequirement>(HardwareSafetyRequirement.class, this, Safe10Package.IMPLEMENTATION_SAFETY_EXTENSION__HARDWARE_SAFETY_REQUIREMENT);
    }
    return hardwareSafetyRequirement;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<SoftwareSafetyRequirement> getSoftwareRequirement()
  {
    if (softwareRequirement == null)
    {
      softwareRequirement = new EObjectContainmentEList<SoftwareSafetyRequirement>(SoftwareSafetyRequirement.class, this, Safe10Package.IMPLEMENTATION_SAFETY_EXTENSION__SOFTWARE_REQUIREMENT);
    }
    return softwareRequirement;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<CodeGenerationConfiguration> getCodeGenerationConfiguration()
  {
    if (codeGenerationConfiguration == null)
    {
      codeGenerationConfiguration = new EObjectContainmentEList<CodeGenerationConfiguration>(CodeGenerationConfiguration.class, this, Safe10Package.IMPLEMENTATION_SAFETY_EXTENSION__CODE_GENERATION_CONFIGURATION);
    }
    return codeGenerationConfiguration;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.IMPLEMENTATION_SAFETY_EXTENSION__HARDWARE_SAFETY_REQUIREMENT:
        return ((InternalEList<?>)getHardwareSafetyRequirement()).basicRemove(otherEnd, msgs);
      case Safe10Package.IMPLEMENTATION_SAFETY_EXTENSION__SOFTWARE_REQUIREMENT:
        return ((InternalEList<?>)getSoftwareRequirement()).basicRemove(otherEnd, msgs);
      case Safe10Package.IMPLEMENTATION_SAFETY_EXTENSION__CODE_GENERATION_CONFIGURATION:
        return ((InternalEList<?>)getCodeGenerationConfiguration()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.IMPLEMENTATION_SAFETY_EXTENSION__HARDWARE_SAFETY_REQUIREMENT:
        return getHardwareSafetyRequirement();
      case Safe10Package.IMPLEMENTATION_SAFETY_EXTENSION__SOFTWARE_REQUIREMENT:
        return getSoftwareRequirement();
      case Safe10Package.IMPLEMENTATION_SAFETY_EXTENSION__CODE_GENERATION_CONFIGURATION:
        return getCodeGenerationConfiguration();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.IMPLEMENTATION_SAFETY_EXTENSION__HARDWARE_SAFETY_REQUIREMENT:
        getHardwareSafetyRequirement().clear();
        getHardwareSafetyRequirement().addAll((Collection<? extends HardwareSafetyRequirement>)newValue);
        return;
      case Safe10Package.IMPLEMENTATION_SAFETY_EXTENSION__SOFTWARE_REQUIREMENT:
        getSoftwareRequirement().clear();
        getSoftwareRequirement().addAll((Collection<? extends SoftwareSafetyRequirement>)newValue);
        return;
      case Safe10Package.IMPLEMENTATION_SAFETY_EXTENSION__CODE_GENERATION_CONFIGURATION:
        getCodeGenerationConfiguration().clear();
        getCodeGenerationConfiguration().addAll((Collection<? extends CodeGenerationConfiguration>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.IMPLEMENTATION_SAFETY_EXTENSION__HARDWARE_SAFETY_REQUIREMENT:
        getHardwareSafetyRequirement().clear();
        return;
      case Safe10Package.IMPLEMENTATION_SAFETY_EXTENSION__SOFTWARE_REQUIREMENT:
        getSoftwareRequirement().clear();
        return;
      case Safe10Package.IMPLEMENTATION_SAFETY_EXTENSION__CODE_GENERATION_CONFIGURATION:
        getCodeGenerationConfiguration().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.IMPLEMENTATION_SAFETY_EXTENSION__HARDWARE_SAFETY_REQUIREMENT:
        return hardwareSafetyRequirement != null && !hardwareSafetyRequirement.isEmpty();
      case Safe10Package.IMPLEMENTATION_SAFETY_EXTENSION__SOFTWARE_REQUIREMENT:
        return softwareRequirement != null && !softwareRequirement.isEmpty();
      case Safe10Package.IMPLEMENTATION_SAFETY_EXTENSION__CODE_GENERATION_CONFIGURATION:
        return codeGenerationConfiguration != null && !codeGenerationConfiguration.isEmpty();
    }
    return super.eIsSet(featureID);
  }

} //ImplementationSafetyExtensionImpl
