/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.safe.metamodel.safe10.MemoryRange;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Memory Range</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.MemoryRangeImpl#getStartAddress <em>Start Address</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.MemoryRangeImpl#getStopAddress <em>Stop Address</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class MemoryRangeImpl extends IdentifiableImpl implements MemoryRange
{
  /**
   * The default value of the '{@link #getStartAddress() <em>Start Address</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getStartAddress()
   * @generated
   * @ordered
   */
  protected static final Integer START_ADDRESS_EDEFAULT = new Integer(0);

  /**
   * The cached value of the '{@link #getStartAddress() <em>Start Address</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getStartAddress()
   * @generated
   * @ordered
   */
  protected Integer startAddress = START_ADDRESS_EDEFAULT;

  /**
   * This is true if the Start Address attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean startAddressESet;

  /**
   * The default value of the '{@link #getStopAddress() <em>Stop Address</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getStopAddress()
   * @generated
   * @ordered
   */
  protected static final Integer STOP_ADDRESS_EDEFAULT = new Integer(0);

  /**
   * The cached value of the '{@link #getStopAddress() <em>Stop Address</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getStopAddress()
   * @generated
   * @ordered
   */
  protected Integer stopAddress = STOP_ADDRESS_EDEFAULT;

  /**
   * This is true if the Stop Address attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean stopAddressESet;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected MemoryRangeImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getMemoryRange();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Integer getStartAddress()
  {
    return startAddress;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setStartAddress(Integer newStartAddress)
  {
    Integer oldStartAddress = startAddress;
    startAddress = newStartAddress;
    boolean oldStartAddressESet = startAddressESet;
    startAddressESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.MEMORY_RANGE__START_ADDRESS, oldStartAddress, startAddress, !oldStartAddressESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetStartAddress()
  {
    Integer oldStartAddress = startAddress;
    boolean oldStartAddressESet = startAddressESet;
    startAddress = START_ADDRESS_EDEFAULT;
    startAddressESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.MEMORY_RANGE__START_ADDRESS, oldStartAddress, START_ADDRESS_EDEFAULT, oldStartAddressESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetStartAddress()
  {
    return startAddressESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Integer getStopAddress()
  {
    return stopAddress;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setStopAddress(Integer newStopAddress)
  {
    Integer oldStopAddress = stopAddress;
    stopAddress = newStopAddress;
    boolean oldStopAddressESet = stopAddressESet;
    stopAddressESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.MEMORY_RANGE__STOP_ADDRESS, oldStopAddress, stopAddress, !oldStopAddressESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetStopAddress()
  {
    Integer oldStopAddress = stopAddress;
    boolean oldStopAddressESet = stopAddressESet;
    stopAddress = STOP_ADDRESS_EDEFAULT;
    stopAddressESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.MEMORY_RANGE__STOP_ADDRESS, oldStopAddress, STOP_ADDRESS_EDEFAULT, oldStopAddressESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetStopAddress()
  {
    return stopAddressESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.MEMORY_RANGE__START_ADDRESS:
        return getStartAddress();
      case Safe10Package.MEMORY_RANGE__STOP_ADDRESS:
        return getStopAddress();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.MEMORY_RANGE__START_ADDRESS:
   			setStartAddress((Integer)newValue);
        return;
      case Safe10Package.MEMORY_RANGE__STOP_ADDRESS:
   			setStopAddress((Integer)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.MEMORY_RANGE__START_ADDRESS:
        unsetStartAddress();
        return;
      case Safe10Package.MEMORY_RANGE__STOP_ADDRESS:
        unsetStopAddress();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.MEMORY_RANGE__START_ADDRESS:
        return isSetStartAddress();
      case Safe10Package.MEMORY_RANGE__STOP_ADDRESS:
        return isSetStopAddress();
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (startAddress: ");
    if (startAddressESet) result.append(startAddress); else result.append("<unset>");
    result.append(", stopAddress: ");
    if (stopAddressESet) result.append(stopAddress); else result.append("<unset>");
    result.append(')');
    return result.toString();
  }

} //MemoryRangeImpl
