/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.safe.metamodel.safe10.MalfunctionType;
import org.safe.metamodel.safe10.MultiLevelSafetyExtension;
import org.safe.metamodel.safe10.Safe10Package;
import org.safe.metamodel.safe10.SafetyCase;
import org.safe.metamodel.safe10.SafetyConcept;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Multi Level Safety Extension</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.MultiLevelSafetyExtensionImpl#getMalfunction <em>Malfunction</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.MultiLevelSafetyExtensionImpl#getSafetyConcept <em>Safety Concept</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.MultiLevelSafetyExtensionImpl#getSafetyCase <em>Safety Case</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class MultiLevelSafetyExtensionImpl extends SafetyExtensionImpl implements MultiLevelSafetyExtension
{
  /**
   * The cached value of the '{@link #getMalfunction() <em>Malfunction</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMalfunction()
   * @generated
   * @ordered
   */
  protected EList<MalfunctionType> malfunction;

  /**
   * The cached value of the '{@link #getSafetyConcept() <em>Safety Concept</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSafetyConcept()
   * @generated
   * @ordered
   */
  protected EList<SafetyConcept> safetyConcept;

  /**
   * The cached value of the '{@link #getSafetyCase() <em>Safety Case</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSafetyCase()
   * @generated
   * @ordered
   */
  protected EList<SafetyCase> safetyCase;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected MultiLevelSafetyExtensionImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getMultiLevelSafetyExtension();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<MalfunctionType> getMalfunction()
  {
    if (malfunction == null)
    {
      malfunction = new EObjectContainmentEList<MalfunctionType>(MalfunctionType.class, this, Safe10Package.MULTI_LEVEL_SAFETY_EXTENSION__MALFUNCTION);
    }
    return malfunction;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<SafetyConcept> getSafetyConcept()
  {
    if (safetyConcept == null)
    {
      safetyConcept = new EObjectContainmentEList<SafetyConcept>(SafetyConcept.class, this, Safe10Package.MULTI_LEVEL_SAFETY_EXTENSION__SAFETY_CONCEPT);
    }
    return safetyConcept;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<SafetyCase> getSafetyCase()
  {
    if (safetyCase == null)
    {
      safetyCase = new EObjectContainmentEList<SafetyCase>(SafetyCase.class, this, Safe10Package.MULTI_LEVEL_SAFETY_EXTENSION__SAFETY_CASE);
    }
    return safetyCase;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.MULTI_LEVEL_SAFETY_EXTENSION__MALFUNCTION:
        return ((InternalEList<?>)getMalfunction()).basicRemove(otherEnd, msgs);
      case Safe10Package.MULTI_LEVEL_SAFETY_EXTENSION__SAFETY_CONCEPT:
        return ((InternalEList<?>)getSafetyConcept()).basicRemove(otherEnd, msgs);
      case Safe10Package.MULTI_LEVEL_SAFETY_EXTENSION__SAFETY_CASE:
        return ((InternalEList<?>)getSafetyCase()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.MULTI_LEVEL_SAFETY_EXTENSION__MALFUNCTION:
        return getMalfunction();
      case Safe10Package.MULTI_LEVEL_SAFETY_EXTENSION__SAFETY_CONCEPT:
        return getSafetyConcept();
      case Safe10Package.MULTI_LEVEL_SAFETY_EXTENSION__SAFETY_CASE:
        return getSafetyCase();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.MULTI_LEVEL_SAFETY_EXTENSION__MALFUNCTION:
        getMalfunction().clear();
        getMalfunction().addAll((Collection<? extends MalfunctionType>)newValue);
        return;
      case Safe10Package.MULTI_LEVEL_SAFETY_EXTENSION__SAFETY_CONCEPT:
        getSafetyConcept().clear();
        getSafetyConcept().addAll((Collection<? extends SafetyConcept>)newValue);
        return;
      case Safe10Package.MULTI_LEVEL_SAFETY_EXTENSION__SAFETY_CASE:
        getSafetyCase().clear();
        getSafetyCase().addAll((Collection<? extends SafetyCase>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.MULTI_LEVEL_SAFETY_EXTENSION__MALFUNCTION:
        getMalfunction().clear();
        return;
      case Safe10Package.MULTI_LEVEL_SAFETY_EXTENSION__SAFETY_CONCEPT:
        getSafetyConcept().clear();
        return;
      case Safe10Package.MULTI_LEVEL_SAFETY_EXTENSION__SAFETY_CASE:
        getSafetyCase().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.MULTI_LEVEL_SAFETY_EXTENSION__MALFUNCTION:
        return malfunction != null && !malfunction.isEmpty();
      case Safe10Package.MULTI_LEVEL_SAFETY_EXTENSION__SAFETY_CONCEPT:
        return safetyConcept != null && !safetyConcept.isEmpty();
      case Safe10Package.MULTI_LEVEL_SAFETY_EXTENSION__SAFETY_CASE:
        return safetyCase != null && !safetyCase.isEmpty();
    }
    return super.eIsSet(featureID);
  }

} //MultiLevelSafetyExtensionImpl
