/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectResolvingEList;

import org.safe.metamodel.safe10.ErrorBehaviorKind;
import org.safe.metamodel.safe10.MalfunctionPrototype;
import org.safe.metamodel.safe10.NativeErrorBehavior;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Native Error Behavior</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.NativeErrorBehaviorImpl#getFailureLogic <em>Failure Logic</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.NativeErrorBehaviorImpl#getType <em>Type</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.NativeErrorBehaviorImpl#getExternalFailure <em>External Failure</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.NativeErrorBehaviorImpl#getExternalFault <em>External Fault</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class NativeErrorBehaviorImpl extends AbstractErrorBehaviorImpl implements NativeErrorBehavior
{
  /**
   * The default value of the '{@link #getFailureLogic() <em>Failure Logic</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFailureLogic()
   * @generated
   * @ordered
   */
  protected static final String FAILURE_LOGIC_EDEFAULT = "";

  /**
   * The cached value of the '{@link #getFailureLogic() <em>Failure Logic</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFailureLogic()
   * @generated
   * @ordered
   */
  protected String failureLogic = FAILURE_LOGIC_EDEFAULT;

  /**
   * This is true if the Failure Logic attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean failureLogicESet;

  /**
   * The default value of the '{@link #getType() <em>Type</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getType()
   * @generated
   * @ordered
   */
  protected static final ErrorBehaviorKind TYPE_EDEFAULT = ErrorBehaviorKind.HIP_HOPS;

  /**
   * The cached value of the '{@link #getType() <em>Type</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getType()
   * @generated
   * @ordered
   */
  protected ErrorBehaviorKind type = TYPE_EDEFAULT;

  /**
   * This is true if the Type attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean typeESet;

  /**
   * The cached value of the '{@link #getExternalFailure() <em>External Failure</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getExternalFailure()
   * @generated
   * @ordered
   */
  protected EList<MalfunctionPrototype> externalFailure;

  /**
   * The cached value of the '{@link #getExternalFault() <em>External Fault</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getExternalFault()
   * @generated
   * @ordered
   */
  protected EList<MalfunctionPrototype> externalFault;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected NativeErrorBehaviorImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getNativeErrorBehavior();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getFailureLogic()
  {
    return failureLogic;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setFailureLogic(String newFailureLogic)
  {
    String oldFailureLogic = failureLogic;
    failureLogic = newFailureLogic;
    boolean oldFailureLogicESet = failureLogicESet;
    failureLogicESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.NATIVE_ERROR_BEHAVIOR__FAILURE_LOGIC, oldFailureLogic, failureLogic, !oldFailureLogicESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetFailureLogic()
  {
    String oldFailureLogic = failureLogic;
    boolean oldFailureLogicESet = failureLogicESet;
    failureLogic = FAILURE_LOGIC_EDEFAULT;
    failureLogicESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.NATIVE_ERROR_BEHAVIOR__FAILURE_LOGIC, oldFailureLogic, FAILURE_LOGIC_EDEFAULT, oldFailureLogicESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetFailureLogic()
  {
    return failureLogicESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ErrorBehaviorKind getType()
  {
    return type;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setType(ErrorBehaviorKind newType)
  {
    ErrorBehaviorKind oldType = type;
    type = newType == null ? TYPE_EDEFAULT : newType;
    boolean oldTypeESet = typeESet;
    typeESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.NATIVE_ERROR_BEHAVIOR__TYPE, oldType, type, !oldTypeESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetType()
  {
    ErrorBehaviorKind oldType = type;
    boolean oldTypeESet = typeESet;
    type = TYPE_EDEFAULT;
    typeESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.NATIVE_ERROR_BEHAVIOR__TYPE, oldType, TYPE_EDEFAULT, oldTypeESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetType()
  {
    return typeESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<MalfunctionPrototype> getExternalFailure()
  {
    if (externalFailure == null)
    {
      externalFailure = new EObjectResolvingEList<MalfunctionPrototype>(MalfunctionPrototype.class, this, Safe10Package.NATIVE_ERROR_BEHAVIOR__EXTERNAL_FAILURE);
    }
    return externalFailure;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<MalfunctionPrototype> getExternalFault()
  {
    if (externalFault == null)
    {
      externalFault = new EObjectResolvingEList<MalfunctionPrototype>(MalfunctionPrototype.class, this, Safe10Package.NATIVE_ERROR_BEHAVIOR__EXTERNAL_FAULT);
    }
    return externalFault;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.NATIVE_ERROR_BEHAVIOR__FAILURE_LOGIC:
        return getFailureLogic();
      case Safe10Package.NATIVE_ERROR_BEHAVIOR__TYPE:
        return getType();
      case Safe10Package.NATIVE_ERROR_BEHAVIOR__EXTERNAL_FAILURE:
        return getExternalFailure();
      case Safe10Package.NATIVE_ERROR_BEHAVIOR__EXTERNAL_FAULT:
        return getExternalFault();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.NATIVE_ERROR_BEHAVIOR__FAILURE_LOGIC:
   			setFailureLogic((String)newValue);
        return;
      case Safe10Package.NATIVE_ERROR_BEHAVIOR__TYPE:
   			setType((ErrorBehaviorKind)newValue);
        return;
      case Safe10Package.NATIVE_ERROR_BEHAVIOR__EXTERNAL_FAILURE:
        getExternalFailure().clear();
        getExternalFailure().addAll((Collection<? extends MalfunctionPrototype>)newValue);
        return;
      case Safe10Package.NATIVE_ERROR_BEHAVIOR__EXTERNAL_FAULT:
        getExternalFault().clear();
        getExternalFault().addAll((Collection<? extends MalfunctionPrototype>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.NATIVE_ERROR_BEHAVIOR__FAILURE_LOGIC:
        unsetFailureLogic();
        return;
      case Safe10Package.NATIVE_ERROR_BEHAVIOR__TYPE:
        unsetType();
        return;
      case Safe10Package.NATIVE_ERROR_BEHAVIOR__EXTERNAL_FAILURE:
        getExternalFailure().clear();
        return;
      case Safe10Package.NATIVE_ERROR_BEHAVIOR__EXTERNAL_FAULT:
        getExternalFault().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.NATIVE_ERROR_BEHAVIOR__FAILURE_LOGIC:
        return isSetFailureLogic();
      case Safe10Package.NATIVE_ERROR_BEHAVIOR__TYPE:
        return isSetType();
      case Safe10Package.NATIVE_ERROR_BEHAVIOR__EXTERNAL_FAILURE:
        return externalFailure != null && !externalFailure.isEmpty();
      case Safe10Package.NATIVE_ERROR_BEHAVIOR__EXTERNAL_FAULT:
        return externalFault != null && !externalFault.isEmpty();
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (failureLogic: ");
    if (failureLogicESet) result.append(failureLogic); else result.append("<unset>");
    result.append(", type: ");
    if (typeESet) result.append(type); else result.append("<unset>");
    result.append(')');
    return result.toString();
  }

} //NativeErrorBehaviorImpl
