/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eatop.eel.eastadl21.Environment;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectResolvingEList;

import org.safe.metamodel.safe10.Actor;
import org.safe.metamodel.safe10.OperationalSituation;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Operational Situation</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.OperationalSituationImpl#getOtherSubjects <em>Other Subjects</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.OperationalSituationImpl#getEnvironment <em>Environment</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.OperationalSituationImpl#getDriver <em>Driver</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.OperationalSituationImpl#getExternalHardware <em>External Hardware</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.OperationalSituationImpl#getOtherParticipants <em>Other Participants</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class OperationalSituationImpl extends TraceableSpecificationImpl implements OperationalSituation
{
  /**
   * The cached value of the '{@link #getOtherSubjects() <em>Other Subjects</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getOtherSubjects()
   * @generated
   * @ordered
   */
  protected EList<Actor> otherSubjects;

  /**
   * The cached value of the '{@link #getEnvironment() <em>Environment</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getEnvironment()
   * @generated
   * @ordered
   */
  protected Environment environment;

  /**
   * The cached value of the '{@link #getDriver() <em>Driver</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDriver()
   * @generated
   * @ordered
   */
  protected Actor driver;

  /**
   * The cached value of the '{@link #getExternalHardware() <em>External Hardware</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getExternalHardware()
   * @generated
   * @ordered
   */
  protected EList<Actor> externalHardware;

  /**
   * The cached value of the '{@link #getOtherParticipants() <em>Other Participants</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getOtherParticipants()
   * @generated
   * @ordered
   */
  protected EList<Actor> otherParticipants;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected OperationalSituationImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getOperationalSituation();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Actor> getOtherSubjects()
  {
    if (otherSubjects == null)
    {
      otherSubjects = new EObjectResolvingEList<Actor>(Actor.class, this, Safe10Package.OPERATIONAL_SITUATION__OTHER_SUBJECTS);
    }
    return otherSubjects;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Environment getEnvironment()
  {
    if (environment != null && environment.eIsProxy())
    {
      InternalEObject oldEnvironment = (InternalEObject)environment;
      environment = (Environment)eResolveProxy(oldEnvironment);
      if (environment != oldEnvironment)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.OPERATIONAL_SITUATION__ENVIRONMENT, oldEnvironment, environment));
      }
    }
    return environment;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Environment basicGetEnvironment()
  {
    return environment;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setEnvironment(Environment newEnvironment)
  {
    Environment oldEnvironment = environment;
    environment = newEnvironment;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.OPERATIONAL_SITUATION__ENVIRONMENT, oldEnvironment, environment));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Actor getDriver()
  {
    if (driver != null && driver.eIsProxy())
    {
      InternalEObject oldDriver = (InternalEObject)driver;
      driver = (Actor)eResolveProxy(oldDriver);
      if (driver != oldDriver)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.OPERATIONAL_SITUATION__DRIVER, oldDriver, driver));
      }
    }
    return driver;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Actor basicGetDriver()
  {
    return driver;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setDriver(Actor newDriver)
  {
    Actor oldDriver = driver;
    driver = newDriver;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.OPERATIONAL_SITUATION__DRIVER, oldDriver, driver));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Actor> getExternalHardware()
  {
    if (externalHardware == null)
    {
      externalHardware = new EObjectResolvingEList<Actor>(Actor.class, this, Safe10Package.OPERATIONAL_SITUATION__EXTERNAL_HARDWARE);
    }
    return externalHardware;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Actor> getOtherParticipants()
  {
    if (otherParticipants == null)
    {
      otherParticipants = new EObjectResolvingEList<Actor>(Actor.class, this, Safe10Package.OPERATIONAL_SITUATION__OTHER_PARTICIPANTS);
    }
    return otherParticipants;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.OPERATIONAL_SITUATION__OTHER_SUBJECTS:
        return getOtherSubjects();
      case Safe10Package.OPERATIONAL_SITUATION__ENVIRONMENT:
        if (resolve) return getEnvironment();
        return basicGetEnvironment();
      case Safe10Package.OPERATIONAL_SITUATION__DRIVER:
        if (resolve) return getDriver();
        return basicGetDriver();
      case Safe10Package.OPERATIONAL_SITUATION__EXTERNAL_HARDWARE:
        return getExternalHardware();
      case Safe10Package.OPERATIONAL_SITUATION__OTHER_PARTICIPANTS:
        return getOtherParticipants();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.OPERATIONAL_SITUATION__OTHER_SUBJECTS:
        getOtherSubjects().clear();
        getOtherSubjects().addAll((Collection<? extends Actor>)newValue);
        return;
      case Safe10Package.OPERATIONAL_SITUATION__ENVIRONMENT:
   			setEnvironment((Environment)newValue);
        return;
      case Safe10Package.OPERATIONAL_SITUATION__DRIVER:
   			setDriver((Actor)newValue);
        return;
      case Safe10Package.OPERATIONAL_SITUATION__EXTERNAL_HARDWARE:
        getExternalHardware().clear();
        getExternalHardware().addAll((Collection<? extends Actor>)newValue);
        return;
      case Safe10Package.OPERATIONAL_SITUATION__OTHER_PARTICIPANTS:
        getOtherParticipants().clear();
        getOtherParticipants().addAll((Collection<? extends Actor>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.OPERATIONAL_SITUATION__OTHER_SUBJECTS:
        getOtherSubjects().clear();
        return;
      case Safe10Package.OPERATIONAL_SITUATION__ENVIRONMENT:
        	setEnvironment((Environment)null);
        return;
      case Safe10Package.OPERATIONAL_SITUATION__DRIVER:
        	setDriver((Actor)null);
        return;
      case Safe10Package.OPERATIONAL_SITUATION__EXTERNAL_HARDWARE:
        getExternalHardware().clear();
        return;
      case Safe10Package.OPERATIONAL_SITUATION__OTHER_PARTICIPANTS:
        getOtherParticipants().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.OPERATIONAL_SITUATION__OTHER_SUBJECTS:
        return otherSubjects != null && !otherSubjects.isEmpty();
      case Safe10Package.OPERATIONAL_SITUATION__ENVIRONMENT:
        return environment != null;
      case Safe10Package.OPERATIONAL_SITUATION__DRIVER:
        return driver != null;
      case Safe10Package.OPERATIONAL_SITUATION__EXTERNAL_HARDWARE:
        return externalHardware != null && !externalHardware.isEmpty();
      case Safe10Package.OPERATIONAL_SITUATION__OTHER_PARTICIPANTS:
        return otherParticipants != null && !otherParticipants.isEmpty();
    }
    return super.eIsSet(featureID);
  }

} //OperationalSituationImpl
