/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.safe.metamodel.safe10.Identifiable;
import org.safe.metamodel.safe10.Restrictable;
import org.safe.metamodel.safe10.Restriction;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Restrictable</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.RestrictableImpl#getVariableElement <em>Variable Element</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.RestrictableImpl#getResSet <em>Res Set</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class RestrictableImpl extends PackageableElementImpl implements Restrictable
{
  /**
   * The cached value of the '{@link #getVariableElement() <em>Variable Element</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getVariableElement()
   * @generated
   * @ordered
   */
  protected Identifiable variableElement;

  /**
   * The cached value of the '{@link #getResSet() <em>Res Set</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getResSet()
   * @generated
   * @ordered
   */
  protected EList<Restriction> resSet;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected RestrictableImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getRestrictable();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Identifiable getVariableElement()
  {
    if (variableElement != null && variableElement.eIsProxy())
    {
      InternalEObject oldVariableElement = (InternalEObject)variableElement;
      variableElement = (Identifiable)eResolveProxy(oldVariableElement);
      if (variableElement != oldVariableElement)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.RESTRICTABLE__VARIABLE_ELEMENT, oldVariableElement, variableElement));
      }
    }
    return variableElement;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Identifiable basicGetVariableElement()
  {
    return variableElement;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setVariableElement(Identifiable newVariableElement)
  {
    Identifiable oldVariableElement = variableElement;
    variableElement = newVariableElement;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.RESTRICTABLE__VARIABLE_ELEMENT, oldVariableElement, variableElement));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Restriction> getResSet()
  {
    if (resSet == null)
    {
      resSet = new EObjectContainmentEList<Restriction>(Restriction.class, this, Safe10Package.RESTRICTABLE__RES_SET);
    }
    return resSet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.RESTRICTABLE__RES_SET:
        return ((InternalEList<?>)getResSet()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.RESTRICTABLE__VARIABLE_ELEMENT:
        if (resolve) return getVariableElement();
        return basicGetVariableElement();
      case Safe10Package.RESTRICTABLE__RES_SET:
        return getResSet();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.RESTRICTABLE__VARIABLE_ELEMENT:
   			setVariableElement((Identifiable)newValue);
        return;
      case Safe10Package.RESTRICTABLE__RES_SET:
        getResSet().clear();
        getResSet().addAll((Collection<? extends Restriction>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.RESTRICTABLE__VARIABLE_ELEMENT:
        	setVariableElement((Identifiable)null);
        return;
      case Safe10Package.RESTRICTABLE__RES_SET:
        getResSet().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.RESTRICTABLE__VARIABLE_ELEMENT:
        return variableElement != null;
      case Safe10Package.RESTRICTABLE__RES_SET:
        return resSet != null && !resSet.isEmpty();
    }
    return super.eIsSet(featureID);
  }

} //RestrictableImpl
