/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.safe.metamodel.safe10.HazardousEvent;
import org.safe.metamodel.safe10.ItemFunctionDescription;
import org.safe.metamodel.safe10.MalfunctionPrototype;
import org.safe.metamodel.safe10.RiskDescription;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Risk Description</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.RiskDescriptionImpl#getInvolvedMalfunction <em>Involved Malfunction</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.RiskDescriptionImpl#getHazardousEvent <em>Hazardous Event</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.RiskDescriptionImpl#getInvolvedFunction <em>Involved Function</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class RiskDescriptionImpl extends TraceableSpecificationImpl implements RiskDescription
{
  /**
   * The cached value of the '{@link #getInvolvedMalfunction() <em>Involved Malfunction</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getInvolvedMalfunction()
   * @generated
   * @ordered
   */
  protected MalfunctionPrototype involvedMalfunction;

  /**
   * The cached value of the '{@link #getHazardousEvent() <em>Hazardous Event</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHazardousEvent()
   * @generated
   * @ordered
   */
  protected HazardousEvent hazardousEvent;

  /**
   * The cached value of the '{@link #getInvolvedFunction() <em>Involved Function</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getInvolvedFunction()
   * @generated
   * @ordered
   */
  protected ItemFunctionDescription involvedFunction;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected RiskDescriptionImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getRiskDescription();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MalfunctionPrototype getInvolvedMalfunction()
  {
    if (involvedMalfunction != null && involvedMalfunction.eIsProxy())
    {
      InternalEObject oldInvolvedMalfunction = (InternalEObject)involvedMalfunction;
      involvedMalfunction = (MalfunctionPrototype)eResolveProxy(oldInvolvedMalfunction);
      if (involvedMalfunction != oldInvolvedMalfunction)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.RISK_DESCRIPTION__INVOLVED_MALFUNCTION, oldInvolvedMalfunction, involvedMalfunction));
      }
    }
    return involvedMalfunction;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MalfunctionPrototype basicGetInvolvedMalfunction()
  {
    return involvedMalfunction;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setInvolvedMalfunction(MalfunctionPrototype newInvolvedMalfunction)
  {
    MalfunctionPrototype oldInvolvedMalfunction = involvedMalfunction;
    involvedMalfunction = newInvolvedMalfunction;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.RISK_DESCRIPTION__INVOLVED_MALFUNCTION, oldInvolvedMalfunction, involvedMalfunction));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HazardousEvent getHazardousEvent()
  {
    if (hazardousEvent != null && hazardousEvent.eIsProxy())
    {
      InternalEObject oldHazardousEvent = (InternalEObject)hazardousEvent;
      hazardousEvent = (HazardousEvent)eResolveProxy(oldHazardousEvent);
      if (hazardousEvent != oldHazardousEvent)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.RISK_DESCRIPTION__HAZARDOUS_EVENT, oldHazardousEvent, hazardousEvent));
      }
    }
    return hazardousEvent;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HazardousEvent basicGetHazardousEvent()
  {
    return hazardousEvent;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setHazardousEvent(HazardousEvent newHazardousEvent)
  {
    HazardousEvent oldHazardousEvent = hazardousEvent;
    hazardousEvent = newHazardousEvent;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.RISK_DESCRIPTION__HAZARDOUS_EVENT, oldHazardousEvent, hazardousEvent));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ItemFunctionDescription getInvolvedFunction()
  {
    if (involvedFunction != null && involvedFunction.eIsProxy())
    {
      InternalEObject oldInvolvedFunction = (InternalEObject)involvedFunction;
      involvedFunction = (ItemFunctionDescription)eResolveProxy(oldInvolvedFunction);
      if (involvedFunction != oldInvolvedFunction)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, Safe10Package.RISK_DESCRIPTION__INVOLVED_FUNCTION, oldInvolvedFunction, involvedFunction));
      }
    }
    return involvedFunction;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ItemFunctionDescription basicGetInvolvedFunction()
  {
    return involvedFunction;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setInvolvedFunction(ItemFunctionDescription newInvolvedFunction)
  {
    ItemFunctionDescription oldInvolvedFunction = involvedFunction;
    involvedFunction = newInvolvedFunction;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.RISK_DESCRIPTION__INVOLVED_FUNCTION, oldInvolvedFunction, involvedFunction));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.RISK_DESCRIPTION__INVOLVED_MALFUNCTION:
        if (resolve) return getInvolvedMalfunction();
        return basicGetInvolvedMalfunction();
      case Safe10Package.RISK_DESCRIPTION__HAZARDOUS_EVENT:
        if (resolve) return getHazardousEvent();
        return basicGetHazardousEvent();
      case Safe10Package.RISK_DESCRIPTION__INVOLVED_FUNCTION:
        if (resolve) return getInvolvedFunction();
        return basicGetInvolvedFunction();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.RISK_DESCRIPTION__INVOLVED_MALFUNCTION:
   			setInvolvedMalfunction((MalfunctionPrototype)newValue);
        return;
      case Safe10Package.RISK_DESCRIPTION__HAZARDOUS_EVENT:
   			setHazardousEvent((HazardousEvent)newValue);
        return;
      case Safe10Package.RISK_DESCRIPTION__INVOLVED_FUNCTION:
   			setInvolvedFunction((ItemFunctionDescription)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.RISK_DESCRIPTION__INVOLVED_MALFUNCTION:
        	setInvolvedMalfunction((MalfunctionPrototype)null);
        return;
      case Safe10Package.RISK_DESCRIPTION__HAZARDOUS_EVENT:
        	setHazardousEvent((HazardousEvent)null);
        return;
      case Safe10Package.RISK_DESCRIPTION__INVOLVED_FUNCTION:
        	setInvolvedFunction((ItemFunctionDescription)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.RISK_DESCRIPTION__INVOLVED_MALFUNCTION:
        return involvedMalfunction != null;
      case Safe10Package.RISK_DESCRIPTION__HAZARDOUS_EVENT:
        return hazardousEvent != null;
      case Safe10Package.RISK_DESCRIPTION__INVOLVED_FUNCTION:
        return involvedFunction != null;
    }
    return super.eIsSet(featureID);
  }

} //RiskDescriptionImpl
