/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.safe.metamodel.safe10.PackageableElement;
import org.safe.metamodel.safe10.SAFEPackage;
import org.safe.metamodel.safe10.Safe10Package;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>SAFE Package</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.SAFEPackageImpl#getElement <em>Element</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.SAFEPackageImpl#getSubPackage <em>Sub Package</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class SAFEPackageImpl extends IdentifiableImpl implements SAFEPackage
{
  /**
   * The cached value of the '{@link #getElement() <em>Element</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getElement()
   * @generated
   * @ordered
   */
  protected EList<PackageableElement> element;

  /**
   * The cached value of the '{@link #getSubPackage() <em>Sub Package</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSubPackage()
   * @generated
   * @ordered
   */
  protected EList<SAFEPackage> subPackage;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected SAFEPackageImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getSAFEPackage();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<PackageableElement> getElement()
  {
    if (element == null)
    {
      element = new EObjectContainmentEList<PackageableElement>(PackageableElement.class, this, Safe10Package.SAFE_PACKAGE__ELEMENT);
    }
    return element;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<SAFEPackage> getSubPackage()
  {
    if (subPackage == null)
    {
      subPackage = new EObjectContainmentEList<SAFEPackage>(SAFEPackage.class, this, Safe10Package.SAFE_PACKAGE__SUB_PACKAGE);
    }
    return subPackage;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.SAFE_PACKAGE__ELEMENT:
        return ((InternalEList<?>)getElement()).basicRemove(otherEnd, msgs);
      case Safe10Package.SAFE_PACKAGE__SUB_PACKAGE:
        return ((InternalEList<?>)getSubPackage()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.SAFE_PACKAGE__ELEMENT:
        return getElement();
      case Safe10Package.SAFE_PACKAGE__SUB_PACKAGE:
        return getSubPackage();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.SAFE_PACKAGE__ELEMENT:
        getElement().clear();
        getElement().addAll((Collection<? extends PackageableElement>)newValue);
        return;
      case Safe10Package.SAFE_PACKAGE__SUB_PACKAGE:
        getSubPackage().clear();
        getSubPackage().addAll((Collection<? extends SAFEPackage>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.SAFE_PACKAGE__ELEMENT:
        getElement().clear();
        return;
      case Safe10Package.SAFE_PACKAGE__SUB_PACKAGE:
        getSubPackage().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.SAFE_PACKAGE__ELEMENT:
        return element != null && !element.isEmpty();
      case Safe10Package.SAFE_PACKAGE__SUB_PACKAGE:
        return subPackage != null && !subPackage.isEmpty();
    }
    return super.eIsSet(featureID);
  }

} //SAFEPackageImpl
