/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.eclipse.sphinx.emf.ecore.ExtendedEObjectImpl;

import org.safe.metamodel.safe10.Assumption;
import org.safe.metamodel.safe10.Context;
import org.safe.metamodel.safe10.Goal;
import org.safe.metamodel.safe10.Justification;
import org.safe.metamodel.safe10.Safe10Package;
import org.safe.metamodel.safe10.SafeElementType;
import org.safe.metamodel.safe10.SafetyCase;
import org.safe.metamodel.safe10.Solution;
import org.safe.metamodel.safe10.Strategy;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Safety Case</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.SafetyCaseImpl#getElementType <em>Element Type</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.SafetyCaseImpl#getAssumption <em>Assumption</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.SafetyCaseImpl#getContext <em>Context</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.SafetyCaseImpl#getGoal <em>Goal</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.SafetyCaseImpl#getJustification <em>Justification</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.SafetyCaseImpl#getSolution <em>Solution</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.SafetyCaseImpl#getStrategy <em>Strategy</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class SafetyCaseImpl extends ExtendedEObjectImpl implements SafetyCase
{
  /**
   * The default value of the '{@link #getElementType() <em>Element Type</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getElementType()
   * @generated
   * @ordered
   */
  protected static final SafeElementType ELEMENT_TYPE_EDEFAULT = SafeElementType.UNKNOWN;

  /**
   * The cached value of the '{@link #getElementType() <em>Element Type</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getElementType()
   * @generated
   * @ordered
   */
  protected SafeElementType elementType = ELEMENT_TYPE_EDEFAULT;

  /**
   * This is true if the Element Type attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean elementTypeESet;

  /**
   * The cached value of the '{@link #getAssumption() <em>Assumption</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getAssumption()
   * @generated
   * @ordered
   */
  protected EList<Assumption> assumption;

  /**
   * The cached value of the '{@link #getContext() <em>Context</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getContext()
   * @generated
   * @ordered
   */
  protected EList<Context> context;

  /**
   * The cached value of the '{@link #getGoal() <em>Goal</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getGoal()
   * @generated
   * @ordered
   */
  protected EList<Goal> goal;

  /**
   * The cached value of the '{@link #getJustification() <em>Justification</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getJustification()
   * @generated
   * @ordered
   */
  protected EList<Justification> justification;

  /**
   * The cached value of the '{@link #getSolution() <em>Solution</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSolution()
   * @generated
   * @ordered
   */
  protected EList<Solution> solution;

  /**
   * The cached value of the '{@link #getStrategy() <em>Strategy</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getStrategy()
   * @generated
   * @ordered
   */
  protected EList<Strategy> strategy;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected SafetyCaseImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getSafetyCase();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SafeElementType getElementType()
  {
    return elementType;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setElementType(SafeElementType newElementType)
  {
    SafeElementType oldElementType = elementType;
    elementType = newElementType == null ? ELEMENT_TYPE_EDEFAULT : newElementType;
    boolean oldElementTypeESet = elementTypeESet;
    elementTypeESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.SAFETY_CASE__ELEMENT_TYPE, oldElementType, elementType, !oldElementTypeESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetElementType()
  {
    SafeElementType oldElementType = elementType;
    boolean oldElementTypeESet = elementTypeESet;
    elementType = ELEMENT_TYPE_EDEFAULT;
    elementTypeESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.SAFETY_CASE__ELEMENT_TYPE, oldElementType, ELEMENT_TYPE_EDEFAULT, oldElementTypeESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetElementType()
  {
    return elementTypeESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Assumption> getAssumption()
  {
    if (assumption == null)
    {
      assumption = new EObjectContainmentEList<Assumption>(Assumption.class, this, Safe10Package.SAFETY_CASE__ASSUMPTION);
    }
    return assumption;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Context> getContext()
  {
    if (context == null)
    {
      context = new EObjectContainmentEList<Context>(Context.class, this, Safe10Package.SAFETY_CASE__CONTEXT);
    }
    return context;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Goal> getGoal()
  {
    if (goal == null)
    {
      goal = new EObjectContainmentEList<Goal>(Goal.class, this, Safe10Package.SAFETY_CASE__GOAL);
    }
    return goal;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Justification> getJustification()
  {
    if (justification == null)
    {
      justification = new EObjectContainmentEList<Justification>(Justification.class, this, Safe10Package.SAFETY_CASE__JUSTIFICATION);
    }
    return justification;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Solution> getSolution()
  {
    if (solution == null)
    {
      solution = new EObjectContainmentEList<Solution>(Solution.class, this, Safe10Package.SAFETY_CASE__SOLUTION);
    }
    return solution;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Strategy> getStrategy()
  {
    if (strategy == null)
    {
      strategy = new EObjectContainmentEList<Strategy>(Strategy.class, this, Safe10Package.SAFETY_CASE__STRATEGY);
    }
    return strategy;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.SAFETY_CASE__ASSUMPTION:
        return ((InternalEList<?>)getAssumption()).basicRemove(otherEnd, msgs);
      case Safe10Package.SAFETY_CASE__CONTEXT:
        return ((InternalEList<?>)getContext()).basicRemove(otherEnd, msgs);
      case Safe10Package.SAFETY_CASE__GOAL:
        return ((InternalEList<?>)getGoal()).basicRemove(otherEnd, msgs);
      case Safe10Package.SAFETY_CASE__JUSTIFICATION:
        return ((InternalEList<?>)getJustification()).basicRemove(otherEnd, msgs);
      case Safe10Package.SAFETY_CASE__SOLUTION:
        return ((InternalEList<?>)getSolution()).basicRemove(otherEnd, msgs);
      case Safe10Package.SAFETY_CASE__STRATEGY:
        return ((InternalEList<?>)getStrategy()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.SAFETY_CASE__ELEMENT_TYPE:
        return getElementType();
      case Safe10Package.SAFETY_CASE__ASSUMPTION:
        return getAssumption();
      case Safe10Package.SAFETY_CASE__CONTEXT:
        return getContext();
      case Safe10Package.SAFETY_CASE__GOAL:
        return getGoal();
      case Safe10Package.SAFETY_CASE__JUSTIFICATION:
        return getJustification();
      case Safe10Package.SAFETY_CASE__SOLUTION:
        return getSolution();
      case Safe10Package.SAFETY_CASE__STRATEGY:
        return getStrategy();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.SAFETY_CASE__ELEMENT_TYPE:
   			setElementType((SafeElementType)newValue);
        return;
      case Safe10Package.SAFETY_CASE__ASSUMPTION:
        getAssumption().clear();
        getAssumption().addAll((Collection<? extends Assumption>)newValue);
        return;
      case Safe10Package.SAFETY_CASE__CONTEXT:
        getContext().clear();
        getContext().addAll((Collection<? extends Context>)newValue);
        return;
      case Safe10Package.SAFETY_CASE__GOAL:
        getGoal().clear();
        getGoal().addAll((Collection<? extends Goal>)newValue);
        return;
      case Safe10Package.SAFETY_CASE__JUSTIFICATION:
        getJustification().clear();
        getJustification().addAll((Collection<? extends Justification>)newValue);
        return;
      case Safe10Package.SAFETY_CASE__SOLUTION:
        getSolution().clear();
        getSolution().addAll((Collection<? extends Solution>)newValue);
        return;
      case Safe10Package.SAFETY_CASE__STRATEGY:
        getStrategy().clear();
        getStrategy().addAll((Collection<? extends Strategy>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.SAFETY_CASE__ELEMENT_TYPE:
        unsetElementType();
        return;
      case Safe10Package.SAFETY_CASE__ASSUMPTION:
        getAssumption().clear();
        return;
      case Safe10Package.SAFETY_CASE__CONTEXT:
        getContext().clear();
        return;
      case Safe10Package.SAFETY_CASE__GOAL:
        getGoal().clear();
        return;
      case Safe10Package.SAFETY_CASE__JUSTIFICATION:
        getJustification().clear();
        return;
      case Safe10Package.SAFETY_CASE__SOLUTION:
        getSolution().clear();
        return;
      case Safe10Package.SAFETY_CASE__STRATEGY:
        getStrategy().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.SAFETY_CASE__ELEMENT_TYPE:
        return isSetElementType();
      case Safe10Package.SAFETY_CASE__ASSUMPTION:
        return assumption != null && !assumption.isEmpty();
      case Safe10Package.SAFETY_CASE__CONTEXT:
        return context != null && !context.isEmpty();
      case Safe10Package.SAFETY_CASE__GOAL:
        return goal != null && !goal.isEmpty();
      case Safe10Package.SAFETY_CASE__JUSTIFICATION:
        return justification != null && !justification.isEmpty();
      case Safe10Package.SAFETY_CASE__SOLUTION:
        return solution != null && !solution.isEmpty();
      case Safe10Package.SAFETY_CASE__STRATEGY:
        return strategy != null && !strategy.isEmpty();
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (elementType: ");
    if (elementTypeESet) result.append(elementType); else result.append("<unset>");
    result.append(')');
    return result.toString();
  }

} //SafetyCaseImpl
