/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.safe.metamodel.safe10.RequirementsReleationship;
import org.safe.metamodel.safe10.Safe10Package;
import org.safe.metamodel.safe10.SafetyExtension;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Safety Extension</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.SafetyExtensionImpl#getRequirementsRelationship <em>Requirements Relationship</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class SafetyExtensionImpl extends SAFEElementImpl implements SafetyExtension
{
  /**
   * The cached value of the '{@link #getRequirementsRelationship() <em>Requirements Relationship</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRequirementsRelationship()
   * @generated
   * @ordered
   */
  protected EList<RequirementsReleationship> requirementsRelationship;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected SafetyExtensionImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getSafetyExtension();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<RequirementsReleationship> getRequirementsRelationship()
  {
    if (requirementsRelationship == null)
    {
      requirementsRelationship = new EObjectContainmentEList<RequirementsReleationship>(RequirementsReleationship.class, this, Safe10Package.SAFETY_EXTENSION__REQUIREMENTS_RELATIONSHIP);
    }
    return requirementsRelationship;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.SAFETY_EXTENSION__REQUIREMENTS_RELATIONSHIP:
        return ((InternalEList<?>)getRequirementsRelationship()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.SAFETY_EXTENSION__REQUIREMENTS_RELATIONSHIP:
        return getRequirementsRelationship();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.SAFETY_EXTENSION__REQUIREMENTS_RELATIONSHIP:
        getRequirementsRelationship().clear();
        getRequirementsRelationship().addAll((Collection<? extends RequirementsReleationship>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.SAFETY_EXTENSION__REQUIREMENTS_RELATIONSHIP:
        getRequirementsRelationship().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.SAFETY_EXTENSION__REQUIREMENTS_RELATIONSHIP:
        return requirementsRelationship != null && !requirementsRelationship.isEmpty();
    }
    return super.eIsSet(featureID);
  }

} //SafetyExtensionImpl
