/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.safe.metamodel.safe10.AllocatableElement;
import org.safe.metamodel.safe10.AllocationTargets;
import org.safe.metamodel.safe10.Safe10Package;
import org.safe.metamodel.safe10.Satisfy;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Satisfy</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.SatisfyImpl#getSatisfiedElement <em>Satisfied Element</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.SatisfyImpl#getSatisfyingTargets <em>Satisfying Targets</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class SatisfyImpl extends RequirementsReleationshipImpl implements Satisfy
{
  /**
   * The cached value of the '{@link #getSatisfiedElement() <em>Satisfied Element</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSatisfiedElement()
   * @generated
   * @ordered
   */
  protected EList<AllocatableElement> satisfiedElement;

  /**
   * The cached value of the '{@link #getSatisfyingTargets() <em>Satisfying Targets</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSatisfyingTargets()
   * @generated
   * @ordered
   */
  protected AllocationTargets satisfyingTargets;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected SatisfyImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getSatisfy();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<AllocatableElement> getSatisfiedElement()
  {
    if (satisfiedElement == null)
    {
      satisfiedElement = new EObjectContainmentEList<AllocatableElement>(AllocatableElement.class, this, Safe10Package.SATISFY__SATISFIED_ELEMENT);
    }
    return satisfiedElement;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AllocationTargets getSatisfyingTargets()
  {
    return satisfyingTargets;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetSatisfyingTargets(AllocationTargets newSatisfyingTargets, NotificationChain msgs)
  {
    AllocationTargets oldSatisfyingTargets = satisfyingTargets;
    satisfyingTargets = newSatisfyingTargets;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Safe10Package.SATISFY__SATISFYING_TARGETS, oldSatisfyingTargets, newSatisfyingTargets);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setSatisfyingTargets(AllocationTargets newSatisfyingTargets)
  {
    if (newSatisfyingTargets != satisfyingTargets)
    {
      NotificationChain msgs = null;
      if (satisfyingTargets != null)
        msgs = ((InternalEObject)satisfyingTargets).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Safe10Package.SATISFY__SATISFYING_TARGETS, null, msgs);
      if (newSatisfyingTargets != null)
        msgs = ((InternalEObject)newSatisfyingTargets).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - Safe10Package.SATISFY__SATISFYING_TARGETS, null, msgs);
      msgs = basicSetSatisfyingTargets(newSatisfyingTargets, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.SATISFY__SATISFYING_TARGETS, newSatisfyingTargets, newSatisfyingTargets));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.SATISFY__SATISFIED_ELEMENT:
        return ((InternalEList<?>)getSatisfiedElement()).basicRemove(otherEnd, msgs);
      case Safe10Package.SATISFY__SATISFYING_TARGETS:
        return basicSetSatisfyingTargets(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.SATISFY__SATISFIED_ELEMENT:
        return getSatisfiedElement();
      case Safe10Package.SATISFY__SATISFYING_TARGETS:
        return getSatisfyingTargets();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.SATISFY__SATISFIED_ELEMENT:
        getSatisfiedElement().clear();
        getSatisfiedElement().addAll((Collection<? extends AllocatableElement>)newValue);
        return;
      case Safe10Package.SATISFY__SATISFYING_TARGETS:
   			setSatisfyingTargets((AllocationTargets)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.SATISFY__SATISFIED_ELEMENT:
        getSatisfiedElement().clear();
        return;
      case Safe10Package.SATISFY__SATISFYING_TARGETS:
        	setSatisfyingTargets((AllocationTargets)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.SATISFY__SATISFIED_ELEMENT:
        return satisfiedElement != null && !satisfiedElement.isEmpty();
      case Safe10Package.SATISFY__SATISFYING_TARGETS:
        return satisfyingTargets != null;
    }
    return super.eIsSet(featureID);
  }

} //SatisfyImpl
