/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.util.EObjectResolvingEList;

import org.eclipse.sphinx.emf.ecore.ExtendedEObjectImpl;

import org.safe.metamodel.safe10.Assumption;
import org.safe.metamodel.safe10.Context;
import org.safe.metamodel.safe10.Goal;
import org.safe.metamodel.safe10.Justification;
import org.safe.metamodel.safe10.Safe10Package;
import org.safe.metamodel.safe10.Strategy;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Strategy</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.StrategyImpl#getJustification <em>Justification</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.StrategyImpl#getInContextOf <em>In Context Of</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.StrategyImpl#getGoal <em>Goal</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.StrategyImpl#getAssumption <em>Assumption</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class StrategyImpl extends ExtendedEObjectImpl implements Strategy
{
  /**
   * The cached value of the '{@link #getJustification() <em>Justification</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getJustification()
   * @generated
   * @ordered
   */
  protected EList<Justification> justification;

  /**
   * The cached value of the '{@link #getInContextOf() <em>In Context Of</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getInContextOf()
   * @generated
   * @ordered
   */
  protected EList<Context> inContextOf;

  /**
   * The cached value of the '{@link #getGoal() <em>Goal</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getGoal()
   * @generated
   * @ordered
   */
  protected EList<Goal> goal;

  /**
   * The cached value of the '{@link #getAssumption() <em>Assumption</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getAssumption()
   * @generated
   * @ordered
   */
  protected EList<Assumption> assumption;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected StrategyImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getStrategy();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Justification> getJustification()
  {
    if (justification == null)
    {
      justification = new EObjectResolvingEList<Justification>(Justification.class, this, Safe10Package.STRATEGY__JUSTIFICATION);
    }
    return justification;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Context> getInContextOf()
  {
    if (inContextOf == null)
    {
      inContextOf = new EObjectResolvingEList<Context>(Context.class, this, Safe10Package.STRATEGY__IN_CONTEXT_OF);
    }
    return inContextOf;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Goal> getGoal()
  {
    if (goal == null)
    {
      goal = new EObjectResolvingEList<Goal>(Goal.class, this, Safe10Package.STRATEGY__GOAL);
    }
    return goal;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<Assumption> getAssumption()
  {
    if (assumption == null)
    {
      assumption = new EObjectResolvingEList<Assumption>(Assumption.class, this, Safe10Package.STRATEGY__ASSUMPTION);
    }
    return assumption;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.STRATEGY__JUSTIFICATION:
        return getJustification();
      case Safe10Package.STRATEGY__IN_CONTEXT_OF:
        return getInContextOf();
      case Safe10Package.STRATEGY__GOAL:
        return getGoal();
      case Safe10Package.STRATEGY__ASSUMPTION:
        return getAssumption();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.STRATEGY__JUSTIFICATION:
        getJustification().clear();
        getJustification().addAll((Collection<? extends Justification>)newValue);
        return;
      case Safe10Package.STRATEGY__IN_CONTEXT_OF:
        getInContextOf().clear();
        getInContextOf().addAll((Collection<? extends Context>)newValue);
        return;
      case Safe10Package.STRATEGY__GOAL:
        getGoal().clear();
        getGoal().addAll((Collection<? extends Goal>)newValue);
        return;
      case Safe10Package.STRATEGY__ASSUMPTION:
        getAssumption().clear();
        getAssumption().addAll((Collection<? extends Assumption>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.STRATEGY__JUSTIFICATION:
        getJustification().clear();
        return;
      case Safe10Package.STRATEGY__IN_CONTEXT_OF:
        getInContextOf().clear();
        return;
      case Safe10Package.STRATEGY__GOAL:
        getGoal().clear();
        return;
      case Safe10Package.STRATEGY__ASSUMPTION:
        getAssumption().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.STRATEGY__JUSTIFICATION:
        return justification != null && !justification.isEmpty();
      case Safe10Package.STRATEGY__IN_CONTEXT_OF:
        return inContextOf != null && !inContextOf.isEmpty();
      case Safe10Package.STRATEGY__GOAL:
        return goal != null && !goal.isEmpty();
      case Safe10Package.STRATEGY__ASSUMPTION:
        return assumption != null && !assumption.isEmpty();
    }
    return super.eIsSet(featureID);
  }

} //StrategyImpl
