/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.safe.metamodel.safe10.HardwareSoftwareInterfaceSpecification;
import org.safe.metamodel.safe10.Safe10Package;
import org.safe.metamodel.safe10.TechnicalSafetyExtension;
import org.safe.metamodel.safe10.TechnicalSafetyRequirement;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Technical Safety Extension</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.TechnicalSafetyExtensionImpl#getRequirement <em>Requirement</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.TechnicalSafetyExtensionImpl#getHSISpecification <em>HSI Specification</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class TechnicalSafetyExtensionImpl extends SingleLevelSafetyExtensionImpl implements TechnicalSafetyExtension
{
  /**
   * The cached value of the '{@link #getRequirement() <em>Requirement</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRequirement()
   * @generated
   * @ordered
   */
  protected EList<TechnicalSafetyRequirement> requirement;

  /**
   * The cached value of the '{@link #getHSISpecification() <em>HSI Specification</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getHSISpecification()
   * @generated
   * @ordered
   */
  protected HardwareSoftwareInterfaceSpecification hSISpecification;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TechnicalSafetyExtensionImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getTechnicalSafetyExtension();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<TechnicalSafetyRequirement> getRequirement()
  {
    if (requirement == null)
    {
      requirement = new EObjectContainmentEList<TechnicalSafetyRequirement>(TechnicalSafetyRequirement.class, this, Safe10Package.TECHNICAL_SAFETY_EXTENSION__REQUIREMENT);
    }
    return requirement;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HardwareSoftwareInterfaceSpecification getHSISpecification()
  {
    return hSISpecification;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetHSISpecification(HardwareSoftwareInterfaceSpecification newHSISpecification, NotificationChain msgs)
  {
    HardwareSoftwareInterfaceSpecification oldHSISpecification = hSISpecification;
    hSISpecification = newHSISpecification;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Safe10Package.TECHNICAL_SAFETY_EXTENSION__HSI_SPECIFICATION, oldHSISpecification, newHSISpecification);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setHSISpecification(HardwareSoftwareInterfaceSpecification newHSISpecification)
  {
    if (newHSISpecification != hSISpecification)
    {
      NotificationChain msgs = null;
      if (hSISpecification != null)
        msgs = ((InternalEObject)hSISpecification).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Safe10Package.TECHNICAL_SAFETY_EXTENSION__HSI_SPECIFICATION, null, msgs);
      if (newHSISpecification != null)
        msgs = ((InternalEObject)newHSISpecification).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - Safe10Package.TECHNICAL_SAFETY_EXTENSION__HSI_SPECIFICATION, null, msgs);
      msgs = basicSetHSISpecification(newHSISpecification, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.TECHNICAL_SAFETY_EXTENSION__HSI_SPECIFICATION, newHSISpecification, newHSISpecification));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case Safe10Package.TECHNICAL_SAFETY_EXTENSION__REQUIREMENT:
        return ((InternalEList<?>)getRequirement()).basicRemove(otherEnd, msgs);
      case Safe10Package.TECHNICAL_SAFETY_EXTENSION__HSI_SPECIFICATION:
        return basicSetHSISpecification(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.TECHNICAL_SAFETY_EXTENSION__REQUIREMENT:
        return getRequirement();
      case Safe10Package.TECHNICAL_SAFETY_EXTENSION__HSI_SPECIFICATION:
        return getHSISpecification();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.TECHNICAL_SAFETY_EXTENSION__REQUIREMENT:
        getRequirement().clear();
        getRequirement().addAll((Collection<? extends TechnicalSafetyRequirement>)newValue);
        return;
      case Safe10Package.TECHNICAL_SAFETY_EXTENSION__HSI_SPECIFICATION:
   			setHSISpecification((HardwareSoftwareInterfaceSpecification)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.TECHNICAL_SAFETY_EXTENSION__REQUIREMENT:
        getRequirement().clear();
        return;
      case Safe10Package.TECHNICAL_SAFETY_EXTENSION__HSI_SPECIFICATION:
        	setHSISpecification((HardwareSoftwareInterfaceSpecification)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.TECHNICAL_SAFETY_EXTENSION__REQUIREMENT:
        return requirement != null && !requirement.isEmpty();
      case Safe10Package.TECHNICAL_SAFETY_EXTENSION__HSI_SPECIFICATION:
        return hSISpecification != null;
    }
    return super.eIsSet(featureID);
  }

} //TechnicalSafetyExtensionImpl
