/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.safe.metamodel.safe10.Safe10Package;
import org.safe.metamodel.safe10.VoterActivationSchemeEnum;
import org.safe.metamodel.safe10.VoterConfig;
import org.safe.metamodel.safe10.VotingAlgorithmEnum;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Voter Config</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.VoterConfigImpl#getNumberOfItems <em>Number Of Items</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.VoterConfigImpl#getConsensusThreshold <em>Consensus Threshold</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.VoterConfigImpl#getAlgorithm <em>Algorithm</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.VoterConfigImpl#getActivationScheme <em>Activation Scheme</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class VoterConfigImpl extends IdentifiableImpl implements VoterConfig
{
  /**
   * The default value of the '{@link #getNumberOfItems() <em>Number Of Items</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNumberOfItems()
   * @generated
   * @ordered
   */
  protected static final Integer NUMBER_OF_ITEMS_EDEFAULT = new Integer(0);

  /**
   * The cached value of the '{@link #getNumberOfItems() <em>Number Of Items</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNumberOfItems()
   * @generated
   * @ordered
   */
  protected Integer numberOfItems = NUMBER_OF_ITEMS_EDEFAULT;

  /**
   * This is true if the Number Of Items attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean numberOfItemsESet;

  /**
   * The default value of the '{@link #getConsensusThreshold() <em>Consensus Threshold</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getConsensusThreshold()
   * @generated
   * @ordered
   */
  protected static final Integer CONSENSUS_THRESHOLD_EDEFAULT = new Integer(0);

  /**
   * The cached value of the '{@link #getConsensusThreshold() <em>Consensus Threshold</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getConsensusThreshold()
   * @generated
   * @ordered
   */
  protected Integer consensusThreshold = CONSENSUS_THRESHOLD_EDEFAULT;

  /**
   * This is true if the Consensus Threshold attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean consensusThresholdESet;

  /**
   * The default value of the '{@link #getAlgorithm() <em>Algorithm</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getAlgorithm()
   * @generated
   * @ordered
   */
  protected static final VotingAlgorithmEnum ALGORITHM_EDEFAULT = VotingAlgorithmEnum.MEDIAN;

  /**
   * The cached value of the '{@link #getAlgorithm() <em>Algorithm</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getAlgorithm()
   * @generated
   * @ordered
   */
  protected VotingAlgorithmEnum algorithm = ALGORITHM_EDEFAULT;

  /**
   * This is true if the Algorithm attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean algorithmESet;

  /**
   * The default value of the '{@link #getActivationScheme() <em>Activation Scheme</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getActivationScheme()
   * @generated
   * @ordered
   */
  protected static final VoterActivationSchemeEnum ACTIVATION_SCHEME_EDEFAULT = VoterActivationSchemeEnum.EVENT_TRIGGERED;

  /**
   * The cached value of the '{@link #getActivationScheme() <em>Activation Scheme</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getActivationScheme()
   * @generated
   * @ordered
   */
  protected VoterActivationSchemeEnum activationScheme = ACTIVATION_SCHEME_EDEFAULT;

  /**
   * This is true if the Activation Scheme attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean activationSchemeESet;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected VoterConfigImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getVoterConfig();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Integer getNumberOfItems()
  {
    return numberOfItems;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setNumberOfItems(Integer newNumberOfItems)
  {
    Integer oldNumberOfItems = numberOfItems;
    numberOfItems = newNumberOfItems;
    boolean oldNumberOfItemsESet = numberOfItemsESet;
    numberOfItemsESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.VOTER_CONFIG__NUMBER_OF_ITEMS, oldNumberOfItems, numberOfItems, !oldNumberOfItemsESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetNumberOfItems()
  {
    Integer oldNumberOfItems = numberOfItems;
    boolean oldNumberOfItemsESet = numberOfItemsESet;
    numberOfItems = NUMBER_OF_ITEMS_EDEFAULT;
    numberOfItemsESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.VOTER_CONFIG__NUMBER_OF_ITEMS, oldNumberOfItems, NUMBER_OF_ITEMS_EDEFAULT, oldNumberOfItemsESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetNumberOfItems()
  {
    return numberOfItemsESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Integer getConsensusThreshold()
  {
    return consensusThreshold;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setConsensusThreshold(Integer newConsensusThreshold)
  {
    Integer oldConsensusThreshold = consensusThreshold;
    consensusThreshold = newConsensusThreshold;
    boolean oldConsensusThresholdESet = consensusThresholdESet;
    consensusThresholdESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.VOTER_CONFIG__CONSENSUS_THRESHOLD, oldConsensusThreshold, consensusThreshold, !oldConsensusThresholdESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetConsensusThreshold()
  {
    Integer oldConsensusThreshold = consensusThreshold;
    boolean oldConsensusThresholdESet = consensusThresholdESet;
    consensusThreshold = CONSENSUS_THRESHOLD_EDEFAULT;
    consensusThresholdESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.VOTER_CONFIG__CONSENSUS_THRESHOLD, oldConsensusThreshold, CONSENSUS_THRESHOLD_EDEFAULT, oldConsensusThresholdESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetConsensusThreshold()
  {
    return consensusThresholdESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public VotingAlgorithmEnum getAlgorithm()
  {
    return algorithm;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setAlgorithm(VotingAlgorithmEnum newAlgorithm)
  {
    VotingAlgorithmEnum oldAlgorithm = algorithm;
    algorithm = newAlgorithm == null ? ALGORITHM_EDEFAULT : newAlgorithm;
    boolean oldAlgorithmESet = algorithmESet;
    algorithmESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.VOTER_CONFIG__ALGORITHM, oldAlgorithm, algorithm, !oldAlgorithmESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetAlgorithm()
  {
    VotingAlgorithmEnum oldAlgorithm = algorithm;
    boolean oldAlgorithmESet = algorithmESet;
    algorithm = ALGORITHM_EDEFAULT;
    algorithmESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.VOTER_CONFIG__ALGORITHM, oldAlgorithm, ALGORITHM_EDEFAULT, oldAlgorithmESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetAlgorithm()
  {
    return algorithmESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public VoterActivationSchemeEnum getActivationScheme()
  {
    return activationScheme;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setActivationScheme(VoterActivationSchemeEnum newActivationScheme)
  {
    VoterActivationSchemeEnum oldActivationScheme = activationScheme;
    activationScheme = newActivationScheme == null ? ACTIVATION_SCHEME_EDEFAULT : newActivationScheme;
    boolean oldActivationSchemeESet = activationSchemeESet;
    activationSchemeESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.VOTER_CONFIG__ACTIVATION_SCHEME, oldActivationScheme, activationScheme, !oldActivationSchemeESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetActivationScheme()
  {
    VoterActivationSchemeEnum oldActivationScheme = activationScheme;
    boolean oldActivationSchemeESet = activationSchemeESet;
    activationScheme = ACTIVATION_SCHEME_EDEFAULT;
    activationSchemeESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.VOTER_CONFIG__ACTIVATION_SCHEME, oldActivationScheme, ACTIVATION_SCHEME_EDEFAULT, oldActivationSchemeESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetActivationScheme()
  {
    return activationSchemeESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.VOTER_CONFIG__NUMBER_OF_ITEMS:
        return getNumberOfItems();
      case Safe10Package.VOTER_CONFIG__CONSENSUS_THRESHOLD:
        return getConsensusThreshold();
      case Safe10Package.VOTER_CONFIG__ALGORITHM:
        return getAlgorithm();
      case Safe10Package.VOTER_CONFIG__ACTIVATION_SCHEME:
        return getActivationScheme();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.VOTER_CONFIG__NUMBER_OF_ITEMS:
   			setNumberOfItems((Integer)newValue);
        return;
      case Safe10Package.VOTER_CONFIG__CONSENSUS_THRESHOLD:
   			setConsensusThreshold((Integer)newValue);
        return;
      case Safe10Package.VOTER_CONFIG__ALGORITHM:
   			setAlgorithm((VotingAlgorithmEnum)newValue);
        return;
      case Safe10Package.VOTER_CONFIG__ACTIVATION_SCHEME:
   			setActivationScheme((VoterActivationSchemeEnum)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.VOTER_CONFIG__NUMBER_OF_ITEMS:
        unsetNumberOfItems();
        return;
      case Safe10Package.VOTER_CONFIG__CONSENSUS_THRESHOLD:
        unsetConsensusThreshold();
        return;
      case Safe10Package.VOTER_CONFIG__ALGORITHM:
        unsetAlgorithm();
        return;
      case Safe10Package.VOTER_CONFIG__ACTIVATION_SCHEME:
        unsetActivationScheme();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.VOTER_CONFIG__NUMBER_OF_ITEMS:
        return isSetNumberOfItems();
      case Safe10Package.VOTER_CONFIG__CONSENSUS_THRESHOLD:
        return isSetConsensusThreshold();
      case Safe10Package.VOTER_CONFIG__ALGORITHM:
        return isSetAlgorithm();
      case Safe10Package.VOTER_CONFIG__ACTIVATION_SCHEME:
        return isSetActivationScheme();
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (numberOfItems: ");
    if (numberOfItemsESet) result.append(numberOfItems); else result.append("<unset>");
    result.append(", consensusThreshold: ");
    if (consensusThresholdESet) result.append(consensusThreshold); else result.append("<unset>");
    result.append(", algorithm: ");
    if (algorithmESet) result.append(algorithm); else result.append("<unset>");
    result.append(", activationScheme: ");
    if (activationSchemeESet) result.append(activationScheme); else result.append("<unset>");
    result.append(')');
    return result.toString();
  }

} //VoterConfigImpl
