/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis France and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 *     itemis France - Initial API and implementation
 * 
 * </copyright>
 */
package org.safe.metamodel.safe10.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectResolvingEList;

import org.safe.metamodel.safe10.Safe10Package;
import org.safe.metamodel.safe10.SafeState;
import org.safe.metamodel.safe10.WarningAndDegradationHandle;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Warning And Degradation Handle</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.safe.metamodel.safe10.impl.WarningAndDegradationHandleImpl#getGuaranteedOperationsTimeInterval <em>Guaranteed Operations Time Interval</em>}</li>
 *   <li>{@link org.safe.metamodel.safe10.impl.WarningAndDegradationHandleImpl#getSafeState <em>Safe State</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class WarningAndDegradationHandleImpl extends HandleImpl implements WarningAndDegradationHandle
{
  /**
   * The default value of the '{@link #getGuaranteedOperationsTimeInterval() <em>Guaranteed Operations Time Interval</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getGuaranteedOperationsTimeInterval()
   * @generated
   * @ordered
   */
  protected static final Integer GUARANTEED_OPERATIONS_TIME_INTERVAL_EDEFAULT = new Integer(0);

  /**
   * The cached value of the '{@link #getGuaranteedOperationsTimeInterval() <em>Guaranteed Operations Time Interval</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getGuaranteedOperationsTimeInterval()
   * @generated
   * @ordered
   */
  protected Integer guaranteedOperationsTimeInterval = GUARANTEED_OPERATIONS_TIME_INTERVAL_EDEFAULT;

  /**
   * This is true if the Guaranteed Operations Time Interval attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean guaranteedOperationsTimeIntervalESet;

  /**
   * The cached value of the '{@link #getSafeState() <em>Safe State</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSafeState()
   * @generated
   * @ordered
   */
  protected EList<SafeState> safeState;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected WarningAndDegradationHandleImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return Safe10Package.eINSTANCE.getWarningAndDegradationHandle();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Integer getGuaranteedOperationsTimeInterval()
  {
    return guaranteedOperationsTimeInterval;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setGuaranteedOperationsTimeInterval(Integer newGuaranteedOperationsTimeInterval)
  {
    Integer oldGuaranteedOperationsTimeInterval = guaranteedOperationsTimeInterval;
    guaranteedOperationsTimeInterval = newGuaranteedOperationsTimeInterval;
    boolean oldGuaranteedOperationsTimeIntervalESet = guaranteedOperationsTimeIntervalESet;
    guaranteedOperationsTimeIntervalESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, Safe10Package.WARNING_AND_DEGRADATION_HANDLE__GUARANTEED_OPERATIONS_TIME_INTERVAL, oldGuaranteedOperationsTimeInterval, guaranteedOperationsTimeInterval, !oldGuaranteedOperationsTimeIntervalESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetGuaranteedOperationsTimeInterval()
  {
    Integer oldGuaranteedOperationsTimeInterval = guaranteedOperationsTimeInterval;
    boolean oldGuaranteedOperationsTimeIntervalESet = guaranteedOperationsTimeIntervalESet;
    guaranteedOperationsTimeInterval = GUARANTEED_OPERATIONS_TIME_INTERVAL_EDEFAULT;
    guaranteedOperationsTimeIntervalESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, Safe10Package.WARNING_AND_DEGRADATION_HANDLE__GUARANTEED_OPERATIONS_TIME_INTERVAL, oldGuaranteedOperationsTimeInterval, GUARANTEED_OPERATIONS_TIME_INTERVAL_EDEFAULT, oldGuaranteedOperationsTimeIntervalESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetGuaranteedOperationsTimeInterval()
  {
    return guaranteedOperationsTimeIntervalESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<SafeState> getSafeState()
  {
    if (safeState == null)
    {
      safeState = new EObjectResolvingEList<SafeState>(SafeState.class, this, Safe10Package.WARNING_AND_DEGRADATION_HANDLE__SAFE_STATE);
    }
    return safeState;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case Safe10Package.WARNING_AND_DEGRADATION_HANDLE__GUARANTEED_OPERATIONS_TIME_INTERVAL:
        return getGuaranteedOperationsTimeInterval();
      case Safe10Package.WARNING_AND_DEGRADATION_HANDLE__SAFE_STATE:
        return getSafeState();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case Safe10Package.WARNING_AND_DEGRADATION_HANDLE__GUARANTEED_OPERATIONS_TIME_INTERVAL:
   			setGuaranteedOperationsTimeInterval((Integer)newValue);
        return;
      case Safe10Package.WARNING_AND_DEGRADATION_HANDLE__SAFE_STATE:
        getSafeState().clear();
        getSafeState().addAll((Collection<? extends SafeState>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.WARNING_AND_DEGRADATION_HANDLE__GUARANTEED_OPERATIONS_TIME_INTERVAL:
        unsetGuaranteedOperationsTimeInterval();
        return;
      case Safe10Package.WARNING_AND_DEGRADATION_HANDLE__SAFE_STATE:
        getSafeState().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case Safe10Package.WARNING_AND_DEGRADATION_HANDLE__GUARANTEED_OPERATIONS_TIME_INTERVAL:
        return isSetGuaranteedOperationsTimeInterval();
      case Safe10Package.WARNING_AND_DEGRADATION_HANDLE__SAFE_STATE:
        return safeState != null && !safeState.isEmpty();
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (guaranteedOperationsTimeInterval: ");
    if (guaranteedOperationsTimeIntervalESet) result.append(guaranteedOperationsTimeInterval); else result.append("<unset>");
    result.append(')');
    return result.toString();
  }

} //WarningAndDegradationHandleImpl
