/**
 */
package org.safe.metamodel.safe10.util;

import java.net.URI;
import java.net.URL;

import java.util.Map;

import javax.xml.datatype.XMLGregorianCalendar;

import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.util.EObjectValidator;

import org.eclipse.emf.ecore.xml.type.util.XMLTypeUtil;

import org.safe.metamodel.safe10.ASILDecomposedEnum;
import org.safe.metamodel.safe10.ASILEnum;
import org.safe.metamodel.safe10.AUTOSARRunnableEntitySequenceConstraint;
import org.safe.metamodel.safe10.AUTOSARSequenceConstraint;
import org.safe.metamodel.safe10.AbstractErrorBehavior;
import org.safe.metamodel.safe10.AbstractQuantifiableSafetyRequirement;
import org.safe.metamodel.safe10.AbstractReference;
import org.safe.metamodel.safe10.AbstractSafetyRequirement;
import org.safe.metamodel.safe10.Activator;
import org.safe.metamodel.safe10.Actor;
import org.safe.metamodel.safe10.ActuatorError;
import org.safe.metamodel.safe10.ActuatorErrorDetection;
import org.safe.metamodel.safe10.ActuatorMonitor;
import org.safe.metamodel.safe10.AlivenessCheckpointTooEarly;
import org.safe.metamodel.safe10.AlivenessCheckpointTooLate;
import org.safe.metamodel.safe10.AlivenessCheckpointTooOften;
import org.safe.metamodel.safe10.AlivenessMonitor;
import org.safe.metamodel.safe10.AllocatableElement;
import org.safe.metamodel.safe10.AllocationTargets;
import org.safe.metamodel.safe10.AnalysisReport;
import org.safe.metamodel.safe10.Application;
import org.safe.metamodel.safe10.Assumption;
import org.safe.metamodel.safe10.AutosarAbstractComponentInstanceRef;
import org.safe.metamodel.safe10.AutosarAbstractPortInComponentInstanceRef;
import org.safe.metamodel.safe10.AutosarActuatorMonitor;
import org.safe.metamodel.safe10.AutosarAlivenessMonitor;
import org.safe.metamodel.safe10.AutosarCRC;
import org.safe.metamodel.safe10.AutosarCheckPoint;
import org.safe.metamodel.safe10.AutosarClientServerOperationInstanceRef;
import org.safe.metamodel.safe10.AutosarComparison;
import org.safe.metamodel.safe10.AutosarComparisonParam;
import org.safe.metamodel.safe10.AutosarComponentInCompositionInstanceRef;
import org.safe.metamodel.safe10.AutosarContext;
import org.safe.metamodel.safe10.AutosarContextRangeCheck;
import org.safe.metamodel.safe10.AutosarEvaluationFunction;
import org.safe.metamodel.safe10.AutosarGradientCheck;
import org.safe.metamodel.safe10.AutosarHardwareSafetyExtension;
import org.safe.metamodel.safe10.AutosarInstanceRef;
import org.safe.metamodel.safe10.AutosarModeInPortFromComponentInCompositionInstanceRef;
import org.safe.metamodel.safe10.AutosarPortInCompositionInstanceRef;
import org.safe.metamodel.safe10.AutosarReference;
import org.safe.metamodel.safe10.AutosarSafetyExtension;
import org.safe.metamodel.safe10.AutosarSystemSafetyExtension;
import org.safe.metamodel.safe10.AutosarUndefinedInstanceRef;
import org.safe.metamodel.safe10.AutosarVariableDataPrototypeInstanceRef;
import org.safe.metamodel.safe10.AutosarVfbSafetyExtension;
import org.safe.metamodel.safe10.Avoid;
import org.safe.metamodel.safe10.BooleanConfigParameterValue;
import org.safe.metamodel.safe10.CHROMOSOMEHealthMonitorNotification;
import org.safe.metamodel.safe10.CHROMOSOMEReference;
import org.safe.metamodel.safe10.CRC;
import org.safe.metamodel.safe10.CRCConfig;
import org.safe.metamodel.safe10.CRCErrorDetection;
import org.safe.metamodel.safe10.CRCFailed;
import org.safe.metamodel.safe10.CheckPoint;
import org.safe.metamodel.safe10.ChromosomeApplicationHealthMonitor;
import org.safe.metamodel.safe10.ChromosomeApplicationSafetyExtension;
import org.safe.metamodel.safe10.ChromosomeComparison;
import org.safe.metamodel.safe10.ChromosomeComparisonParameter;
import org.safe.metamodel.safe10.ChromosomeComponentModeCondition;
import org.safe.metamodel.safe10.ChromosomeCpuSelfTest;
import org.safe.metamodel.safe10.ChromosomeErrorEventCondition;
import org.safe.metamodel.safe10.ChromosomeErrorHandler;
import org.safe.metamodel.safe10.ChromosomeHealthMonitor;
import org.safe.metamodel.safe10.ChromosomeHeartbeatReceiver;
import org.safe.metamodel.safe10.ChromosomeHeartbeatSender;
import org.safe.metamodel.safe10.ChromosomeMemoryTest;
import org.safe.metamodel.safe10.ChromosomeNodeHealthMonitor;
import org.safe.metamodel.safe10.ChromosomeSafeExtension;
import org.safe.metamodel.safe10.ChromosomeSystemSafetyExtension;
import org.safe.metamodel.safe10.ChromosomeVoter;
import org.safe.metamodel.safe10.ChromosomeVoterParameter;
import org.safe.metamodel.safe10.CodeGenerationConfiguration;
import org.safe.metamodel.safe10.Comparison;
import org.safe.metamodel.safe10.ComparisonDetection;
import org.safe.metamodel.safe10.ComparisonFalse;
import org.safe.metamodel.safe10.ComparisonOperationEnum;
import org.safe.metamodel.safe10.ComparisonParameter;
import org.safe.metamodel.safe10.ComparisonTrue;
import org.safe.metamodel.safe10.Component;
import org.safe.metamodel.safe10.ComponentModeInstanceRef;
import org.safe.metamodel.safe10.ComponentPrototypeCRC;
import org.safe.metamodel.safe10.ConfigParameter;
import org.safe.metamodel.safe10.ConfigParameterValue;
import org.safe.metamodel.safe10.ConstantComparisonParameter;
import org.safe.metamodel.safe10.Context;
import org.safe.metamodel.safe10.ContextParameter;
import org.safe.metamodel.safe10.ContextRangeCheck;
import org.safe.metamodel.safe10.ContextRangeCheckDetection;
import org.safe.metamodel.safe10.ControlBlock;
import org.safe.metamodel.safe10.ControlFlowError;
import org.safe.metamodel.safe10.ControlFlowErrorDetection;
import org.safe.metamodel.safe10.ControlFlowMonitor;
import org.safe.metamodel.safe10.ControlFlowPolicy;
import org.safe.metamodel.safe10.ControllabilityClassKind;
import org.safe.metamodel.safe10.ControllabilityReference;
import org.safe.metamodel.safe10.CpuSelfTest;
import org.safe.metamodel.safe10.CpuSelfTestConfig;
import org.safe.metamodel.safe10.CpuSelfTestDetection;
import org.safe.metamodel.safe10.CpuSelfTestFailed;
import org.safe.metamodel.safe10.CpuTestAlgorithmEnum;
import org.safe.metamodel.safe10.DesignLevelSafetyExtension;
import org.safe.metamodel.safe10.DesignSpecification;
import org.safe.metamodel.safe10.Detect;
import org.safe.metamodel.safe10.DevelopmentCategory;
import org.safe.metamodel.safe10.DiagnosticCoverageContextEnum;
import org.safe.metamodel.safe10.DiagnosticCoverageTypeEnum;
import org.safe.metamodel.safe10.EMPAnalysis;
import org.safe.metamodel.safe10.EMPBswModule;
import org.safe.metamodel.safe10.EMPDesign;
import org.safe.metamodel.safe10.EMPHwComponent;
import org.safe.metamodel.safe10.EMPReference;
import org.safe.metamodel.safe10.EMPSwComponent;
import org.safe.metamodel.safe10.EMTypeAnalysis;
import org.safe.metamodel.safe10.EMTypeApplicationEnvironment;
import org.safe.metamodel.safe10.EMTypeBswModule;
import org.safe.metamodel.safe10.EMTypeDesign;
import org.safe.metamodel.safe10.EMTypeHwComponent;
import org.safe.metamodel.safe10.EMTypeSwComponent;
import org.safe.metamodel.safe10.EastADLErrorBehavior;
import org.safe.metamodel.safe10.EastAdlReference;
import org.safe.metamodel.safe10.ErrorBehaviorKind;
import org.safe.metamodel.safe10.ErrorBehaviorMapping;
import org.safe.metamodel.safe10.ErrorModel;
import org.safe.metamodel.safe10.ErrorModelInstanceRef;
import org.safe.metamodel.safe10.ErrorModelKind;
import org.safe.metamodel.safe10.ErrorModelMapping;
import org.safe.metamodel.safe10.ErrorModelPrototype;
import org.safe.metamodel.safe10.ErrorModelPrototype_analysisFunctionTarget;
import org.safe.metamodel.safe10.ErrorModelPrototype_designFunctionTarget;
import org.safe.metamodel.safe10.ErrorModelPrototype_hwTarget;
import org.safe.metamodel.safe10.ErrorModelType;
import org.safe.metamodel.safe10.EvaluationFunction;
import org.safe.metamodel.safe10.ExposureClassKind;
import org.safe.metamodel.safe10.FMEAReport;
import org.safe.metamodel.safe10.FailureLogicFormula;
import org.safe.metamodel.safe10.FailureRate;
import org.safe.metamodel.safe10.FaultFailurePort_functionTarget;
import org.safe.metamodel.safe10.FaultFailurePort_hwPinTarget;
import org.safe.metamodel.safe10.FaultFailurePort_hwPortTarget;
import org.safe.metamodel.safe10.FaultFailurePropagationLink;
import org.safe.metamodel.safe10.FieldTestProtocol;
import org.safe.metamodel.safe10.Filter;
import org.safe.metamodel.safe10.FilterBasedHandling;
import org.safe.metamodel.safe10.FilterError;
import org.safe.metamodel.safe10.FilterExpression;
import org.safe.metamodel.safe10.FilterParameter;
import org.safe.metamodel.safe10.FloatConfigParameterValue;
import org.safe.metamodel.safe10.FormulaDocumentation;
import org.safe.metamodel.safe10.FormulaExpression;
import org.safe.metamodel.safe10.FunctionBehaviorKind;
import org.safe.metamodel.safe10.FunctionalSafetyExtension;
import org.safe.metamodel.safe10.FunctionalSafetyRequirement;
import org.safe.metamodel.safe10.Goal;
import org.safe.metamodel.safe10.GradientCheck;
import org.safe.metamodel.safe10.GradientCheckDetection;
import org.safe.metamodel.safe10.GradientTooHigh;
import org.safe.metamodel.safe10.GradientTooLow;
import org.safe.metamodel.safe10.HSIElementCategory;
import org.safe.metamodel.safe10.HWArchitecturalMetrics;
import org.safe.metamodel.safe10.HWComponentPrototypeScope;
import org.safe.metamodel.safe10.HWComponentQuantifiedFMFromPart;
import org.safe.metamodel.safe10.HWElementFailureRateClass;
import org.safe.metamodel.safe10.HWElementPrototypeScope;
import org.safe.metamodel.safe10.HWElementScopeInstanceRef;
import org.safe.metamodel.safe10.HWFMSingleContribution;
import org.safe.metamodel.safe10.HWFMSingleContributionFormula;
import org.safe.metamodel.safe10.HWFailureClassContainer;
import org.safe.metamodel.safe10.HWFailureClassContributionFormula;
import org.safe.metamodel.safe10.HWFailureMode;
import org.safe.metamodel.safe10.HWFailureRate;
import org.safe.metamodel.safe10.HWFault;
import org.safe.metamodel.safe10.HWFaultMetricsEnum;
import org.safe.metamodel.safe10.HWLFTargetFailureRateClassEnum;
import org.safe.metamodel.safe10.HWLambdaPartFormula;
import org.safe.metamodel.safe10.HWLatentFaultMetric;
import org.safe.metamodel.safe10.HWLatentFaultMetricFormula;
import org.safe.metamodel.safe10.HWMultiplePointFaultEnum;
import org.safe.metamodel.safe10.HWPMHF;
import org.safe.metamodel.safe10.HWPMHFFormula;
import org.safe.metamodel.safe10.HWPartFailure;
import org.safe.metamodel.safe10.HWPartFailureAnalysis;
import org.safe.metamodel.safe10.HWPartFailureMode;
import org.safe.metamodel.safe10.HWPartFailureRate;
import org.safe.metamodel.safe10.HWPointFaultEnum;
import org.safe.metamodel.safe10.HWProbabilisticValue;
import org.safe.metamodel.safe10.HWQuantitativeFailureAnalysis;
import org.safe.metamodel.safe10.HWRFTargetFailureRateClassEnum;
import org.safe.metamodel.safe10.HWSPFTargetFailureRateClassEnum;
import org.safe.metamodel.safe10.HWSinglePointFaultMetric;
import org.safe.metamodel.safe10.HWSinglePointFaultMetricFormula;
import org.safe.metamodel.safe10.HWTargetValuesPMHFEnum;
import org.safe.metamodel.safe10.HWValuesFailureRateClassEnum;
import org.safe.metamodel.safe10.Handle;
import org.safe.metamodel.safe10.HandlingType;
import org.safe.metamodel.safe10.HardwareComponentFailure;
import org.safe.metamodel.safe10.HardwareFailureAnalysis;
import org.safe.metamodel.safe10.HardwareSafetyExtension;
import org.safe.metamodel.safe10.HardwareSafetyRequirement;
import org.safe.metamodel.safe10.HardwareSoftwareInterfaceElement;
import org.safe.metamodel.safe10.HardwareSoftwareInterfaceSpecification;
import org.safe.metamodel.safe10.Hazard;
import org.safe.metamodel.safe10.HazardandRiskSafetyExtension;
import org.safe.metamodel.safe10.HazardousEvent;
import org.safe.metamodel.safe10.HealthMonitor;
import org.safe.metamodel.safe10.HealthMonitorErrorCondition;
import org.safe.metamodel.safe10.HealthMonitoring;
import org.safe.metamodel.safe10.HeartBeatDeadlineMissed;
import org.safe.metamodel.safe10.HeartBeatDetection;
import org.safe.metamodel.safe10.Heartbeat;
import org.safe.metamodel.safe10.HeartbeatConfig;
import org.safe.metamodel.safe10.HeartbeatReceiver;
import org.safe.metamodel.safe10.HeartbeatSender;
import org.safe.metamodel.safe10.HwComponentScopeInstanceRef;
import org.safe.metamodel.safe10.Identifiable;
import org.safe.metamodel.safe10.IdentifierConfigParameterValue;
import org.safe.metamodel.safe10.ImplementationSafetyExtension;
import org.safe.metamodel.safe10.InputBlock;
import org.safe.metamodel.safe10.IntegerConfigParameterValue;
import org.safe.metamodel.safe10.InterfaceCRC;
import org.safe.metamodel.safe10.Item;
import org.safe.metamodel.safe10.ItemFunctionDescription;
import org.safe.metamodel.safe10.Justification;
import org.safe.metamodel.safe10.MFPBswPort;
import org.safe.metamodel.safe10.MFPFunctionPort;
import org.safe.metamodel.safe10.MFPHardwarePin;
import org.safe.metamodel.safe10.MFPHardwarePort;
import org.safe.metamodel.safe10.MFPOperation;
import org.safe.metamodel.safe10.MFPSwcPort;
import org.safe.metamodel.safe10.MFPVariable;
import org.safe.metamodel.safe10.MTComposite;
import org.safe.metamodel.safe10.MTCompositeElementPrototype;
import org.safe.metamodel.safe10.MTPrimitive;
import org.safe.metamodel.safe10.MalfunctionInstanceRef;
import org.safe.metamodel.safe10.MalfunctionMapping;
import org.safe.metamodel.safe10.MalfunctionPrototype;
import org.safe.metamodel.safe10.MalfunctionType;
import org.safe.metamodel.safe10.MemoryRange;
import org.safe.metamodel.safe10.MemorySelfTest;
import org.safe.metamodel.safe10.MemorySelfTestConfig;
import org.safe.metamodel.safe10.MemorySelfTestFailed;
import org.safe.metamodel.safe10.MemorySelfTesting;
import org.safe.metamodel.safe10.MemoryTestAlgorithmsEnum;
import org.safe.metamodel.safe10.MultiLevelSafetyExtension;
import org.safe.metamodel.safe10.NativeErrorBehavior;
import org.safe.metamodel.safe10.Node;
import org.safe.metamodel.safe10.OperatingMode;
import org.safe.metamodel.safe10.OperationBlock;
import org.safe.metamodel.safe10.OperationalSituation;
import org.safe.metamodel.safe10.OutputBlock;
import org.safe.metamodel.safe10.PackageableElement;
import org.safe.metamodel.safe10.QuantifiedDiagnosticCoverageProperty;
import org.safe.metamodel.safe10.QuantifiedHWProperty;
import org.safe.metamodel.safe10.QuantitativeErrorModel;
import org.safe.metamodel.safe10.RangeCheckContext;
import org.safe.metamodel.safe10.Referrable;
import org.safe.metamodel.safe10.RequirementTypeEnum;
import org.safe.metamodel.safe10.RequirementsLink;
import org.safe.metamodel.safe10.RequirementsLinkTypeEnum;
import org.safe.metamodel.safe10.RequirementsReleationship;
import org.safe.metamodel.safe10.Restrictable;
import org.safe.metamodel.safe10.Restriction;
import org.safe.metamodel.safe10.RiskDescription;
import org.safe.metamodel.safe10.RunnableEntitySequenceElement;
import org.safe.metamodel.safe10.SAFE;
import org.safe.metamodel.safe10.SAFEElement;
import org.safe.metamodel.safe10.SAFEPackage;
import org.safe.metamodel.safe10.Safe10Package;
import org.safe.metamodel.safe10.SafeElementType;
import org.safe.metamodel.safe10.SafeState;
import org.safe.metamodel.safe10.SafetyCase;
import org.safe.metamodel.safe10.SafetyConcept;
import org.safe.metamodel.safe10.SafetyExtension;
import org.safe.metamodel.safe10.Satisfy;
import org.safe.metamodel.safe10.SequenceBlock;
import org.safe.metamodel.safe10.SeverityClassKind;
import org.safe.metamodel.safe10.SingleLevelSafetyExtension;
import org.safe.metamodel.safe10.Situation;
import org.safe.metamodel.safe10.SoftwareAlivenessDetection;
import org.safe.metamodel.safe10.SoftwareSafetyExtension;
import org.safe.metamodel.safe10.SoftwareSafetyRequirement;
import org.safe.metamodel.safe10.Solution;
import org.safe.metamodel.safe10.Strategy;
import org.safe.metamodel.safe10.StringConfigParameterValue;
import org.safe.metamodel.safe10.Tactic;
import org.safe.metamodel.safe10.TargetValuesLFMetricEnum;
import org.safe.metamodel.safe10.TargetValuesSPFMetricEnum;
import org.safe.metamodel.safe10.TechnicalSafetyExtension;
import org.safe.metamodel.safe10.TechnicalSafetyRequirement;
import org.safe.metamodel.safe10.TestProtocol;
import org.safe.metamodel.safe10.Topic;
import org.safe.metamodel.safe10.TraceableSpecification;
import org.safe.metamodel.safe10.UnitTestProtocol;
import org.safe.metamodel.safe10.ValueAboveRange;
import org.safe.metamodel.safe10.ValueBelowRange;
import org.safe.metamodel.safe10.Variant;
import org.safe.metamodel.safe10.VariantDescriptionMode;
import org.safe.metamodel.safe10.Verify;
import org.safe.metamodel.safe10.Voter;
import org.safe.metamodel.safe10.VoterActivationSchemeEnum;
import org.safe.metamodel.safe10.VoterConfig;
import org.safe.metamodel.safe10.VoterNoConsensus;
import org.safe.metamodel.safe10.VoterParameter;
import org.safe.metamodel.safe10.VoterValueMismatch;
import org.safe.metamodel.safe10.Voting;
import org.safe.metamodel.safe10.VotingAlgorithmEnum;
import org.safe.metamodel.safe10.WarningAndDegradation;
import org.safe.metamodel.safe10.WarningAndDegradationHandle;

/**
 * <!-- begin-user-doc -->
 * The <b>Validator</b> for the model.
 * <!-- end-user-doc -->
 * @see org.safe.metamodel.safe10.Safe10Package
 * @generated
 */
public class Safe10Validator extends EObjectValidator
{
  /**
   * The cached model package
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final Safe10Validator INSTANCE = new Safe10Validator();

  /**
   * A constant for the {@link org.eclipse.emf.common.util.Diagnostic#getSource() source} of diagnostic {@link org.eclipse.emf.common.util.Diagnostic#getCode() codes} from this package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.eclipse.emf.common.util.Diagnostic#getSource()
   * @see org.eclipse.emf.common.util.Diagnostic#getCode()
   * @generated
   */
  public static final String DIAGNOSTIC_SOURCE = "org.safe.metamodel.safe10";

  /**
   * A constant with a fixed name that can be used as the base value for additional hand written constants.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private static final int GENERATED_DIAGNOSTIC_CODE_COUNT = 0;

  /**
   * A constant with a fixed name that can be used as the base value for additional hand written constants in a derived class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected static final int DIAGNOSTIC_CODE_COUNT = GENERATED_DIAGNOSTIC_CODE_COUNT;

  /**
   * Creates an instance of the switch.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Safe10Validator()
  {
    super();
  }

  /**
   * Returns the package of this validator switch.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EPackage getEPackage()
  {
    return Safe10Package.eINSTANCE;
  }

  /**
   * Calls <code>validateXXX</code> for the corresponding classifier of the model.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected boolean validate(int classifierID, Object value, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    switch (classifierID)
    {
      case Safe10Package.FILTER_EXPRESSION:
        return validateFilterExpression((FilterExpression)value, diagnostics, context);
      case Safe10Package.FORMULA_EXPRESSION:
        return validateFormulaExpression((FormulaExpression)value, diagnostics, context);
      case Safe10Package.ABSTRACT_REFERENCE:
        return validateAbstractReference((AbstractReference)value, diagnostics, context);
      case Safe10Package.AUTOSAR_REFERENCE:
        return validateAutosarReference((AutosarReference)value, diagnostics, context);
      case Safe10Package.CHROMOSOME_REFERENCE:
        return validateCHROMOSOMEReference((CHROMOSOMEReference)value, diagnostics, context);
      case Safe10Package.EAST_ADL_REFERENCE:
        return validateEastAdlReference((EastAdlReference)value, diagnostics, context);
      case Safe10Package.APPLICATION:
        return validateApplication((Application)value, diagnostics, context);
      case Safe10Package.COMPONENT:
        return validateComponent((Component)value, diagnostics, context);
      case Safe10Package.COMPONENT_MODE_INSTANCE_REF:
        return validateComponentModeInstanceRef((ComponentModeInstanceRef)value, diagnostics, context);
      case Safe10Package.NODE:
        return validateNode((Node)value, diagnostics, context);
      case Safe10Package.SYSTEM:
        return validateSystem((org.safe.metamodel.safe10.System)value, diagnostics, context);
      case Safe10Package.TOPIC:
        return validateTopic((Topic)value, diagnostics, context);
      case Safe10Package.MULTI_LEVEL_SAFETY_EXTENSION:
        return validateMultiLevelSafetyExtension((MultiLevelSafetyExtension)value, diagnostics, context);
      case Safe10Package.SAFETY_EXTENSION:
        return validateSafetyExtension((SafetyExtension)value, diagnostics, context);
      case Safe10Package.SINGLE_LEVEL_SAFETY_EXTENSION:
        return validateSingleLevelSafetyExtension((SingleLevelSafetyExtension)value, diagnostics, context);
      case Safe10Package.FUNCTIONAL_SAFETY_EXTENSION:
        return validateFunctionalSafetyExtension((FunctionalSafetyExtension)value, diagnostics, context);
      case Safe10Package.HAZARDAND_RISK_SAFETY_EXTENSION:
        return validateHazardandRiskSafetyExtension((HazardandRiskSafetyExtension)value, diagnostics, context);
      case Safe10Package.AUTOSAR_HARDWARE_SAFETY_EXTENSION:
        return validateAutosarHardwareSafetyExtension((AutosarHardwareSafetyExtension)value, diagnostics, context);
      case Safe10Package.AUTOSAR_SAFETY_EXTENSION:
        return validateAutosarSafetyExtension((AutosarSafetyExtension)value, diagnostics, context);
      case Safe10Package.AUTOSAR_SYSTEM_SAFETY_EXTENSION:
        return validateAutosarSystemSafetyExtension((AutosarSystemSafetyExtension)value, diagnostics, context);
      case Safe10Package.AUTOSAR_VFB_SAFETY_EXTENSION:
        return validateAutosarVfbSafetyExtension((AutosarVfbSafetyExtension)value, diagnostics, context);
      case Safe10Package.CHROMOSOME_APPLICATION_SAFETY_EXTENSION:
        return validateChromosomeApplicationSafetyExtension((ChromosomeApplicationSafetyExtension)value, diagnostics, context);
      case Safe10Package.CHROMOSOME_SAFE_EXTENSION:
        return validateChromosomeSafeExtension((ChromosomeSafeExtension)value, diagnostics, context);
      case Safe10Package.CHROMOSOME_SYSTEM_SAFETY_EXTENSION:
        return validateChromosomeSystemSafetyExtension((ChromosomeSystemSafetyExtension)value, diagnostics, context);
      case Safe10Package.IMPLEMENTATION_SAFETY_EXTENSION:
        return validateImplementationSafetyExtension((ImplementationSafetyExtension)value, diagnostics, context);
      case Safe10Package.DESIGN_LEVEL_SAFETY_EXTENSION:
        return validateDesignLevelSafetyExtension((DesignLevelSafetyExtension)value, diagnostics, context);
      case Safe10Package.HARDWARE_SAFETY_EXTENSION:
        return validateHardwareSafetyExtension((HardwareSafetyExtension)value, diagnostics, context);
      case Safe10Package.SOFTWARE_SAFETY_EXTENSION:
        return validateSoftwareSafetyExtension((SoftwareSafetyExtension)value, diagnostics, context);
      case Safe10Package.TECHNICAL_SAFETY_EXTENSION:
        return validateTechnicalSafetyExtension((TechnicalSafetyExtension)value, diagnostics, context);
      case Safe10Package.PACKAGEABLE_ELEMENT:
        return validatePackageableElement((PackageableElement)value, diagnostics, context);
      case Safe10Package.REFERRABLE:
        return validateReferrable((Referrable)value, diagnostics, context);
      case Safe10Package.SAFE:
        return validateSAFE((SAFE)value, diagnostics, context);
      case Safe10Package.SAFE_ELEMENT:
        return validateSAFEElement((SAFEElement)value, diagnostics, context);
      case Safe10Package.SAFE_PACKAGE:
        return validateSAFEPackage((SAFEPackage)value, diagnostics, context);
      case Safe10Package.IDENTIFIABLE:
        return validateIdentifiable((Identifiable)value, diagnostics, context);
      case Safe10Package.AUTOSAR_ABSTRACT_COMPONENT_INSTANCE_REF:
        return validateAutosarAbstractComponentInstanceRef((AutosarAbstractComponentInstanceRef)value, diagnostics, context);
      case Safe10Package.AUTOSAR_ABSTRACT_PORT_IN_COMPONENT_INSTANCE_REF:
        return validateAutosarAbstractPortInComponentInstanceRef((AutosarAbstractPortInComponentInstanceRef)value, diagnostics, context);
      case Safe10Package.AUTOSAR_CLIENT_SERVER_OPERATION_INSTANCE_REF:
        return validateAutosarClientServerOperationInstanceRef((AutosarClientServerOperationInstanceRef)value, diagnostics, context);
      case Safe10Package.AUTOSAR_COMPONENT_IN_COMPOSITION_INSTANCE_REF:
        return validateAutosarComponentInCompositionInstanceRef((AutosarComponentInCompositionInstanceRef)value, diagnostics, context);
      case Safe10Package.AUTOSAR_INSTANCE_REF:
        return validateAutosarInstanceRef((AutosarInstanceRef)value, diagnostics, context);
      case Safe10Package.AUTOSAR_MODE_IN_PORT_FROM_COMPONENT_IN_COMPOSITION_INSTANCE_REF:
        return validateAutosarModeInPortFromComponentInCompositionInstanceRef((AutosarModeInPortFromComponentInCompositionInstanceRef)value, diagnostics, context);
      case Safe10Package.AUTOSAR_PORT_IN_COMPOSITION_INSTANCE_REF:
        return validateAutosarPortInCompositionInstanceRef((AutosarPortInCompositionInstanceRef)value, diagnostics, context);
      case Safe10Package.AUTOSAR_UNDEFINED_INSTANCE_REF:
        return validateAutosarUndefinedInstanceRef((AutosarUndefinedInstanceRef)value, diagnostics, context);
      case Safe10Package.AUTOSAR_VARIABLE_DATA_PROTOTYPE_INSTANCE_REF:
        return validateAutosarVariableDataPrototypeInstanceRef((AutosarVariableDataPrototypeInstanceRef)value, diagnostics, context);
      case Safe10Package.RESTRICTABLE:
        return validateRestrictable((Restrictable)value, diagnostics, context);
      case Safe10Package.RESTRICTION:
        return validateRestriction((Restriction)value, diagnostics, context);
      case Safe10Package.VARIANT:
        return validateVariant((Variant)value, diagnostics, context);
      case Safe10Package.ERROR_MODEL:
        return validateErrorModel((ErrorModel)value, diagnostics, context);
      case Safe10Package.ERROR_MODEL_INSTANCE_REF:
        return validateErrorModelInstanceRef((ErrorModelInstanceRef)value, diagnostics, context);
      case Safe10Package.ERROR_MODEL_PROTOTYPE_ANALYSIS_FUNCTION_TARGET:
        return validateErrorModelPrototype_analysisFunctionTarget((ErrorModelPrototype_analysisFunctionTarget)value, diagnostics, context);
      case Safe10Package.ERROR_MODEL_PROTOTYPE_DESIGN_FUNCTION_TARGET:
        return validateErrorModelPrototype_designFunctionTarget((ErrorModelPrototype_designFunctionTarget)value, diagnostics, context);
      case Safe10Package.ERROR_MODEL_PROTOTYPE_HW_TARGET:
        return validateErrorModelPrototype_hwTarget((ErrorModelPrototype_hwTarget)value, diagnostics, context);
      case Safe10Package.FAULT_FAILURE_PORT_FUNCTION_TARGET:
        return validateFaultFailurePort_functionTarget((FaultFailurePort_functionTarget)value, diagnostics, context);
      case Safe10Package.FAULT_FAILURE_PORT_HW_PIN_TARGET:
        return validateFaultFailurePort_hwPinTarget((FaultFailurePort_hwPinTarget)value, diagnostics, context);
      case Safe10Package.FAULT_FAILURE_PORT_HW_PORT_TARGET:
        return validateFaultFailurePort_hwPortTarget((FaultFailurePort_hwPortTarget)value, diagnostics, context);
      case Safe10Package.MALFUNCTION_INSTANCE_REF:
        return validateMalfunctionInstanceRef((MalfunctionInstanceRef)value, diagnostics, context);
      case Safe10Package.ABSTRACT_ERROR_BEHAVIOR:
        return validateAbstractErrorBehavior((AbstractErrorBehavior)value, diagnostics, context);
      case Safe10Package.EAST_ADL_ERROR_BEHAVIOR:
        return validateEastADLErrorBehavior((EastADLErrorBehavior)value, diagnostics, context);
      case Safe10Package.FAILURE_LOGIC_FORMULA:
        return validateFailureLogicFormula((FailureLogicFormula)value, diagnostics, context);
      case Safe10Package.NATIVE_ERROR_BEHAVIOR:
        return validateNativeErrorBehavior((NativeErrorBehavior)value, diagnostics, context);
      case Safe10Package.EMP_ANALYSIS:
        return validateEMPAnalysis((EMPAnalysis)value, diagnostics, context);
      case Safe10Package.EMP_BSW_MODULE:
        return validateEMPBswModule((EMPBswModule)value, diagnostics, context);
      case Safe10Package.EMP_DESIGN:
        return validateEMPDesign((EMPDesign)value, diagnostics, context);
      case Safe10Package.EMP_HW_COMPONENT:
        return validateEMPHwComponent((EMPHwComponent)value, diagnostics, context);
      case Safe10Package.EMP_REFERENCE:
        return validateEMPReference((EMPReference)value, diagnostics, context);
      case Safe10Package.EMP_SW_COMPONENT:
        return validateEMPSwComponent((EMPSwComponent)value, diagnostics, context);
      case Safe10Package.EM_TYPE_ANALYSIS:
        return validateEMTypeAnalysis((EMTypeAnalysis)value, diagnostics, context);
      case Safe10Package.EM_TYPE_APPLICATION_ENVIRONMENT:
        return validateEMTypeApplicationEnvironment((EMTypeApplicationEnvironment)value, diagnostics, context);
      case Safe10Package.EM_TYPE_BSW_MODULE:
        return validateEMTypeBswModule((EMTypeBswModule)value, diagnostics, context);
      case Safe10Package.EM_TYPE_DESIGN:
        return validateEMTypeDesign((EMTypeDesign)value, diagnostics, context);
      case Safe10Package.EM_TYPE_HW_COMPONENT:
        return validateEMTypeHwComponent((EMTypeHwComponent)value, diagnostics, context);
      case Safe10Package.EM_TYPE_SW_COMPONENT:
        return validateEMTypeSwComponent((EMTypeSwComponent)value, diagnostics, context);
      case Safe10Package.ERROR_MODEL_PROTOTYPE:
        return validateErrorModelPrototype((ErrorModelPrototype)value, diagnostics, context);
      case Safe10Package.ERROR_MODEL_TYPE:
        return validateErrorModelType((ErrorModelType)value, diagnostics, context);
      case Safe10Package.FAULT_FAILURE_PROPAGATION_LINK:
        return validateFaultFailurePropagationLink((FaultFailurePropagationLink)value, diagnostics, context);
      case Safe10Package.FAILURE_RATE:
        return validateFailureRate((FailureRate)value, diagnostics, context);
      case Safe10Package.QUANTITATIVE_ERROR_MODEL:
        return validateQuantitativeErrorModel((QuantitativeErrorModel)value, diagnostics, context);
      case Safe10Package.MALFUNCTION_PROTOTYPE:
        return validateMalfunctionPrototype((MalfunctionPrototype)value, diagnostics, context);
      case Safe10Package.MALFUNCTION_TYPE:
        return validateMalfunctionType((MalfunctionType)value, diagnostics, context);
      case Safe10Package.MFP_BSW_PORT:
        return validateMFPBswPort((MFPBswPort)value, diagnostics, context);
      case Safe10Package.MFP_FUNCTION_PORT:
        return validateMFPFunctionPort((MFPFunctionPort)value, diagnostics, context);
      case Safe10Package.MFP_HARDWARE_PIN:
        return validateMFPHardwarePin((MFPHardwarePin)value, diagnostics, context);
      case Safe10Package.MFP_HARDWARE_PORT:
        return validateMFPHardwarePort((MFPHardwarePort)value, diagnostics, context);
      case Safe10Package.MFP_OPERATION:
        return validateMFPOperation((MFPOperation)value, diagnostics, context);
      case Safe10Package.MFP_SWC_PORT:
        return validateMFPSwcPort((MFPSwcPort)value, diagnostics, context);
      case Safe10Package.MFP_VARIABLE:
        return validateMFPVariable((MFPVariable)value, diagnostics, context);
      case Safe10Package.MT_COMPOSITE:
        return validateMTComposite((MTComposite)value, diagnostics, context);
      case Safe10Package.MT_COMPOSITE_ELEMENT_PROTOTYPE:
        return validateMTCompositeElementPrototype((MTCompositeElementPrototype)value, diagnostics, context);
      case Safe10Package.MT_PRIMITIVE:
        return validateMTPrimitive((MTPrimitive)value, diagnostics, context);
      case Safe10Package.ERROR_BEHAVIOR_MAPPING:
        return validateErrorBehaviorMapping((ErrorBehaviorMapping)value, diagnostics, context);
      case Safe10Package.ERROR_MODEL_MAPPING:
        return validateErrorModelMapping((ErrorModelMapping)value, diagnostics, context);
      case Safe10Package.MALFUNCTION_MAPPING:
        return validateMalfunctionMapping((MalfunctionMapping)value, diagnostics, context);
      case Safe10Package.FORMULA_DOCUMENTATION:
        return validateFormulaDocumentation((FormulaDocumentation)value, diagnostics, context);
      case Safe10Package.HW_FAILURE_CLASS_CONTRIBUTION_FORMULA:
        return validateHWFailureClassContributionFormula((HWFailureClassContributionFormula)value, diagnostics, context);
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION_FORMULA:
        return validateHWFMSingleContributionFormula((HWFMSingleContributionFormula)value, diagnostics, context);
      case Safe10Package.HW_LAMBDA_PART_FORMULA:
        return validateHWLambdaPartFormula((HWLambdaPartFormula)value, diagnostics, context);
      case Safe10Package.HW_LATENT_FAULT_METRIC_FORMULA:
        return validateHWLatentFaultMetricFormula((HWLatentFaultMetricFormula)value, diagnostics, context);
      case Safe10Package.HWPMHF_FORMULA:
        return validateHWPMHFFormula((HWPMHFFormula)value, diagnostics, context);
      case Safe10Package.HW_SINGLE_POINT_FAULT_METRIC_FORMULA:
        return validateHWSinglePointFaultMetricFormula((HWSinglePointFaultMetricFormula)value, diagnostics, context);
      case Safe10Package.HARDWARE_FAILURE_ANALYSIS:
        return validateHardwareFailureAnalysis((HardwareFailureAnalysis)value, diagnostics, context);
      case Safe10Package.HARDWARE_COMPONENT_FAILURE:
        return validateHardwareComponentFailure((HardwareComponentFailure)value, diagnostics, context);
      case Safe10Package.HW_FAILURE_RATE:
        return validateHWFailureRate((HWFailureRate)value, diagnostics, context);
      case Safe10Package.HW_FAILURE_MODE:
        return validateHWFailureMode((HWFailureMode)value, diagnostics, context);
      case Safe10Package.HW_FAULT:
        return validateHWFault((HWFault)value, diagnostics, context);
      case Safe10Package.HW_COMPONENT_PROTOTYPE_SCOPE:
        return validateHWComponentPrototypeScope((HWComponentPrototypeScope)value, diagnostics, context);
      case Safe10Package.HW_COMPONENT_SCOPE_INSTANCE_REF:
        return validateHwComponentScopeInstanceRef((HwComponentScopeInstanceRef)value, diagnostics, context);
      case Safe10Package.HW_COMPONENT_QUANTIFIED_FM_FROM_PART:
        return validateHWComponentQuantifiedFMFromPart((HWComponentQuantifiedFMFromPart)value, diagnostics, context);
      case Safe10Package.HW_ELEMENT_PROTOTYPE_SCOPE:
        return validateHWElementPrototypeScope((HWElementPrototypeScope)value, diagnostics, context);
      case Safe10Package.HW_PART_FAILURE:
        return validateHWPartFailure((HWPartFailure)value, diagnostics, context);
      case Safe10Package.HW_PART_FAILURE_ANALYSIS:
        return validateHWPartFailureAnalysis((HWPartFailureAnalysis)value, diagnostics, context);
      case Safe10Package.HW_PART_FAILURE_MODE:
        return validateHWPartFailureMode((HWPartFailureMode)value, diagnostics, context);
      case Safe10Package.HW_PART_FAILURE_RATE:
        return validateHWPartFailureRate((HWPartFailureRate)value, diagnostics, context);
      case Safe10Package.HW_ELEMENT_SCOPE_INSTANCE_REF:
        return validateHWElementScopeInstanceRef((HWElementScopeInstanceRef)value, diagnostics, context);
      case Safe10Package.HW_ARCHITECTURAL_METRICS:
        return validateHWArchitecturalMetrics((HWArchitecturalMetrics)value, diagnostics, context);
      case Safe10Package.HWFM_SINGLE_CONTRIBUTION:
        return validateHWFMSingleContribution((HWFMSingleContribution)value, diagnostics, context);
      case Safe10Package.HW_PROBABILISTIC_VALUE:
        return validateHWProbabilisticValue((HWProbabilisticValue)value, diagnostics, context);
      case Safe10Package.HW_QUANTITATIVE_FAILURE_ANALYSIS:
        return validateHWQuantitativeFailureAnalysis((HWQuantitativeFailureAnalysis)value, diagnostics, context);
      case Safe10Package.HW_LATENT_FAULT_METRIC:
        return validateHWLatentFaultMetric((HWLatentFaultMetric)value, diagnostics, context);
      case Safe10Package.HW_SINGLE_POINT_FAULT_METRIC:
        return validateHWSinglePointFaultMetric((HWSinglePointFaultMetric)value, diagnostics, context);
      case Safe10Package.HW_ELEMENT_FAILURE_RATE_CLASS:
        return validateHWElementFailureRateClass((HWElementFailureRateClass)value, diagnostics, context);
      case Safe10Package.HW_FAILURE_CLASS_CONTAINER:
        return validateHWFailureClassContainer((HWFailureClassContainer)value, diagnostics, context);
      case Safe10Package.HWPMHF:
        return validateHWPMHF((HWPMHF)value, diagnostics, context);
      case Safe10Package.ACTOR:
        return validateActor((Actor)value, diagnostics, context);
      case Safe10Package.CONTROLLABILITY_REFERENCE:
        return validateControllabilityReference((ControllabilityReference)value, diagnostics, context);
      case Safe10Package.HAZARD:
        return validateHazard((Hazard)value, diagnostics, context);
      case Safe10Package.HAZARDOUS_EVENT:
        return validateHazardousEvent((HazardousEvent)value, diagnostics, context);
      case Safe10Package.ITEM:
        return validateItem((Item)value, diagnostics, context);
      case Safe10Package.ITEM_FUNCTION_DESCRIPTION:
        return validateItemFunctionDescription((ItemFunctionDescription)value, diagnostics, context);
      case Safe10Package.OPERATING_MODE:
        return validateOperatingMode((OperatingMode)value, diagnostics, context);
      case Safe10Package.OPERATIONAL_SITUATION:
        return validateOperationalSituation((OperationalSituation)value, diagnostics, context);
      case Safe10Package.RISK_DESCRIPTION:
        return validateRiskDescription((RiskDescription)value, diagnostics, context);
      case Safe10Package.SAFE_STATE:
        return validateSafeState((SafeState)value, diagnostics, context);
      case Safe10Package.ABSTRACT_QUANTIFIABLE_SAFETY_REQUIREMENT:
        return validateAbstractQuantifiableSafetyRequirement((AbstractQuantifiableSafetyRequirement)value, diagnostics, context);
      case Safe10Package.ABSTRACT_SAFETY_REQUIREMENT:
        return validateAbstractSafetyRequirement((AbstractSafetyRequirement)value, diagnostics, context);
      case Safe10Package.ALLOCATABLE_ELEMENT:
        return validateAllocatableElement((AllocatableElement)value, diagnostics, context);
      case Safe10Package.ALLOCATION_TARGETS:
        return validateAllocationTargets((AllocationTargets)value, diagnostics, context);
      case Safe10Package.FUNCTIONAL_SAFETY_REQUIREMENT:
        return validateFunctionalSafetyRequirement((FunctionalSafetyRequirement)value, diagnostics, context);
      case Safe10Package.HARDWARE_SAFETY_REQUIREMENT:
        return validateHardwareSafetyRequirement((HardwareSafetyRequirement)value, diagnostics, context);
      case Safe10Package.QUANTIFIED_DIAGNOSTIC_COVERAGE_PROPERTY:
        return validateQuantifiedDiagnosticCoverageProperty((QuantifiedDiagnosticCoverageProperty)value, diagnostics, context);
      case Safe10Package.QUANTIFIED_HW_PROPERTY:
        return validateQuantifiedHWProperty((QuantifiedHWProperty)value, diagnostics, context);
      case Safe10Package.REQUIREMENTS_LINK:
        return validateRequirementsLink((RequirementsLink)value, diagnostics, context);
      case Safe10Package.REQUIREMENTS_RELEATIONSHIP:
        return validateRequirementsReleationship((RequirementsReleationship)value, diagnostics, context);
      case Safe10Package.SAFETY_CONCEPT:
        return validateSafetyConcept((SafetyConcept)value, diagnostics, context);
      case Safe10Package.SATISFY:
        return validateSatisfy((Satisfy)value, diagnostics, context);
      case Safe10Package.SOFTWARE_SAFETY_REQUIREMENT:
        return validateSoftwareSafetyRequirement((SoftwareSafetyRequirement)value, diagnostics, context);
      case Safe10Package.TECHNICAL_SAFETY_REQUIREMENT:
        return validateTechnicalSafetyRequirement((TechnicalSafetyRequirement)value, diagnostics, context);
      case Safe10Package.TRACEABLE_SPECIFICATION:
        return validateTraceableSpecification((TraceableSpecification)value, diagnostics, context);
      case Safe10Package.VERIFY:
        return validateVerify((Verify)value, diagnostics, context);
      case Safe10Package.WARNING_AND_DEGRADATION:
        return validateWarningAndDegradation((WarningAndDegradation)value, diagnostics, context);
      case Safe10Package.WARNING_AND_DEGRADATION_HANDLE:
        return validateWarningAndDegradationHandle((WarningAndDegradationHandle)value, diagnostics, context);
      case Safe10Package.ASSUMPTION:
        return validateAssumption((Assumption)value, diagnostics, context);
      case Safe10Package.CONTEXT:
        return validateContext((Context)value, diagnostics, context);
      case Safe10Package.GOAL:
        return validateGoal((Goal)value, diagnostics, context);
      case Safe10Package.JUSTIFICATION:
        return validateJustification((Justification)value, diagnostics, context);
      case Safe10Package.SAFETY_CASE:
        return validateSafetyCase((SafetyCase)value, diagnostics, context);
      case Safe10Package.SOLUTION:
        return validateSolution((Solution)value, diagnostics, context);
      case Safe10Package.STRATEGY:
        return validateStrategy((Strategy)value, diagnostics, context);
      case Safe10Package.ANALYSIS_REPORT:
        return validateAnalysisReport((AnalysisReport)value, diagnostics, context);
      case Safe10Package.DESIGN_SPECIFICATION:
        return validateDesignSpecification((DesignSpecification)value, diagnostics, context);
      case Safe10Package.FIELD_TEST_PROTOCOL:
        return validateFieldTestProtocol((FieldTestProtocol)value, diagnostics, context);
      case Safe10Package.FMEA_REPORT:
        return validateFMEAReport((FMEAReport)value, diagnostics, context);
      case Safe10Package.TEST_PROTOCOL:
        return validateTestProtocol((TestProtocol)value, diagnostics, context);
      case Safe10Package.UNIT_TEST_PROTOCOL:
        return validateUnitTestProtocol((UnitTestProtocol)value, diagnostics, context);
      case Safe10Package.AVOID:
        return validateAvoid((Avoid)value, diagnostics, context);
      case Safe10Package.DETECT:
        return validateDetect((Detect)value, diagnostics, context);
      case Safe10Package.HANDLE:
        return validateHandle((Handle)value, diagnostics, context);
      case Safe10Package.SITUATION:
        return validateSituation((Situation)value, diagnostics, context);
      case Safe10Package.TACTIC:
        return validateTactic((Tactic)value, diagnostics, context);
      case Safe10Package.AUTOSAR_RUNNABLE_ENTITY_SEQUENCE_CONSTRAINT:
        return validateAUTOSARRunnableEntitySequenceConstraint((AUTOSARRunnableEntitySequenceConstraint)value, diagnostics, context);
      case Safe10Package.AUTOSAR_SEQUENCE_CONSTRAINT:
        return validateAUTOSARSequenceConstraint((AUTOSARSequenceConstraint)value, diagnostics, context);
      case Safe10Package.CONTROL_BLOCK:
        return validateControlBlock((ControlBlock)value, diagnostics, context);
      case Safe10Package.CONTROL_FLOW_ERROR:
        return validateControlFlowError((ControlFlowError)value, diagnostics, context);
      case Safe10Package.CONTROL_FLOW_ERROR_DETECTION:
        return validateControlFlowErrorDetection((ControlFlowErrorDetection)value, diagnostics, context);
      case Safe10Package.CONTROL_FLOW_MONITOR:
        return validateControlFlowMonitor((ControlFlowMonitor)value, diagnostics, context);
      case Safe10Package.INPUT_BLOCK:
        return validateInputBlock((InputBlock)value, diagnostics, context);
      case Safe10Package.OPERATION_BLOCK:
        return validateOperationBlock((OperationBlock)value, diagnostics, context);
      case Safe10Package.OUTPUT_BLOCK:
        return validateOutputBlock((OutputBlock)value, diagnostics, context);
      case Safe10Package.RUNNABLE_ENTITY_SEQUENCE_ELEMENT:
        return validateRunnableEntitySequenceElement((RunnableEntitySequenceElement)value, diagnostics, context);
      case Safe10Package.SEQUENCE_BLOCK:
        return validateSequenceBlock((SequenceBlock)value, diagnostics, context);
      case Safe10Package.ALIVENESS_CHECKPOINT_TOO_EARLY:
        return validateAlivenessCheckpointTooEarly((AlivenessCheckpointTooEarly)value, diagnostics, context);
      case Safe10Package.ALIVENESS_CHECKPOINT_TOO_LATE:
        return validateAlivenessCheckpointTooLate((AlivenessCheckpointTooLate)value, diagnostics, context);
      case Safe10Package.ALIVENESS_CHECKPOINT_TOO_OFTEN:
        return validateAlivenessCheckpointTooOften((AlivenessCheckpointTooOften)value, diagnostics, context);
      case Safe10Package.ALIVENESS_MONITOR:
        return validateAlivenessMonitor((AlivenessMonitor)value, diagnostics, context);
      case Safe10Package.AUTOSAR_ALIVENESS_MONITOR:
        return validateAutosarAlivenessMonitor((AutosarAlivenessMonitor)value, diagnostics, context);
      case Safe10Package.AUTOSAR_CHECK_POINT:
        return validateAutosarCheckPoint((AutosarCheckPoint)value, diagnostics, context);
      case Safe10Package.CHECK_POINT:
        return validateCheckPoint((CheckPoint)value, diagnostics, context);
      case Safe10Package.SOFTWARE_ALIVENESS_DETECTION:
        return validateSoftwareAlivenessDetection((SoftwareAlivenessDetection)value, diagnostics, context);
      case Safe10Package.ACTUATOR_ERROR:
        return validateActuatorError((ActuatorError)value, diagnostics, context);
      case Safe10Package.ACTUATOR_ERROR_DETECTION:
        return validateActuatorErrorDetection((ActuatorErrorDetection)value, diagnostics, context);
      case Safe10Package.ACTUATOR_MONITOR:
        return validateActuatorMonitor((ActuatorMonitor)value, diagnostics, context);
      case Safe10Package.AUTOSAR_ACTUATOR_MONITOR:
        return validateAutosarActuatorMonitor((AutosarActuatorMonitor)value, diagnostics, context);
      case Safe10Package.AUTOSAR_EVALUATION_FUNCTION:
        return validateAutosarEvaluationFunction((AutosarEvaluationFunction)value, diagnostics, context);
      case Safe10Package.EVALUATION_FUNCTION:
        return validateEvaluationFunction((EvaluationFunction)value, diagnostics, context);
      case Safe10Package.AUTOSAR_CRC:
        return validateAutosarCRC((AutosarCRC)value, diagnostics, context);
      case Safe10Package.COMPONENT_PROTOTYPE_CRC:
        return validateComponentPrototypeCRC((ComponentPrototypeCRC)value, diagnostics, context);
      case Safe10Package.CRC:
        return validateCRC((CRC)value, diagnostics, context);
      case Safe10Package.CRC_CONFIG:
        return validateCRCConfig((CRCConfig)value, diagnostics, context);
      case Safe10Package.CRC_ERROR_DETECTION:
        return validateCRCErrorDetection((CRCErrorDetection)value, diagnostics, context);
      case Safe10Package.CRC_FAILED:
        return validateCRCFailed((CRCFailed)value, diagnostics, context);
      case Safe10Package.INTERFACE_CRC:
        return validateInterfaceCRC((InterfaceCRC)value, diagnostics, context);
      case Safe10Package.AUTOSAR_COMPARISON:
        return validateAutosarComparison((AutosarComparison)value, diagnostics, context);
      case Safe10Package.AUTOSAR_COMPARISON_PARAM:
        return validateAutosarComparisonParam((AutosarComparisonParam)value, diagnostics, context);
      case Safe10Package.CHROMOSOME_COMPARISON:
        return validateChromosomeComparison((ChromosomeComparison)value, diagnostics, context);
      case Safe10Package.CHROMOSOME_COMPARISON_PARAMETER:
        return validateChromosomeComparisonParameter((ChromosomeComparisonParameter)value, diagnostics, context);
      case Safe10Package.COMPARISON:
        return validateComparison((Comparison)value, diagnostics, context);
      case Safe10Package.COMPARISON_DETECTION:
        return validateComparisonDetection((ComparisonDetection)value, diagnostics, context);
      case Safe10Package.COMPARISON_FALSE:
        return validateComparisonFalse((ComparisonFalse)value, diagnostics, context);
      case Safe10Package.COMPARISON_PARAMETER:
        return validateComparisonParameter((ComparisonParameter)value, diagnostics, context);
      case Safe10Package.COMPARISON_TRUE:
        return validateComparisonTrue((ComparisonTrue)value, diagnostics, context);
      case Safe10Package.CONSTANT_COMPARISON_PARAMETER:
        return validateConstantComparisonParameter((ConstantComparisonParameter)value, diagnostics, context);
      case Safe10Package.AUTOSAR_CONTEXT:
        return validateAutosarContext((AutosarContext)value, diagnostics, context);
      case Safe10Package.AUTOSAR_CONTEXT_RANGE_CHECK:
        return validateAutosarContextRangeCheck((AutosarContextRangeCheck)value, diagnostics, context);
      case Safe10Package.CONTEXT_PARAMETER:
        return validateContextParameter((ContextParameter)value, diagnostics, context);
      case Safe10Package.CONTEXT_RANGE_CHECK:
        return validateContextRangeCheck((ContextRangeCheck)value, diagnostics, context);
      case Safe10Package.CONTEXT_RANGE_CHECK_DETECTION:
        return validateContextRangeCheckDetection((ContextRangeCheckDetection)value, diagnostics, context);
      case Safe10Package.RANGE_CHECK_CONTEXT:
        return validateRangeCheckContext((RangeCheckContext)value, diagnostics, context);
      case Safe10Package.VALUE_ABOVE_RANGE:
        return validateValueAboveRange((ValueAboveRange)value, diagnostics, context);
      case Safe10Package.VALUE_BELOW_RANGE:
        return validateValueBelowRange((ValueBelowRange)value, diagnostics, context);
      case Safe10Package.CHROMOSOME_CPU_SELF_TEST:
        return validateChromosomeCpuSelfTest((ChromosomeCpuSelfTest)value, diagnostics, context);
      case Safe10Package.CPU_SELF_TEST:
        return validateCpuSelfTest((CpuSelfTest)value, diagnostics, context);
      case Safe10Package.CPU_SELF_TEST_CONFIG:
        return validateCpuSelfTestConfig((CpuSelfTestConfig)value, diagnostics, context);
      case Safe10Package.CPU_SELF_TEST_DETECTION:
        return validateCpuSelfTestDetection((CpuSelfTestDetection)value, diagnostics, context);
      case Safe10Package.CPU_SELF_TEST_FAILED:
        return validateCpuSelfTestFailed((CpuSelfTestFailed)value, diagnostics, context);
      case Safe10Package.FILTER:
        return validateFilter((Filter)value, diagnostics, context);
      case Safe10Package.FILTER_BASED_HANDLING:
        return validateFilterBasedHandling((FilterBasedHandling)value, diagnostics, context);
      case Safe10Package.FILTER_ERROR:
        return validateFilterError((FilterError)value, diagnostics, context);
      case Safe10Package.FILTER_PARAMETER:
        return validateFilterParameter((FilterParameter)value, diagnostics, context);
      case Safe10Package.AUTOSAR_GRADIENT_CHECK:
        return validateAutosarGradientCheck((AutosarGradientCheck)value, diagnostics, context);
      case Safe10Package.GRADIENT_CHECK:
        return validateGradientCheck((GradientCheck)value, diagnostics, context);
      case Safe10Package.GRADIENT_CHECK_DETECTION:
        return validateGradientCheckDetection((GradientCheckDetection)value, diagnostics, context);
      case Safe10Package.GRADIENT_TOO_HIGH:
        return validateGradientTooHigh((GradientTooHigh)value, diagnostics, context);
      case Safe10Package.GRADIENT_TOO_LOW:
        return validateGradientTooLow((GradientTooLow)value, diagnostics, context);
      case Safe10Package.CHROMOSOME_APPLICATION_HEALTH_MONITOR:
        return validateChromosomeApplicationHealthMonitor((ChromosomeApplicationHealthMonitor)value, diagnostics, context);
      case Safe10Package.CHROMOSOME_COMPONENT_MODE_CONDITION:
        return validateChromosomeComponentModeCondition((ChromosomeComponentModeCondition)value, diagnostics, context);
      case Safe10Package.CHROMOSOME_ERROR_EVENT_CONDITION:
        return validateChromosomeErrorEventCondition((ChromosomeErrorEventCondition)value, diagnostics, context);
      case Safe10Package.CHROMOSOME_ERROR_HANDLER:
        return validateChromosomeErrorHandler((ChromosomeErrorHandler)value, diagnostics, context);
      case Safe10Package.CHROMOSOME_HEALTH_MONITOR:
        return validateChromosomeHealthMonitor((ChromosomeHealthMonitor)value, diagnostics, context);
      case Safe10Package.CHROMOSOME_HEALTH_MONITOR_NOTIFICATION:
        return validateCHROMOSOMEHealthMonitorNotification((CHROMOSOMEHealthMonitorNotification)value, diagnostics, context);
      case Safe10Package.CHROMOSOME_NODE_HEALTH_MONITOR:
        return validateChromosomeNodeHealthMonitor((ChromosomeNodeHealthMonitor)value, diagnostics, context);
      case Safe10Package.HEALTH_MONITOR:
        return validateHealthMonitor((HealthMonitor)value, diagnostics, context);
      case Safe10Package.HEALTH_MONITOR_ERROR_CONDITION:
        return validateHealthMonitorErrorCondition((HealthMonitorErrorCondition)value, diagnostics, context);
      case Safe10Package.HEALTH_MONITORING:
        return validateHealthMonitoring((HealthMonitoring)value, diagnostics, context);
      case Safe10Package.CHROMOSOME_HEARTBEAT_RECEIVER:
        return validateChromosomeHeartbeatReceiver((ChromosomeHeartbeatReceiver)value, diagnostics, context);
      case Safe10Package.CHROMOSOME_HEARTBEAT_SENDER:
        return validateChromosomeHeartbeatSender((ChromosomeHeartbeatSender)value, diagnostics, context);
      case Safe10Package.HEARTBEAT:
        return validateHeartbeat((Heartbeat)value, diagnostics, context);
      case Safe10Package.HEARTBEAT_CONFIG:
        return validateHeartbeatConfig((HeartbeatConfig)value, diagnostics, context);
      case Safe10Package.HEART_BEAT_DEADLINE_MISSED:
        return validateHeartBeatDeadlineMissed((HeartBeatDeadlineMissed)value, diagnostics, context);
      case Safe10Package.HEART_BEAT_DETECTION:
        return validateHeartBeatDetection((HeartBeatDetection)value, diagnostics, context);
      case Safe10Package.HEARTBEAT_RECEIVER:
        return validateHeartbeatReceiver((HeartbeatReceiver)value, diagnostics, context);
      case Safe10Package.HEARTBEAT_SENDER:
        return validateHeartbeatSender((HeartbeatSender)value, diagnostics, context);
      case Safe10Package.CHROMOSOME_MEMORY_TEST:
        return validateChromosomeMemoryTest((ChromosomeMemoryTest)value, diagnostics, context);
      case Safe10Package.MEMORY_RANGE:
        return validateMemoryRange((MemoryRange)value, diagnostics, context);
      case Safe10Package.MEMORY_SELF_TEST:
        return validateMemorySelfTest((MemorySelfTest)value, diagnostics, context);
      case Safe10Package.MEMORY_SELF_TEST_CONFIG:
        return validateMemorySelfTestConfig((MemorySelfTestConfig)value, diagnostics, context);
      case Safe10Package.MEMORY_SELF_TEST_FAILED:
        return validateMemorySelfTestFailed((MemorySelfTestFailed)value, diagnostics, context);
      case Safe10Package.MEMORY_SELF_TESTING:
        return validateMemorySelfTesting((MemorySelfTesting)value, diagnostics, context);
      case Safe10Package.CHROMOSOME_VOTER:
        return validateChromosomeVoter((ChromosomeVoter)value, diagnostics, context);
      case Safe10Package.CHROMOSOME_VOTER_PARAMETER:
        return validateChromosomeVoterParameter((ChromosomeVoterParameter)value, diagnostics, context);
      case Safe10Package.VOTER:
        return validateVoter((Voter)value, diagnostics, context);
      case Safe10Package.VOTER_CONFIG:
        return validateVoterConfig((VoterConfig)value, diagnostics, context);
      case Safe10Package.VOTER_NO_CONSENSUS:
        return validateVoterNoConsensus((VoterNoConsensus)value, diagnostics, context);
      case Safe10Package.VOTER_PARAMETER:
        return validateVoterParameter((VoterParameter)value, diagnostics, context);
      case Safe10Package.VOTER_VALUE_MISMATCH:
        return validateVoterValueMismatch((VoterValueMismatch)value, diagnostics, context);
      case Safe10Package.VOTING:
        return validateVoting((Voting)value, diagnostics, context);
      case Safe10Package.BOOLEAN_CONFIG_PARAMETER_VALUE:
        return validateBooleanConfigParameterValue((BooleanConfigParameterValue)value, diagnostics, context);
      case Safe10Package.CODE_GENERATION_CONFIGURATION:
        return validateCodeGenerationConfiguration((CodeGenerationConfiguration)value, diagnostics, context);
      case Safe10Package.CONFIG_PARAMETER:
        return validateConfigParameter((ConfigParameter)value, diagnostics, context);
      case Safe10Package.CONFIG_PARAMETER_VALUE:
        return validateConfigParameterValue((ConfigParameterValue)value, diagnostics, context);
      case Safe10Package.FLOAT_CONFIG_PARAMETER_VALUE:
        return validateFloatConfigParameterValue((FloatConfigParameterValue)value, diagnostics, context);
      case Safe10Package.IDENTIFIER_CONFIG_PARAMETER_VALUE:
        return validateIdentifierConfigParameterValue((IdentifierConfigParameterValue)value, diagnostics, context);
      case Safe10Package.INTEGER_CONFIG_PARAMETER_VALUE:
        return validateIntegerConfigParameterValue((IntegerConfigParameterValue)value, diagnostics, context);
      case Safe10Package.STRING_CONFIG_PARAMETER_VALUE:
        return validateStringConfigParameterValue((StringConfigParameterValue)value, diagnostics, context);
      case Safe10Package.HARDWARE_SOFTWARE_INTERFACE_ELEMENT:
        return validateHardwareSoftwareInterfaceElement((HardwareSoftwareInterfaceElement)value, diagnostics, context);
      case Safe10Package.HARDWARE_SOFTWARE_INTERFACE_SPECIFICATION:
        return validateHardwareSoftwareInterfaceSpecification((HardwareSoftwareInterfaceSpecification)value, diagnostics, context);
      case Safe10Package.ASIL_DECOMPOSED_ENUM:
        return validateASILDecomposedEnum((ASILDecomposedEnum)value, diagnostics, context);
      case Safe10Package.ASIL_ENUM:
        return validateASILEnum((ASILEnum)value, diagnostics, context);
      case Safe10Package.DEVELOPMENT_CATEGORY:
        return validateDevelopmentCategory((DevelopmentCategory)value, diagnostics, context);
      case Safe10Package.FUNCTION_BEHAVIOR_KIND:
        return validateFunctionBehaviorKind((FunctionBehaviorKind)value, diagnostics, context);
      case Safe10Package.SAFE_ELEMENT_TYPE:
        return validateSafeElementType((SafeElementType)value, diagnostics, context);
      case Safe10Package.VARIANT_DESCRIPTION_MODE:
        return validateVariantDescriptionMode((VariantDescriptionMode)value, diagnostics, context);
      case Safe10Package.ERROR_BEHAVIOR_KIND:
        return validateErrorBehaviorKind((ErrorBehaviorKind)value, diagnostics, context);
      case Safe10Package.ERROR_MODEL_KIND:
        return validateErrorModelKind((ErrorModelKind)value, diagnostics, context);
      case Safe10Package.HW_MULTIPLE_POINT_FAULT_ENUM:
        return validateHWMultiplePointFaultEnum((HWMultiplePointFaultEnum)value, diagnostics, context);
      case Safe10Package.HW_POINT_FAULT_ENUM:
        return validateHWPointFaultEnum((HWPointFaultEnum)value, diagnostics, context);
      case Safe10Package.TARGET_VALUES_LF_METRIC_ENUM:
        return validateTargetValuesLFMetricEnum((TargetValuesLFMetricEnum)value, diagnostics, context);
      case Safe10Package.TARGET_VALUES_SPF_METRIC_ENUM:
        return validateTargetValuesSPFMetricEnum((TargetValuesSPFMetricEnum)value, diagnostics, context);
      case Safe10Package.HWLF_TARGET_FAILURE_RATE_CLASS_ENUM:
        return validateHWLFTargetFailureRateClassEnum((HWLFTargetFailureRateClassEnum)value, diagnostics, context);
      case Safe10Package.HWRF_TARGET_FAILURE_RATE_CLASS_ENUM:
        return validateHWRFTargetFailureRateClassEnum((HWRFTargetFailureRateClassEnum)value, diagnostics, context);
      case Safe10Package.HWSPF_TARGET_FAILURE_RATE_CLASS_ENUM:
        return validateHWSPFTargetFailureRateClassEnum((HWSPFTargetFailureRateClassEnum)value, diagnostics, context);
      case Safe10Package.HW_TARGET_VALUES_PMHF_ENUM:
        return validateHWTargetValuesPMHFEnum((HWTargetValuesPMHFEnum)value, diagnostics, context);
      case Safe10Package.HW_VALUES_FAILURE_RATE_CLASS_ENUM:
        return validateHWValuesFailureRateClassEnum((HWValuesFailureRateClassEnum)value, diagnostics, context);
      case Safe10Package.CONTROLLABILITY_CLASS_KIND:
        return validateControllabilityClassKind((ControllabilityClassKind)value, diagnostics, context);
      case Safe10Package.EXPOSURE_CLASS_KIND:
        return validateExposureClassKind((ExposureClassKind)value, diagnostics, context);
      case Safe10Package.SEVERITY_CLASS_KIND:
        return validateSeverityClassKind((SeverityClassKind)value, diagnostics, context);
      case Safe10Package.DIAGNOSTIC_COVERAGE_CONTEXT_ENUM:
        return validateDiagnosticCoverageContextEnum((DiagnosticCoverageContextEnum)value, diagnostics, context);
      case Safe10Package.DIAGNOSTIC_COVERAGE_TYPE_ENUM:
        return validateDiagnosticCoverageTypeEnum((DiagnosticCoverageTypeEnum)value, diagnostics, context);
      case Safe10Package.HW_FAULT_METRICS_ENUM:
        return validateHWFaultMetricsEnum((HWFaultMetricsEnum)value, diagnostics, context);
      case Safe10Package.REQUIREMENTS_LINK_TYPE_ENUM:
        return validateRequirementsLinkTypeEnum((RequirementsLinkTypeEnum)value, diagnostics, context);
      case Safe10Package.REQUIREMENT_TYPE_ENUM:
        return validateRequirementTypeEnum((RequirementTypeEnum)value, diagnostics, context);
      case Safe10Package.HANDLING_TYPE:
        return validateHandlingType((HandlingType)value, diagnostics, context);
      case Safe10Package.CONTROL_FLOW_POLICY:
        return validateControlFlowPolicy((ControlFlowPolicy)value, diagnostics, context);
      case Safe10Package.COMPARISON_OPERATION_ENUM:
        return validateComparisonOperationEnum((ComparisonOperationEnum)value, diagnostics, context);
      case Safe10Package.CPU_TEST_ALGORITHM_ENUM:
        return validateCpuTestAlgorithmEnum((CpuTestAlgorithmEnum)value, diagnostics, context);
      case Safe10Package.MEMORY_TEST_ALGORITHMS_ENUM:
        return validateMemoryTestAlgorithmsEnum((MemoryTestAlgorithmsEnum)value, diagnostics, context);
      case Safe10Package.VOTER_ACTIVATION_SCHEME_ENUM:
        return validateVoterActivationSchemeEnum((VoterActivationSchemeEnum)value, diagnostics, context);
      case Safe10Package.VOTING_ALGORITHM_ENUM:
        return validateVotingAlgorithmEnum((VotingAlgorithmEnum)value, diagnostics, context);
      case Safe10Package.HSI_ELEMENT_CATEGORY:
        return validateHSIElementCategory((HSIElementCategory)value, diagnostics, context);
      case Safe10Package.BOOLEAN:
        return validateBoolean((Boolean)value, diagnostics, context);
      case Safe10Package.DATE:
        return validateDate((XMLGregorianCalendar)value, diagnostics, context);
      case Safe10Package.FLOAT:
        return validateFloat((Double)value, diagnostics, context);
      case Safe10Package.IDENTIFIER:
        return validateIdentifier((String)value, diagnostics, context);
      case Safe10Package.INTEGER:
        return validateInteger((Integer)value, diagnostics, context);
      case Safe10Package.NUMERICAL:
        return validateNumerical((String)value, diagnostics, context);
      case Safe10Package.STRING:
        return validateString((String)value, diagnostics, context);
      case Safe10Package.URI_STRING:
        return validateUriString((URI)value, diagnostics, context);
      case Safe10Package.URL_STRING:
        return validateUrlString((URL)value, diagnostics, context);
      default:
        return true;
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateFilterExpression(FilterExpression filterExpression, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(filterExpression, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateFormulaExpression(FormulaExpression formulaExpression, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(formulaExpression, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateAbstractReference(AbstractReference abstractReference, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(abstractReference, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateAutosarReference(AutosarReference autosarReference, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(autosarReference, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateCHROMOSOMEReference(CHROMOSOMEReference chromosomeReference, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(chromosomeReference, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateEastAdlReference(EastAdlReference eastAdlReference, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(eastAdlReference, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateApplication(Application application, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(application, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateComponent(Component component, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(component, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateComponentModeInstanceRef(ComponentModeInstanceRef componentModeInstanceRef, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(componentModeInstanceRef, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateNode(Node node, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(node, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateSystem(org.safe.metamodel.safe10.System system, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(system, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateTopic(Topic topic, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(topic, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateMultiLevelSafetyExtension(MultiLevelSafetyExtension multiLevelSafetyExtension, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(multiLevelSafetyExtension, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateSafetyExtension(SafetyExtension safetyExtension, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(safetyExtension, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateSingleLevelSafetyExtension(SingleLevelSafetyExtension singleLevelSafetyExtension, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(singleLevelSafetyExtension, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateFunctionalSafetyExtension(FunctionalSafetyExtension functionalSafetyExtension, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(functionalSafetyExtension, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHazardandRiskSafetyExtension(HazardandRiskSafetyExtension hazardandRiskSafetyExtension, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(hazardandRiskSafetyExtension, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateAutosarHardwareSafetyExtension(AutosarHardwareSafetyExtension autosarHardwareSafetyExtension, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(autosarHardwareSafetyExtension, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateAutosarSafetyExtension(AutosarSafetyExtension autosarSafetyExtension, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(autosarSafetyExtension, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateAutosarSystemSafetyExtension(AutosarSystemSafetyExtension autosarSystemSafetyExtension, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(autosarSystemSafetyExtension, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateAutosarVfbSafetyExtension(AutosarVfbSafetyExtension autosarVfbSafetyExtension, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(autosarVfbSafetyExtension, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateChromosomeApplicationSafetyExtension(ChromosomeApplicationSafetyExtension chromosomeApplicationSafetyExtension, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(chromosomeApplicationSafetyExtension, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateChromosomeSafeExtension(ChromosomeSafeExtension chromosomeSafeExtension, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(chromosomeSafeExtension, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateChromosomeSystemSafetyExtension(ChromosomeSystemSafetyExtension chromosomeSystemSafetyExtension, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(chromosomeSystemSafetyExtension, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateImplementationSafetyExtension(ImplementationSafetyExtension implementationSafetyExtension, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(implementationSafetyExtension, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateDesignLevelSafetyExtension(DesignLevelSafetyExtension designLevelSafetyExtension, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(designLevelSafetyExtension, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHardwareSafetyExtension(HardwareSafetyExtension hardwareSafetyExtension, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(hardwareSafetyExtension, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateSoftwareSafetyExtension(SoftwareSafetyExtension softwareSafetyExtension, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(softwareSafetyExtension, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateTechnicalSafetyExtension(TechnicalSafetyExtension technicalSafetyExtension, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(technicalSafetyExtension, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validatePackageableElement(PackageableElement packageableElement, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(packageableElement, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateReferrable(Referrable referrable, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(referrable, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateSAFE(SAFE safe, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(safe, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateSAFEElement(SAFEElement safeElement, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(safeElement, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateSAFEPackage(SAFEPackage safePackage, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(safePackage, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateIdentifiable(Identifiable identifiable, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(identifiable, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateAutosarAbstractComponentInstanceRef(AutosarAbstractComponentInstanceRef autosarAbstractComponentInstanceRef, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(autosarAbstractComponentInstanceRef, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateAutosarAbstractPortInComponentInstanceRef(AutosarAbstractPortInComponentInstanceRef autosarAbstractPortInComponentInstanceRef, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(autosarAbstractPortInComponentInstanceRef, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateAutosarClientServerOperationInstanceRef(AutosarClientServerOperationInstanceRef autosarClientServerOperationInstanceRef, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(autosarClientServerOperationInstanceRef, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateAutosarComponentInCompositionInstanceRef(AutosarComponentInCompositionInstanceRef autosarComponentInCompositionInstanceRef, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(autosarComponentInCompositionInstanceRef, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateAutosarInstanceRef(AutosarInstanceRef autosarInstanceRef, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(autosarInstanceRef, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateAutosarModeInPortFromComponentInCompositionInstanceRef(AutosarModeInPortFromComponentInCompositionInstanceRef autosarModeInPortFromComponentInCompositionInstanceRef, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(autosarModeInPortFromComponentInCompositionInstanceRef, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateAutosarPortInCompositionInstanceRef(AutosarPortInCompositionInstanceRef autosarPortInCompositionInstanceRef, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(autosarPortInCompositionInstanceRef, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateAutosarUndefinedInstanceRef(AutosarUndefinedInstanceRef autosarUndefinedInstanceRef, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(autosarUndefinedInstanceRef, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateAutosarVariableDataPrototypeInstanceRef(AutosarVariableDataPrototypeInstanceRef autosarVariableDataPrototypeInstanceRef, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(autosarVariableDataPrototypeInstanceRef, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateRestrictable(Restrictable restrictable, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(restrictable, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateRestriction(Restriction restriction, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(restriction, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateVariant(Variant variant, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(variant, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateErrorModel(ErrorModel errorModel, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(errorModel, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateErrorModelInstanceRef(ErrorModelInstanceRef errorModelInstanceRef, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(errorModelInstanceRef, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateErrorModelPrototype_analysisFunctionTarget(ErrorModelPrototype_analysisFunctionTarget errorModelPrototype_analysisFunctionTarget, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(errorModelPrototype_analysisFunctionTarget, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateErrorModelPrototype_designFunctionTarget(ErrorModelPrototype_designFunctionTarget errorModelPrototype_designFunctionTarget, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(errorModelPrototype_designFunctionTarget, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateErrorModelPrototype_hwTarget(ErrorModelPrototype_hwTarget errorModelPrototype_hwTarget, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(errorModelPrototype_hwTarget, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateFaultFailurePort_functionTarget(FaultFailurePort_functionTarget faultFailurePort_functionTarget, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(faultFailurePort_functionTarget, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateFaultFailurePort_hwPinTarget(FaultFailurePort_hwPinTarget faultFailurePort_hwPinTarget, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(faultFailurePort_hwPinTarget, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateFaultFailurePort_hwPortTarget(FaultFailurePort_hwPortTarget faultFailurePort_hwPortTarget, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(faultFailurePort_hwPortTarget, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateMalfunctionInstanceRef(MalfunctionInstanceRef malfunctionInstanceRef, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(malfunctionInstanceRef, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateAbstractErrorBehavior(AbstractErrorBehavior abstractErrorBehavior, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(abstractErrorBehavior, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateEastADLErrorBehavior(EastADLErrorBehavior eastADLErrorBehavior, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(eastADLErrorBehavior, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateFailureLogicFormula(FailureLogicFormula failureLogicFormula, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(failureLogicFormula, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateNativeErrorBehavior(NativeErrorBehavior nativeErrorBehavior, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(nativeErrorBehavior, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateEMPAnalysis(EMPAnalysis empAnalysis, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(empAnalysis, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateEMPBswModule(EMPBswModule empBswModule, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(empBswModule, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateEMPDesign(EMPDesign empDesign, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(empDesign, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateEMPHwComponent(EMPHwComponent empHwComponent, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(empHwComponent, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateEMPReference(EMPReference empReference, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(empReference, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateEMPSwComponent(EMPSwComponent empSwComponent, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(empSwComponent, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateEMTypeAnalysis(EMTypeAnalysis emTypeAnalysis, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(emTypeAnalysis, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateEMTypeApplicationEnvironment(EMTypeApplicationEnvironment emTypeApplicationEnvironment, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(emTypeApplicationEnvironment, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateEMTypeBswModule(EMTypeBswModule emTypeBswModule, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(emTypeBswModule, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateEMTypeDesign(EMTypeDesign emTypeDesign, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(emTypeDesign, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateEMTypeHwComponent(EMTypeHwComponent emTypeHwComponent, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(emTypeHwComponent, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateEMTypeSwComponent(EMTypeSwComponent emTypeSwComponent, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(emTypeSwComponent, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateErrorModelPrototype(ErrorModelPrototype errorModelPrototype, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(errorModelPrototype, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateErrorModelType(ErrorModelType errorModelType, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(errorModelType, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateFaultFailurePropagationLink(FaultFailurePropagationLink faultFailurePropagationLink, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(faultFailurePropagationLink, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateFailureRate(FailureRate failureRate, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(failureRate, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateQuantitativeErrorModel(QuantitativeErrorModel quantitativeErrorModel, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(quantitativeErrorModel, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateMalfunctionPrototype(MalfunctionPrototype malfunctionPrototype, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(malfunctionPrototype, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateMalfunctionType(MalfunctionType malfunctionType, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(malfunctionType, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateMFPBswPort(MFPBswPort mfpBswPort, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(mfpBswPort, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateMFPFunctionPort(MFPFunctionPort mfpFunctionPort, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(mfpFunctionPort, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateMFPHardwarePin(MFPHardwarePin mfpHardwarePin, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(mfpHardwarePin, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateMFPHardwarePort(MFPHardwarePort mfpHardwarePort, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(mfpHardwarePort, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateMFPOperation(MFPOperation mfpOperation, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(mfpOperation, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateMFPSwcPort(MFPSwcPort mfpSwcPort, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(mfpSwcPort, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateMFPVariable(MFPVariable mfpVariable, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(mfpVariable, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateMTComposite(MTComposite mtComposite, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(mtComposite, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateMTCompositeElementPrototype(MTCompositeElementPrototype mtCompositeElementPrototype, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(mtCompositeElementPrototype, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateMTPrimitive(MTPrimitive mtPrimitive, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(mtPrimitive, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateErrorBehaviorMapping(ErrorBehaviorMapping errorBehaviorMapping, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(errorBehaviorMapping, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateErrorModelMapping(ErrorModelMapping errorModelMapping, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(errorModelMapping, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateMalfunctionMapping(MalfunctionMapping malfunctionMapping, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(malfunctionMapping, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateFormulaDocumentation(FormulaDocumentation formulaDocumentation, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(formulaDocumentation, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHWFailureClassContributionFormula(HWFailureClassContributionFormula hwFailureClassContributionFormula, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(hwFailureClassContributionFormula, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHWFMSingleContributionFormula(HWFMSingleContributionFormula hwfmSingleContributionFormula, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(hwfmSingleContributionFormula, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHWLambdaPartFormula(HWLambdaPartFormula hwLambdaPartFormula, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(hwLambdaPartFormula, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHWLatentFaultMetricFormula(HWLatentFaultMetricFormula hwLatentFaultMetricFormula, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(hwLatentFaultMetricFormula, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHWPMHFFormula(HWPMHFFormula hwpmhfFormula, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(hwpmhfFormula, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHWSinglePointFaultMetricFormula(HWSinglePointFaultMetricFormula hwSinglePointFaultMetricFormula, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(hwSinglePointFaultMetricFormula, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHardwareFailureAnalysis(HardwareFailureAnalysis hardwareFailureAnalysis, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(hardwareFailureAnalysis, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHardwareComponentFailure(HardwareComponentFailure hardwareComponentFailure, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(hardwareComponentFailure, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHWFailureRate(HWFailureRate hwFailureRate, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(hwFailureRate, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHWFailureMode(HWFailureMode hwFailureMode, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(hwFailureMode, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHWFault(HWFault hwFault, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(hwFault, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHWComponentPrototypeScope(HWComponentPrototypeScope hwComponentPrototypeScope, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(hwComponentPrototypeScope, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHwComponentScopeInstanceRef(HwComponentScopeInstanceRef hwComponentScopeInstanceRef, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(hwComponentScopeInstanceRef, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHWComponentQuantifiedFMFromPart(HWComponentQuantifiedFMFromPart hwComponentQuantifiedFMFromPart, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(hwComponentQuantifiedFMFromPart, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHWElementPrototypeScope(HWElementPrototypeScope hwElementPrototypeScope, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(hwElementPrototypeScope, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHWPartFailure(HWPartFailure hwPartFailure, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(hwPartFailure, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHWPartFailureAnalysis(HWPartFailureAnalysis hwPartFailureAnalysis, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(hwPartFailureAnalysis, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHWPartFailureMode(HWPartFailureMode hwPartFailureMode, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(hwPartFailureMode, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHWPartFailureRate(HWPartFailureRate hwPartFailureRate, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(hwPartFailureRate, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHWElementScopeInstanceRef(HWElementScopeInstanceRef hwElementScopeInstanceRef, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(hwElementScopeInstanceRef, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHWArchitecturalMetrics(HWArchitecturalMetrics hwArchitecturalMetrics, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(hwArchitecturalMetrics, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHWFMSingleContribution(HWFMSingleContribution hwfmSingleContribution, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(hwfmSingleContribution, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHWProbabilisticValue(HWProbabilisticValue hwProbabilisticValue, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(hwProbabilisticValue, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHWQuantitativeFailureAnalysis(HWQuantitativeFailureAnalysis hwQuantitativeFailureAnalysis, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(hwQuantitativeFailureAnalysis, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHWLatentFaultMetric(HWLatentFaultMetric hwLatentFaultMetric, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(hwLatentFaultMetric, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHWSinglePointFaultMetric(HWSinglePointFaultMetric hwSinglePointFaultMetric, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(hwSinglePointFaultMetric, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHWElementFailureRateClass(HWElementFailureRateClass hwElementFailureRateClass, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(hwElementFailureRateClass, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHWFailureClassContainer(HWFailureClassContainer hwFailureClassContainer, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(hwFailureClassContainer, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHWPMHF(HWPMHF hwpmhf, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(hwpmhf, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateActor(Actor actor, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(actor, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateControllabilityReference(ControllabilityReference controllabilityReference, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(controllabilityReference, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHazard(Hazard hazard, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(hazard, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHazardousEvent(HazardousEvent hazardousEvent, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(hazardousEvent, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateItem(Item item, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(item, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateItemFunctionDescription(ItemFunctionDescription itemFunctionDescription, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(itemFunctionDescription, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateOperatingMode(OperatingMode operatingMode, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(operatingMode, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateOperationalSituation(OperationalSituation operationalSituation, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(operationalSituation, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateRiskDescription(RiskDescription riskDescription, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(riskDescription, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateSafeState(SafeState safeState, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(safeState, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateAbstractQuantifiableSafetyRequirement(AbstractQuantifiableSafetyRequirement abstractQuantifiableSafetyRequirement, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(abstractQuantifiableSafetyRequirement, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateAbstractSafetyRequirement(AbstractSafetyRequirement abstractSafetyRequirement, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(abstractSafetyRequirement, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateAllocatableElement(AllocatableElement allocatableElement, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(allocatableElement, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateAllocationTargets(AllocationTargets allocationTargets, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(allocationTargets, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateFunctionalSafetyRequirement(FunctionalSafetyRequirement functionalSafetyRequirement, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(functionalSafetyRequirement, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHardwareSafetyRequirement(HardwareSafetyRequirement hardwareSafetyRequirement, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(hardwareSafetyRequirement, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateQuantifiedDiagnosticCoverageProperty(QuantifiedDiagnosticCoverageProperty quantifiedDiagnosticCoverageProperty, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(quantifiedDiagnosticCoverageProperty, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateQuantifiedHWProperty(QuantifiedHWProperty quantifiedHWProperty, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(quantifiedHWProperty, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateRequirementsLink(RequirementsLink requirementsLink, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(requirementsLink, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateRequirementsReleationship(RequirementsReleationship requirementsReleationship, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(requirementsReleationship, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateSafetyConcept(SafetyConcept safetyConcept, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(safetyConcept, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateSatisfy(Satisfy satisfy, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(satisfy, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateSoftwareSafetyRequirement(SoftwareSafetyRequirement softwareSafetyRequirement, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(softwareSafetyRequirement, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateTechnicalSafetyRequirement(TechnicalSafetyRequirement technicalSafetyRequirement, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(technicalSafetyRequirement, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateTraceableSpecification(TraceableSpecification traceableSpecification, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(traceableSpecification, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateVerify(Verify verify, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(verify, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateWarningAndDegradation(WarningAndDegradation warningAndDegradation, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(warningAndDegradation, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateWarningAndDegradationHandle(WarningAndDegradationHandle warningAndDegradationHandle, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(warningAndDegradationHandle, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateAssumption(Assumption assumption, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(assumption, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateContext(Context context, DiagnosticChain diagnostics, Map<Object, Object> theContext)
  {
    return validate_EveryDefaultConstraint(context, diagnostics, theContext);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateGoal(Goal goal, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(goal, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateJustification(Justification justification, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(justification, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateSafetyCase(SafetyCase safetyCase, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(safetyCase, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateSolution(Solution solution, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(solution, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateStrategy(Strategy strategy, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(strategy, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateAnalysisReport(AnalysisReport analysisReport, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(analysisReport, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateDesignSpecification(DesignSpecification designSpecification, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(designSpecification, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateFieldTestProtocol(FieldTestProtocol fieldTestProtocol, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(fieldTestProtocol, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateFMEAReport(FMEAReport fmeaReport, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(fmeaReport, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateTestProtocol(TestProtocol testProtocol, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(testProtocol, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateUnitTestProtocol(UnitTestProtocol unitTestProtocol, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(unitTestProtocol, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateAvoid(Avoid avoid, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(avoid, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateDetect(Detect detect, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(detect, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHandle(Handle handle, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(handle, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateSituation(Situation situation, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(situation, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateTactic(Tactic tactic, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(tactic, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateAUTOSARRunnableEntitySequenceConstraint(AUTOSARRunnableEntitySequenceConstraint autosarRunnableEntitySequenceConstraint, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(autosarRunnableEntitySequenceConstraint, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateAUTOSARSequenceConstraint(AUTOSARSequenceConstraint autosarSequenceConstraint, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(autosarSequenceConstraint, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateControlBlock(ControlBlock controlBlock, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(controlBlock, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateControlFlowError(ControlFlowError controlFlowError, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(controlFlowError, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateControlFlowErrorDetection(ControlFlowErrorDetection controlFlowErrorDetection, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(controlFlowErrorDetection, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateControlFlowMonitor(ControlFlowMonitor controlFlowMonitor, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(controlFlowMonitor, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateInputBlock(InputBlock inputBlock, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(inputBlock, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateOperationBlock(OperationBlock operationBlock, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(operationBlock, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateOutputBlock(OutputBlock outputBlock, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(outputBlock, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateRunnableEntitySequenceElement(RunnableEntitySequenceElement runnableEntitySequenceElement, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(runnableEntitySequenceElement, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateSequenceBlock(SequenceBlock sequenceBlock, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(sequenceBlock, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateAlivenessCheckpointTooEarly(AlivenessCheckpointTooEarly alivenessCheckpointTooEarly, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(alivenessCheckpointTooEarly, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateAlivenessCheckpointTooLate(AlivenessCheckpointTooLate alivenessCheckpointTooLate, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(alivenessCheckpointTooLate, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateAlivenessCheckpointTooOften(AlivenessCheckpointTooOften alivenessCheckpointTooOften, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(alivenessCheckpointTooOften, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateAlivenessMonitor(AlivenessMonitor alivenessMonitor, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(alivenessMonitor, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateAutosarAlivenessMonitor(AutosarAlivenessMonitor autosarAlivenessMonitor, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(autosarAlivenessMonitor, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateAutosarCheckPoint(AutosarCheckPoint autosarCheckPoint, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(autosarCheckPoint, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateCheckPoint(CheckPoint checkPoint, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(checkPoint, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateSoftwareAlivenessDetection(SoftwareAlivenessDetection softwareAlivenessDetection, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(softwareAlivenessDetection, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateActuatorError(ActuatorError actuatorError, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(actuatorError, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateActuatorErrorDetection(ActuatorErrorDetection actuatorErrorDetection, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(actuatorErrorDetection, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateActuatorMonitor(ActuatorMonitor actuatorMonitor, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(actuatorMonitor, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateAutosarActuatorMonitor(AutosarActuatorMonitor autosarActuatorMonitor, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(autosarActuatorMonitor, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateAutosarEvaluationFunction(AutosarEvaluationFunction autosarEvaluationFunction, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(autosarEvaluationFunction, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateEvaluationFunction(EvaluationFunction evaluationFunction, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(evaluationFunction, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateAutosarCRC(AutosarCRC autosarCRC, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(autosarCRC, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateComponentPrototypeCRC(ComponentPrototypeCRC componentPrototypeCRC, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(componentPrototypeCRC, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateCRC(CRC crc, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(crc, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateCRCConfig(CRCConfig crcConfig, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(crcConfig, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateCRCErrorDetection(CRCErrorDetection crcErrorDetection, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(crcErrorDetection, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateCRCFailed(CRCFailed crcFailed, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(crcFailed, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateInterfaceCRC(InterfaceCRC interfaceCRC, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(interfaceCRC, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateAutosarComparison(AutosarComparison autosarComparison, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(autosarComparison, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateAutosarComparisonParam(AutosarComparisonParam autosarComparisonParam, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(autosarComparisonParam, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateChromosomeComparison(ChromosomeComparison chromosomeComparison, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(chromosomeComparison, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateChromosomeComparisonParameter(ChromosomeComparisonParameter chromosomeComparisonParameter, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(chromosomeComparisonParameter, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateComparison(Comparison comparison, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(comparison, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateComparisonDetection(ComparisonDetection comparisonDetection, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(comparisonDetection, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateComparisonFalse(ComparisonFalse comparisonFalse, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(comparisonFalse, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateComparisonParameter(ComparisonParameter comparisonParameter, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(comparisonParameter, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateComparisonTrue(ComparisonTrue comparisonTrue, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(comparisonTrue, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateConstantComparisonParameter(ConstantComparisonParameter constantComparisonParameter, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(constantComparisonParameter, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateAutosarContext(AutosarContext autosarContext, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(autosarContext, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateAutosarContextRangeCheck(AutosarContextRangeCheck autosarContextRangeCheck, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(autosarContextRangeCheck, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateContextParameter(ContextParameter contextParameter, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(contextParameter, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateContextRangeCheck(ContextRangeCheck contextRangeCheck, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(contextRangeCheck, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateContextRangeCheckDetection(ContextRangeCheckDetection contextRangeCheckDetection, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(contextRangeCheckDetection, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateRangeCheckContext(RangeCheckContext rangeCheckContext, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(rangeCheckContext, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateValueAboveRange(ValueAboveRange valueAboveRange, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(valueAboveRange, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateValueBelowRange(ValueBelowRange valueBelowRange, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(valueBelowRange, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateChromosomeCpuSelfTest(ChromosomeCpuSelfTest chromosomeCpuSelfTest, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(chromosomeCpuSelfTest, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateCpuSelfTest(CpuSelfTest cpuSelfTest, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(cpuSelfTest, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateCpuSelfTestConfig(CpuSelfTestConfig cpuSelfTestConfig, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(cpuSelfTestConfig, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateCpuSelfTestDetection(CpuSelfTestDetection cpuSelfTestDetection, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(cpuSelfTestDetection, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateCpuSelfTestFailed(CpuSelfTestFailed cpuSelfTestFailed, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(cpuSelfTestFailed, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateFilter(Filter filter, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(filter, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateFilterBasedHandling(FilterBasedHandling filterBasedHandling, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(filterBasedHandling, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateFilterError(FilterError filterError, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(filterError, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateFilterParameter(FilterParameter filterParameter, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(filterParameter, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateAutosarGradientCheck(AutosarGradientCheck autosarGradientCheck, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(autosarGradientCheck, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateGradientCheck(GradientCheck gradientCheck, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(gradientCheck, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateGradientCheckDetection(GradientCheckDetection gradientCheckDetection, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(gradientCheckDetection, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateGradientTooHigh(GradientTooHigh gradientTooHigh, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(gradientTooHigh, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateGradientTooLow(GradientTooLow gradientTooLow, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(gradientTooLow, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateChromosomeApplicationHealthMonitor(ChromosomeApplicationHealthMonitor chromosomeApplicationHealthMonitor, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(chromosomeApplicationHealthMonitor, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateChromosomeComponentModeCondition(ChromosomeComponentModeCondition chromosomeComponentModeCondition, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(chromosomeComponentModeCondition, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateChromosomeErrorEventCondition(ChromosomeErrorEventCondition chromosomeErrorEventCondition, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(chromosomeErrorEventCondition, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateChromosomeErrorHandler(ChromosomeErrorHandler chromosomeErrorHandler, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(chromosomeErrorHandler, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateChromosomeHealthMonitor(ChromosomeHealthMonitor chromosomeHealthMonitor, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(chromosomeHealthMonitor, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateCHROMOSOMEHealthMonitorNotification(CHROMOSOMEHealthMonitorNotification chromosomeHealthMonitorNotification, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(chromosomeHealthMonitorNotification, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateChromosomeNodeHealthMonitor(ChromosomeNodeHealthMonitor chromosomeNodeHealthMonitor, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(chromosomeNodeHealthMonitor, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHealthMonitor(HealthMonitor healthMonitor, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(healthMonitor, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHealthMonitorErrorCondition(HealthMonitorErrorCondition healthMonitorErrorCondition, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(healthMonitorErrorCondition, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHealthMonitoring(HealthMonitoring healthMonitoring, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(healthMonitoring, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateChromosomeHeartbeatReceiver(ChromosomeHeartbeatReceiver chromosomeHeartbeatReceiver, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(chromosomeHeartbeatReceiver, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateChromosomeHeartbeatSender(ChromosomeHeartbeatSender chromosomeHeartbeatSender, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(chromosomeHeartbeatSender, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHeartbeat(Heartbeat heartbeat, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(heartbeat, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHeartbeatConfig(HeartbeatConfig heartbeatConfig, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(heartbeatConfig, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHeartBeatDeadlineMissed(HeartBeatDeadlineMissed heartBeatDeadlineMissed, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(heartBeatDeadlineMissed, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHeartBeatDetection(HeartBeatDetection heartBeatDetection, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(heartBeatDetection, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHeartbeatReceiver(HeartbeatReceiver heartbeatReceiver, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(heartbeatReceiver, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHeartbeatSender(HeartbeatSender heartbeatSender, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(heartbeatSender, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateChromosomeMemoryTest(ChromosomeMemoryTest chromosomeMemoryTest, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(chromosomeMemoryTest, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateMemoryRange(MemoryRange memoryRange, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(memoryRange, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateMemorySelfTest(MemorySelfTest memorySelfTest, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(memorySelfTest, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateMemorySelfTestConfig(MemorySelfTestConfig memorySelfTestConfig, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(memorySelfTestConfig, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateMemorySelfTestFailed(MemorySelfTestFailed memorySelfTestFailed, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(memorySelfTestFailed, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateMemorySelfTesting(MemorySelfTesting memorySelfTesting, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(memorySelfTesting, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateChromosomeVoter(ChromosomeVoter chromosomeVoter, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(chromosomeVoter, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateChromosomeVoterParameter(ChromosomeVoterParameter chromosomeVoterParameter, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(chromosomeVoterParameter, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateVoter(Voter voter, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(voter, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateVoterConfig(VoterConfig voterConfig, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(voterConfig, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateVoterNoConsensus(VoterNoConsensus voterNoConsensus, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(voterNoConsensus, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateVoterParameter(VoterParameter voterParameter, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(voterParameter, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateVoterValueMismatch(VoterValueMismatch voterValueMismatch, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(voterValueMismatch, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateVoting(Voting voting, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(voting, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateBooleanConfigParameterValue(BooleanConfigParameterValue booleanConfigParameterValue, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(booleanConfigParameterValue, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateCodeGenerationConfiguration(CodeGenerationConfiguration codeGenerationConfiguration, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(codeGenerationConfiguration, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateConfigParameter(ConfigParameter configParameter, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(configParameter, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateConfigParameterValue(ConfigParameterValue configParameterValue, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(configParameterValue, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateFloatConfigParameterValue(FloatConfigParameterValue floatConfigParameterValue, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(floatConfigParameterValue, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateIdentifierConfigParameterValue(IdentifierConfigParameterValue identifierConfigParameterValue, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(identifierConfigParameterValue, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateIntegerConfigParameterValue(IntegerConfigParameterValue integerConfigParameterValue, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(integerConfigParameterValue, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateStringConfigParameterValue(StringConfigParameterValue stringConfigParameterValue, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(stringConfigParameterValue, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHardwareSoftwareInterfaceElement(HardwareSoftwareInterfaceElement hardwareSoftwareInterfaceElement, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(hardwareSoftwareInterfaceElement, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHardwareSoftwareInterfaceSpecification(HardwareSoftwareInterfaceSpecification hardwareSoftwareInterfaceSpecification, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validate_EveryDefaultConstraint(hardwareSoftwareInterfaceSpecification, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateASILDecomposedEnum(ASILDecomposedEnum asilDecomposedEnum, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return true;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateASILEnum(ASILEnum asilEnum, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return true;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateDevelopmentCategory(DevelopmentCategory developmentCategory, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return true;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateFunctionBehaviorKind(FunctionBehaviorKind functionBehaviorKind, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return true;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateSafeElementType(SafeElementType safeElementType, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return true;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateVariantDescriptionMode(VariantDescriptionMode variantDescriptionMode, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return true;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateErrorBehaviorKind(ErrorBehaviorKind errorBehaviorKind, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return true;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateErrorModelKind(ErrorModelKind errorModelKind, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return true;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHWMultiplePointFaultEnum(HWMultiplePointFaultEnum hwMultiplePointFaultEnum, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return true;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHWPointFaultEnum(HWPointFaultEnum hwPointFaultEnum, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return true;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateTargetValuesLFMetricEnum(TargetValuesLFMetricEnum targetValuesLFMetricEnum, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return true;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateTargetValuesSPFMetricEnum(TargetValuesSPFMetricEnum targetValuesSPFMetricEnum, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return true;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHWLFTargetFailureRateClassEnum(HWLFTargetFailureRateClassEnum hwlfTargetFailureRateClassEnum, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return true;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHWRFTargetFailureRateClassEnum(HWRFTargetFailureRateClassEnum hwrfTargetFailureRateClassEnum, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return true;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHWSPFTargetFailureRateClassEnum(HWSPFTargetFailureRateClassEnum hwspfTargetFailureRateClassEnum, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return true;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHWTargetValuesPMHFEnum(HWTargetValuesPMHFEnum hwTargetValuesPMHFEnum, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return true;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHWValuesFailureRateClassEnum(HWValuesFailureRateClassEnum hwValuesFailureRateClassEnum, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return true;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateControllabilityClassKind(ControllabilityClassKind controllabilityClassKind, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return true;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateExposureClassKind(ExposureClassKind exposureClassKind, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return true;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateSeverityClassKind(SeverityClassKind severityClassKind, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return true;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateDiagnosticCoverageContextEnum(DiagnosticCoverageContextEnum diagnosticCoverageContextEnum, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return true;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateDiagnosticCoverageTypeEnum(DiagnosticCoverageTypeEnum diagnosticCoverageTypeEnum, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return true;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHWFaultMetricsEnum(HWFaultMetricsEnum hwFaultMetricsEnum, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return true;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateRequirementsLinkTypeEnum(RequirementsLinkTypeEnum requirementsLinkTypeEnum, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return true;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateRequirementTypeEnum(RequirementTypeEnum requirementTypeEnum, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return true;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHandlingType(HandlingType handlingType, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return true;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateControlFlowPolicy(ControlFlowPolicy controlFlowPolicy, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return true;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateComparisonOperationEnum(ComparisonOperationEnum comparisonOperationEnum, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return true;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateCpuTestAlgorithmEnum(CpuTestAlgorithmEnum cpuTestAlgorithmEnum, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return true;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateMemoryTestAlgorithmsEnum(MemoryTestAlgorithmsEnum memoryTestAlgorithmsEnum, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return true;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateVoterActivationSchemeEnum(VoterActivationSchemeEnum voterActivationSchemeEnum, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return true;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateVotingAlgorithmEnum(VotingAlgorithmEnum votingAlgorithmEnum, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return true;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateHSIElementCategory(HSIElementCategory hsiElementCategory, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return true;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateBoolean(Boolean boolean_, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return true;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateDate(XMLGregorianCalendar date, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return true;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateFloat(Double float_, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return true;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateIdentifier(String identifier, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    boolean result = validateIdentifier_Pattern(identifier, diagnostics, context);
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @see #validateIdentifier_Pattern
   */
  public static final  PatternMatcher [][] IDENTIFIER__PATTERN__VALUES =
    new PatternMatcher [][]
    {
      new PatternMatcher []
      {
        XMLTypeUtil.createPatternMatcher("[a-zA-Z]([a-zA-Z0-9]|_[a-zA-Z0-9])*_?")
      }
    };

  /**
   * Validates the Pattern constraint of '<em>Identifier</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateIdentifier_Pattern(String identifier, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return validatePattern(Safe10Package.eINSTANCE.getIdentifier(), identifier, IDENTIFIER__PATTERN__VALUES, diagnostics, context);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateInteger(Integer integer, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return true;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateNumerical(String numerical, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return true;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateString(String string, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return true;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateUriString(URI uriString, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return true;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean validateUrlString(URL urlString, DiagnosticChain diagnostics, Map<Object, Object> context)
  {
    return true;
  }

  /**
   * Returns the resource locator that will be used to fetch messages for this validator's diagnostics.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public ResourceLocator getResourceLocator()
  {
    return Activator.INSTANCE;
  }

} //Safe10Validator
