package org.safe.metamodelgen.postprocessings;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;

import org.eclipse.core.resources.IContainer;
import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IFolder;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IPath;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Path;

import org.eclipse.eatop.eaadapter.Activator;
import org.eclipse.eatop.eaadapter.ea2ecore.PostProcessingTemplate;
import org.eclipse.eatop.metamodelgen.util.ModelUtil;
import org.eclipse.sphinx.platform.util.StatusUtil;

public class CopyEastadlFiles extends PostProcessingTemplate {
	
	private static final String EASTADL_STUB_GENMODEL = "eastadlStub.genmodel";
	private static final String EASTADL_STUB_ECORE = "eastadlStub.ecore";
	
//	private static final String GEASTADL_GENMODEL = "geastadl.genmodel";
//	private static final String GEASTADL_ECORE = "geastadl.ecore";
	
	private File ecoreModelFile = null;
	private String eastadlStubRootDir = null;
	
	public CopyEastadlFiles(File ecoreModelFile, String eastadlStubRootDir) {
		this.ecoreModelFile = ecoreModelFile;
		this.eastadlStubRootDir = eastadlStubRootDir;
	}
	
	private void copyFile (File file, IContainer destFolder) throws FileNotFoundException, CoreException {
		IFile newFile = destFolder.getFile(new Path(file.getName()));
		newFile.create(new FileInputStream(file), true, null);
	}

	@Override
	public void execute() throws CoreException {
		IPath genModelPath = new Path(ecoreModelFile.getAbsolutePath());
		IFile iFile = ResourcesPlugin.getWorkspace().getRoot().getFileForLocation(
				genModelPath);
		IContainer destFolder = iFile.getParent();
		
//		File file = ModelUtil.findFileByName(new File(eastadlStubRootDir), EASTADL_STUB_ECORE);
//		copyFile(file, destFolder);
//		//copy genmodel
//		file = ModelUtil.findFileByName(new File(eastadlStubRootDir), EASTADL_STUB_GENMODEL);
//		copyFile(file, destFolder);
		
		//copy ecore
		IFolder eastadlStubRootFolder = ResourcesPlugin.getWorkspace().getRoot().getFolder(new Path(eastadlStubRootDir));
		IFile eastadlStubEcoreFile = eastadlStubRootFolder.getFile(EASTADL_STUB_ECORE);
		eastadlStubEcoreFile.copy(destFolder.getFullPath().append(EASTADL_STUB_ECORE), true, null);
		
		//copy genmodel
		IFile eastadlStubGenmodelFile = eastadlStubRootFolder.getFile(EASTADL_STUB_GENMODEL);
		eastadlStubGenmodelFile.copy(destFolder.getFullPath().append(EASTADL_STUB_GENMODEL), true, null);
	}
}
